#include <windows.h>
#include <tchar.h>
#include <gdiplus.h>
#include <D2D1.h>

//  ėpvOCdlhtg 2014/04/19 o[W
//  ݂̂ƂA~j}ȎdlłB
//  ݂̎dlŎ擾łȂf[^擾R[obN~A
//  ʒmė~CxgȂǂ΁Av]B

#pragma once

#pragma pack(push, 1)

namespace GenericPlugin
{
	enum DrawMode
	{
		DrawModeGdiplus = 0,
		DrawModeDirect2D,
	};
	class DrawItem		//  tFCXւ̕`̂߂̃IuWFNg
	{
	public:
		Gdiplus::Bitmap *FrameBuffer;	//  tFCX֕`悳IuWFNgւ̃|C^Bg̃rbg}bv̏ĂBdelete ATCYύX肵Ă͂Ȃ
		RECT rcView;					//  tFCXɕ`悳ʒuB̃TCYKrbg}bṽTCYƈv킯ł͂Ȃ̂ŒӁB͈͓̔ŃACgꍇB
		BOOL fIsVisible;				//  ݕ\Ԃɂ邩A\Ԃɂ邩̃tOBAj[VȂǂ́A\Ԃ̂Ƃ̂ݏ邱Ƃ𐄏
	};
	class DrawItemD2D
	{
	public:
		ID2D1RenderTarget *pRenderTarget;
		RECT rcView;
		BOOL fIsVisible;
	};

	class SoundData		//  TEhf[^擾邽߂̃IuWFNg
	{
	public:
		double * PCMData;	//  Tvf[^i[obt@B
		int nChannels;		//  PCMData Ɏ߂ꂽ`lBWindows PCM ` (`lƂɃC^[u) łB
		int nCount;			//  擾TvBPCMData ̎ۂ̐́AnChannels * nCount łB
	};

	class SoundInfo
	{
	public:
		int nUniqueId;				//  Ώۃt@C̈ ID
		LPCTSTR pszFilePath;		//  t@C̃pX (t@C͊܂܂Ȃ)
		LPCTSTR pszFileName;		//  t@C
		LPCTSTR pszTitle;			//  ^Õ^Cg
		LPCTSTR pszArtist;			//  ^ÕA[eBXg
		LPCTSTR pszAlbum;			//  ^ÕAo
		LPCTSTR pszDate;			//  ^O̓t
		LPCTSTR pszTrackNumber;		//  ^ÕgbNԍ
		LPCTSTR pszGenre;			//  ^ÕW
		LPCTSTR pszComment;			//  ^ÕRg
		LPCTSTR pszTotalTime;		//  t@C̑t
		LPCTSTR pszListCurrent;		//  t@C̃Xgł̉t
		LPCTSTR pszListNumber;		//  t@Cԍ (vCXg No. J̒l)
		LPCTSTR pszListCount;		//  Xg̃t@C̐
		LPCTSTR pszListPlayed;		//  Xg̍Đς݃t@C (ݖ)
		LPCTSTR pszListTotalTime;	//  Xg̑St@C̍vt
		LPCTSTR pszFileType;		//  t@C̎
		LPCTSTR pszBitrate;			//  σrbg[g
		LPCTSTR pszBitsPerSample;	//  rbg[x
		LPCTSTR pszSamplerate;		//  TvO[g
		LPCTSTR pszChannels;		//  `l
		LPCTSTR pszChannelMode;		//  `l[h (JointStereo ƂA5.1ch Surround Ƃ)
		LPCTSTR pszBitrateMode;		//  rbg[g[h (CBR or VBR)

		__int64 qlTotalTime;		//  t@C̑t (ms P)
		int nListCurrent;			//  t@C̃Xgł̉t
		int nListNumber;			//  t@Cԍ (vCXg No. J̒l)
		int nListCount;				//  Xg̃t@C̐
		int nListPlayed;			//  Xg̍Đς݃t@C (ݖ)
		__int64 qlListTotalTime;	//  Xg̑St@C̍vt
		int nBitrate;				//  σrbg[g
		int nBitsPerSample;			//  rbg[x
		int nSamplerate;			//  TvO[g
		int nChannles;				//  `l
	};

	enum CommandParamType
	{
		CommandParamInt = 0,		//   (nParam Ɋi[)
		CommandParamString,			//   (pszParam Ɋi[)
		CommandParamDouble,			//  _ (dParam Ɋi[)
		CommandParamBool,			//  bool  (fParam Ɋi[)
		CommandParamRandomInt,		//  _ ( pszParam Ɋi[)
		CommandParamRandomString,	//  _ ( pszParam Ɋi[)
		CommandParamMax,
	};

	class FaceCommandData
	{
	public:
		FaceCommandData(void)
		{
			pszCommandName = TEXT("");
			pszCallerItemName = NULL;
			Type = CommandParamInt;
			nParam = 0;
			pszTargetWindow = NULL;
			pszTargetPlugin = NULL;
		}
	public:
		LPCTSTR pszCommandName;		//  R}h (tFCX`t@Cɏ̂Ɠ)
		LPCTSTR pszCallerItemName;	//  ĂяoACe (ȗBR}hV[PXĂяonƁAvOCbZ[Wgp̂ݕKv)
		CommandParamType Type;		//  ^Cv
		union
		{
			int nParam;				//  ̒l
			double dParam;			//  _̒l
			BOOL fParam;			//  bool ̒l
			LPCTSTR pszParam;		//  /_/_̒l
		};
		LPCTSTR pszTargetWindow;	//  ^[QbgEBhE (ȗBȗ hFace Ŏw肵tFCXEBhEɂȂ)
		LPCTSTR pszTargetPlugin;	//  ^[QbgvOC (ȗBvOCbZ[W𑗐Mꍇɂ̂ݎgp)
	};

	//  f[^擾̃R[obN֐Ƃ

	//DWORD WINAPI WaitLockFace(HANDLE hFace, DWORD nCount, CONST HANDLE *lpHandles, DWORD dwMilliseconds);
	//void WINAPI UnlockFace(HANDLE hFace);
	//HANDLE WINAPI FindFirstFaceItem(HANDLE hFace, LPCTSTR pszSubCategory, LPTSTR pszFieldName, int nBufferLength);
	//BOOL WINAPI FindNextFaceItem(HANDLE hffi, LPTSTR pszFieldName, int nBufferLength);
	//void WINAPI FindFaceItemClose(HANDLE hffi);
	//DrawItem WINAPI GetFaceItem(HANDLE hFace, LPCTSTR pszFieldName);
	//void WINAPI InvalidateFaceRect(HANDLE hFace, const RECT& rcUpdate);
	//void WINAPI UpdateFace(HANDLE hFace);
	//SoundData* WINAPI GetCurrentSoundData(int nCount);
	//void WINAPI FreeSoundData(SoundData *data);
	//__int64 WINAPI GetCurrentSoundTime(void);
	//int WINAPI GetConfigFileDirectory(LPTSTR pszBuffer, int nLength);
	//DrawMode WINAPI GetDrawMode(void);
	//DrawItemD2D WINAPI GetFaceItemD2D(HANDLE hFace, LPCTSTR pszFieldName);
	//HANDLE WINAPI GetFaceFromIndex(int index);
	//LPCTSTR WINAPI GetWindowNameFromHandle(HANDLE hFace);
	//void WINAPI ReleaseFace(HANDLE hFace);
	//bool WINAPI ExecuteFaceCommand(HANDLE hFace, FaceCommandData *pFaceCommand);
	//DWORD WINAPI GetFaceScale(void);

	enum
	{
		GenericPlugin_Version = 0x0203,		//  ėpvOC̃o[WBPluginCallbacks ɓn̂ŁAǂ̃R[obNg邩̖ڈɂǂ
	};

	typedef void (WINAPI * pfnRegisterDialog) (HWND hwndDialog);
	//  [hX_CAOo^
	//  ̊֐Ń_CAOo^ƁAbZ[W[v
	//  ̃_CAOɑ΂ IsDialogMessage() API s邽߁A
	//  Tab L[ł̃tH[JẌړȂǂɍs悤ɂȂB
	//  _CAOjOɁAK UnregisterDialog ĂяoƁB

	typedef void (WINAPI * pfnUnregisterDialog) (HWND hwndDialog);
	//  o^[hX_CAOAo^
	//  RegisterDialog œo^_CAÓA
	//  jOɕK̃R[obNĂсAo^邱

	typedef DWORD (WINAPI * pfnWaitLockFace) (HANDLE hFace, DWORD nCount, CONST HANDLE *lpHandles, DWORD dwMilliseconds);
	//  w肵^CAEgԂ̊ԁAtFCXbNƃVOiIuWFNg̑ҋ@݂B
	//  GetFaceItem sOɃbNȂƁA`IuWFNgȂ\B
	//  bNAKAbN邱ƁB
	//  [LOXbh̏ImƂ̊ԂŃfbhbNȂ悤ɁAWaitForMultipleObjects ƌ݊ɂȂĂB
	//  tFCX̃bNsꍇAnCount  0 ł삷B
	//  bNɐƁAWAIT_OBJECT_0 + nCount ԂB
	//  ̖̑߂ĺAWaitForMultipleObjects ƊS݊B
	//  ȂAWaitForMultipleObjetcts ƈقȂAׂẴIuWFNgVOiԂɂȂ܂őҋ@邱Ƃ͂łȂB
	//  bNԂ͂ȂׂZȂ悤ɁAԂ̂e͂炩߃_OĂāAbNRs[ȂǍHv邱ƁB
	//  ܂AbŃAtFCX֘ÃR[obNȊO͌Ă΂ȂƁBfbhbN\
	//  ̓IɌĂł̂́Â݂ƂÂSBUnlockFace / GetFaceItem / InvalidateFaceRect / UpdateFace

	typedef void (WINAPI * pfnUnlockFace) (HANDLE hFace);
	//  tFCX̃bN̉sBbNƃAbN̉񐔂͐ȂƁÃXbh~܂܂B

	typedef HANDLE (WINAPI * pfnFindFirstFaceItem) (HANDLE hFace, LPCTSTR pszSubCategory, LPTSTR pszFieldName, int nBufferLength);
	//  TuJeSŁAtFCX̍ŏ̃ACe
	//  TuJeSvACeȂꍇANULL ԂB
	//  vACeꍇAŏ̃ACẽtB[hi[A
	//  nhԂBFindNextFaceItem ֌nhnƂŁA
	//  ̃ACẽtB[h擾łB
	//  IAK FindFaceItemClose ĂԂƁB

	typedef BOOL (WINAPI * pfnFindNextFaceItem) (HANDLE hffi, LPTSTR pszFieldName, int nBufferLength);
	//  nhpāAtFCX̎̃ACe
	//  v鎟̃ACeꍇ́AACẽtB[hi[ATRUE ԂB
	//  vACeȂꍇɂ́AFALSE ԂB

	typedef void (WINAPI * pfnFindFaceItemClose) (HANDLE hffi);
	//  tFCXACěnh
	//  nh͕K̃R[obNŕ邱
	//  YƁA[N܂B

	typedef DrawItem (WINAPI * pfnGetFaceItem) (HANDLE hFace, LPCTSTR pszFieldName);
	//  w肵ÕtB[hŒ`ꂽAtFCXACeɑ΂`IuWFNg擾
	//  oʂA̎\ȂǁAړIɉătFCXґƋcāA
	//  tB[h܂́ÃL[̓eȂǂŎʂł悤ɁA[肵ĂKv
	//  w肳ꂽtB[h݂Ȃꍇ́ADrawItem::FrameBuffer  NULL ŕԂĂB
	//
	//  2009/12/02 ȍ~ł́ADirect2D [hłꍇAG~[gꂽ Gdiplus::Bitmap ԂB
	//  gē삳邱Ƃł邪Aϑxx̂ŁA
	//  GetDrawMode ŁAGdiplus [h Direct2D [hʂA
	//  Direct2D [hł́AȂׂGetFaceItemD2D gpāADirect2D ŕ`悷邱

	typedef void (WINAPI * pfnInvalidateFaceRect) (HANDLE hFace, const RECT& rcUpdate);
	//  tFCX̎w肵̈𖳌AUpdateFace ōXV悤ɗ\񂷂B
	//  Ȃׂŏ̗̈w肷邱ƁB̈́AIɂ́A[Wŕێ܂B
	//  Ȃ̂ŁA̋`̈ύXꍇ́A̕ύẌŜ܂ދ`łPĂԂ̂ł͂ȂA
	//  ꂼ̋`ŖĂяoA`ׂ̕yȂ܂B

	typedef void (WINAPI * pfnUpdateFace) (HANDLE hFace);
	//  tFCX̖ꂽ̈`悵AEBhE̕\XVB
	//  炩 InvalidateFaceRect gĂȂƁAXV܂B
	//  ܂ǍĂяoł́A`lϊŁAUpdateLayeredWindow ĂяôŁA
	//  ȂdłBʂȌĂяo͔ĂB
	//  ̈XVɂ́Ä悲ƂɌĂяôł͂ȂAInvalidateRect őSo^ĂAPxĂłB
	//  ȂA̐ۂ߁AtFCXAbNOɌĂяoƁB

	typedef SoundData* (WINAPI * pfnGetCurrentSoundData) (int nCount);
	//  ݂̍ĐʒuAw肵̃Tvf[^ǂݏoB
	//  SoundData NXւ̃|C^Ԃ̂ŁAgQƂ邱ƁB
	//  {̑̍Đobt@̃TCYɂẮAw肵Tv擾łȂꍇB
	//  擾łő吔́AĐobt@TCY / 2 bB
	//  AfR[hxȂǂɂÃTvȂƂB
	//  Đobt@TCY / 4 b炢܂łɎ߂ĂׂB
	//  ȂAĐobt@TCY̍ŒĺA200ms Ȃ̂ŁA50ms ̖ڈƂƂ悢B
	//  擾Tvf[^́AK FreeSoundData ŉ邱ƁBdelete gĂ̓_B

	typedef void (WINAPI * pfnFreeSoundData) (SoundData *data);
	//  擾Tvf[^B
	//  delete Ȃǂg킸ɁAK̃R[obNgpĉ邱ƁB
	//  Yƃ[N̂Œ

	typedef __int64 (WINAPI * pfnGetCurrentSoundTime) (void);
	//  ݂̍Đʒu~bPʂŎ擾B

	typedef int (WINAPI * pfnGetConfigFileDirectory) (LPTSTR pszBuffer, int nLength);
	//  uLilith ̐ݒtH_̃pX擾

	typedef DrawMode (WINAPI * pfnGetDrawMode)(void);
	//  ݂̕`惂[hԂB̃[h́AuLilith NɕύX邱Ƃ͂Ȃ

	typedef DrawItemD2D (WINAPI * pfnGetFaceItemD2D) (HANDLE hFace, LPCTSTR pszFieldName);
	//  Direct2D [hŁAACe̕`IuWFNg擾
	//  GetFaceItem Ǝg͓BԂ̂́AGdiplus::Bitmap ł͂ȂA
	//  ID2D1RenderTarget łB
	//  AddRef Ăn̂ŁAKvȂȂK Release 邱ƁB
	//  2009-11-25 _ł̎ł́AID2D1BitmapRenderTarget ̃CX^Xł̂ŁA
	//  QueryInterface  ID2D1BitmapRenderTarget::GetBitmap gpāA
	//  ID2D1Bitmap 擾邱Ƃł邪AύX\B

	typedef ID2D1RenderTarget *(WINAPI *pfnGetRootRenderTarget) (HANDLE hFace);
	//  Direct2D œobt@쐬邽߂́A RenderTaget 擾B
	//  ō쐬 RenderTarget ACreateCompatibleRenderTarget ŁAŎgp RenderTarget 쐬邱
	//  ܂AAddRef ĂԂ̂ŁAKvȂȂ Release 邱

	typedef HANDLE (WINAPI * pfnGetFaceFromIndex) (int index);
	//  tFCX̃nhCfbNX擾
	//  index == 0 ͏ɃCEBhEŁAAvP[V̏IłȂΕK݂B
	//  ȏtFCX݂ȂꍇANULL ԂB

	typedef LPCTSTR (WINAPI * pfnGetWindowNameFromHandle) (HANDLE hFace);
	//  tFCX̃nhAEBhE擾

	typedef bool (WINAPI * pfnExecuteFaceCommand) (HANDLE hFace, FaceCommandData *pFaceCommand);
	//  Cӂ̃tFCXR}h𔭍s
	//  FaceCommand ̊eoɒlݒ肵ăR[邱ƂŁAtFCX̃ACeNbNA܂́A
	//  V[gJbgL[ƓlɁAtFCXR}hs邱ƂłB
	//  fbhbN̂߁AtFCXbNĂȂԂŌĂяoƂ]܂B
	//  eReiȂǂ̊OtB[hɂĂ͒ڒ`łȂ̂ŁA
	//  YtFCX`Ɋ܂܂ĂKvB

	typedef DWORD (WINAPI * pfnGetFaceScale) (void);
	//  tFCX̃XP[O{擾 (P %)
	//  ftHg 100% ŁA100% ̂Ƃ]ʂ̕\B
	//  tHgTCYȂǁAvOCƎ̃TCYĂACeɑ΂āA
	//  ̃XP[O{ɉăTCY̒sB
	//  PluginFrameBuffer ̗̈TCYȂǂ́A{̑ł̔{ɉ
	//  ̒l͕␳ς݂ł̂ŁACɂȂĂ悢B
	//  ܂łAvOCƎɒ`t@CݒǂŐ䂷镔ɂ̂ݓKpB
	//  XP[OύX̂́A2017/03/06 ݂̎dlŁACtFCX[h̃^C~OłB
	//  쒆ɓIɃTCYς邱Ƃ܂ł͍lȂĂ悢B

	struct PluginCallbacks
	{
		DWORD dwVersion;
		pfnRegisterDialog RegisterDialog;
		pfnUnregisterDialog UnregisterDialog;
		pfnWaitLockFace WaitLockFace;
		pfnUnlockFace UnlockFace;
		pfnFindFirstFaceItem FindFirstFaceItem;
		pfnFindNextFaceItem FindNextFaceItem;
		pfnFindFaceItemClose FindFaceItemClose;
		pfnGetFaceItem GetFaceItem;
		pfnInvalidateFaceRect InvalidateFaceRect;
		pfnUpdateFace UpdateFace;
		pfnGetCurrentSoundData GetCurrentSoundData;
		pfnFreeSoundData FreeSoundData;
		pfnGetCurrentSoundTime GetCurrentSoundTime;
		pfnGetConfigFileDirectory GetConfigFileDirectory;
		pfnGetDrawMode GetDrawMode;
		pfnGetFaceItemD2D GetFaceItemD2D;
		pfnGetRootRenderTarget GetRootRenderTarget;
		pfnGetFaceFromIndex GetFaceFromIndex;
		pfnGetWindowNameFromHandle GetWindowNameFromHandle;
		pfnExecuteFaceCommand ExecuteFaceCommand;
		pfnGetFaceScale GetFaceScale;
	};

	enum SoundStatus
	{
		SoundStatusPlay = 0,	//  ĐJnꂽ
		SoundStatusSuspend,		//  Đꎞ~ꂽ
		SoundStatusResume,		//  ĐĊJꂽ
		SoundStatusStop,		//  Đ~ꂽ
		SoundStatusSeeked,		//  V[Nsꂽ
		SoundStatusMax,
	};

	enum FaceItemNotify
	{
		FaceItemNotifySizeChanged = 0,	//  ̈TCYςAt[obt@NAꂽ
		FaceItemNotifyFaceCommand = 1,	//  tFCXACeR}hCnꂽ
		FaceItemNotifyMouseEvent = 2,
		FaceItemNotifyMax,
	};
	struct FaceItemNotifySizeChangedStruct
	{
		DrawMode mode;
		DrawItem Item;
		DrawItemD2D ItemD2D;
	};
	struct FaceItemNotifyFaceCommandStruct
	{
		LPCTSTR pszCommandLine;
	};
	enum MouseEvent
	{
		MouseEventNormal = 0,
		MouseEventPushed = 1,
		MouseEventOver = 2,
		MouseEventMax,
	};
	struct FaceItemNotifyMouseEventStruct
	{
		DrawMode mode;
		DrawItem Item;
		DrawItemD2D ItemD2D;
		MouseEvent mouseEvent;
	};
	struct FaceEffectCallbackStruct
	{
		DrawMode mode;
		DrawItem Item;
		DrawItemD2D ItemD2D;
	};
	typedef	LPVOID (WINAPI * pfnInitializePlugin) (HWND hwndMain, const PluginCallbacks* callbacks);
	typedef void (WINAPI * pfnUninitializePlugin) (LPVOID lpvUserData);
	typedef HWND (WINAPI * pfnShowProperty) (LPVOID lpvUserData, HWND hwndOwner);
	typedef int (WINAPI * pfnOnFaceLoad) (LPVOID lpvUserData, HANDLE hFace, LPCTSTR pszFileName);
	typedef int (WINAPI * pfnOnFaceUnload) (LPVOID lpvUserData, HANDLE hFace, LPCTSTR pszFileName);
	typedef int (WINAPI * pfnOnSoundOpen) (LPVOID lpvUserData, LPVOID lpvInstance, const SoundInfo& Info);
	typedef int (WINAPI * pfnOnSoundChange) (LPVOID lpvUserData, LPVOID lpvInstance, const SoundInfo& Info);
	typedef int (WINAPI * pfnOnSoundClose) (LPVOID lpvUserData, LPVOID lpvInstance);
	typedef int (WINAPI * pfnOnUpdateVisual) (LPVOID lpvUserData, HANDLE hFace);
	typedef int (WINAPI * pfnOnSoundStatus) (LPVOID lpvUserData, SoundStatus Status);
	//  2016/03/10 AFaceEffectCallback ̈ FaceEffectCallbackStruct ɕύX
	typedef void (WINAPI * pfnFaceEffectCallback) (LPVOID lpvUserData, HANDLE hFace, const FaceEffectCallbackStruct& Canvas, LPCTSTR pszFieldName);
	typedef BOOL (WINAPI * pfnFaceItemNotifyCallback) (LPVOID lpvUserData, HANDLE hFace, LPCTSTR pszFieldName, FaceItemNotify NotifyCode, LPCVOID pNotifyStruct);

	enum SupportedDrawMode
	{
		SupportedDrawModeGdiplus = 0,
		SupportedDrawModeDirect2D,
	};
	struct GenericPluginInfo
	{
		DWORD dwVersion;
		LPCTSTR pszPluginName;
		LPCTSTR pszAuthorName;
		LPCTSTR pszComment;
		pfnInitializePlugin InitializePlugin;
		pfnUninitializePlugin UninitializePlugin;
		pfnShowProperty ShowProperty;
		pfnOnFaceLoad OnFaceLoad;
		pfnOnFaceUnload OnFaceUnload;
		pfnOnSoundOpen OnSoundOpen;
		pfnOnSoundChange OnSoundChange;
		pfnOnSoundClose OnSoundClose;
		pfnOnUpdateVisual OnUpdateVisual;
		pfnOnSoundStatus OnSoundStatus;
		pfnFaceEffectCallback FaceEffectCallback;
		pfnFaceItemNotifyCallback FaceItemNotifyCallback;
		SupportedDrawMode dwSupportedMode;
	};

	typedef void (WINAPI * pfnGetPluginInfo) (GenericPluginInfo& info);


	//  ȉ̓vOCŎ API
	//  ׂĂ API Kv͂ȂB
	//  W[`t@Cgp̂]܂B
	//  {̑́AGetProcAddress ł API 擾B
	//  ݂Ȃꍇ́AĂяosȂB
	//  ȂA API ́Aǂ̃XbhĂ΂邩ł͂Ȃ̂ŁA
	//  ̃XbȟĂяoOƂR[h͏Ȃ
	//  ꉞAvOČĂяo̓NeBJZNVŕی삳̂ŁA
	//  ǂꂩ API Ă΂ĂԂɕʂ API Ă΂邱Ƃ͍lȂĂ
	//  OIɁAInitializePlugin  UninitializePlugin ́A
	//  KCXbhĂ΂B
	//  EBhE쐬Kvꍇɂ́AInitializePlugin ō쐬邱ƁB
	//  ȊO API ́AbZ[W[vȂXbhĂ΂\B
	//  邢́AƎɃXbh쐬AŃbZ[W[vpӂA
	//  ̃XbhɏăEBhE쐬邱ƁB

	void WINAPI GetPluginInfo(GenericPluginInfo& info);
	//  vOC̏擾֐
	//  vOC[hĈԍŏɌĂ΂B
	//  vOC̊e API ƁAC^[tF[Xo[Wi[\̂Ԃ
	//   API ́AC P[WŃGNX|[g邱
	
	LPVOID WINAPI InitializePlugin(HWND hwndMain, const PluginCallbacks* callbacks);
	//  vOC[hƂɁAĂ΂鏉֐
	//  vOC𑽏do^ꍇ́AĂ΂邱Ƃ̂ŒӁB
	//  ̏ꍇłAUninitializePlugin Ƃ̌Ăяo񐔂͎̐B
	//  ɂ́ACEBhẼnhƁAvOCgR[obN֐nB
	//  R[obN֐gꍇ́AlۑĂƁB
	//  ܂A߂lɂ́ACX^Xʂ ID ԂƁB
	//  AP[g[Uf[^ւ̃|C^ł܂ȂB
	//  vOCdo^Ăꍇ́AID łǂ̏ʂB
	//   API ȗꍇ́AID  0 ňȍ~ API ĂяoB

	void WINAPI UninitializePlugin(LPVOID lpvUserData);
	//  vOC̃A[hOɌĂ΂֐
	//  vOCdo^Ăꍇ́AInitializePlugin ŕԂ
	//  ꂼ ID ɁAĂ΂B

	HWND WINAPI ShowProperty(LPVOID lpvUserData, HWND hwndOwner);
	//  vOC̐ݒEBhEJ֐
	//  ɂ́AID ƁAeEBhEƂׂEBhẼnhnB
	//  ɐݒ肪KvȂꍇɂ́AȂĂ܂ȂB
	//  [hX_CAOł̎𐄏B
	//  ̏ꍇARegisterDialog / UnregisterDialog R[obNgpƁA
	//  Tab L[ł̃tH[JẌړȂǂ{̑ŏB

	int WINAPI OnFaceLoad(LPVOID lpvUserData, HANDLE hFace, LPCTSTR pszFileName);
	//  tFCX[hꂽƂɌĂ΂֐
	//  ɂ́AID ƁAǂݍ񂾃tFCX`t@C̃tpXnB
	//  tFCXւ̕`svOCł́AtFCX`t@Cǂݍ݁A
	//  `悷ׂtFCXACeƁA̓Ǝp[^QƂ邱ƁB
	//  ̊֐́AtFCXbNĂԂŌĂяôŁA
	//  ŃXbh𐶐AR[obN WaitLockFace gpꍇA
	//  fbhbNɒӂ邱

	int WINAPI OnFaceUnload(LPVOID lpvUserData, HANDLE hFace, LPCTSTR pszFileName);
	//  tFCXA[hꂽƂɌĂ΂֐
	//  ID ƃA[hꂽtFCX̒`t@C̃tpXnB
	//  ̊֐́AtFCXbNĂԂŌĂяôŁA
	//  ŃXbh𐶐AR[obN WaitLockFace gpꍇA
	//  fbhbNɒӂ邱

	int WINAPI OnSoundOpen(LPVOID lpvUserData, LPVOID lpvInstance, const SoundInfo& Info);
	//  TEht@CI[vꂽƂɌĂ΂֐
	//  NXtF[hȂǁAKΉ OnSoundClose Ă΂ꂽƂ
	//  Ăяo킯ł͂Ȃ̂ɒӁB
	//  ̃t@C OnSoundOpen Ă΂ĂAÕt@C OnSoundClose Ă΂邱ƂB
	//  lpvInstance ӂ̒lȂ̂ŁAOpen  Close ̑Ή́AŎʂ邱ƁB
	//  {̑Ή̃^OȂǂ́Aׂ SoundInfo Ɏ߂Ă̂ŊpׂB

	int WINAPI OnSoundChange(LPVOID lpvUserData, LPVOID lpvInstance, const SoundInfo& Info);
	//  mXgbvĐȂǂŁACX^X͕ωɁAȏ񂾂ωƂɌĂ΂֐
	//   API pӂĂ炸AOnSoundOpen Ăꍇɂ́A
	//  OnSoundClose  OnSoundOpen ɌĂяoB
	//   API ̌Ăяoł́ATEh̃tH[}bg (rbg[x/`l/TvO[g)
	//  ωĂȂƂۏ؂̂ŁAClose & Open AIɏł͂B

	int WINAPI OnSoundClose(LPVOID lpvUserData, LPVOID lpvInstance);
	//  TEht@CN[YꂽƂɌĂ΂֐
	//  KPO OnSoundOpen ƑΉĂ킯ł͂Ȃ̂ŒӁB
	//  lpvInstance ŁAOnSoundOpen Ƃ̑Ήʂ邱ƁB

	int WINAPI OnUpdateVisual(LPVOID lpvUserDatam, HANDLE hFace);
	//  XVXbhĂ΂֐
	//  {̂̃t[[g̐ݒɉāAIɌĂяoB
	//  Visualization vOCȂǂł̍Đ󋵂ɉŎgB
	//  A{̑̕`XVubN̂ŁA
	//  vOC̏dꍇ́A API oRł͍̏sׂł͂ȂB
	//  ƎɃXbh쐬AŏsƁB
	//  tFCXł̃Aj[V̎ȂǁA{̑̃t[[gɈˑȂꍇlB

	int WINAPI OnSoundStatus(LPVOID lpvUserData, SoundStatus Status);
	//  TEh̍ĐJn/~Ȃǂ̃ANVʒm󂯎֐
	//  󂯎ʒḿÂق SoundStatus 񋓑̂̒`QƂ邱

	void WINAPI FaceEffectCallback(LPVOID lpvUserData, HANDLE hFace, const FaceEffectCallbackStruct& Canvas, LPCTSTR pszFieldName);
	//  tFCX̃GtFNgsR[obN֐
	//  2016/03/10 At[obt@̈ FaceEffectCallbackStruct ɕύX
	//  Gdiplus [hł́ACanvas.Item.FrameBuffer ɂ́AtFCXEBhỄt[obt@nB
	//  Direct2D [hł́ACanvas.ItemD2D.RenderTarget ɂ́AtFCXEBhỄ_[^[QbgnB
	//  ǂ炪nꂽ́ACanvas.DrawMode ̓eŔfłB
	//  SupportedDrawMode  Gdiplus ݂̂̑ΉĂĂA{̂ Direct2D [hł̓쎞́AItemD2D ̕n܂B
	//  łɕ`悳Ăe or ēƎ̃GtFNgsƂłB
	//  GtFNgsׂ̈́ArcView ŎwB
	//  wꂽ̈ÓA΂ɕύXȂƁBtFCX̕\ȂB
	//  fIsVisible  FALSE ̂Ƃɂ́AR[obN̂Ă΂Ȃ̂ŁA͍lȂĂ悢B
	//  ̃R[obŃAtFCX̕`揈Ă΂邽߁A
	//  ĂяoŃtFCXbNĂ̂ŁAfbhbNɒӂ邱ƁB

	BOOL WINAPI FaceItemNotifyCallback(LPVOID lpvUserData, HANDLE hFace, LPCTSTR pszFieldName, FaceItemNotify NotifyCode, LPCVOID pNotifyStruct);
	//  tFCXACȅԂςƂɌĂяoR[obN֐
	//  Category == PluginFrameBuffer ̃ACȅԂςƂAKvɉČĂяo
	//  evOCnhĂtB[h́AuLilith ͔cłȂ̂ŁA
	//  pszFieldName `FbNAvOCŃnhOĂtB[ĥݏ邱ƁB
	//  ܂Asꍇɂ́ATRUE AȊȌꍇ́AFALSE ԂƁB
	//  vOC TRUE ԂꍇAuLilith {̂́A㑱̃vOC̃R[obN͌ĂяoȂB
	//  
	//  ANotifyCode  FaceItemNotifySizeChanged  FaceItemNotifyFaceCommand ̂Q̂݁B
	//  NotifyCode == FaceItemNotifySizeChanged ̂Ƃɂ́ApNotifyStruct ɂ́A
	//  FaceItemNotifySizeChangedStruct ւ̃|C^nB
	//  FaceItemNotifySizeChangedStruct::Item.rcView ɁAV\`n̂ŁA
	//  VTCYɊÂāAFrameBuffer ̓eXV邱ƁB
	//   FaceItemNotifySizeChanged OɁAFrameBuffer ̓e̓NAB
	//  FaceItemNotifySizeChanged ́AtFCX̒Ă΂邽߁A
	//  ĂяoŃtFCXbNĂ̂ŁAfbhbNɒӂ邱ƁB
	//
	//  NotifyCode == FaceItemNotifyFaceCommand ̂Ƃɂ́ApNotifyStruct ɂ́A
	//  FaceItemNotifyFaceCommandStruct ւ̃|C^nB
	//  pszCommandLine ́AtFCX`ɋLqĂ CommandParam ̓ełB
	//  Ԃ̂R}hꍇɂ́AvOCŃ[J[Xbh쐬ȂǁA
	//  ԃubNȂHv邱Ƃ𐄏B
};

#pragma pack(pop)