#include "main.h"

extern TCHAR g_szDestFileName[READ_BUF_LEN];
extern BOOL g_fIsNewPlayControl;
extern BOOL g_fIsUseMs;
extern BOOL g_fIsAutoTipHit;
extern BOOL g_fPlayTimeFieldExist;
extern BOOL g_fRemainTimeFieldExist;


BOOL ConvertPredefinedField(LPCTSTR pszFaceFileName, LPCTSTR pszField)
{
	int i = GetPredefinedFieldParam(pszFaceFileName, pszField);
	if (i < 0)
	{
		return FALSE;
	}

	if (lpButtonParam[i].pszCategory[0])
	{
		if (lpButtonParam[i].pszCommand[0])
		{
			WritePrivateProfileString(pszField, TEXT("Command"), lpButtonParam[i].pszCommand, g_szDestFileName);
		}
		if (lpButtonParam[i].pszCommandParamType[0])
		{
			WritePrivateProfileString(pszField, TEXT("CommandParamType"), lpButtonParam[i].pszCommandParamType, g_szDestFileName);
		}
		if (lpButtonParam[i].pszCommandParam[0])
		{
			WritePrivateProfileString(pszField, TEXT("CommandParam"), lpButtonParam[i].pszCommandParam, g_szDestFileName);
		}
		if (lpButtonParam[i].pszTypeString[0])
		{
			WritePrivateProfileString(pszField, TEXT("Type"), lpButtonParam[i].pszTypeString, g_szDestFileName);
		}
		if (lpButtonParam[i].pszViewTypeString[0])
		{
			WritePrivateProfileString(pszField, TEXT("ViewType"), lpButtonParam[i].pszViewTypeString, g_szDestFileName);
		}
		if (lpButtonParam[i].pszCategory[0])
		{
			WritePrivateProfileString(pszField, TEXT("Category"), lpButtonParam[i].pszCategory, g_szDestFileName);
		}
		if (lpButtonParam[i].pszFormatString[0])
		{
			WritePrivateProfileString(pszField, TEXT("FormatString"), lpButtonParam[i].pszFormatString, g_szDestFileName);
		}
	}
	else
	{
		_tprintf(TEXT("T|[gÕACeH %s\n"), pszField);
		return FALSE;
	}

	if (g_fIsNewPlayControl)
	{
		if (_tcsicmp(pszField, TEXT("Play")) == 0)
		{
			WritePrivateProfileString(pszField, TEXT("ViewType"), TEXT("Stopping"), g_szDestFileName);
		}
		else if (_tcsicmp(pszField, TEXT("Stop")) == 0)
		{
			WritePrivateProfileString(pszField, TEXT("ViewType"), TEXT("NotStopping"), g_szDestFileName);
		}
		else if (_tcsicmp(pszField, TEXT("Suspend")) == 0)
		{
			WritePrivateProfileString(pszField, TEXT("ViewType"), TEXT("NotSuspending"), g_szDestFileName);
		}
		else if (_tcsicmp(pszField, TEXT("Resume")) == 0)
		{
			WritePrivateProfileString(pszField, TEXT("ViewType"), TEXT("Suspending"), g_szDestFileName);
		}
	}

	if (g_fIsUseMs)
	{
		if (_tcsicmp(pszField, TEXT("TotalTime")) == 0)
		{
			WritePrivateProfileString(pszField, TEXT("Type"), TEXT("TotalTimeMs"), g_szDestFileName);
		}
		else if (_tcsicmp(pszField, TEXT("PlayTime")) == 0)
		{
			WritePrivateProfileString(pszField, TEXT("Type"), TEXT("PlayTimeMs"), g_szDestFileName);
		}
		else if (_tcsicmp(pszField, TEXT("RemainTime")) == 0)
		{
			WritePrivateProfileString(pszField, TEXT("Type"), TEXT("RemainTimeMs"), g_szDestFileName);
		}
/*		else if (_tcsicmp(pszField, TEXT("ListPlayTime")) == 0)
		{
			WritePrivateProfileString(pszField, TEXT("Type"), TEXT("ListTotalTimeMs"), g_szDestFileName);
		}
*/
	}

	if (g_fIsAutoTipHit)
	{
		WritePrivateProfileString(pszField, TEXT("TipHint"), lpszButtonText[i], g_szDestFileName);
	}

	if (_tcsicmp(pszField, TEXT("PlayTime")) == 0)
	{
		g_fPlayTimeFieldExist = TRUE;
	}
	else if (_tcsicmp(pszField, TEXT("RemainTime")) == 0)
	{
		g_fRemainTimeFieldExist = TRUE;
	}

	if (_tcsicmp(pszField, TEXT("Seek")) == 0 || _tcsicmp(pszField, TEXT("VolumeBar")) == 0 || _tcsicmp(pszField, TEXT("PanControl")) == 0)
	{
		WritePrivateProfileBool(pszField, TEXT("Enable"), TRUE, g_szDestFileName);
	}

	return TRUE;
}

int GetPredefinedFieldParam(LPCTSTR pszFaceFileName, LPCTSTR pszField)
{
	int i;

	for (i = 0; i < NV_BUTTONMAX; i++)
	{
		if (_tcsicmp(pszField, lpszButtonName[i]) == 0)
		{
			break;
		}
	}
	if (i >= NV_BUTTONMAX)
	{
		_tprintf(TEXT("m̃ACe %s\n"), pszField);
		return -1;
	}

	return i;
}

