#include "main.h"
#include "Resource_Lilith.h"


//TCHAR g_szSrcFileName[READ_BUF_LEN];
TCHAR g_szDestFileName[READ_BUF_LEN];
CLSID g_EncoderId;
BOOL g_fIsNewPlayControl = FALSE;
BOOL g_fIsNewButtonControl = FALSE;
BOOL g_fIsUseMs = FALSE;
BOOL g_fIsAutoTipHit = TRUE;
BOOL g_fIsExistAnalyzerOnOff = FALSE;
_tstring g_astNextFace[5];

BOOL g_fPlayTimeFieldExist = FALSE;
BOOL g_fRemainTimeFieldExist = FALSE;
TCHAR g_szSrcFolder[READ_BUF_LEN];
TCHAR g_szDestFolder[READ_BUF_LEN];



int _tmain(int argc, TCHAR *argv[])
{
	_tsetlocale(LC_ALL, TEXT("japanese"));
	if (argc < 2)
	{
		_tprintf(TEXT("exe ɃtFCXt@C̓tH_ D&D ĂˁB\n"));
		_tprintf(TEXT("L[ƏI܂B\n"));
		_getch();
		return -1;
	}

	Gdiplus::Status status = Gdiplus::GenericError;
	ULONG_PTR token = NULL;
	Gdiplus::GdiplusStartupInput si(NULL, FALSE, FALSE);
	Gdiplus::GdiplusStartupOutput so;

	status = Gdiplus::GdiplusStartup(&token, &si, &so);

	if (GetEncoderClsid(L"image/png", &g_EncoderId) < 0)
	{
		_tprintf(TEXT("PNG GR[_܂B\n"));
		_tprintf(TEXT("L[ƏI܂B\n"));
		_getch();
		return -2;
	}

	{
		if (! (GetFileAttributes(argv[1]) & FILE_ATTRIBUTE_DIRECTORY))
		{
			_tprintf(TEXT("tFCX`t@CP̂ł͂ȂAetH_w肵ĂB\n"));
			_tprintf(TEXT("L[ƏI܂B\n"));
			_getch();
			return -3;
		}
		_tcscpy_s(g_szSrcFolder, READ_BUF_LEN, argv[1]);
		_tcscpy_s(g_szDestFolder, READ_BUF_LEN, argv[1]);
		_tcscat_s(g_szDestFolder, READ_BUF_LEN, TEXT("_uLilith"));

		NVCreateDirectory(g_szDestFolder);
	}

	ConvertFolder(g_szSrcFolder);

	_tprintf(TEXT("L[ƏI܂B\n"));
	_getch();
	return 0;
}


int GetEncoderClsid(const WCHAR* format, CLSID* pClsid)
{
   UINT  num = 0;          // number of image encoders
   UINT  size = 0;         // size of the image encoder array in bytes

   Gdiplus::ImageCodecInfo* pImageCodecInfo = NULL;

   Gdiplus::GetImageEncodersSize(&num, &size);
   if(size == 0)
      return -1;  // Failure

   pImageCodecInfo = (Gdiplus::ImageCodecInfo*)(malloc(size));
   if(pImageCodecInfo == NULL)
      return -1;  // Failure

   GetImageEncoders(num, size, pImageCodecInfo);

   for(UINT j = 0; j < num; ++j)
   {
      if( wcscmp(pImageCodecInfo[j].MimeType, format) == 0 )
      {
         *pClsid = pImageCodecInfo[j].Clsid;
         free(pImageCodecInfo);
         return j;  // Success
      }    
   }

   free(pImageCodecInfo);
   return -1;  // Failure
}


BOOL ConvertFolder(LPCTSTR pszSrcFolder)
{
	TCHAR szFileName[READ_BUF_LEN];
	HANDLE hffd;
	WIN32_FIND_DATA ffd;

	_tcscpy_s(szFileName, READ_BUF_LEN, pszSrcFolder);
	PathAppend(szFileName, TEXT("*"));
	hffd = FindFirstFile(szFileName, &ffd);

	if (hffd && hffd != INVALID_HANDLE_VALUE)
	{
		do
		{
			if (_tcsicmp(ffd.cFileName, TEXT(".")) != 0 && _tcsicmp(ffd.cFileName, TEXT("..")) != 0)
			{
				_tcscpy_s(szFileName, READ_BUF_LEN, pszSrcFolder);
				PathAppend(szFileName, ffd.cFileName);

				if (ffd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
				{
					ConvertFolder(szFileName);
				}
				else
				{
					TCHAR szReadBuf[READ_BUF_LEN];

					GetPrivateProfileString(TEXT("Window"), TEXT("Image"), TEXT(""), szReadBuf, READ_BUF_LEN, szFileName);
					if (szReadBuf[0])
					{
						TCHAR szTemp[READ_BUF_LEN];

						_tcscpy_s(szTemp, READ_BUF_LEN, szFileName);
						PathRemoveFileSpec(szTemp);
						PathAppend(szTemp, szReadBuf);
						int t = GetFileAttributes(szTemp);
						if (t != INVALID_FILE_ATTRIBUTES)
						{
							ConvertFile(szFileName);
						}
					}
				}
			}
		} while (FindNextFile(hffd, &ffd));
		FindClose(hffd);
	}

	return NV_OK;
}

BOOL ConvertFile(LPCTSTR pszFaceFileName)
{
	g_fIsNewPlayControl = FALSE;
	g_fIsNewButtonControl = FALSE;
	g_fIsUseMs = FALSE;
	g_fIsAutoTipHit = TRUE;

	_tcscpy_s(g_szDestFileName, READ_BUF_LEN, pszFaceFileName);
	ConvertSrcToDestFileName(g_szDestFileName, READ_BUF_LEN);
	{
		int i;
		for (i = 0; i < 5; i++)
		{
			g_astNextFace[i].clear();
		}
	}

	g_fPlayTimeFieldExist = FALSE;
	g_fRemainTimeFieldExist = FALSE;
	g_fIsExistAnalyzerOnOff = FALSE;

	WritePrivateProfileString(TEXT("Preference"), TEXT("Signature"), TEXT("uLilith Face File"), g_szDestFileName);

	{
		TCHAR szReadBuf[READ_BUF_LEN];

		GetPrivateProfileString(TEXT("Preference"), TEXT("FaceName"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
		if (szReadBuf[0])
		{
			WritePrivateProfileString(TEXT("Preference"), TEXT("FaceName"), szReadBuf, g_szDestFileName);
		}
		else
		{
			WritePrivateProfileString(TEXT("Preference"), TEXT("FaceName"), PathFindFileName(pszFaceFileName), g_szDestFileName);
		}
		GetPrivateProfileString(TEXT("Preference"), TEXT("DefaultMessage"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
		if (szReadBuf[0])
		{
			WritePrivateProfileString(TEXT("Preference"), TEXT("DefaultMessage"), szReadBuf, g_szDestFileName);
		}

		g_fIsNewPlayControl = GetPrivateProfileBool(TEXT("Preference"), TEXT("NewPlayControl"), FALSE, pszFaceFileName);
		GetPrivateProfileString(TEXT("Preference"), TEXT("NextFace"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
		g_astNextFace[0] = szReadBuf;
		GetPrivateProfileString(TEXT("Preference"), TEXT("NextFace2"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
		g_astNextFace[1] = szReadBuf;
		GetPrivateProfileString(TEXT("Preference"), TEXT("NextFace3"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
		g_astNextFace[2] = szReadBuf;
		GetPrivateProfileString(TEXT("Preference"), TEXT("NextFace4"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
		g_astNextFace[3] = szReadBuf;
		GetPrivateProfileString(TEXT("Preference"), TEXT("NextFace5"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
		g_astNextFace[4] = szReadBuf;
		g_fIsNewButtonControl = GetPrivateProfileBool(TEXT("Preference"), TEXT("NewButtonControl"), FALSE, pszFaceFileName);
		g_fIsUseMs = GetPrivateProfileBool(TEXT("Preference"), TEXT("UseMiliSecTime"), FALSE, pszFaceFileName);
		g_fIsAutoTipHit = GetPrivateProfileBool(TEXT("Preference"), TEXT("AutoTipHint"), TRUE, pszFaceFileName);
		WritePrivateProfileString(TEXT("Preference"), TEXT("UseWindowRegion"), TEXT("TRUE"), g_szDestFileName);
	}

	LPTSTR pszKey;
	LPTSTR pszCur;
	TCHAR szReadBuf[READ_BUF_LEN];

	pszKey = (LPTSTR) _malloca(LOADFACE_KEY_BUFSIZE + 1);
	GetPrivateProfileString(NULL, NULL, TEXT(""), pszKey, LOADFACE_KEY_BUFSIZE, pszFaceFileName);

	pszCur = pszKey;
	while (pszCur[0])
	{
		if (_tcsicmp(pszCur, TEXT("Window")) == 0)
		{
			ConvertBaseWindow(pszFaceFileName);
		}
		else if (_tcsicmp(pszCur, TEXT("Template")) == 0)
		{
			_tprintf(TEXT("ev[g@\́AuLilith ł͎Ă܂B\n(ɁAGlogalOffset L[gāA悤ȂƂo܂B\n"));
		}
		else if (_tcsicmp(pszCur, TEXT("Preference")) != 0)
		{
			__int64 flags = GetFlags(pszFaceFileName, pszCur);
			GetPrivateProfileString(pszCur, TEXT("Category"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
			if (_tcsicmp(szReadBuf, TEXT("UserItem")) == 0)
			{
				if (flags & NVBUTTON_IMAGE)
				{
					WritePrivateProfileString(pszCur, TEXT("Category"), TEXT("DynamicImage"), g_szDestFileName);
					ConvertImageButton(pszFaceFileName, pszCur);
					ConvertCommand(pszFaceFileName, pszCur);
					ConvertTipHint(pszFaceFileName, pszCur);
				}
				else if (flags & NVBUTTON_CAPTION)
				{
					WritePrivateProfileString(pszCur, TEXT("Category"), TEXT("DynamicString"), g_szDestFileName);
					ConvertCaption(pszFaceFileName, pszCur);
					ConvertCommand(pszFaceFileName, pszCur);
					ConvertTipHint(pszFaceFileName, pszCur);
				}
				else
				{
					_tprintf(TEXT("C[WłłȂACe %s ܂\n"), pszCur);
				}
			}
			else if (_tcsicmp(szReadBuf, TEXT("PlayList")) == 0)
			{
				ConvertDockingPlayList(pszFaceFileName, pszCur);
			}
			else
			{
				int index = GetPredefinedFieldParam(pszFaceFileName, pszCur);
				if (index < 0)
				{
					_tprintf(TEXT("`ς݃tB[h %s ܂B\n"), pszCur);
				}
				else
				{
					if (_tcsicmp(pszCur, TEXT("Analyzer")) == 0)
					{
						ConvertAnalyzer(pszFaceFileName, pszCur);
						ConvertCommand(pszFaceFileName, pszCur);
						ConvertTipHint(pszFaceFileName, pszCur);
					}
					else if (_tcsicmp(lpButtonParam[index].pszCategory, TEXT("StaticImage")) == 0 || _tcsicmp(lpButtonParam[index].pszCategory, TEXT("DynamicImage")) == 0)
					{
						WritePrivateProfileString(pszCur, TEXT("Category"), TEXT("DynamicImage"), g_szDestFileName);
						ConvertImageButton(pszFaceFileName, pszCur);
						ConvertPredefinedField(pszFaceFileName, pszCur);
						ConvertTipHint(pszFaceFileName, pszCur);
						ConvertCommand(pszFaceFileName, pszCur);
					}
					else if (_tcsicmp(lpButtonParam[index].pszCategory, TEXT("StaticString")) == 0 || _tcsicmp(lpButtonParam[index].pszCategory, TEXT("DynamicString")) == 0)
					{
						ConvertCaption(pszFaceFileName, pszCur);
						WritePrivateProfileString(pszCur, TEXT("Category"), TEXT("DynamicString"), g_szDestFileName);
						ConvertPredefinedField(pszFaceFileName, pszCur);
						ConvertTipHint(pszFaceFileName, pszCur);
						ConvertCommand(pszFaceFileName, pszCur);
					}
					else
					{
						if (lpButtonParam[index].pszCategory[0])
						{
							_tprintf(TEXT("C[WłłȂACe %s ܂\n"), pszCur);
						}
						else
						{
							_tprintf(TEXT("tB[h %s F %s\n"), pszCur, lpButtonParam[index].pszCommand);
						}
					}
				}
			}
		}

		pszCur += _tcslen(pszCur) + 1;
	}
	_freea(pszKey);

	if ((g_fPlayTimeFieldExist && g_fRemainTimeFieldExist) || g_fIsExistAnalyzerOnOff)
	{
		if ((g_fPlayTimeFieldExist && g_fRemainTimeFieldExist) && g_fIsExistAnalyzerOnOff)
		{
			WritePrivateProfileInt(TEXT("Preference"), TEXT("InitCommandCount"), 2, g_szDestFileName);
			WritePrivateProfileString(TEXT("Preference"), TEXT("Command1"), TEXT("HideItem"), g_szDestFileName);
			WritePrivateProfileString(TEXT("Preference"), TEXT("CommandParamType1"), TEXT("String"), g_szDestFileName);
			WritePrivateProfileString(TEXT("Preference"), TEXT("CommandParam1"), TEXT("RemainTime"), g_szDestFileName);
			WritePrivateProfileString(TEXT("Preference"), TEXT("Command2"), TEXT("HideItem"), g_szDestFileName);
			WritePrivateProfileString(TEXT("Preference"), TEXT("CommandParamType2"), TEXT("String"), g_szDestFileName);
			WritePrivateProfileString(TEXT("Preference"), TEXT("CommandParam2"), TEXT("AnalyzerOff"), g_szDestFileName);
		}
		else
		{
			WritePrivateProfileInt(TEXT("Preference"), TEXT("InitCommandCount"), 1, g_szDestFileName);
			if (g_fPlayTimeFieldExist && g_fRemainTimeFieldExist)
			{
				WritePrivateProfileString(TEXT("Preference"), TEXT("Command1"), TEXT("HideItem"), g_szDestFileName);
				WritePrivateProfileString(TEXT("Preference"), TEXT("CommandParamType1"), TEXT("String"), g_szDestFileName);
				WritePrivateProfileString(TEXT("Preference"), TEXT("CommandParam1"), TEXT("RemainTime"), g_szDestFileName);
			}
			else if (g_fIsExistAnalyzerOnOff)
			{
				WritePrivateProfileString(TEXT("Preference"), TEXT("Command1"), TEXT("HideItem"), g_szDestFileName);
				WritePrivateProfileString(TEXT("Preference"), TEXT("CommandParamType1"), TEXT("String"), g_szDestFileName);
				WritePrivateProfileString(TEXT("Preference"), TEXT("CommandParam1"), TEXT("AnalyzerOff"), g_szDestFileName);
			}
		}

		int n = GetPrivateProfileInt(TEXT("PlayTime"), TEXT("CommandId"), -1, pszFaceFileName);
		int m = GetPrivateProfileInt(TEXT("RemainTime"), TEXT("CommandId"), -1, pszFaceFileName);
		if (n < 0 && m < 0)
		{
			WritePrivateProfileBool(TEXT("PlayTime"), TEXT("Enable"), TRUE, g_szDestFileName);
			WritePrivateProfileString(TEXT("PlayTime"), TEXT("Command"), TEXT("SwitchShowItem"), g_szDestFileName);
			WritePrivateProfileString(TEXT("PlayTime"), TEXT("CommandParamType"), TEXT("String"), g_szDestFileName);
			WritePrivateProfileString(TEXT("PlayTime"), TEXT("CommandParam"), TEXT("RemainTime"), g_szDestFileName);
			WritePrivateProfileBool(TEXT("RemainTime"), TEXT("Enable"), TRUE, g_szDestFileName);
			WritePrivateProfileString(TEXT("RemainTime"), TEXT("Command"), TEXT("SwitchShowItem"), g_szDestFileName);
			WritePrivateProfileString(TEXT("RemainTime"), TEXT("CommandParamType"), TEXT("String"), g_szDestFileName);
			WritePrivateProfileString(TEXT("RemainTime"), TEXT("CommandParam"), TEXT("PlayTime"), g_szDestFileName);
		}
	}

	return TRUE;
}


BOOL ConvertSrcToDestFileName(LPTSTR pszFileName, int nLength)
{
	TCHAR szRelativePath[READ_BUF_LEN];

	PathRelativePathTo(szRelativePath, g_szSrcFolder, FILE_ATTRIBUTE_DIRECTORY, pszFileName, FILE_ATTRIBUTE_NORMAL);

	_tcsncpy_s(pszFileName, nLength, g_szDestFolder, nLength - 1);
	PathAppend(pszFileName, szRelativePath);

	LPTSTR pszCur = pszFileName;
	while (pszCur = _tcschr(pszCur, TEXT('/')))
	{
		*pszCur = TEXT('\\');
	}
	NVCreateDirectoryFromFileName(pszFileName);
	return TRUE;
}


BOOL ConvertCommand(LPCTSTR pszFaceFileName, LPCTSTR pszField)
{
	int i;
	int nCommandId = GetPrivateProfileInt(pszField, TEXT("CommandID"), -1, pszFaceFileName);

	if (nCommandId >= 0)
	{
		for (i = 0; i < COMMAND_MAX; i++)
		{
			if (lpCommandTable[i].nCommandId == nCommandId)
			{
				break;
			}
		}

		if (i >= COMMAND_MAX)
		{
			_tprintf(TEXT("m̃R}h ID łB%d\n"), nCommandId);
			return FALSE;
		}

		if (! lpCommandTable[i].pszCommand[0])
		{
			_tprintf(TEXT("R}h ID : %d (%s) ͕ϊs\łB\nR}hp~ꂽAӖ̂ȂȂR}hłB\n"), nCommandId, lpCommandTable[i].pszCommandParam);
		}
		else
		{
			WritePrivateProfileString(pszField, TEXT("Command"), lpCommandTable[i].pszCommand, g_szDestFileName);
			if (lpCommandTable[i].pszCommandParamType[0])
			{
				WritePrivateProfileString(pszField, TEXT("CommandParamType"), lpCommandTable[i].pszCommandParamType, g_szDestFileName);
			}
			if (lpCommandTable[i].pszCommandParam[0])
			{
				WritePrivateProfileString(pszField, TEXT("CommandParam"), lpCommandTable[i].pszCommandParam, g_szDestFileName);
			}
		}
		switch (nCommandId)
		{
		case 40073:
			WritePrivateProfileString(pszField, TEXT("CommandParam"), g_astNextFace[0].c_str(), g_szDestFileName);
			break;
		case 40079:
			WritePrivateProfileString(pszField, TEXT("CommandParam"), g_astNextFace[1].c_str(), g_szDestFileName);
			break;
		case 40105:
			WritePrivateProfileString(pszField, TEXT("CommandParam"), g_astNextFace[2].c_str(), g_szDestFileName);
			break;
		case 40106:
			WritePrivateProfileString(pszField, TEXT("CommandParam"), g_astNextFace[3].c_str(), g_szDestFileName);
			break;
		case 40107:
			WritePrivateProfileString(pszField, TEXT("CommandParam"), g_astNextFace[4].c_str(), g_szDestFileName);
			break;
		}
	}

	return TRUE;
}

BOOL ConvertTipHint(LPCTSTR pszFaceFileName, LPCTSTR pszField)
{
	TCHAR szReadBuf[READ_BUF_LEN];

	GetPrivateProfileString(pszField, TEXT("TipHint"), TEXT(""), szReadBuf, READ_BUF_LEN, pszFaceFileName);
	if (szReadBuf[0])
	{
		WritePrivateProfileString(pszField, TEXT("TipHint"), szReadBuf, g_szDestFileName);
	}

	return TRUE;
}

BOOL WritePrivateProfileRelativePath(LPCTSTR pszAppName, LPCTSTR pszKeyName, LPCTSTR pszPath, LPCTSTR pszIniFile)
{
	TCHAR szRelativePath[READ_BUF_LEN];

	PathRelativePathTo(szRelativePath, pszIniFile, FILE_ATTRIBUTE_NORMAL, pszPath, FILE_ATTRIBUTE_NORMAL);
	return WritePrivateProfileString(pszAppName, pszKeyName, szRelativePath, pszIniFile);
}

