//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  NVAudioFileLibrary `t@C  for  NVAudioFileLibrary                                    //
//  NVAFLibDef.h                                                                                //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////




#pragma once



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "..\\NVLibCore\\NVLibCore.h"
#include "..\\NVFileLib\\NVFileLib.h"
#include <mmreg.h>
//#include <ks.h>
//#include <ksmedia.h>


#ifdef __cplusplus
extern "C" {
#endif



#pragma pack(push, 1)



/*  VCOM ̃_Ci~bN[ĥ݂ŉ̂ŁAKvȂ
#ifndef NVAFLIB_EXPORTS
#ifdef _DEBUG
	#pragma comment(lib, "..\\DebugLib\\NVAFLib.lib")
#else
	#pragma comment(lib, "..\\ReleaseLib\\NVAFLib.lib")
#endif
#endif
*/





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  }N̒`
//


//  DLLGNX|[gp
#define NVAFLIB_API __stdcall

#ifdef NVAFLIB_EXPORTS

#define NVAFLIB_CLASS_EXPORT __declspec(dllexport)
#define NVAFLIB_EXPORT
//#define NVAFLIB_EXPORT __declspec(dllexport)

#else

#define NVAFLIB_CLASS_EXPORT __declspec(dllimport)
#define NVAFLIB_EXPORT __declspec(dllimport)

#endif	//  #ifdef NVAFLIB_EXPORTS




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  ߂l̒`
//



//  INVAUDIOFILEp}N

#define VAFERR_                        0x3000
#define MAKE_VAFERR(name, value, flag) MAKE_NVERR((name), (VAFERR_ | (value)), (flag))
#define MAKE_VAFERR_VALUE(value) MAKE_NVERR_VALUE(VAFERR_ | (value))

//  0x3001   //  vꂽIy[V́A܂T|[gĂȂ
#define VAFERR_UNSUPPORTED                   MAKE_VAFERR(TEXT("VAFERR_UNSUPPORTED"), 0x01, NVERR_FATAL)
#define VAFERR_VALUE_UNSUPPORTED             MAKE_VAFERR_VALUE(0x01)

//  0x3002
#define VAFERR_ALREADYUSED                   MAKE_VAFERR(TEXT("VAFERR_ALREADYUSED"), 0x02, NVERR_FATAL)
#define VAFERR_VALUE_ALREADYUSED             MAKE_VAFERR_VALUE(0x02)

//  0x3003
#define VAFERR_INVALIDPARAMTYPE              MAKE_VAFERR(TEXT("VAFERR_INVALIDPARAMTYPE"), 0x03, NVERR_FATAL)
#define VAFERR_VALUE_INVALIDPARAMTYPE        MAKE_VAFERR_VALUE(0x03)

//  0x3004
#define VAFERR_INVALIDPARAMSIZE              MAKE_VAFERR(TEXT("VAFERR_INVALIDPARAMSIZE"), 0x04, NVERR_FATAL)
#define VAFERR_VALUE_INVALIDPARAMSIZE        MAKE_VAFERR_VALUE(0x04)

//  0x3005
#define VAFERR_INVALIDPARAM                  MAKE_VAFERR(TEXT("VAFERR_INVALIDPARAM"), 0x05, NVERR_FATAL)
#define VAFERR_VALUE_INVALIDPARAM            MAKE_VAFERR_VALUE(0x05)

//  0x3006
#define VAFERR_NOCREATE                      MAKE_VAFERR(TEXT("VAFERR_NOCREATE"), 0x06, NVERR_FATAL)
#define VAFERR_VALUE_NOCREATE                MAKE_VAFERR_VALUE(0x06)

//  0x3007
#define VAFERR_ENDOFDATA                     MAKE_VAFERR(TEXT("VAFERR_ENDOFDATA"), 0x07, NVERR_SAFE)
#define VAFERR_VALUE_ENDOFDATA               MAKE_VAFERR_VALUE(0x07)

//  0x3008
#define VAFERR_BUFFERTOOSMALL                MAKE_VAFERR(TEXT("VAFERR_BUFFERTOOSMALL"), 0x08, NVERR_FATAL)
#define VAFERR_VALUE_BUFFERTOOSMALL          MAKE_VAFERR_VALUE(0x08)

//  0x300B
#define VAFERR_UNKNOWNFOURCC                 MAKE_VAFERR(TEXT("VAFERR_UNKNOWNFOURCC"), 0x0B, NVERR_FATAL)
#define VAFERR_VALUE_UNKNOWNFOURCC           MAKE_VAFERR_VALUE(0x0B)

//  0x30FF
#define VAFERR_ERRORRECOVERED                MAKE_VAFERR(TEXT("VAFERR_ERRORRECOVERED"), 0xFF, NVERR_SAFE)
#define VAFERR_VALUE_ERRORRECOVERED          MAKE_VAFERR_VALUE(0xFF)



#pragma pack(pop)



#ifdef __cplusplus
}
#endif
