//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  AudioFile Decompression W[ \[Xt@C  for  NVAudioFileLibrary                  //
//  NVAudioFile.cpp                                                                             //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "NVAudioFile.h"



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̒`
//


NVRESULT NVAFLIB_EXPORT NVAFLIB_API CreateInstance_NVAudioFile(LPIVCOM lpivcom)
{
	//  CX^X̍쐬
	//  vtable Kv̂ŁAnew ZqoRŃAP[VB

	if (! lpivcom)
	{
		return NVERR_UNDEFINED;
	}

	*lpivcom = (IVCOM) new Class_NVAudioFile;
	if (*lpivcom)
	{
		return NV_OK;
	}
	else
	{
		return NVERR_UNDEFINED;
	}
}




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  o֐̐錾  Class_NVAudioFile
//



Class_NVAudioFile::Class_NVAudioFile(void)
{
//  ftHgRXgN^

	//  {NX̕ێf[^ݒ肷BRXgN^͊{NX珇ԂɌĂяôŁA
	//  ŌɌĂяo邱ƂɂȂACX^X̃IWǐ^݂̏̂cB
	//  ]ȏ̂ŃI[o[wbh邪AdldƁB
	Class_VCOM::SetCoreData((LPVOID) this, (DWORD) sizeof(Class_NVAudioFile), NVAUDIOFILE_FOURCC);

	//  ێf[^͖̏B

	return;
}


Class_NVAudioFile::~Class_NVAudioFile(void)
{
//  fXgN^

	//  Release oRȊOĂяoƁAvcd.bIsCreated  TRUE ł邱ƂB
	//  ̏ꍇAȉsĂȂ͂Ȃ̂ŁAASSERT B
	assert(! vcd.bIsCreated);

	return;
}


NVRESULT Class_NVAudioFile::Create(LPCVOID lpvParam)
{
//  CX^X̏

	//  _~[NXȂ̂ŁÃ\bh͌Ă΂Ȃ͂B
	//  ɕԂB

	return VAFERR_UNSUPPORTED;
}


NVRESULT Class_NVAudioFile::ResetData(void)
{
//  CX^X̃f[^Zbg

	//  ێf[^OZbg

	if (nvafd.lpnvafcm)
	{
		NVMemFree(nvafd.lpnvafcm);
	}
	ZeroMemory(&nvafd, sizeof(NVAUDIOFILEDATA));
	//  eNX ResetData Ɉp
	return Class_VCOM::ResetData();
}


NVRESULT Class_NVAudioFile::QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface)
{
//  C^[tF[X̎擾

	//  dwFourCC ɂāAKȌ^̃C^[tF[XԂB
	//  ǧ^̃C^[tF[X̍쐬ȊÓAeNX̃\bhĂԂƂŉƗǂƎvB

	if (dwFourCC == NVAUDIOFILE_FOURCC)
	{
		//  ̃NX̃C^[tF[X擾Ȃ̂ŁAԂli[AAddRef() ƂɐIB
		*lpvInterface = (INVAUDIOFILE) this;
		AddRef();
		return NV_OK;
	}
	else
	{
		//  ǧ^ȊÓAeNXɔC
		return Class_VCOM::QueryInterface(dwFourCC, lpvInterface);
	}
}


NVRESULT Class_NVAudioFile::AddInterface(DWORD dwFlag)
{
//  C^[tF[XQƃe[uɓo^

	//  CX^Xɑ΂ŏ̂P̌Ăяoł́A
	//  dwFlag ɂ VCOM_CLASSINTERFACE ĂB
	//  ȍ~̌Ăяoł́AOĂB
	VAddInterface(this, (IVCOM) this, NVAUDIOFILE_FOURCC, dwFlag);

	//  eNX̃\bhɈp
	//  ̂ƂAdwFlag ɂ Ow肷B
	return Class_VCOM::AddInterface(0);
}


NVRESULT Class_NVAudioFile::DeleteInterface(void)
{
//  C^[tF[XQƃe[u폜

	VDeleteInterface(this);

	//  eNX̃\bhɈp
	return Class_VCOM::DeleteInterface();
}


NVRESULT Class_NVAudioFile::GetInfo(DWORD dwFourCC, LPVOID lpvInfo, LPDWORD lpdwSize)
{
//  tH[}bgƎ̊g擾

	//  _~[NXȂ̂ŁÃ\bh͌Ă΂Ȃ͂B
	//  ɕԂB

	*lpdwSize = 0;

	return VAFERR_UNSUPPORTED;
}


NVRESULT Class_NVAudioFile::GetComment(DWORD dwFourCC, LPVOID lpvInfo, LPDWORD lpdwSize)
{
//  ȖȂǂ̃Rg擾

	if (dwFourCC == NVAUDIOFILE_FOURCC)
	{
		if (nvafd.lpnvafcm)
		{
			if (lpvInfo)
			{
				if (*lpdwSize < nvafd.lpnvafcm->dwObjSize)
				{
					*lpdwSize = nvafd.lpnvafcm->dwObjSize;
					return VAFERR_BUFFERTOOSMALL;
				}
				else
				{
					CopyMemory(lpvInfo, nvafd.lpnvafcm, nvafd.lpnvafcm->dwObjSize);
					*lpdwSize = nvafd.lpnvafcm->dwObjSize;
					return NV_OK;
				}
			}
			else
			{
				*lpdwSize = nvafd.lpnvafcm->dwObjSize;
				return NV_OK;
			}
		}
		else
		{
			if (lpvInfo)
			{
				if (*lpdwSize < sizeof(NVAUDIOFILECOMMENT))
				{
					*lpdwSize = sizeof(NVAUDIOFILECOMMENT);
					return VAFERR_BUFFERTOOSMALL;
				}
				else
				{
					LPNVAUDIOFILECOMMENT lpafcm = (LPNVAUDIOFILECOMMENT) lpvInfo;

					ZeroMemory(lpvInfo, *lpdwSize);
					lpafcm->dwFourCC = NVAUDIOFILE_FOURCC;
					lpafcm->dwObjSize = sizeof(NVAUDIOFILECOMMENT);
					lpafcm->lOffsetArtist = 0;
					lpafcm->lOffsetTitle = 0;
					lpafcm->lOffsetAlbum = 0;
					lpafcm->lOffsetDate = 0;
					lpafcm->lOffsetTrackNumber = 0;
					lpafcm->lOffsetGenre = 0;
					lpafcm->lOffsetComment = 0;
					lpafcm->szString[0] = TEXT('\0');
					*lpdwSize = sizeof(NVAUDIOFILECOMMENT);
					return NV_OK;
				}
			}
			else
			{
				*lpdwSize = sizeof(NVAUDIOFILECOMMENT);
				return NV_OK;
			}
		}
	}

	return VAFERR_UNSUPPORTED;
}


NVRESULT Class_NVAudioFile::GetPCMWaveFormat(LPPCMWAVEFORMAT lppcmwf)
{
//  fR[hf[^̃tH[}bg擾

	//  _~[NXȂ̂ŁÃ\bh͌Ă΂Ȃ͂B
	//  ɕԂB

	return VAFERR_UNSUPPORTED;
}


NVRESULT Class_NVAudioFile::DecodeToPCMData(LPVOID lpBuffer, LONG lBufferSize, LPLONG lplResultSize)
{
//  f[^fR[hA󂯎

	//  _~[NXȂ̂ŁÃ\bh͌Ă΂Ȃ͂B
	//  ɕԂB

	*lplResultSize = 0;

	return VAFERR_UNSUPPORTED;
}

NVRESULT Class_NVAudioFile::Rewind(void)
{
//  f[^擪܂Ŋ߂

	//  _~[NXȂ̂ŁÃ\bh͌Ă΂Ȃ͂B
	//  ɕԂB

	return VAFERR_UNSUPPORTED;
}

NVRESULT Class_NVAudioFile::FileInfoDialog(HWND hwnd)
{
//  t@C̃_CAO\

	//  _~[NXȂ̂ŁÃ\bh͌Ă΂Ȃ͂B
	//  ɕԂB

	return VAFERR_UNSUPPORTED;
}

NVRESULT Class_NVAudioFile::GetCurrentPosition(LPQWUNION lpquPosition, DWORD dwFlag)
{
	//  _~[NXȂ̂ŁÃ\bh͌Ă΂Ȃ͂B
	//  ɕԂB

	return VAFERR_UNSUPPORTED;
}


NVRESULT Class_NVAudioFile::SetCurrentPosition(QWUNION quPosition, DWORD dwFlag)
{
	//  _~[NXȂ̂ŁÃ\bh͌Ă΂Ȃ͂B
	//  ɕԂB

	return VAFERR_UNSUPPORTED;
}

NVRESULT Class_NVAudioFile::ReferenceTimeToSamples(QWUNION quReferenceTime, LPQWUNION lpquSamples)
{
//  QƎ(}CNbP)Tv֕ϊ
	if (! vcd.bIsCreated)
	{
		return VAFERR_NOCREATE;
	}

	PCMWAVEFORMAT pcmwf;
	if (GetPCMWaveFormat(&pcmwf) == NV_OK)
	{
		lpquSamples->ql = NVMulDiv64(quReferenceTime.ql ,pcmwf.wf.nSamplesPerSec, 1000 * 1000);
		return NV_OK;
	}

	return VAFERR_UNSUPPORTED;
}

NVRESULT Class_NVAudioFile::SamplesToReferenceTime(QWUNION quSamples, LPQWUNION lpquReferenceTime)
{
//  TvQƎ(}CNbP)֕ϊ
	if (! vcd.bIsCreated)
	{
		return VAFERR_NOCREATE;
	}

	PCMWAVEFORMAT pcmwf;
	if (GetPCMWaveFormat(&pcmwf) == NV_OK)
	{
		lpquReferenceTime->ql = NVMulDiv64(quSamples.ql, 1000 * 1000, pcmwf.wf.nSamplesPerSec);
		return NV_OK;
	}

	return VAFERR_UNSUPPORTED;
}

NVRESULT Class_NVAudioFile::GetReferenceTime(LPQWUNION lpquReferenceTime)
{
	//  ݂̎QƎ(}CNbP)擾
	if (! vcd.bIsCreated)
	{
		return VAFERR_NOCREATE;
	}

	return VAFERR_UNSUPPORTED;
}

NVRESULT Class_NVAudioFile::GetTotalTime(LPQWUNION lpquTotalTime)
{
	//  }CNbPʂőSĐԂ擾
	if (! vcd.bIsCreated)
	{
		return VAFERR_NOCREATE;
	}

	return VAFERR_UNSUPPORTED;
}
