//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  AudioFile Compression W[ \[Xt@C  for  NVAudioFileLibrary                    //
//  VSSEncoder.cpp                                                                              //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "VSSEncoder.h"



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̒`
//


NVRESULT NVAFLIB_EXPORT NVAFLIB_API CreateInstance_VSSEncoder(LPIVCOM lpivcom)
{
	//  CX^X̍쐬
	//  vtable Kv̂ŁAnew ZqoRŃAP[VB

	if (! lpivcom)
	{
		return NVERR_UNDEFINED;
	}

	*lpivcom = (IVCOM) new Class_VSSEncoder;
	if (*lpivcom)
	{
		return NV_OK;
	}
	else
	{
		return NVERR_UNDEFINED;
	}
}




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  o֐̐錾  Class_VSSEncoder
//



Class_VSSEncoder::Class_VSSEncoder(void)
{
//  ftHgRXgN^

	//  {NX̕ێf[^ݒ肷BRXgN^͊{NX珇ԂɌĂяôŁA
	//  ŌɌĂяo邱ƂɂȂACX^X̃IWǐ^݂̏̂cB
	//  ]ȏ̂ŃI[o[wbh邪AdldƁB
	Class_VCOM::SetCoreData((LPVOID) this, (DWORD) sizeof(Class_VSSEncoder), VSSENCODER_FOURCC);

	//  ێf[^͖̏B

	return;
}


Class_VSSEncoder::~Class_VSSEncoder(void)
{
//  fXgN^

	//  Release oRȊOĂяoƁAvcd.bIsCreated  TRUE ł邱ƂB
	//  ̏ꍇAȉsĂȂ͂Ȃ̂ŁAASSERT B
	assert(! vcd.bIsCreated);

	return;
}


NVRESULT Class_VSSEncoder::Create(LPCVOID lpvParam)
{
//  CX^X̏

	//  _~[NXȂ̂ŁÃ\bh͌Ă΂Ȃ͂B
	//  ɕԂB

	return VAFERR_UNSUPPORTED;
}


NVRESULT Class_VSSEncoder::ResetData(void)
{
//  CX^X̃f[^Zbg

	//  ێf[^OZbg
	if (vssed.invaf)
	{
		vssed.invaf->Release();
	}

	if (vssed.invst)
	{
		vssed.invst->Release();
	}

	if (vssed.lpnvafc)
	{
		NVMemFree((HNVMEM)vssed.lpnvafc);
	}

	if (vssed.lpvParam)
	{
		FreeParam((LPVOID) vssed.lpvParam);
	}
	//  eNX ResetData Ɉp
	return Class_VCOM::ResetData();
}


NVRESULT Class_VSSEncoder::QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface)
{
//  C^[tF[X̎擾

	//  dwFourCC ɂāAKȌ^̃C^[tF[XԂB
	//  ǧ^̃C^[tF[X̍쐬ȊÓAeNX̃\bhĂԂƂŉƗǂƎvB

	if (dwFourCC == VSSENCODER_FOURCC)
	{
		//  ̃NX̃C^[tF[X擾Ȃ̂ŁAԂli[AAddRef() ƂɐIB
		*lpvInterface = (IVSSENCODER) this;
		AddRef();
		return NV_OK;
	}
	else
	{
		//  ǧ^ȊÓAeNXɔC
		return Class_VCOM::QueryInterface(dwFourCC, lpvInterface);
	}
}


NVRESULT Class_VSSEncoder::AddInterface(DWORD dwFlag)
{
//  C^[tF[XQƃe[uɓo^

	//  CX^Xɑ΂ŏ̂P̌Ăяoł́A
	//  dwFlag ɂ VCOM_CLASSINTERFACE ĂB
	//  ȍ~̌Ăяoł́AOĂB
	VAddInterface(this, (IVCOM) this, VSSENCODER_FOURCC, dwFlag);

	//  eNX̃\bhɈp
	//  ̂ƂAdwFlag ɂ Ow肷B
	return Class_VCOM::AddInterface(0);
}


NVRESULT Class_VSSEncoder::DeleteInterface(void)
{
//  C^[tF[XQƃe[u폜

	VDeleteInterface(this);

	//  eNX̃\bhɈp
	return Class_VCOM::DeleteInterface();
}


NVRESULT Class_VSSEncoder::ProcessData(void)
{
	//  _~[NXȂ̂ŁÃ\bh͌Ă΂Ȃ͂B
	//  ɕԂB

	return VAFERR_UNSUPPORTED;
}

NVRESULT Class_VSSEncoder::FreeParam(LPVOID lpvEncParam)
{
	//  _~[NXȂ̂ŁÃ\bh͌Ă΂Ȃ͂B
	//  ɕԂB

	return VAFERR_UNSUPPORTED;
}

