//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  AudioFile compression W[ wb_[t@C  for  NVAudioFileLibrary				    //
//  VSSEncoder.h                                                                                //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



#pragma once




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "NVAFLibDef.h"
#include "..\\NVFileLib\\NVFileLib.h"
#include "NVAudioFile.h"


#ifdef __cplusplus
extern "C" {
#endif


#pragma pack(push, 1)





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  }N̐錾
//


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  \̂̐錾
//


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  NX̒`  :  IVSSENCODER
//


//  NXʎq
#define VSSENCODER_FOURCC MAKEFOURCC('V', 'S', 'S', 'E')


/*  IVSSENCODER NXWXg (VCOM.ini ւ̋Lq)
[VSSE]

Class_ID = "VSSE"
Module_Name = "NVAFLib.dll"
Entry_Point = "CreateInstance_VSSEncoder"
Dependence = ""IPP.dll""
*/


class Class_VSSEncoder;
typedef Class_VSSEncoder * IVSSENCODER;
typedef const Class_VSSEncoder * CIVSSENCODER;
typedef IVSSENCODER * LPIVSSENCODER;
typedef const IVSSENCODER * LPCIVSSENCODER;

typedef NVRESULT (WINAPI * VSSENCPROGRESS) (LPCVOID lpvProgressParam, QWORD qwTotalProgress);

//  IVSSENCODER ̏f[^
struct VSSENCODERCREATE
{
	DWORD dwFourCC;					//  NXʎq
	DWORD dwObjSize;				//  \̂̃TCY
	DWORD dwFlag;					//  tO
	INVAUDIOFILE invaf;				//  ̓Xg[
	INVSTREAM invst;				//  o̓Xg[
	LPCVOID lpvParam;				//  ϊp[^
	LPCNVAUDIOFILECOMMENT lpnvafc;	//  ݒ肷ׂRg
	VSSENCPROGRESS VSSEncProgress;	//  i󋵕\R[obN֐
	LPCVOID lpvProgressParam;		//  R[obN֐ɓn
};
typedef VSSENCODERCREATE * LPVSSENCODERCREATE;
typedef const VSSENCODERCREATE * LPCVSSENCODERCREATE;


//  IVSSENCODER ̕ێf[^
struct VSSENCODERDATA
{
	DWORD dwFlag;
	INVAUDIOFILE invaf;
	INVSTREAM invst;
	LPCVOID lpvParam;
	LPCNVAUDIOFILECOMMENT lpnvafc;
	VSSENCPROGRESS VSSEncProgress;
	LPCVOID lpvProgressParam;
};
typedef VSSENCODERDATA * LPVSSENCODERDATA;
typedef const VSSENCODERDATA * LPCVSSENCODERDATA;


class NVAFLIB_CLASS_EXPORT Class_VSSEncoder : virtual public Class_VCOM
{
	public:
		Class_VSSEncoder(void);
		//  ftHgRXgN^
		//
		//  SetCoreData() ĂяoāA{NXɃf[^ݒ肷B

	VCOM_CLASSMETHOD
		~Class_VSSEncoder(void);
		//  fXgN^
		//

	VCOM_CLASSMETHOD
		NVRESULT Create(LPCVOID lpvParam);
		//  CX^X̏
		//
		//  CX^XɃp[^^āACX^X̃f[^(쐬)B
		//  vcd.bIsCreated tO𗧂āAς݂`FbNs悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT ResetData(void);
		//  CX^X̃f[^Zbg
		//
		//  CX^XŗpȂǂACreate() ĂяoȌԂɖ߂B
		//  vcd.bIsCreated tOZbgAĂ Create() s悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface);
		//  C^[tF[X̎擾
		//
		//  DWORD dwFourCC			擾C^[tF[X
		//  LPVOID *lpvInterface	C^[tF[Xi[|C^
		//
		//  ̃CX^X́AdwFourCC Ŏw肵^̃C^[tF[X擾B
		//  擾łC^[tF[X́ACX^XɂĈقȂ邪A
		//  CX^XNX̃X[p[NXɂNX̃C^[tF[X
		//  K擾ł悤ɎȂ΂ȂȂB
		//  ̊֐ŕʂ̃C^[tF[X擾ƁA AddRef() ŝŁA
		//  ÂC^[tF[Xɑ΂Ă Release() KvB

	VCOM_CLASSMETHOD
		NVRESULT ProcessData(void);
	VCOM_CLASSMETHOD
		NVRESULT FreeParam(LPVOID lpvEncParam);

protected:
	VCOM_CLASSMETHOD
		NVRESULT AddInterface(DWORD dwFlag);
		//  C^[tF[XQƃe[uɓo^
		//
		//  DWORD dwFlag	NXCX^X̏ꍇPAȊO͂O
		//
		//  RXgN^̒ŌĂ΂AC^[tF[X|C^e[uɓo^A
		//  VIsValidInterface() ŃC^[tF[X̗L؂ł悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT DeleteInterface(void);
		//  C^[tF[XQƃe[u폜
		//
		//  DeleteInstance() ̒ŌĂ΂AC^[tF[X|C^e[u폜B
protected:
	VSSENCODERDATA vssed;
};



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̐錾
//

NVRESULT NVAFLIB_EXPORT NVAFLIB_API CreateInstance_VSSEncoder(LPIVCOM lpivcom);
//  CX^X̍쐬
//
//  IVSSENCODER CX^X쐬ÃC^[tF[XԂ


inline void SetVSSEncoderCreate(LPVSSENCODERCREATE lpvssec, DWORD dwFlag, INVAUDIOFILE invaf, INVSTREAM invst,
								LPCVOID lpvParam, LPCNVAUDIOFILECOMMENT lpnvafc,
								VSSENCPROGRESS VSSEncProgress, LPCVOID lpvProgressParam);
//  VSSENCODERCREATE \̏֐
//
//  LPVSSENCODERCREATE lpvssec		\
//  DWORD dwFlag					ZbgtO



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  CC֐̒`
//


inline void SetVSSEncoderCreate(LPVSSENCODERCREATE lpvssec, DWORD dwFlag, INVAUDIOFILE invaf, INVSTREAM invst,
								LPCVOID lpvParam, LPCNVAUDIOFILECOMMENT lpnvafc,
								VSSENCPROGRESS VSSEncProgress, LPCVOID lpvProgressParam)
{
	lpvssec->dwFourCC = VSSENCODER_FOURCC;
	lpvssec->dwObjSize = sizeof(VSSENCODERCREATE);
	lpvssec->dwFlag = dwFlag;
	lpvssec->invaf = invaf;
	lpvssec->invst = invst;
	lpvssec->lpvParam = lpvParam;
	lpvssec->lpnvafc = lpnvafc;
	lpvssec->VSSEncProgress = VSSEncProgress;
	lpvssec->lpvProgressParam = lpvProgressParam;

	return;
}


#pragma pack(pop)

#ifdef __cplusplus
}
#endif
