//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  COM ݊ o̓Xg[ NX  wb_[t@C  for  NVFileLibrary                      //
//  IStream.h                                                                                   //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////




#pragma once





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "NVStream.h"


#ifdef __cplusplus
extern "C" {
#endif

#pragma pack(push, 1)


//#define STREAM_SEEK_SETDELAY  0xFFFFFFFF
//#define STREAM_SEEK_DISABLEDELAY  0xFFFFFFFE


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  NX̒`      INVCOMSTREAM
//



class Class_NVComStream;
typedef Class_NVComStream * INVCOMSTREAM;
typedef const Class_NVComStream * CINVCOMSTREAM;
typedef INVCOMSTREAM * LPINVCOMSTREAM;
typedef const INVCOMSTREAM * LPCINVCOMSTREAM;


class Class_NVComStream : public IStream
{
public:
	virtual /* [local] */ HRESULT STDMETHODCALLTYPE Seek( 
		/* [in] */ LARGE_INTEGER dlibMove,
		/* [in] */ DWORD dwOrigin,
		/* [out] */ ULARGE_INTEGER __RPC_FAR *plibNewPosition);
		
	virtual HRESULT STDMETHODCALLTYPE SetSize( 
		/* [in] */ ULARGE_INTEGER libNewSize);
		
	virtual /* [local] */ HRESULT STDMETHODCALLTYPE CopyTo( 
		/* [unique][in] */ IStream __RPC_FAR *pstm,
		/* [in] */ ULARGE_INTEGER cb,
		/* [out] */ ULARGE_INTEGER __RPC_FAR *pcbRead,
		/* [out] */ ULARGE_INTEGER __RPC_FAR *pcbWritten);
		
	virtual HRESULT STDMETHODCALLTYPE Commit( 
		/* [in] */ DWORD grfCommitFlags);
		
	virtual HRESULT STDMETHODCALLTYPE Revert( void);
	
	virtual HRESULT STDMETHODCALLTYPE LockRegion( 
		/* [in] */ ULARGE_INTEGER libOffset,
		/* [in] */ ULARGE_INTEGER cb,
		/* [in] */ DWORD dwLockType);
		
	virtual HRESULT STDMETHODCALLTYPE UnlockRegion( 
		/* [in] */ ULARGE_INTEGER libOffset,
		/* [in] */ ULARGE_INTEGER cb,
		/* [in] */ DWORD dwLockType);
		
	virtual HRESULT STDMETHODCALLTYPE Stat( 
		/* [out] */ STATSTG __RPC_FAR *pstatstg,
		/* [in] */ DWORD grfStatFlag);
		
	virtual HRESULT STDMETHODCALLTYPE Clone( 
		/* [out] */ IStream __RPC_FAR *__RPC_FAR *ppstm);

    virtual /* [local] */ HRESULT STDMETHODCALLTYPE Read( 
        /* [length_is][size_is][out] */ void __RPC_FAR *pv,
        /* [in] */ ULONG cb,
        /* [out] */ ULONG __RPC_FAR *pcbRead);
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE Write( 
        /* [size_is][in] */ const void __RPC_FAR *pv,
        /* [in] */ ULONG cb,
        /* [out] */ ULONG __RPC_FAR *pcbWritten);


    virtual HRESULT STDMETHODCALLTYPE QueryInterface( 
        /* [in] */ REFIID riid,
        /* [iid_is][out] */ void __RPC_FAR *__RPC_FAR *ppvObject);
    
    virtual ULONG STDMETHODCALLTYPE AddRef( void);
    
    virtual ULONG STDMETHODCALLTYPE Release( void);

	Class_NVComStream(void);
	virtual ~Class_NVComStream(void);
	virtual HRESULT CreateFromNVStream(INVSTREAM invst);
protected:
	INVSTREAM invst;
    LONG lRefCount;
};

#pragma pack(pop)

#ifdef __cplusplus
}
#endif
