//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  NVFileLibrary `t@C  for  NVFileLibrary                                              //
//  NVFileLibDef.h                                                                              //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



#pragma once



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "..\\NVLibCore\\NVLibCore.h"



#ifdef __cplusplus
extern "C" {
#endif


#pragma pack(push, 1)



/*  VCOM ̃_Ci~bN[ĥ݂ŉ̂ŁAKvȂ
#ifndef NVFILELIB_EXPORTS
#ifdef _DEBUG
	#pragma comment(lib, "..\\DebugLib\\NVFileLib.lib")
#else
	#pragma comment(lib, "..\\ReleaseLib\\NVFileLib.lib")
#endif
#endif
*/


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  }N̒`
//


//  DLLGNX|[gp
#define NVFILELIB_API __stdcall

#ifdef NVFILELIB_EXPORTS

#define NVFILELIB_CLASS_EXPORT __declspec(dllexport)
#define NVFILELIB_EXPORT
//#define NVFILELIB_EXPORT __declspec(dllexport)

#else

#define NVFILELIB_CLASS_EXPORT __declspec(dllimport)
#define NVFILELIB_EXPORT __declspec(dllimport)

#endif	//  #ifdef NVFILELIB_EXPORTS




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  ߂l̒`
//


//  INVSTREAM p

#define VSTMERR_                       0x2100
#define MAKE_VSTMERR(name, value, flag) MAKE_NVERR((name), (VSTMERR_ | (value)), (flag))
#define MAKE_VSTMERR_VALUE(value) MAKE_NVERR_VALUE(VSTMERR_ | (value))

//  0x2101   //  vꂽIy[V́A܂T|[gĂȂ
#define VSTMERR_UNSUPPORTED                   MAKE_VSTMERR(TEXT("VSTMERR_UNSUPPORTED"), 0x01, NVERR_FATAL)
#define VSTMERR_VALUE_UNSUPPORTED             MAKE_VSTMERR_VALUE(0x01)

//  0x2102
#define VSTMERR_ALREADYUSED                   MAKE_VSTMERR(TEXT("VSTMERR_ALREADYUSED"), 0x02, NVERR_FATAL)
#define VSTMERR_VALUE_ALREADYUSED             MAKE_VSTMERR_VALUE(0x02)

//  0x2103
#define VSTMERR_INVALIDPARAMTYPE              MAKE_VSTMERR(TEXT("VSTMERR_INVALIDPARAMTYPE"), 0x03, NVERR_FATAL)
#define VSTMERR_VALUE_INVALIDPARAMTYPE        MAKE_VSTMERR_VALUE(0x03)

//  0x2104
#define VSTMERR_INVALIDPARAMSIZE              MAKE_VSTMERR(TEXT("VSTMERR_INVALIDPARAMSIZE"), 0x04, NVERR_FATAL)
#define VSTMERR_VALUE_INVALIDPARAMSIZE        MAKE_VSTMERR_VALUE(0x04)

//  0x2105
#define VSTMERR_INVALIDPARAM                  MAKE_VSTMERR(TEXT("VSTMERR_INVALIDPARAM"), 0x05, NVERR_FATAL)
#define VSTMERR_VALUE_INVALIDPARAM            MAKE_VSTMERR_VALUE(0x05)

//  0x2106
#define VSTMERR_NOCREATE                      MAKE_VSTMERR(TEXT("VSTMERR_NOCREATE"), 0x06, NVERR_FATAL)
#define VSTMERR_VALUE_NOCREATE                MAKE_VSTMERR_VALUE(0x06)

//  0x2107
#define VSTMERR_CANTOPENDATA                  MAKE_VSTMERR(TEXT("VSTMERR_CANTOPENDATA"), 0x07, NVERR_FATAL)
#define VSTMERR_VALUE_CANTOPENDATA            MAKE_VSTMERR_VALUE(0x07)

//  0x2108
#define VSTMERR_CANTGETDATASIZE               MAKE_VSTMERR(TEXT("VSTMERR_CANTGETDATASIZE"), 0x08, NVERR_FATAL)
#define VSTMERR_VALUE_CANTGETDATASIZE         MAKE_VSTMERR_VALUE(0x08)

//  0x2109
#define VSTMERR_INVALIDACCESSMODE             MAKE_VSTMERR(TEXT("VSTMERR_INVALIDACCESSMODE"), 0x09, NVERR_FATAL)
#define VSTMERR_VALUE_INVALIDACCESSMODE       MAKE_VSTMERR_VALUE(0x09)

//  0x210A
#define VSTMERR_ENDOFDATA                     MAKE_VSTMERR(TEXT("VSTMERR_ENDOFDATA"), 0x0A, NVERR_SAFE)
#define VSTMERR_VALUE_ENDOFDATA               MAKE_VSTMERR_VALUE(0x0A)

//  0x210B
#define VSTMERR_CANTWRITEDATA                 MAKE_VSTMERR(TEXT("VSTMERR_CANTWRITEDATA"), 0x0B, NVERR_FATAL)
#define VSTMERR_VALUE_CANTWRITEDATA           MAKE_VSTMERR_VALUE(0x0B)

//  0x210C
#define VSTMERR_CANTREADDATA                  MAKE_VSTMERR(TEXT("VSTMERR_CANTREADDATA"), 0x0C, NVERR_FATAL)
#define VSTMERR_VALUE_CANTREADDATA            MAKE_VSTMERR_VALUE(0x0C)

//  0x210D
#define VSTMERR_CANTGETPOSITION               MAKE_VSTMERR(TEXT("VSTMERR_CANTGETPOSITION"), 0x0D, NVERR_FATAL)
#define VSTMERR_VALUE_CANTGETPOSITION         MAKE_VSTMERR_VALUE(0x0D)

//  0x210E
#define VSTMERR_INVALIDOFFSET                 MAKE_VSTMERR(TEXT("VSTMERR_INVALIDOFFSET"), 0x0E, NVERR_FATAL)
#define VSTMERR_VALUE_INVALIDOFFSET           MAKE_VSTMERR_VALUE(0x0E)

//  0x210F
#define VSTMERR_CANTSETPOSITION               MAKE_VSTMERR(TEXT("VSTMERR_CANTSETPOSITION"), 0x0F, NVERR_FATAL)
#define VSTMERR_VALUE_CANTSETPOSITION         MAKE_VSTMERR_VALUE(0x0F)

//  0x2110
#define VSTMERR_CANTCHANGEOPENMODE            MAKE_VSTMERR(TEXT("VSTMERR_CANTCHANGEOPENMODE"), 0x10, NVERR_FATAL)
#define VSTMERR_VALUE_CANTCHANGEOPENMODE      MAKE_VSTMERR_VALUE(0x10)

//  0x2111
#define VSTMERR_CANTOVERRIDESIZE              MAKE_VSTMERR(TEXT("VSTMERR_CANTOVERRIDESIZE"), 0x11, NVERR_FATAL)
#define VSTMERR_VALUE_CANTOVERRIDESIZE        MAKE_VSTMERR_VALUE(0x11)

//  0x2112
#define VSTMERR_READONLY                      MAKE_VSTMERR(TEXT("VSTMERR_READONLY"), 0x12, NVERR_FATAL)
#define VSTMERR_VALUE_READONLY                MAKE_VSTMERR_VALUE(0x12)

//  0x2113
#define VSTMERR_BUFFERTOOSMALL                MAKE_VSTMERR(TEXT("VSTMERR_BUFFERTOOSMALL"), 0x13, NVERR_FATAL)
#define VSTMERR_VALUE_BUFFERTOOSMALL          MAKE_VSTMERR_VALUE(0x13)

//  0x2114
#define VSTMERR_DATATYPEUNKOWN                MAKE_VSTMERR(TEXT("VSTMERR_DATATYPEUNKOWN"), 0x14, NVERR_NORMAL)
#define VSTMERR_VALUE_DATATYPEUNKOWN          MAKE_VSTMERR_VALUE(0x14)

//  0x2115
#define VSTMERR_DATAISBROKEN                  MAKE_VSTMERR(TEXT("VSTMERR_DATAISBROKEN"), 0x15, NVERR_NORMAL)
#define VSTMERR_VALUE_DATAISBROKEN            MAKE_VSTMERR_VALUE(0x15)

//  0x2116
#define VSTMERR_CANTSETDATASIZE               MAKE_VSTMERR(TEXT("VSTMERR_CANTSETDATASIZE"), 0x16, NVERR_FATAL)
#define VSTMERR_VALUE_CANTSETDATASIZE         MAKE_VSTMERR_VALUE(0x16)




#pragma pack(pop)


#ifdef __cplusplus
}
#endif

