//                                                                                              //
//  o̓Xg[ Ԋ{NX  \[Xt@C  for  NVFileLibrary                         //
//  NVStream.h                                                                                  //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  eo̓Xg[̊{C^[tF[XƂȂ_~[NXłB                            //
//  t@Co͂Albg[Nf[^]ȂǂɂāAʂ̃C^[tF[X              //
//  Ȃׂ̂CvgĂ܂B                                                  //
//  ۊ{NXł͂Ȃ̂ŁACX^X̍쐬oĂ܂܂A                        //
//  ̃NX̃CX^X쐬ĂAsȂ̂ňӖ܂B                    //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "IStream.h"
#include "NVStream.h"



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̒`
//


NVRESULT NVFILELIB_EXPORT NVFILELIB_API CreateInstance_NVStream(LPIVCOM lpivcom)
{
	//  CX^X̍쐬
	//  vtable Kv̂ŁAnew ZqoRŃAP[VB

	if (! lpivcom)
	{
		return NVERR_UNDEFINED;
	}

	*lpivcom = (IVCOM) new Class_NVStream;
	if (*lpivcom)
	{
		return NV_OK;
	}
	else
	{
		return NVERR_UNDEFINED;
	}
}



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  o֐̐錾  Class_NVStream
//


Class_NVStream::Class_NVStream(void)
{
//  ftHgRXgN^

	//  {NX̕ێf[^ݒ肷BRXgN^͊{NX珇ԂɌĂяôŁA
	//  ŌɌĂяo邱ƂɂȂACX^X̃IWǐ^݂̏̂cB
	//  ]ȏ̂ŃI[o[wbh邪AdldƁB
	Class_VCOM::SetCoreData((LPVOID) this, (DWORD) sizeof(Class_NVStream), NVSTREAM_FOURCC);

	//  ێf[^͖̏B

	return;
}


Class_NVStream::~Class_NVStream(void)
{
//  fXgN^
	//  Release oRȊOĂяoƁAvcd.bIsCreated  TRUE ł邱ƂB
	//  ̏ꍇAȉsĂȂ͂Ȃ̂ŁAASSERT B
	assert(! vcd.bIsCreated);
	return;
}


NVRESULT Class_NVStream::Create(LPCVOID lpvParam)
{
//  CX^X̏

	//  _~[NXȂ̂ŁÃ\bh͌Ă΂Ȃ͂B
	//  ɕԂB

	return VSTMERR_UNSUPPORTED;
}


NVRESULT Class_NVStream::ResetData(void)
{
//  CX^X̃f[^Zbg

	//  ێf[^OZbg
	ZeroMemory(&nvstd, sizeof(NVSTREAMDATA));

	//  eNX ResetData Ɉp
	return Class_VCOM::ResetData();
}


NVRESULT Class_NVStream::QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface)
{
//  C^[tF[X̎擾

	//  dwFourCC ɂāAKȌ^̃C^[tF[XԂB
	//  ǧ^̃C^[tF[X̍쐬ȊÓAeNX̃\bhĂԂƂŉƗǂƎvB

	if (dwFourCC == NVSTREAM_FOURCC)
	{
		//  ̃NX̃C^[tF[X擾Ȃ̂ŁAԂli[AAddRef() ƂɐIB
		*lpvInterface = (INVSTREAM) this;
		AddRef();
		return NV_OK;
	}
	else
	{
		//  ǧ^ȊÓAeNXɔC
		return Class_VCOM::QueryInterface(dwFourCC, lpvInterface);
	}
}


NVRESULT Class_NVStream::AddInterface(DWORD dwFlag)
{
//  C^[tF[XQƃe[uɓo^

	//  CX^Xɑ΂ŏ̂P̌Ăяoł́A
	//  dwFlag ɂ VCOM_CLASSINTERFACE ĂB
	//  ȍ~̌Ăяoł́AOĂB
	VAddInterface(this, (IVCOM) this, NVSTREAM_FOURCC, dwFlag);

	//  eNX̃\bhɈp
	//  ̂ƂAdwFlag ɂ Ow肷B
	return Class_VCOM::AddInterface(0);
}


NVRESULT Class_NVStream::DeleteInterface(void)
{
//  C^[tF[XQƃe[u폜

	VDeleteInterface(this);

	//  eNX̃\bhɈp
	return Class_VCOM::DeleteInterface();
}


NVRESULT Class_NVStream::Read(LPVOID lpvDestBuffer, DWORD dwReadSize, LPDWORD lpdwResult)
{
//  Xg[f[^ǂݏo

	//  Xg[f[^ǂݏo֐Aۊ{NXIȃ_~[NXȂ̂ŁA
	//  KG[ԂB

	*lpdwResult = 0;
	
	return VSTMERR_UNSUPPORTED;
}

NVRESULT Class_NVStream::Write(LPCVOID lpvSrcBuffer, DWORD dwWriteSize, LPDWORD lpdwResult)
{
//  Xg[փf[^

	//  Xg[փf[^ފ֐Aۊ{NXIȃ_~[NXȂ̂ŁA
	//  KG[ԂB

	*lpdwResult = 0;

	return VSTMERR_UNSUPPORTED;
}

NVRESULT Class_NVStream::GetCurrentPosition(LPQLONG lpqlOffset, DWORD dwFlag)
{
//  Xg[ł݈̌ʒu擾

	//  Xg[ł݈̌ʒu擾֐Aۊ{NXIȃ_~[NXȂ̂ŁA
	//  KG[ԂB

	return VSTMERR_UNSUPPORTED;
}

NVRESULT Class_NVStream::SetCurrentPosition(QLONG qlOffset, DWORD dwFlag)
{
//  Xg[ł݈̌ʒuݒ

	//  Xg[ł݈̌ʒuݒ肷֐Aۊ{NXIȃ_~[NXȂ̂ŁA
	//  KG[ԂB

	return VSTMERR_UNSUPPORTED;
}

NVRESULT Class_NVStream::GetDataSize(LPQWORD lpqwDataSize)
{
//  Xg[̃f[^TCY擾

	//  Xg[̃f[^TCY擾֐Aۊ{NXIȃ_~[NXȂ̂ŁA
	//  KG[ԂB

	return VSTMERR_UNSUPPORTED;
}

NVRESULT Class_NVStream::SetDataSize(QWORD qwDataSize)
{
//  Xg[̃f[^TCY擾

	//  Xg[̃f[^TCY擾֐Aۊ{NXIȃ_~[NXȂ̂ŁA
	//  KG[ԂB

	return VSTMERR_UNSUPPORTED;
}

NVRESULT Class_NVStream::GetDataName(LPTSTR lpszDataName, DWORD dwLength)
{
//  Xg[̃f[^擾

	//  ̊֐́Aʂ̏ŗǂ͂


	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	//  t@CRs[

	if (nvstd.dwFlag & NVSTREAM_DATANAMEOVERRIDE)
	{
		//  f[^I[o[ChĂꍇ

		_tcsncpy_s(lpszDataName, dwLength, nvstd.lpszDataNameOverride, dwLength - 1);
	}
	else
	{
		//  I[o[ChĂȂꍇ
		_tcsncpy_s(lpszDataName, dwLength, nvstd.lpszDataName, dwLength - 1);
	}

	return NV_OK;
}

NVRESULT Class_NVStream::GetOpenMode(LPDWORD lpdwFlag)
{
//  Xg[̃I[v[h擾

	//  ̊֐́Aʂ̏ŗǂ͂

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	*lpdwFlag = nvstd.dwFlag;
	return NV_OK;
}

NVRESULT Class_NVStream::ChangeOpenMode(DWORD dwFlag)
{
//  Xg[̃I[v[hύX

	//  Xg[̃I[v[hύX֐Aۊ{NXIȃ_~[NXȂ̂ŁA
	//  KG[ԂB

	return VSTMERR_UNSUPPORTED;
}

NVRESULT Class_NVStream::OverrideDataName(LPCTSTR lpcszDataName)
{
//  Xg[̃I[o[Chݒ肷

	//  ̊֐́Aʂ̏ŗǂ͂

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	_tcscpy_s(nvstd.lpszDataNameOverride, NV_PATHMAX, lpcszDataName);

	return NV_OK;
}

NVRESULT Class_NVStream::OverrideSize(QWORD qwStartOverride, QWORD qwSizeOverride)
{
//  Xg[̃I[o[ChTCYݒ肷

	//  Xg[̃I[o[ChTCYݒ肷֐Aۊ{NXIȃ_~[NXȂ̂ŁA
	//  KG[ԂB

	return VSTMERR_UNSUPPORTED;
}


NVRESULT Class_NVStream::GetInfo(LPVOID lpvParam, LPDWORD lpdwSize)
{
//  Xg[̏擾

	//  Xg[̏擾֐Aۊ{NXIȃ_~[NXȂ̂ŁA
	//  KG[ԂB

	*lpdwSize = 0;
	return VSTMERR_UNSUPPORTED;
}


NVRESULT Class_NVStream::SetInfo(LPVOID lpvParam, DWORD dwSize)
{
//  Xg[̏ݒ肷

	//  Xg[̏ݒ肷֐Aۊ{NXIȃ_~[NXȂ̂ŁA
	//  KG[ԂB

	return VSTMERR_UNSUPPORTED;
}


NVRESULT Class_NVStream::CreateAlias(LPINVSTREAM lpinvst)
{
//  Xg[̃GCAX쐬
	//  Xg[̃GCAX쐬֐Aۊ{NXIȃ_~[NXȂ̂ŁA
	//  KG[ԂB

	return VSTMERR_UNSUPPORTED;
}


NVRESULT Class_NVStream::QueryClassInfo(LPVOID lpvInfo, LPDWORD lpdwSize)
{
//  NX̎@\擾

	//  NX̎@\擾֐Aۊ{NXIȃ_~[NXȂ̂ŁA
	//  KG[ԂB

	*lpdwSize = 0;

	return VSTMERR_UNSUPPORTED;
}

NVRESULT Class_NVStream::QueryIStreamInterface(IStream **lplpStream)
{
	INVCOMSTREAM invcomst = new Class_NVComStream;
	HRESULT hres;

	hres = invcomst->CreateFromNVStream(this);
	if (FAILED(hres))
	{
		invcomst->Release();
		*lplpStream = NULL;
		return NVERR_UNDEFINED;
	}

	hres = invcomst->QueryInterface(IID_IStream, (LPVOID *) lplpStream);
	invcomst->Release();

	return (SUCCEEDED(hres)) ? NV_OK : NVERR_UNDEFINED;
}


