//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  ACMFile Decompression W[ wb_[t@C  for  NVWaveFileLibrary                   //
//  NVACM.h                                                                                     //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



#pragma once



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "NVWaveDef.h"
#include "mmreg.h"
#include "msacm.h"


#ifdef __cplusplus
extern "C" {
#endif


#pragma pack(push, 1)





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  }N̐錾
//


//  oblt@CI[v[htO
#define NVACM_OPENFILE  0x01
#define NVACM_OPENSTREAM 0x02

//  ACMtH[}bg̎ (CheckNVACMFileTypeŎgp)
#define NVACM_ACMFORMAT_UNKNOWN  0x00
#define NVACM_ACMFORMAT_ACMWAVE  0x01

//  V[NptO
#define NVACM_SEEKBEGIN   NVAUDIOFILE_SEEKBEGIN
#define NVACM_SEEKCURRENT NVAUDIOFILE_SEEKCURRENT
#define NVACM_SEEKEND     NVAUDIOFILE_SEEKEND


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  \̂̐錾
//


struct NVACMINFO			//  nvacmInfo
{
	DWORD dwFourCC;					//  NXʎq
	DWORD dwObjSize;				//  IuWFNgTCY
	TCHAR lpszDataName[NV_PATHMAX];	//  \[Xt@C
	DWORD dwFileType;				//  t@C^Cv
	QWUNION quDataSize;				//  ǂݍ݃f[^TCY
	QWUNION quDecodedSize;			//  fR[h̃f[^TCY
	DWORD dwBitsPerSample;			//  ʎqrbg
	DWORD dwSamplerate;				//  TvOg
	DWORD dwMode;					//  XeI[h
	DWORD dwBitrate;				//  rbg[g
	QWUNION quPlayTime;				//  Đ
	DWORD dwFlag;					//  VBR tO
	TCHAR lpszFormatString[NVAUDIOFILEINFO_FORMATSTRING_MAX];	//  tH[}bg̖
	TCHAR lpszModeString[NVAUDIOFILEINFO_MODESTRING_MAX];		//  XeI[h̖
};
typedef NVACMINFO * LPNVACMINFO;
typedef const NVACMINFO * LPCNVACMINFO;



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  NX̒`  :  INVACM
//


//  NXʎq
#define NVACM_FOURCC MAKEFOURCC('V', 'A', 'C', 'M')


/*  INVACM NXWXg (VCOM.ini ւ̋Lq)
[VACM]

Class_ID = "VACM"
Module_Name = "NVWave.vss"
Entry_Point = "CreateInstance_NVACM"
Dependence = ""NVAFLib.dll""
*/


class Class_NVACM;
typedef Class_NVACM * INVACM;
typedef const Class_NVACM * CINVACM;
typedef INVACM * LPINVACM;
typedef const INVACM * LPCINVACM;



//  INVACM ̏f[^
struct NVACMCREATE				//  nvacmc
{
	DWORD dwFourCC;				//  NXʎq
	DWORD dwObjSize;			//  \̂̃TCY
	DWORD dwFlag;				//  tO
	union
	{
		LPCTSTR lpcszDataName;	//  I[vt@C
		INVSTREAM invst;		//  I[vXg[
	};
	LONG lBitsPerSample;		//  o͗ʎqrbg(0=ϊȂ)
};
typedef NVACMCREATE * LPNVACMCREATE;
typedef const NVACMCREATE * LPCNVACMCREATE;


//  INVACM ̕ێf[^
struct NVACMDATA		//  nvacmd
{
	HACMSTREAM hacmst;		//  ACM Xg[̃nh
	INVSTREAM invst;		//  ̓Xg[
	DWORD dwFlag;			//  쐬tO
	NVACMINFO nvacmInfo;	//  obl
	LONG lType;				//  t@C^Cv
	QLONG qlStartOffset;		//  f[^Jnʒu
	QLONG qlDataSize;			//  f[^TCY
	HWND hwndInfo;			//  _CAÕnh
	DWORD dwEqualizerEnable;//  CRCULtO
	LPBYTE lpBuf;			//  ԃobt@
	DWORD dwBufOffset;		//  obt@݈̌ʒũItZbg
	DWORD dwBufRest;		//  obt@̎c
	QLONG qlRestSize;		//  Ŝł̎c
	QWUNION quCurrent;		//  Ŝł݈̌ʒu
};
typedef NVACMDATA * LPNVACMDATA;
typedef const NVACMDATA * LPCNVACMDATA;



class NVWAVE_CLASS_EXPORT Class_NVACM : virtual public Class_NVAudioFile
{
	public:
		Class_NVACM(void);
		//  ftHgRXgN^
		//
		//  SetCoreData() ĂяoāA{NXɃf[^ݒ肷B

	VCOM_CLASSMETHOD
		~Class_NVACM(void);
		//  fXgN^
		//

	VCOM_CLASSMETHOD
		NVRESULT Create(LPCVOID lpvParam);
		//  CX^X̏
		//
		//  CX^XɃp[^^āACX^X̃f[^(쐬)B
		//  vcd.bIsCreated tO𗧂āAς݂`FbNs悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT ResetData(void);
		//  CX^X̃f[^Zbg
		//
		//  CX^XŗpȂǂACreate() ĂяoȌԂɖ߂B
		//  vcd.bIsCreated tOZbgAĂ Create() s悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface);
		//  C^[tF[X̎擾
		//
		//  DWORD dwFourCC			擾C^[tF[X
		//  LPVOID *lpvInterface	C^[tF[Xi[|C^
		//
		//  ̃CX^X́AdwFourCC Ŏw肵^̃C^[tF[X擾B
		//  擾łC^[tF[X́ACX^XɂĈقȂ邪A
		//  CX^XNX̃X[p[NXɂNX̃C^[tF[X
		//  K擾ł悤ɎȂ΂ȂȂB
		//  ̊֐ŕʂ̃C^[tF[X擾ƁA AddRef() ŝŁA
		//  ÂC^[tF[Xɑ΂Ă Release() KvB

	VCOM_CLASSMETHOD
		NVRESULT GetInfo(DWORD dwFourCC, LPVOID lpvInfo, LPDWORD lpdwSize);
		//  tH[}bgƎ̊g擾
		//
		//  DWORD dwFourCC			̌`NXʎq
		//  LPVOID@lpvInfo			󂯎obt@
		//  LPDWORD@lpdwSize		obt@̃TCY
		//
		//  tH[}bgƂɒ߂ꂽgԂB
		//  lpvInfo  NULL nƁAKvȃobt@TCYԂB
		//  񂪎擾ƁAlpdwSize ɎۂɊi[ꂽTCYԂB
		//  obt@TCYȂꍇAG[ԂÂƂ lpdwSize ɕKvȃTCYԂB
		//  NVAudioFileC^[tF[XW̏ƂāA
		//  NVAudioFileInfo`̂ŁAɂ͕KΉ悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT GetComment(DWORD dwFourCC, LPVOID lpvInfo, LPDWORD lpdwSize);
		//  ȖȂǂ̃Rg擾
		//
		//  DWORD dwFourCC		󂯎\̂̎ʎq
		//  LPVOID lpvInfo		󂯎obt@(\)̃|C^
		//  LPDWORD lpdwSize	obt@̃TCY
		//
		//  lpvInfo  NULL nƁAKvȃobt@TCYԂB
		//  񂪎擾ƁAlpdwSize ɎۂɊi[ꂽTCYԂB
		//  obt@TCYȂꍇAG[ԂÂƂ lpdwSize ɕKvȃTCYԂB
		//  W̌`ƂāANVAudioFileComment`̂ŁA
		//  ɂ͕KΉ悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT GetPCMWaveFormat(LPPCMWAVEFORMAT lppcmwf);
		//  fR[hf[^̃tH[}bg擾
		//
		//  LPPCMWAVEFORMAT lppcmwf		󂯎obt@
		//
		//  PCMWAVEFORMAT `ŁAfR[hĂf[^̌`擾B
		//  PCMWAVEFORMAT::wf.wFormatTaǵAWAVE_FORMAT_PCM܂WAVE_FORMAT_IEEE_FLOAT݂̂T|[g

	VCOM_CLASSMETHOD
		NVRESULT DecodeToPCMData(LPVOID lpBuffer, LONG lBufferSize, LPLONG lplResultSize);
		//  f[^fR[hA󂯎
		//
		//  LPVOID lpBuffer			fR[hꂽf[^󂯎obt@
		//  LONG lBufferSize		擾f[^̗
		//  LPLONG lplResultSize	ۂɎ擾ꂽf[^̗
		//
		//  f[^fR[hāAPCM `Ŏ󂯎B̃tH[}bǵAGetPCMWaveFormat Ŏ擾łtH[}bgɊÂĂB
		//  NV_OK Ԃꍇ́AKvTCỸf[^擾ĂB
		//  VAFERR_VALUE_ENDOFDATA ̏ꍇAۂɎ擾ꂽf[^̗ʂ́AlplResultSize ɕԂB
		//  ̌ĂяóAKVAFERR_VALUE_ENDOFDATA ɂȂB
		//  f[^ɃG[̂́A񕜂łꍇɂ́AVAFERR_VALUE_ERRORRECOVEREDԂB
		//	̏ꍇ́AfR[h͂̂܂ܑsłB
		//  ȊÕG[Ԃꍇ́AfR[h𑱂邱Ƃ͂łȂB
		//  f[^̈ꕔłɏꂽꍇ́AlplResultSize ɎۂɎ擾ꂽf[^̗ʂԂĂB

	VCOM_CLASSMETHOD
		NVRESULT Rewind(void);
		//  f[^擪܂Ŋ߂
		//
		//  ʓIɂSetCurrentPosition(0, NVAUDIOFILE_SEEKBEGIN)ƓA
		//  tH[}bgɂĂ͐擪ւ̃V[N͍ɍs邽ߕʓrp
		//  p~ĂǂȁccH

	VCOM_CLASSMETHOD
		NVRESULT FileInfoDialog(HWND hwnd);
		//  t@C̃_CAO\
		//
		//  HWND hwnd		eEBhẼnh
		//
		//  t@C̏Rg[hX_CAO\B
		//  ɍ쐬ς݂̏ꍇɂ́AQdɕ\Ȃ悤ɒ
		//  ܂AAddRef() Release()gāA
		//  \ɃfR[_N[YĂvȂ悤ɂĂKvB
		//  _CAÓANVRegisterDialog()NVUnRegisterDialog()ŁA
		//  bZ[W[vłƏ悤ɂKvB

	VCOM_CLASSMETHOD
		NVRESULT GetCurrentPosition(LPQWUNION lpquPosition, DWORD dwFlag);
		//  t@Č݈ʒuoCgPʂŎ擾
		//
		//  LPQWUNION lpquPosition	擾錻݈ʒũItZbg
		//  DWORD dwFlag			ItZbg̊ʒu

	VCOM_CLASSMETHOD
		NVRESULT SetCurrentPosition(QWUNION quPosition, DWORD dwFlag);
		//  t@Č݈ʒuoCgPʂŐݒ
		//
		//  QWUNION quPosition	ݒ肷錻݈ʒũItZbg
		//  DWORD dwFlag		ItZbg̊ʒu
		//
		//  \ȌoCgPʂł̃V[Ns悤ɂׂA
		//  ݂Lilithł́Ǎ덷ĂvȂɂȂĂB
		//  bp[vOCȂǁÃfR[_TvPʂmsPʂł
		//  V[NsȂɂ́A̒PʂɊۂ߂Ă\ȂB
		//  ÂƂthLgɖL̂S邱ƁB

	VCOM_CLASSMETHOD
		NVRESULT ReferenceTimeToSamples(QWUNION quReferenceTime, LPQWUNION lpquSamples);
		//  QƎ(}CNbP)Tv֕ϊ
		//
		//  QWUNION quReferenceTime		QƎ(}CNbP)
		//  LPQWUNION lpquSamples		Tv
	VCOM_CLASSMETHOD
		NVRESULT SamplesToReferenceTime(QWUNION quSamples, LPQWUNION lpquReferenceTime);
		//  TvQƎ(}CNbP)֕ϊ
		//
		//  QWUNION quSamples			Tv
		//  LPQWUNION lpquReferenceTime	QƎ(}CNbP)
	VCOM_CLASSMETHOD
		NVRESULT GetReferenceTime(LPQWUNION lpquReferenceTime);
		//  ݂̎QƎ(}CNbP)擾
		//
		//  LPQWUNION lpquReferenceTime		QƎ(}CNbP)

	VCOM_CLASSMETHOD
		NVRESULT GetTotalTime(LPQWUNION lpquTotalTime);
		//  }CNbPʂőSĐԂ擾
		//
		//  LPQWUNION lpquTotalTime		SĐ(}CNbP)

protected:
	VCOM_CLASSMETHOD
		NVRESULT AddInterface(DWORD dwFlag);
		//  C^[tF[XQƃe[uɓo^
		//
		//  DWORD dwFlag	NXCX^X̏ꍇPAȊO͂O
		//
		//  RXgN^̒ŌĂ΂AC^[tF[X|C^e[uɓo^A
		//  VIsValidInterface() ŃC^[tF[X̗L؂ł悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT DeleteInterface(void);
		//  C^[tF[XQƃe[u폜
		//
		//  DeleteInstance() ̒ŌĂ΂AC^[tF[X|C^e[u폜B

	friend INT_PTR CALLBACK NVACM_InfoDialogProc(HWND hwnd, UINT uMessage, WPARAM wParam, LPARAM lParam);

protected:
	NVACMDATA nvacmd;
};



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̐錾
//

NVRESULT NVWAVE_EXPORT NVWAVE_API CreateInstance_NVACM(LPIVCOM lpivcom);
//  CX^X̍쐬
//
//  INVACM CX^X쐬ÃC^[tF[XԂ


inline void SetNVACMCreate(LPNVACMCREATE lpnvacmc, DWORD dwFlag, LPCTSTR lpcszDataName, LONG lBitsPerSample = 0);
//  NVACMCREATE \̏֐
//
//  LPNVACMCREATE lpnvacmc			\
//  DWORD dwFlag					ZbgtO
//  LPCTSTR lpcszDataName			I[vt@CA܂̓Xg[̃C^[tF[X


inline NVRESULT CheckACMFileType(INVSTREAM invst, LPLONG lplType, LPQLONG lplStartOffset, LPQLONG lplDataSize, LPNVACMINFO lpnvacmInfo = NULL,
								 LPWAVEFORMATEX *lplpwfxDest = NULL, LPWAVEFORMATEX *lplpwfxSrc = NULL);
//  `blt@C̃`FbNp֐




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  CC֐̒`
//


inline void SetNVACMCreate(LPNVACMCREATE lpnvacmc, DWORD dwFlag, LPCTSTR lpcszDataName, LONG lBitsPerSample)
{
	lpnvacmc->dwFourCC = NVACM_FOURCC;
	lpnvacmc->dwObjSize = sizeof(NVACMCREATE);
	lpnvacmc->dwFlag = dwFlag;
	lpnvacmc->lpcszDataName = lpcszDataName;
	lpnvacmc->lBitsPerSample = lBitsPerSample;

	return;
}


inline NVRESULT CheckACMFileType(INVSTREAM invst, LPLONG lplType, LPQLONG lpqlStartOffset, LPQLONG lpqlDataSize, LPNVACMINFO lpnvacmInfo,
								 LPWAVEFORMATEX *lplpwfxDest, LPWAVEFORMATEX *lplpwfxSrc)
{
//  `blt@C̃`FbNp֐

	NVRESULT nvres = NV_OK;
	DWORD dwRead;
	union
	{
		struct
		{
			DWORD dwTag;
			DWORD dwDataSize;
		};
		QWORD Header;
		struct
		{
			DWORD dwFileSize;
			DWORD dwFileType;
		};
		QWORD FileInfo;
	};
	LPWAVEFORMATEX lpwfxSrc = NULL;
	LPWAVEFORMATEX lpwfxDest = NULL;
	NVACMINFO nvacmInfo;
	QWUNION quFilePosition;
	HACMSTREAM hacmst = NULL;
	LONG lFactSamples = 0;
	BOOL bFactRead = FALSE;
	QLONG qlStartOffset = 0;
	QLONG qlDataSize = 0;

	//  ߂lĂ
	*lplType = NVACM_ACMFORMAT_UNKNOWN;

	do
	{
		//  t@C|WVۑĂ
		invst->GetCurrentPosition(&quFilePosition.ql, NVSTREAM_SEEKBEGIN);

		//  擪^Oǂݏo
		nvres = invst->Read(&dwTag, sizeof(DWORD), &dwRead);
		if (nvres)
		{
			nvres =  VACMERR_VALUE_FILEISBROKEN;
			break;
		}

		//  RIFF t@CłȂ΃G[
		if (dwTag != MAKEFOURCC('R', 'I', 'F', 'F'))
		{
			nvres = VACMERR_VALUE_UNSUPPORTEDFILE;
			break;
		}

		//  t@CTCYt@C^Cvǂݏo
		nvres = invst->Read(&FileInfo, sizeof(DWORD) * 2, &dwRead);
		if (nvres)
		{
			nvres = VACMERR_FILEISBROKEN;
			break;
		}

		//  WAVE t@CłȂ΃G[
		if (dwFileType != MAKEFOURCC('W', 'A', 'V', 'E'))
		{
			nvres = VACMERR_VALUE_UNSUPPORTEDFILE;
			break;
		}

		//  `N^O`NTCYǂݏo
		nvres = invst->Read(&Header, sizeof(DWORD) * 2, &dwRead);
		if (nvres)
		{
			nvres = VACMERR_FILEISBROKEN;
			break;
		}

		while (dwTag != MAKEFOURCC('f', 'm', 't', ' '))
		{
			//  ̃`N̐擪܂ňړ
			nvres = invst->SetCurrentPosition(dwDataSize + (dwDataSize & 0x01), NVSTREAM_SEEKCURRENT);

			//  ̃`N擾
			nvres = invst->Read(&Header, sizeof(DWORD) * 2, &dwRead);
			if (nvres)
			{
				nvres = VACMERR_FILEISBROKEN;
				break;
			}
		}

		if (dwDataSize < sizeof(PCMWAVEFORMAT))
		{
			nvres = VACMERR_FILEISBROKEN;
			break;
		}

		//  WAVEFORMATEX ̃obt@m
		lpwfxSrc = (LPWAVEFORMATEX) NVMemAlloc(NVMEM_FIXED, dwDataSize);

		//  WAVEFORMATEX ǂݏo
		nvres = invst->Read(lpwfxSrc, dwDataSize, &dwRead);
		if (nvres)
		{
			nvres = VACMERR_FILEISBROKEN;
			break;
		}
		if (dwDataSize & 0x01)
		{
			invst->SetCurrentPosition(1, NVSTREAM_SEEKCURRENT);
		}

		//  o͗pWAVEFORMATEXm
		lpwfxDest = (LPWAVEFORMATEX) NVMemAlloc(NVMEM_FIXED | NVMEM_ZEROINIT, sizeof(WAVEFORMATEX));

		MMRESULT mmres;

		//  o͗pWAVEFORMATEX 
		lpwfxDest->wFormatTag = WAVE_FORMAT_PCM;
		mmres = acmFormatSuggest(NULL, lpwfxSrc, lpwfxDest, sizeof(WAVEFORMATEX), ACM_FORMATSUGGESTF_WFORMATTAG);

		//  fR[hł Codec 邩ǂׂ
		mmres = acmStreamOpen(&hacmst, NULL, lpwfxSrc, lpwfxDest, NULL, NULL, 0, ACM_STREAMOPENF_NONREALTIME);
		if (mmres)
		{
			nvres = VACMERR_VALUE_UNSUPPORTEDFILE;
			break;
		}

		*lplType = NVACM_ACMFORMAT_ACMWAVE;

		//  ̃`N擾
		nvres = invst->Read(&Header, sizeof(DWORD) * 2, &dwRead);
		if (nvres)
		{
			nvres = VACMERR_FILEISBROKEN;
			break;
		}

		//  data `N܂ŌJԂ
		while (dwTag != MAKEFOURCC('d', 'a', 't', 'a'))
		{
			if (dwTag == MAKEFOURCC('f', 'a', 'c', 't'))
			{
				bFactRead = TRUE;
				nvres = invst->Read(&lFactSamples, min(dwDataSize, 4), &dwRead);
				if (nvres)
				{
					nvres = VACMERR_FILEISBROKEN;
				}
				if (dwDataSize > 4)
				{
					nvres = invst->SetCurrentPosition(dwDataSize + (dwDataSize & 0x01) - 4, NVSTREAM_SEEKCURRENT);
				}

				//  ̃`N擾
				nvres = invst->Read(&Header, sizeof(DWORD) * 2, &dwRead);
				if (nvres)
				{
					nvres = VACMERR_FILEISBROKEN;
					break;
				}
			}
			else
			{
				//  ̃`N̐擪܂ňړ
				nvres = invst->SetCurrentPosition(dwDataSize + (dwDataSize & 0x01), NVSTREAM_SEEKCURRENT);

				//  ̃`N擾
				nvres = invst->Read(&Header, sizeof(DWORD) * 2, &dwRead);
				if (nvres)
				{
					nvres = VACMERR_FILEISBROKEN;
					break;
				}
			}
		}

		if(nvres)
		{
			break;
		}

		//  ̈ʒuoblf[^̎n_
		//  f[^TCÝA`ÑTCY
		*lplType = NVACM_ACMFORMAT_ACMWAVE;
		nvres = invst->GetCurrentPosition(&qlStartOffset, NVSTREAM_SEEKBEGIN);
		if (nvres)
		{
			break;
		}
		nvres = invst->GetDataSize((LPQWORD) &qlDataSize);
		qlDataSize = min(dwDataSize, qlDataSize - qlStartOffset);
		if (qlDataSize == 0)
		{
			nvres = VACMERR_FILEISBROKEN;
			break;
		}

		//  NVACMINFO ݒ
		nvacmInfo.dwFourCC = NVACM_FOURCC;
		nvacmInfo.dwObjSize = sizeof(NVACMINFO);
		nvacmInfo.quDataSize.qw = qlDataSize;
		if (bFactRead)
		{
			nvacmInfo.quDecodedSize.qw = ((QWORD) lFactSamples) * lpwfxDest->wBitsPerSample * lpwfxDest->nChannels / 8;
		}
		else
		{
			mmres = acmStreamSize(hacmst, nvacmInfo.quDataSize.dwLow, &nvacmInfo.quDecodedSize.dwLow, ACM_STREAMSIZEF_SOURCE);
			nvacmInfo.quDecodedSize.dwHigh = 0;
		}
		nvacmInfo.dwBitsPerSample = lpwfxDest->wBitsPerSample;
		nvacmInfo.dwSamplerate = lpwfxDest->nSamplesPerSec;
		nvacmInfo.dwMode = lpwfxDest->nChannels;
		nvacmInfo.quPlayTime.qw = nvacmInfo.quDecodedSize.qw * 1000 / ((nvacmInfo.dwBitsPerSample / 8) * nvacmInfo.dwSamplerate * nvacmInfo.dwMode);
		nvacmInfo.dwBitrate = (DWORD) (nvacmInfo.quDataSize.qw * nvacmInfo.dwBitsPerSample * nvacmInfo.dwSamplerate * nvacmInfo.dwMode / (nvacmInfo.quDecodedSize.qw * 1000));
		nvacmInfo.dwFileType = NVACM_FOURCC;
		nvacmInfo.dwFlag = 0;
		{
			const TCHAR *lpszMode[9] = { TEXT("Unknown"), TEXT("Monaural"), TEXT("Stereo"), TEXT("3 Channels"), TEXT("4 Channels"), TEXT("4.1 Channels"), TEXT("5.1 Channels"), TEXT("7.0 Channels"), TEXT("7.1 Channels") };
			_tcscpy_s(nvacmInfo.lpszModeString, NVAUDIOFILEINFO_MODESTRING_MAX, (nvacmInfo.dwMode < 9) ? lpszMode[nvacmInfo.dwMode] : lpszMode[0]);
		}
		invst->GetDataName(nvacmInfo.lpszDataName, NV_PATHMAX);
		{
			ACMFORMATTAGDETAILS aftd;

			ZeroMemory(&aftd, sizeof(ACMFORMATTAGDETAILS));
			aftd.cbStruct = sizeof(ACMFORMATTAGDETAILS);
			aftd.dwFormatTag = lpwfxSrc->wFormatTag;
			mmres = acmFormatTagDetails(NULL, &aftd, ACM_FORMATTAGDETAILSF_FORMATTAG);
			if (! mmres)
			{
				_tcscpy_s(nvacmInfo.lpszFormatString, NVAUDIOFILEINFO_FORMATSTRING_MAX, aftd.szFormatTag);
			}
		}

		//  ACM Stream N[Y
		acmStreamClose(hacmst, 0);
		hacmst = NULL;
		*lpqlStartOffset = qlStartOffset;
		*lpqlDataSize = qlDataSize;
	}
	while (0);

	if (nvres)
	{
		if (hacmst)
		{
			acmStreamClose(hacmst, 0);
		}

		if (lpwfxSrc)
		{
			NVMemFree(lpwfxSrc);
		}

		if (lpwfxDest)
		{
			NVMemFree(lpwfxDest);
		}
		//  t@C|C^߂
		invst->SetCurrentPosition(quFilePosition.ql, NVSTREAM_SEEKBEGIN);

		*lplType = NVACM_ACMFORMAT_UNKNOWN;
		*lpqlStartOffset = 0;
		*lpqlDataSize = 0;
		return nvres;
	}

	//  t@C|C^߂
	invst->SetCurrentPosition(quFilePosition.ql, NVSTREAM_SEEKBEGIN);

	//  NVACMINFO ̗v΁ARs[
	if (lpnvacmInfo)
	{
		CopyMemory(lpnvacmInfo, &nvacmInfo, sizeof(NVACMINFO));
	}

	if (lplpwfxSrc)
	{
		*lplpwfxSrc = lpwfxSrc;
	}
	else
	{
		NVMemFree(lpwfxSrc);
	}

	if (lplpwfxDest)
	{
		*lplpwfxDest = lpwfxDest;
	}
	else
	{
		NVMemFree(lpwfxDest);
	}

	return NV_OK;
}



#pragma pack(pop)

#ifdef __cplusplus
}
#endif

