//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  PCMFile Decompression W[ wb_[t@C  for  NVWaveFileLibrary                   //
//  NVPCM.h                                                                                     //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



#pragma once



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "NVWaveDef.h"


#ifdef __cplusplus
extern "C" {
#endif


#pragma pack(push, 1)





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  }N̐錾
//


//  oblt@CI[v[htO
#define NVPCM_OPENFILE  0x01
#define NVPCM_OPENSTREAM 0x02

//  PCMtH[}bg̎ (CheckNVPCMFileTypeŎgp)
#define NVPCM_PCMFORMAT_UNKNOWN  0x00
#define NVPCM_PCMFORMAT_PCMWAVE  0x01
#define NVPCM_PCMFORMAT_IEEEFLOAT 0x02

//  V[NptO
#define NVPCM_SEEKBEGIN   NVAUDIOFILE_SEEKBEGIN
#define NVPCM_SEEKCURRENT NVAUDIOFILE_SEEKCURRENT
#define NVPCM_SEEKEND     NVAUDIOFILE_SEEKEND


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  \̂̐錾
//


struct NVPCMINFO			//  nvpcmInfo
{
	DWORD dwFourCC;					//  NXʎq
	DWORD dwObjSize;				//  IuWFNgTCY
	TCHAR lpszDataName[NV_PATHMAX];	//  \[Xt@C
	DWORD dwFileType;				//  t@C^Cv
	QWUNION quDataSize;				//  ǂݍ݃f[^TCY
	QWUNION quDecodedSize;			// fR[h̃f[^TCY
	DWORD dwBitsPerSample;			//  ʎqrbg
	DWORD dwSamplerate;				//  TvOg
	DWORD dwMode;					//  XeI[h
	DWORD dwBitrate;				//  rbg[g
	QWUNION quPlayTime;				//  Đ
	DWORD dwFlag;					//  VBR tO
	TCHAR lpszFormatString[NVAUDIOFILEINFO_FORMATSTRING_MAX];	//  tH[}bg̖
	TCHAR lpszModeString[NVAUDIOFILEINFO_MODESTRING_MAX];		//  XeI[h̖
};
typedef NVPCMINFO * LPNVPCMINFO;
typedef const NVPCMINFO * LPCNVPCMINFO;



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  NX̒`  :  INVPCM
//


//  NXʎq
#define NVPCM_FOURCC MAKEFOURCC('V', 'P', 'C', 'M')


/*  INVPCM NXWXg (VCOM.ini ւ̋Lq)
[VPCM]

Class_ID = "VPCM"
Module_Name = "NVWave.vss"
Entry_Point = "CreateInstance_NVPCM"
Dependence = ""NVAFLib.dll""
*/


class Class_NVPCM;
typedef Class_NVPCM * INVPCM;
typedef const Class_NVPCM * CINVPCM;
typedef INVPCM * LPINVPCM;
typedef const INVPCM * LPCINVPCM;



//  INVPCM ̏f[^
struct NVPCMCREATE				//  nvpcmc
{
	DWORD dwFourCC;				//  NXʎq
	DWORD dwObjSize;			//  \̂̃TCY
	DWORD dwFlag;				//  tO
	union
	{
		LPCTSTR lpcszDataName;	//  I[vt@C
		INVSTREAM invst;		//  I[vXg[
	};
	LONG lBitsPerSample;		//  o͗ʎqrbg(0=ϊȂ 32=24bit32bitFloatɕϊ)
};
typedef NVPCMCREATE * LPNVPCMCREATE;
typedef const NVPCMCREATE * LPCNVPCMCREATE;


//  INVPCM ̕ێf[^
struct NVPCMDATA		//  nvpcmd
{
	INVSTREAM invst;		//  ̓Xg[
	DWORD dwFlag;			//  쐬tO
	NVPCMINFO nvpcmInfo;	//  obl
	LONG lType;				//  t@C^Cv
	QLONG qlStartOffset;		//  f[^Jnʒu
	QLONG qlDataSize;			//  f[^TCY
	HWND hwndInfo;			//  _CAÕnh
	DWORD dwEqualizerEnable;//  CRCULtO
};
typedef NVPCMDATA * LPNVPCMDATA;
typedef const NVPCMDATA * LPCNVPCMDATA;



class NVWAVE_CLASS_EXPORT Class_NVPCM : virtual public Class_NVAudioFile
{
	public:
		Class_NVPCM(void);
		//  ftHgRXgN^
		//
		//  SetCoreData() ĂяoāA{NXɃf[^ݒ肷B

	VCOM_CLASSMETHOD
		~Class_NVPCM(void);
		//  fXgN^
		//

	VCOM_CLASSMETHOD
		NVRESULT Create(LPCVOID lpvParam);
		//  CX^X̏
		//
		//  CX^XɃp[^^āACX^X̃f[^(쐬)B
		//  vcd.bIsCreated tO𗧂āAς݂`FbNs悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT ResetData(void);
		//  CX^X̃f[^Zbg
		//
		//  CX^XŗpȂǂACreate() ĂяoȌԂɖ߂B
		//  vcd.bIsCreated tOZbgAĂ Create() s悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface);
		//  C^[tF[X̎擾
		//
		//  DWORD dwFourCC			擾C^[tF[X
		//  LPVOID *lpvInterface	C^[tF[Xi[|C^
		//
		//  ̃CX^X́AdwFourCC Ŏw肵^̃C^[tF[X擾B
		//  擾łC^[tF[X́ACX^XɂĈقȂ邪A
		//  CX^XNX̃X[p[NXɂNX̃C^[tF[X
		//  K擾ł悤ɎȂ΂ȂȂB
		//  ̊֐ŕʂ̃C^[tF[X擾ƁA AddRef() ŝŁA
		//  ÂC^[tF[Xɑ΂Ă Release() KvB

	VCOM_CLASSMETHOD
		NVRESULT GetInfo(DWORD dwFourCC, LPVOID lpvInfo, LPDWORD lpdwSize);
		//  tH[}bgƎ̊g擾
		//
		//  DWORD dwFourCC			̌`NXʎq
		//  LPVOID@lpvInfo			󂯎obt@
		//  LPDWORD@lpdwSize		obt@̃TCY
		//
		//  tH[}bgƂɒ߂ꂽgԂB
		//  lpvInfo  NULL nƁAKvȃobt@TCYԂB
		//  񂪎擾ƁAlpdwSize ɎۂɊi[ꂽTCYԂB
		//  obt@TCYȂꍇAG[ԂÂƂ lpdwSize ɕKvȃTCYԂB
		//  NVAudioFileC^[tF[XW̏ƂāA
		//  NVAudioFileInfo`̂ŁAɂ͕KΉ悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT GetComment(DWORD dwFourCC, LPVOID lpvInfo, LPDWORD lpdwSize);
		//  ȖȂǂ̃Rg擾
		//
		//  DWORD dwFourCC		󂯎\̂̎ʎq
		//  LPVOID lpvInfo		󂯎obt@(\)̃|C^
		//  LPDWORD lpdwSize	obt@̃TCY
		//
		//  lpvInfo  NULL nƁAKvȃobt@TCYԂB
		//  񂪎擾ƁAlpdwSize ɎۂɊi[ꂽTCYԂB
		//  obt@TCYȂꍇAG[ԂÂƂ lpdwSize ɕKvȃTCYԂB
		//  W̌`ƂāANVAudioFileComment`̂ŁA
		//  ɂ͕KΉ悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT GetPCMWaveFormat(LPPCMWAVEFORMAT lppcmwf);
		//  fR[hf[^̃tH[}bg擾
		//
		//  LPPCMWAVEFORMAT lppcmwf		󂯎obt@
		//
		//  PCMWAVEFORMAT `ŁAfR[hĂf[^̌`擾B
		//  PCMWAVEFORMAT::wf.wFormatTaǵAWAVE_FORMAT_PCM܂WAVE_FORMAT_IEEE_FLOAT݂̂T|[g

	VCOM_CLASSMETHOD
		NVRESULT DecodeToPCMData(LPVOID lpBuffer, LONG lBufferSize, LPLONG lplResultSize);
		//  f[^fR[hA󂯎
		//
		//  LPVOID lpBuffer			fR[hꂽf[^󂯎obt@
		//  LONG lBufferSize		擾f[^̗
		//  LPLONG lplResultSize	ۂɎ擾ꂽf[^̗
		//
		//  f[^fR[hāAPCM `Ŏ󂯎B̃tH[}bǵAGetPCMWaveFormat Ŏ擾łtH[}bgɊÂĂB
		//  NV_OK Ԃꍇ́AKvTCỸf[^擾ĂB
		//  VAFERR_VALUE_ENDOFDATA ̏ꍇAۂɎ擾ꂽf[^̗ʂ́AlplResultSize ɕԂB
		//  ̌ĂяóAKVAFERR_VALUE_ENDOFDATA ɂȂB
		//  f[^ɃG[̂́A񕜂łꍇɂ́AVAFERR_VALUE_ERRORRECOVEREDԂB
		//	̏ꍇ́AfR[h͂̂܂ܑsłB
		//  ȊÕG[Ԃꍇ́AfR[h𑱂邱Ƃ͂łȂB
		//  f[^̈ꕔłɏꂽꍇ́AlplResultSize ɎۂɎ擾ꂽf[^̗ʂԂĂB

	VCOM_CLASSMETHOD
		NVRESULT Rewind(void);
		//  f[^擪܂Ŋ߂
		//
		//  ʓIɂSetCurrentPosition(0, NVAUDIOFILE_SEEKBEGIN)ƓA
		//  tH[}bgɂĂ͐擪ւ̃V[N͍ɍs邽ߕʓrp
		//  p~ĂǂȁccH

	VCOM_CLASSMETHOD
		NVRESULT FileInfoDialog(HWND hwnd);
		//  t@C̃_CAO\
		//
		//  HWND hwnd		eEBhẼnh
		//
		//  t@C̏Rg[hX_CAO\B
		//  ɍ쐬ς݂̏ꍇɂ́AQdɕ\Ȃ悤ɒ
		//  ܂AAddRef() Release()gāA
		//  \ɃfR[_N[YĂvȂ悤ɂĂKvB
		//  _CAÓANVRegisterDialog()NVUnRegisterDialog()ŁA
		//  bZ[W[vłƏ悤ɂKvB

	VCOM_CLASSMETHOD
		NVRESULT GetCurrentPosition(LPQWUNION lpquPosition, DWORD dwFlag);
		//  t@Č݈ʒuoCgPʂŎ擾
		//
		//  LPQWUNION lpquPosition	擾錻݈ʒũItZbg
		//  DWORD dwFlag			ItZbg̊ʒu

	VCOM_CLASSMETHOD
		NVRESULT SetCurrentPosition(QWUNION quPosition, DWORD dwFlag);
		//  t@Č݈ʒuoCgPʂŐݒ
		//
		//  QWUNION quPosition	ݒ肷錻݈ʒũItZbg
		//  DWORD dwFlag		ItZbg̊ʒu
		//
		//  \ȌoCgPʂł̃V[Ns悤ɂׂA
		//  ݂Lilithł́Ǎ덷ĂvȂɂȂĂB
		//  bp[vOCȂǁÃfR[_TvPʂmsPʂł
		//  V[NsȂɂ́A̒PʂɊۂ߂Ă\ȂB
		//  ÂƂthLgɖL̂S邱ƁB

	VCOM_CLASSMETHOD
		NVRESULT ReferenceTimeToSamples(QWUNION quReferenceTime, LPQWUNION lpquSamples);
		//  QƎ(}CNbP)Tv֕ϊ
		//
		//  QWUNION quReferenceTime		QƎ(}CNbP)
		//  LPQWUNION lpquSamples		Tv
	VCOM_CLASSMETHOD
		NVRESULT SamplesToReferenceTime(QWUNION quSamples, LPQWUNION lpquReferenceTime);
		//  TvQƎ(}CNbP)֕ϊ
		//
		//  QWUNION quSamples			Tv
		//  LPQWUNION lpquReferenceTime	QƎ(}CNbP)
	VCOM_CLASSMETHOD
		NVRESULT GetReferenceTime(LPQWUNION lpquReferenceTime);
		//  ݂̎QƎ(}CNbP)擾
		//
		//  LPQWUNION lpquReferenceTime		QƎ(}CNbP)

	VCOM_CLASSMETHOD
		NVRESULT GetTotalTime(LPQWUNION lpquTotalTime);
		//  }CNbPʂőSĐԂ擾
		//
		//  LPQWUNION lpquTotalTime		SĐ(}CNbP)

protected:
	VCOM_CLASSMETHOD
		NVRESULT AddInterface(DWORD dwFlag);
		//  C^[tF[XQƃe[uɓo^
		//
		//  DWORD dwFlag	NXCX^X̏ꍇPAȊO͂O
		//
		//  RXgN^̒ŌĂ΂AC^[tF[X|C^e[uɓo^A
		//  VIsValidInterface() ŃC^[tF[X̗L؂ł悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT DeleteInterface(void);
		//  C^[tF[XQƃe[u폜
		//
		//  DeleteInstance() ̒ŌĂ΂AC^[tF[X|C^e[u폜B

	friend INT_PTR CALLBACK NVPCM_InfoDialogProc(HWND hwnd, UINT uMessage, WPARAM wParam, LPARAM lParam);

protected:
	NVPCMDATA nvpcmd;
};



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̐錾
//

NVRESULT NVWAVE_EXPORT NVWAVE_API CreateInstance_NVPCM(LPIVCOM lpivcom);
//  CX^X̍쐬
//
//  INVPCM CX^X쐬ÃC^[tF[XԂ


inline void SetNVPCMCreate(LPNVPCMCREATE lpnvpcmc, DWORD dwFlag, LPCTSTR lpcszDataName, LONG lBitsPerSample = 0);
//  NVPCMCREATE \̏֐
//
//  LPNVPCMCREATE lpnvpcmc			\
//  DWORD dwFlag					ZbgtO
//  LPCTSTR lpcszDataName			I[vt@CA܂̓Xg[̃C^[tF[X


inline NVRESULT CheckPCMFileType(INVSTREAM invst, LPLONG lplType, LPQLONG lpqlStartOffset, LPQLONG lpqlDataSize, LPNVPCMINFO lpnvpcmInfo = NULL);
//  oblt@C̃`FbNp֐
//
//  NV_OKԂ΁AINVPCMŎ舵\B
//  lplTypeɂ NVPCM_PCMFORMAT_UNKNOWN/NVPCM_PCMFORMAT_PCMWAVE/NVPCM_PCMFORMAT_IEEEFLOAT̂ꂩi[
//  lpqlStartOffsetɂ́Af[^(RAW-PCM)̊JnItZbgA
//  lpqlDataSizeɂ́Af[^̃TCYԂ
//  lpnvpcmInfow肵ꍇɂ́ANVPCMINFOԂ



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  CC֐̒`
//


inline void SetNVPCMCreate(LPNVPCMCREATE lpnvpcmc, DWORD dwFlag, LPCTSTR lpcszDataName, LONG lBitsPerSample)
{
	lpnvpcmc->dwFourCC = NVPCM_FOURCC;
	lpnvpcmc->dwObjSize = sizeof(NVPCMCREATE);
	lpnvpcmc->dwFlag = dwFlag;
	lpnvpcmc->lpcszDataName = lpcszDataName;
	lpnvpcmc->lBitsPerSample = lBitsPerSample;

	return;
}


inline NVRESULT CheckPCMFileType(INVSTREAM invst, LPLONG lplType, LPQLONG lpqlStartOffset, LPQLONG lpqlDataSize, LPNVPCMINFO lpnvpcmInfo)
{
//  oblt@C̃`FbNp֐

	NVRESULT nvres = NV_OK;
	union
	{
		struct
		{
			DWORD dwTag;
			DWORD dwDataSize;
		};
		QWORD Header;
		struct
		{
			DWORD dwFileSize;
			DWORD dwFileType;
		};
		QWORD FileInfo;
	};
	DWORD dwRead;
	LPWAVEFORMATEX lpwfx = NULL;
	NVPCMINFO nvpcmInfo;
	QWUNION quFilePosition;
	QLONG qlStartOffset = 0;
	QLONG qlDataSize = 0;

	//  ߂lĂ
	*lplType = NVPCM_PCMFORMAT_UNKNOWN;

	do
	{
		//  t@C|WVۑĂ
		invst->GetCurrentPosition(&quFilePosition.ql, NVSTREAM_SEEKBEGIN);

		//  擪^Oǂݏo
		nvres = invst->Read(&dwTag, sizeof(DWORD), &dwRead);
		if (nvres)
		{
			nvres = VPCMERR_VALUE_FILEISBROKEN;
			break;
		}

		//  RIFF t@CłȂ΃G[
		if (dwTag != MAKEFOURCC('R', 'I', 'F', 'F'))
		{
			nvres = VPCMERR_VALUE_UNSUPPORTEDFILE;
			break;
		}

		{
			//  t@CTCYt@C^Cvǂݏo
			nvres = invst->Read(&FileInfo, sizeof(DWORD) * 2, &dwRead);
			if (nvres)
			{
				nvres = VPCMERR_FILEISBROKEN;
				break;
			}

			//  WAVE t@CłȂ΃G[
			if (dwFileType != MAKEFOURCC('W', 'A', 'V', 'E'))
			{
				nvres = VPCMERR_VALUE_UNSUPPORTEDFILE;
				break;
			}
		}

		//  `N^O`NTCYǂݏo
		nvres = invst->Read(&Header, sizeof(DWORD) * 2, &dwRead);
		if (nvres)
		{
			nvres = VPCMERR_FILEISBROKEN;
			break;
		}
		//  fmt  `N܂ŌJԂ
		while (dwTag != MAKEFOURCC('f', 'm', 't', ' '))
		{
			//  ̃`N̐擪܂ňړ
			nvres = invst->SetCurrentPosition(dwDataSize + (dwDataSize & 0x01), NVSTREAM_SEEKCURRENT);

			//  ̃`N擾
			nvres = invst->Read(&Header, sizeof(DWORD) * 2, &dwRead);
			if (nvres)
			{
				nvres = VPCMERR_FILEISBROKEN;
				break;
			}
		}

		if (dwDataSize < sizeof(PCMWAVEFORMAT))
		{
			nvres = VPCMERR_FILEISBROKEN;
			break;
		}

		//  WAVEFORMATEX ̃obt@m
		lpwfx = (LPWAVEFORMATEX) NVMemAlloc(NVMEM_FIXED, dwDataSize);

		//  WAVEFORMATEX ǂݏo
		nvres = invst->Read(lpwfx, dwDataSize, &dwRead);
		if (nvres)
		{
			nvres = VPCMERR_FILEISBROKEN;
			break;
		}
		if (dwDataSize & 0x01)
		{
			invst->SetCurrentPosition(1, NVSTREAM_SEEKCURRENT);
		}

		if ((lpwfx->wFormatTag != WAVE_FORMAT_PCM) && (lpwfx->wFormatTag != WAVE_FORMAT_IEEE_FLOAT) && (lpwfx->wFormatTag != WAVE_FORMAT_EXTENSIBLE))
		{
			//  oblȊȌꍇG[Ƃ
			nvres = VPCMERR_VALUE_UNSUPPORTEDFILE;
			break;
		}

		//  ̃`N擾
		nvres = invst->Read(&Header, sizeof(DWORD) * 2, &dwRead);
		if (nvres)
		{
			nvres = VPCMERR_FILEISBROKEN;
			break;
		}

		//  data `N܂ŌJԂ
		while (dwTag != MAKEFOURCC('d', 'a', 't', 'a'))
		{
			//  ̃`N̐擪܂ňړ
			nvres = invst->SetCurrentPosition(dwDataSize + (dwDataSize & 0x01), NVSTREAM_SEEKCURRENT);

			//  ̃`N擾
			nvres = invst->Read(&Header, sizeof(DWORD) * 2, &dwRead);
			if (nvres)
			{
				nvres = VPCMERR_FILEISBROKEN;
				break;
			}
		}

		if (nvres)
		{
			break;
		}

		//  ̈ʒuoblf[^̎n_
		//  f[^TCÝA`ÑTCY
		if (lpwfx->wFormatTag == WAVE_FORMAT_EXTENSIBLE)
		{
			if (((WAVEFORMATEXTENSIBLE *)lpwfx)->SubFormat == KSDATAFORMAT_SUBTYPE_IEEE_FLOAT)
			{
				*lplType = NVPCM_PCMFORMAT_IEEEFLOAT;
			}
			else if (((WAVEFORMATEXTENSIBLE *)lpwfx)->SubFormat == KSDATAFORMAT_SUBTYPE_PCM)
			{
				*lplType = NVPCM_PCMFORMAT_PCMWAVE;
			}
			else
			{
				nvres = VPCMERR_VALUE_UNSUPPORTEDFILE;
				break;
			}
		}
		else if (lpwfx->wFormatTag == WAVE_FORMAT_IEEE_FLOAT)
		{
			if ((lpwfx->wBitsPerSample != 32) && (lpwfx->wBitsPerSample != 64))
			{
				nvres = VPCMERR_VALUE_UNSUPPORTEDFILE;
				break;
			}

			*lplType = NVPCM_PCMFORMAT_IEEEFLOAT;
		}
		else
		{
			*lplType = NVPCM_PCMFORMAT_PCMWAVE;
		}
		nvres = invst->GetCurrentPosition(&qlStartOffset, NVSTREAM_SEEKBEGIN);
		if (nvres)
		{
			break;
		}

		nvres = invst->GetDataSize((LPQWORD) &qlDataSize);
		qlDataSize = min(dwDataSize, qlDataSize - qlStartOffset);
		if (qlDataSize <= 0)
		{
			nvres = VPCMERR_FILEISBROKEN;
			break;
		}

		//  NVPCMINFO ݒ
		nvpcmInfo.dwFourCC = NVPCM_FOURCC;
		nvpcmInfo.dwObjSize = sizeof(NVPCMINFO);
		nvpcmInfo.dwFileType = NVPCM_FOURCC;
		nvpcmInfo.quDataSize.qw = qlDataSize;
		nvpcmInfo.quDecodedSize.qw = qlDataSize;
		nvpcmInfo.dwBitsPerSample = lpwfx->wBitsPerSample;
		nvpcmInfo.dwSamplerate = lpwfx->nSamplesPerSec;
		nvpcmInfo.dwMode = lpwfx->nChannels;
		nvpcmInfo.quPlayTime.qw = nvpcmInfo.quDecodedSize.qw * 1000 / ((nvpcmInfo.dwBitsPerSample / 8) * nvpcmInfo.dwSamplerate * nvpcmInfo.dwMode);
		nvpcmInfo.dwBitrate = (DWORD) (nvpcmInfo.quDataSize.qw * nvpcmInfo.dwBitsPerSample * nvpcmInfo.dwSamplerate * nvpcmInfo.dwMode / (nvpcmInfo.quDecodedSize.qw * 1000));
		nvpcmInfo.dwFlag = 0;
		{
			const TCHAR *lpszMode[9] = { TEXT("Unknown"), TEXT("Monaural"), TEXT("Stereo"), TEXT("3 Channels"), TEXT("4 Channels"), TEXT("4.1 Channels"), TEXT("5.1 Channels"), TEXT("7.0 Channels"), TEXT("7.1 Channels") };
			_tcscpy_s(nvpcmInfo.lpszModeString, NVAUDIOFILEINFO_MODESTRING_MAX, (nvpcmInfo.dwMode < 9) ? lpszMode[nvpcmInfo.dwMode] : lpszMode[0]);
		}
		invst->GetDataName(nvpcmInfo.lpszDataName, NV_PATHMAX);
		_tcscpy_s(nvpcmInfo.lpszFormatString, NVAUDIOFILEINFO_FORMATSTRING_MAX, TEXT("Pulse Code Modulation"));

		*lpqlStartOffset = qlStartOffset;
		*lpqlDataSize = qlDataSize;
		NVMemFree(lpwfx);
		lpwfx = NULL;
	}
	while (0);

	if (nvres)
	{
		if (lpwfx)
		{
			NVMemFree(lpwfx);
		}
		//  t@C|C^߂
		invst->SetCurrentPosition(quFilePosition.ql, NVSTREAM_SEEKBEGIN);

		*lplType = NVPCM_PCMFORMAT_UNKNOWN;
		*lpqlStartOffset = 0;
		*lpqlDataSize = 0;
		return nvres;
	}

	//  t@C|C^߂
	invst->SetCurrentPosition(quFilePosition.ql, NVSTREAM_SEEKBEGIN);

	//  NVPCMINFO ̗v΁ARs[
	if (lpnvpcmInfo)
	{
		CopyMemory(lpnvpcmInfo, &nvpcmInfo, sizeof(NVPCMINFO));
	}

	return NV_OK;
}




#pragma pack(pop)

#ifdef __cplusplus
}
#endif
