//  ȉANorthern Verseɂg
//  ̒̕쌠́AԂNorthern Verseɂ܂B


#include "NVExtension.h"
#include <stdio.h>

//#define USE_RESET_DEVICE
#define USE_ALLOCA


#ifdef USE_ALLOCA
#include <malloc.h>
#endif

extern CDHANDLEREC *cdHandles;
extern HANDLE *cdMutexes;
extern CRITICAL_SECTION getHandle;
extern int alErrCode;
extern BYTE alAspiErr;
extern int *nextHandle;

extern DWORD (*pfnSendASPI32Command)(LPSRB);

extern void MSB2DWORD( DWORD *d, BYTE *b );


//#define NV_LOG_ENABLE
#ifdef NV_LOG_ENABLE
#include <shlwapi.h>
#pragma comment(lib, "shlwapi.lib")
void NVOutputDebugLog(char *fmt, ...)
{
	va_list arg;
	FILE *fp;
	char szName[1024];
	char buf[1024];

	GetModuleFileName((HMODULE)GetModuleHandle(NULL), szName, 1024);
	PathRemoveFileSpec(szName);
	PathAppend(szName, "\\ReadTocLog.txt");
	fp =fopen(szName, "a");

	va_start(arg, fmt);

	vsprintf(buf, fmt, arg);
	fputs(buf, fp);

	va_end(arg);
	fclose(fp);
}
#else
#define NVOutputDebugLog
#endif



DWORD ModeSense(LONG lPage, LPBYTE lpBuffer, WORD wBufSize, HCDROM hCD)
{
	DWORD dwStatus;
	BYTE cmd[10];
	int idx = (int)hCD - 1;
	
	if ( (idx<0) || (idx>=MAXCDHAND) )
	{
		alErrCode = ALERR_INVHANDLE;
		return SS_ERR;
	}

	memset(lpBuffer, 0x00, wBufSize);
	memset(cmd, 0x00, sizeof(cmd));

	cmd[1] = cdHandles[idx].lun << 5;
	cmd[2] = lPage & 0x3F;

	if (cdHandles[idx].fAtapi)	//  ATAPI
	{
		LONG len;

		cmd[0] = 0x5A;
		cmd[7] = wBufSize >> 8;
		cmd[8] = wBufSize & 0xFF;

		dwStatus = IssueSCSICommand(SRB_DIR_IN, cmd, 10, lpBuffer, wBufSize, hCD);

		len = (lpBuffer[0] << 8) | lpBuffer[1];

		lpBuffer[0] = (BYTE)(len - 4);
		lpBuffer[1] = lpBuffer[2];
		lpBuffer[2] = lpBuffer[3];
		lpBuffer[3] = lpBuffer[7];

		memmove(lpBuffer + 4, lpBuffer + 8, wBufSize - 4);
	}
	else
	{
		cmd[0] = 0x1A;
		cmd[4] = wBufSize & 0xFF;

		dwStatus = IssueSCSICommand(SRB_DIR_IN, cmd, 6, lpBuffer, wBufSize, hCD);
	}

	return dwStatus;
}

DWORD ModeSelect(LONG lPageSize, LPBYTE lpBuffer, WORD wBufSize, BOOL fPageFormat, HCDROM hCD)
{
	DWORD dwStatus;
	BYTE cmd[10];
	int idx = (int)hCD - 1;
	
	if ( (idx<0) || (idx>=MAXCDHAND) )
	{
		alErrCode = ALERR_INVHANDLE;
		return SS_ERR;
	}

	memset(cmd, 0x00, sizeof(cmd));

	if (cdHandles[idx].fAtapi)	//  ATAPI
	{
		LONG lBlockSize = 8;

		cmd[0] = 0x55;
		cmd[1] = (cdHandles[idx].lun << 5) | ((fPageFormat) ? 0x10 : 0x00);
		cmd[8] = (BYTE)(lPageSize + lBlockSize);

		memmove(lpBuffer + lBlockSize, lpBuffer, wBufSize - lBlockSize);
		memset(lpBuffer, 0x00, lBlockSize);
		lpBuffer[lBlockSize - 1] = 8;
		dwStatus = IssueSCSICommand(SRB_DIR_OUT, cmd, 10, lpBuffer, lPageSize + lBlockSize, hCD);
	}
	else
	{
		LONG lBlockSize = 4;

		cmd[0] = 0x15;
		cmd[1] = (cdHandles[idx].lun << 5) | ((fPageFormat) ? 0x10 : 0x00);
		cmd[4] = (BYTE)(lPageSize + lBlockSize);
		memmove(lpBuffer + lBlockSize, lpBuffer, wBufSize - lBlockSize);
		memset(lpBuffer, 0x00, lBlockSize);
		lpBuffer[lBlockSize - 1] = 8;
		dwStatus = IssueSCSICommand(SRB_DIR_OUT, cmd, 6, lpBuffer, lPageSize + lBlockSize, hCD);
	}
	return dwStatus;
}


DWORD GetSectorSize(BYTE *lpbDensity, HCDROM hCD)
{
	BYTE buf[256];
	DWORD dwSectorSize = 2352;
	DWORD dwStatus;

	*lpbDensity = 0;

	memset(buf, 0x00, sizeof(buf));
	dwStatus = ModeSense(0x01, buf, sizeof(buf), hCD);

	if (dwStatus == SS_COMP && buf[3] > 0)
	{
		*lpbDensity = buf[4];
		dwSectorSize = (buf[9] << 16) | (buf[10] << 8) | buf[11];
	}

    return dwSectorSize;
}

DWORD SetSectorSize(DWORD dwSecSize,BYTE bDensity, HCDROM hCD)
{
	BYTE buf[16];

	memset(buf, 0x00, sizeof(buf));
	if (dwSecSize == 2048)
	{
		bDensity = 0x81;
	}

	buf[0] = bDensity;
	buf[6] = (BYTE)(dwSecSize >> 8);
	buf[7] = (BYTE)(dwSecSize & 0xFF);

	return ModeSelect(8, buf, 16, FALSE, hCD);
}

DWORD EnableCdda(BOOL fAudioMode, HCDROM hCD)
{
	BYTE bDensity;
	DWORD dwSecSize = GetSectorSize(&bDensity, hCD);
	int idx = (int)hCD - 1;
	
	if ( (idx<0) || (idx>=MAXCDHAND) )
	{
		alErrCode = ALERR_INVHANDLE;
		return SS_ERR;
	}

	if (fAudioMode)
	{
		cdHandles[idx].dwSecSize = dwSecSize;
		cdHandles[idx].bDensity = bDensity;

		return SetSectorSize(2352, 0, hCD);
	}
	else
	{
		return SetSectorSize(cdHandles[idx].dwSecSize, cdHandles[idx].bDensity, hCD);
	}
}

DWORD PreventMediaRemoval(BOOL fLock, HCDROM hCD)
{
	BYTE cmd[6] = { 0x1E, 0, 0, 0, fLock ? 1 : 0, 0 };
	int idx = (int)hCD - 1;
	if ( (idx<0) || (idx>=MAXCDHAND) )
	{
		alErrCode = ALERR_INVHANDLE;
		return SS_ERR;
	}

	cmd[1] = cdHandles[idx].lun << 5;
	return IssueSCSICommand(SRB_DIR_OUT, cmd, sizeof(cmd), NULL, 0, hCD);
}

DWORD IssueSCSICommand(BYTE bFlags, LPVOID cmd, BYTE bCmdSize, LPVOID lpBuffer, DWORD dwBufSize, HCDROM hCD)
{
	int idx = (int)hCD - 1;
	
	if ( (idx<0) || (idx>=MAXCDHAND) )
	{
		alErrCode = ALERR_INVHANDLE;
		return SS_ERR;
	}
	
	return IssueSCSICommandDirect(bFlags, cmd, bCmdSize, lpBuffer, dwBufSize, cdHandles[idx].ha, cdHandles[idx].tgt, cdHandles[idx].lun);
}

DWORD IssueSCSICommandDirect(BYTE bFlags, LPVOID cmd, BYTE bCmdSize, LPVOID lpBuffer, DWORD dwBufSize, BYTE ha, BYTE tgt, BYTE lun)
{
	DWORD dwStatus;
	SRB_ExecSCSICmd s;
	HANDLE heventSRB;
	LPVOID lpBufSub = NULL;
	LPVOID lpBufAlign = NULL;

	if (sizeof(s.CDBByte) < bCmdSize)
	{
		return SS_ERR;
	}

	if (dwBufSize > 0xFFFF)
	{
		return SS_ERR;
	}

	if (((DWORD)lpBuffer) & 0x0F)
	{
#ifdef USE_ALLOCA
		lpBufSub = _alloca(dwBufSize + 0x10);
		lpBufAlign = (LPVOID) ((((DWORD) lpBufSub) + 0x10) & 0xFFFFFFF0);
#else
		lpBufSub = malloc(dwBufSize + 0x10);
		lpBufAlign = (LPVOID) ((((DWORD) lpBufSub) + 0x10) & 0xFFFFFFF0);
#endif
		CopyMemory(lpBufAlign, lpBuffer, dwBufSize);
	}

	heventSRB = CreateEvent(NULL, TRUE, FALSE, NULL);

	memset(&s, 0, sizeof(s));
	s.SRB_Cmd = SC_EXEC_SCSI_CMD;
	s.SRB_HaID = ha;
	s.SRB_Target = tgt;
	s.SRB_Lun = lun;
	s.SRB_Flags = bFlags | SRB_EVENT_NOTIFY;
	s.SRB_BufLen = (WORD)dwBufSize;
	s.SRB_BufPointer = (BYTE FAR *) (lpBufAlign ? lpBufAlign : lpBuffer);
	s.SRB_SenseLen = SENSE_LEN;
	s.SRB_CDBLen = bCmdSize;
	s.SRB_PostProc = (LPVOID) heventSRB;
	memcpy(s.CDBByte, cmd, bCmdSize);

	ResetEvent(heventSRB);
	dwStatus = pfnSendASPI32Command((LPSRB) &s);
	if (dwStatus == SS_PENDING)
	{
		if (WaitForSingleObject(heventSRB, NVEXT_WAIT_TIMEOUT) == WAIT_TIMEOUT)
		{
			ResetEvent(heventSRB);
		}
		if (s.SRB_Status == SS_PENDING)
		{
			abortOperation((LPSRB) &s);
			CloseHandle(heventSRB);
			return SS_ABORTED;
		}
	}

	if (lpBufAlign)
	{
		CopyMemory(lpBuffer, lpBufAlign, dwBufSize);
	}
#ifdef USE_ALLOCA
#else
	free(lpBufSub);
#endif
	CloseHandle(heventSRB);

	return s.SRB_Status;
}

#ifdef USE_NV_EXTENSION
//  CD-ExtraŃNbV\̂ŁA
//  x_j[NR[hgāAPZbṼZN^𐳊mɎ擾āA
//  QZbVȍ~̃gbN폜悤Co[W
//  C̒쌠́ANorthern Verseɂ邩

#define SESSION_INFO_SIZE 16
//#define SESSION_INFO_SIZE 12

DWORD ReadTOC( HCDROM hCD, LPTOC toc )
{
	DWORD dwStatus;
	DWORD retVal = SS_COMP;
	int idx = (int)hCD - 1;

	NVOutputDebugLog("Enter ReadToc\n");

	if ( (idx<0) || (idx>=MAXCDHAND) )
	{
		alErrCode = ALERR_INVHANDLE;
		return SS_ERR;
	}

	if ( WaitForSingleObject( cdMutexes[idx], TIMEOUT ) != WAIT_OBJECT_0 )
	{
		alErrCode = ALERR_LOCK;
		return SS_ERR;
	}

	if ( !cdHandles[idx].used )
	{
		alErrCode = ALERR_INVHANDLE;
		ReleaseMutex( cdMutexes[idx] );
		return SS_ERR;
	}

	NVOutputDebugLog("ReadToc\n");
	{
		BYTE cmd[10];

		memset(cmd, 0x00, sizeof(cmd));
		cmd[0] = 0x43;
		cmd[1] = (cdHandles[idx].lun << 5) | (cdHandles[idx].bMSF ? 0x02 : 0x00);
		cmd[7] = 0x03;
		cmd[8] = 0x24;

		dwStatus = IssueSCSICommand(SRB_DIR_IN, cmd, sizeof(cmd), toc, 0x324, hCD);
	}

	if (dwStatus != SS_COMP )
	{
		NVOutputDebugLog("ReadToc Error\n");
		alErrCode = ALERR_ASPI;
		alAspiErr = (BYTE)dwStatus;
		retVal = SS_ERR;
	}

	if (dwStatus == SS_COMP)
	{
		BOOL bMultiSession = FALSE;
		DWORD FirstSessionEnd = 0x7FFFFFFF;
		BYTE Format1 = 1;
		BYTE Format2 = 2;
		BYTE Vendor1 = 0;
		BYTE Vendor2 = 0;
		{
			BYTE cmd[10];
			BYTE pbtBuffer[SESSION_INFO_SIZE];

			memset(cmd, 0x00, sizeof(cmd));
			memset(pbtBuffer, 0x00, sizeof(pbtBuffer));

			cmd[0] = 0x43;
			cmd[1] = cdHandles[idx].lun << 5;
			cmd[2] = Format1;
			cmd[6] = 1;
			cmd[8] = SESSION_INFO_SIZE;
			cmd[9] = Vendor1;
			NVOutputDebugLog("GetSessionCount by MMC\n");
			dwStatus = IssueSCSICommand(SRB_DIR_IN, cmd, sizeof(cmd), pbtBuffer, sizeof(pbtBuffer), hCD);

			if (dwStatus == SS_COMP && pbtBuffer[0] == 0x00 && pbtBuffer[1] == 0x0A && pbtBuffer[2] == 1)
			{
				NVOutputDebugLog("GetSessionCount by MMC Success.\n");
			}
			else
			{
#ifdef USE_RESET_DEVICE
				ResetDevice(hCD);
#endif

				NVOutputDebugLog("GetSessionCount by MMC Failed.\n");
				memset(pbtBuffer, 0x00, sizeof(pbtBuffer));

				Format1 = 0;
				Format2 = 0;
				Vendor1 = 0x40;
				Vendor2 = 0x80;

				cmd[2] = Format1;
				cmd[9] = Vendor1;

				NVOutputDebugLog("GetSessionCount by Sony\n");
				dwStatus = IssueSCSICommand(SRB_DIR_IN, cmd, sizeof(cmd), pbtBuffer, sizeof(pbtBuffer), hCD);
				if (dwStatus == SS_COMP && pbtBuffer[0] == 0x00 && pbtBuffer[1] == 0x0A && pbtBuffer[2] == 1)
				{
					NVOutputDebugLog("GetSessionCount by Sony Success.\n");
				}
				else
				{
#ifdef USE_RESET_DEVICE
					ResetDevice(hCD);
#endif
					NVOutputDebugLog("GetSessionCount by Sony Failed.\n");
					Format1 = 0xFF;
				}
			}
			
			if (Format1 != 0xFF)
			{
				if (pbtBuffer[2] < pbtBuffer[3])
				{
					bMultiSession = TRUE;

					cmd[2] = Format2;
					cmd[9] = Vendor2;

					NVOutputDebugLog("GetSessionInfoSize by %s\n", (Vendor2) ? "Sony" : "MMC");
					dwStatus = IssueSCSICommand(SRB_DIR_IN, cmd, sizeof(cmd), pbtBuffer, sizeof(pbtBuffer), hCD);

					if (dwStatus == SS_COMP)
					{
					}
					else
					{
#ifdef USE_RESET_DEVICE
						ResetDevice(hCD);
						NVOutputDebugLog("GetSessionInfoSize by %s Failed.\n", (Vendor2) ? "Sony" : "MMC");
#endif
					}
					if (dwStatus == SS_COMP)
					{
						DWORD dwSize = ((DWORD)pbtBuffer[0] << 8 | pbtBuffer[1]) + 4;
						LPBYTE pbtBuffer2 = (LPBYTE) malloc(dwSize);
						memset(pbtBuffer2, 0x00, dwSize);

						cmd[7] = (BYTE)(dwSize >> 8);
						cmd[8] = (BYTE)(dwSize & 0xFF);

						NVOutputDebugLog("ReadSessionInfo by %s\n", (Vendor2) ? "Sony" : "MMC");
						dwStatus = IssueSCSICommand(SRB_DIR_IN, cmd, sizeof(cmd), pbtBuffer2, dwSize, hCD);
						
						NVOutputDebugLog("GetSessionInfoSize by %s %s\n", (Vendor2) ? "Sony" : "MMC", (dwStatus == SS_COMP) ? "Success" : "Failed");
						if (dwStatus == SS_COMP)
						{
							LPBYTE lp = pbtBuffer2 + 4;
							DWORD dwCount = (dwSize - 4) / 11;
							DWORD i;
							for (i = 0; i < dwCount; i++, lp += 11)
							{
								if (lp[3] == 0xA2)
								{
									FirstSessionEnd = lp[8] * 60 * 75 + lp[9] * 75 + lp[10];
									break;
								}
							}
						}
						free(pbtBuffer2);
					}
				}
			}
		}

		if (FirstSessionEnd != 0x7FFFFFFF)
		{
			BYTE addr[4];
			if (cdHandles[idx].bMSF)
			{
				memcpy(addr, toc->tracks[0].addr, 4);
			}
			else
			{
				TOC toc2;
				BYTE cmd[10];

				memset(cmd, 0x00, sizeof(cmd));
				cmd[0] = 0x43;
				cmd[1] = (cdHandles[idx].lun << 5) | 0x02;
				cmd[7] = 0x03;
				cmd[8] = 0x24;

				NVOutputDebugLog("ReadToc 2nd\n");
				dwStatus = IssueSCSICommand(SRB_DIR_IN, cmd, sizeof(cmd), &toc2, 0x324, hCD); 

				if (dwStatus == SS_COMP)
				{
					NVOutputDebugLog("ReadToc 2nd Success\n");
					memcpy(addr, toc2.tracks[0].addr, 4);
				}
				else
				{
					NVOutputDebugLog("ReadToc 2nd Failed\n");
					addr[0] = 0;
					addr[1] = 0;
					addr[2] = 2;
					addr[3] = 0;
				}
			}

			{
				LONG lStartSector;
				lStartSector = addr[0] * 60 * 60 * 75 + addr[1] * 60 * 75 + addr[2] * 75 + addr[3];
				FirstSessionEnd -= lStartSector;
			}
		}
		
		if (FirstSessionEnd != 0x7FFFFFFF)
		{
			LONG i;
			LONG limit;
			if (cdHandles[idx].bMSF)
			{
				limit = FirstSessionEnd / (60 * 60 * 75);
				limit <<= 8;
				limit |= (FirstSessionEnd / (60 * 75)) % 60;
				limit <<= 8;
				limit |= (FirstSessionEnd / (75)) % 60;
				limit <<= 8;
				limit |= FirstSessionEnd % 75;
			}
			else
			{
				limit = FirstSessionEnd;
			}
			for (i = 0; i < 100; )
			{
				LONG sector;
				MSB2DWORD((LPDWORD)&sector, toc->tracks[i].addr);
				if (toc->tracks[i].trackNumber == 0xAA)
				{
					toc->tracks[i].addr[0] = (limit >> 24) & 0xFF;
					toc->tracks[i].addr[1] = (limit >> 16) & 0xFF;
					toc->tracks[i].addr[2] = (limit >> 8) & 0xFF;
					toc->tracks[i].addr[3] = (limit) & 0xFF;
					toc->lastTrack = (BYTE)i;
					if (i < 100 - 1)
					{
						memset(&toc->tracks[i + 1], 0, (100 - 1 - i) * sizeof(TOCTRACK));
					}
					break;
				}
				else if (sector > limit)
				{
					{
						LONG j;
						for (j = i; j < toc->lastTrack; j++)
						{
							toc->tracks[j] = toc->tracks[j + 1];
						}
					}
				}
				else
				{
					i++;
				}
			}
		}
	}

	ReleaseMutex( cdMutexes[idx] );

	NVOutputDebugLog("Leave ReadToc\n");
	return retVal;
}

#endif

BOOL EjectCD( HCDROM hCD, BOOL fEject)
{
//  CD̃CWFNgor}Eg֐
//  fEject = TRUE ŃCWFNgAFALSEŃ}Eg
	DWORD dwStatus;
	DWORD retVal = SS_COMP;
	int idx = (int)hCD - 1;
	
	if ( (idx<0) || (idx>=MAXCDHAND) )
	{
		alErrCode = ALERR_INVHANDLE;
		return SS_ERR;
	}
	
	if ( WaitForSingleObject( cdMutexes[idx], TIMEOUT ) != WAIT_OBJECT_0 )
	{
		alErrCode = ALERR_LOCK;
		return SS_ERR;
	}
	
	if ( !cdHandles[idx].used )
	{
		alErrCode = ALERR_INVHANDLE;
		ReleaseMutex( cdMutexes[idx] );
		return SS_ERR;
	}

	{
		BYTE cmd[6] = { 0x1B, cdHandles[idx].lun << 5, 0, 0, (fEject) ? 0x02 : 0x03, 0 };

		dwStatus = IssueSCSICommand(SRB_DIR_OUT, cmd, sizeof(cmd), NULL, 0, hCD);

		if (dwStatus != SS_COMP)
		{
			alErrCode = ALERR_ASPI;
			alAspiErr = (BYTE)dwStatus;
			retVal = SS_ERR;
		}
	}
	
	ReleaseMutex( cdMutexes[idx] );
	return retVal;
}

static TOC staticToc;
static LPBYTE staticCDText = NULL;
static LONG staticCDTextSize = 0;
static BOOL fMediaChanged = TRUE;

DWORD ReadCDText( HCDROM hCD, LPBYTE lpbBuffer,int nBufferSize, LPINT lpnCDTextSize)
{
//  CD-TEXTǂݎ֐
//  lpbBufferNULLwŁAlpnCDTextSizeCD-TEXT̃TCYԂB

//  ȂACD-TEXTǂݎɂ͔rIԂ悤Ȃ̂ŁA
//  ̂߂ɓǂݎɎԂ̂ȂTOCCD̓ւoA
//  TOCςĂȂCD-TEXTςĂȂƂ݂ȂāAǑʂԂB
//  TOCSCD-TEXTႤꍇAǂݏoȂƂoOB
//  ȂÃoO΍ƂāANotifyMediaChange()֐ŁACD̓ւm点邱ƂłB
//  tgGhWindows̃bZ[WȂǂCD̓ւołꍇɂ́A
//  NotifyMediaChange()֐gƂŁAL̃oO͖̔hB
	DWORD dwStatus;
	DWORD retVal = SS_COMP;
	int idx = (int)hCD - 1;
	BOOL bIsChanged = TRUE;
	TOC CurToc;
	

	if ( (idx<0) || (idx>=MAXCDHAND) )
	{
		alErrCode = ALERR_INVHANDLE;
		return SS_ERR;
	}
	
	if ( WaitForSingleObject( cdMutexes[idx], TIMEOUT ) != WAIT_OBJECT_0 )
	{
		alErrCode = ALERR_LOCK;
		return SS_ERR;
	}
	
	if ( !cdHandles[idx].used )
	{
		alErrCode = ALERR_INVHANDLE;
		ReleaseMutex( cdMutexes[idx] );
		return SS_ERR;
	}
	
	{
		BYTE cmd[10];
		memset(cmd, 0x00, sizeof(cmd));
		cmd[0] = 0x43;
		cmd[1] = cdHandles[idx].lun << 5;
		cmd[6] = 1;
		cmd[7] = sizeof(CurToc) >> 8;
		cmd[8] = sizeof(CurToc) & 0xFF;

		memset(&CurToc, 0x00, sizeof(CurToc));

		dwStatus = IssueSCSICommand(SRB_DIR_IN, cmd, sizeof(cmd), &CurToc, sizeof(CurToc), hCD);

		if (dwStatus != SS_COMP)
		{
			alErrCode = ALERR_ASPI;
			alAspiErr = (BYTE)dwStatus;
			retVal = SS_ERR;
			ReleaseMutex( cdMutexes[idx] );
			return SS_ERR;
		}
	}

	if (fMediaChanged)
	{
		fMediaChanged = FALSE;
	}
	else
	{
		//if (staticCDText)	//  02/07/03 fixed
		{
			bIsChanged = memcmp(&staticToc, &CurToc, sizeof(TOC));
		}
	}
	if (! bIsChanged)
	{
		*lpnCDTextSize = staticCDTextSize;
		CopyMemory(lpbBuffer, staticCDText, min(nBufferSize, staticCDTextSize));
	}
	else
	{
		BYTE buf[4];
		BYTE cmd[10];

		CopyMemory(&staticToc, &CurToc, sizeof(TOC));
		memset(buf, 0, sizeof(buf));
		memset(cmd, 0, sizeof(cmd));

		cmd[0] = 0x43;
		cmd[1] = cdHandles[idx].lun << 5;
		cmd[2] = 0x05;
#if 0
		cmd[6] = 0x01;
#endif
		cmd[7] = 0x00;
		cmd[8] = 0x04;

		if (staticCDText)
		{
			free(staticCDText);
			staticCDText = NULL;
			staticCDTextSize = 0;
		}

		dwStatus = IssueSCSICommand(SRB_DIR_IN, cmd, sizeof(cmd), buf, sizeof(buf), hCD);

		if ( dwStatus != SS_COMP )
		{
			alErrCode = ALERR_ASPI;
			alAspiErr = (BYTE)dwStatus;
			retVal = SS_ERR;
			ReleaseMutex( cdMutexes[idx] );
			return SS_ERR;
		}

		*lpnCDTextSize = ((buf[0] << 8) | buf[1]) + 2;

		if (*lpnCDTextSize < 4)
		{
			retVal = SS_ERR;
		}
		else
		{
			BYTE cmd[10];

			staticCDText = (LPBYTE) malloc(*lpnCDTextSize);
			staticCDTextSize = *lpnCDTextSize;

			memset(cmd, 0x00, sizeof(cmd));
			cmd[0] = 0x43;
			cmd[1] = cdHandles[idx].lun << 5;
			cmd[2] = 0x05;
			cmd[6] = 0x01;
			cmd[7] = (BYTE)(staticCDTextSize >> 8);
			cmd[8] = (BYTE)(staticCDTextSize & 0xFF);

			dwStatus = IssueSCSICommand(SRB_DIR_IN, cmd, sizeof(cmd), staticCDText, staticCDTextSize, hCD);
			
			if ( dwStatus != SS_COMP )
			{
				free(staticCDText);
				staticCDText = NULL;
				staticCDTextSize = 0;

				alErrCode = ALERR_ASPI;
				alAspiErr = (BYTE)dwStatus;
				retVal = SS_ERR;
				ReleaseMutex( cdMutexes[idx] );
				return SS_ERR;
			}
			CopyMemory(lpbBuffer, staticCDText, min(nBufferSize, staticCDTextSize));
		}
	}

	ReleaseMutex( cdMutexes[idx] );
	return retVal;
}

DWORD NotifyMediaChange(void)
{
//  fBǍƂCuɒm点֐
//  tgGhŃfBǍoꍇɂ́A
//  ̊֐ĂяoׂłB
	fMediaChanged = TRUE;
	return SS_COMP;
}

DWORD abortOperation(LPSRB lpsrb)
{
	SRB_Abort a;

	memset(&a, 0, sizeof(a));
	a.SRB_Cmd = SC_ABORT_SRB;
	a.SRB_HaId = lpsrb->SRB_HaId;
	a.SRB_ToAbort = lpsrb;
	return pfnSendASPI32Command((LPSRB) &a);
}

char TranslateDeviceIDToDriveLetter(BYTE ha, BYTE tgt, BYTE lun)
{
  extern BOOL  (*pfnTranslateASPI32Address)(PDWORD,PDWORD);
  DWORD dwAspiPath;
  DWORD dwID;
  BOOL ret;

  if (pfnTranslateASPI32Address == NULL)
  {
	  return 0;
  }

  dwAspiPath = (((DWORD) ha) << 16) | (((DWORD) tgt) << 8) | (((DWORD) lun));
  dwID = 0;

  ret = pfnTranslateASPI32Address(&dwAspiPath, &dwID);
  if (ret)
  {
	  HKEY hKey;
	  char szKey[256];

	  wsprintf(szKey, "Config Manager\\Enum\\%08X", dwID);
	  if (RegOpenKeyEx(HKEY_DYN_DATA, szKey, 0, KEY_ALL_ACCESS, &hKey) == NOERROR)
	  {
		  char szDeviceKey[256];
		  DWORD dwSize = 256;
		  DWORD dwType;
		  if (RegQueryValueEx(hKey, "HardWareKey", NULL, &dwType, (LPBYTE) szDeviceKey, &dwSize) == NOERROR)
		  {
			  if (dwType == REG_SZ)
			  {
				  HKEY hKeyDevice;
				  if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, szDeviceKey, 0, KEY_ALL_ACCESS, &hKeyDevice) == NOERROR)
				  {
					  char szDriveAssign[256];
					  DWORD dwSize = 256;
					  DWORD dwType;
					  szDriveAssign[0] = '\0';
					  if (RegQueryValueEx(hKeyDevice, "CurrentDriveLetterAssignment", NULL, &dwType, (LPBYTE) szDriveAssign, &dwSize) == NOERROR)
					  {
						  if (dwType == REG_SZ)
						  {
							  if (isalpha(szDriveAssign[0]))
							  {
								  RegCloseKey(hKeyDevice);
								  RegCloseKey(hKey);
								  return toupper(szDriveAssign[0]);
							  }
						  }
					  }
					  RegCloseKey(hKeyDevice);
				  }
			  }
		  }

		  RegCloseKey(hKey);
	  }
  }

  return 0;
}

DWORD ResetDevice(HCDROM hCD)
{
	DWORD dwStatus;
	DWORD retVal = SS_COMP;
	int idx = (int)hCD - 1;
	
	if ( (idx<0) || (idx>=MAXCDHAND) )
	{
		alErrCode = ALERR_INVHANDLE;
		return SS_ERR;
	}
	
	if ( WaitForSingleObject( cdMutexes[idx], TIMEOUT ) != WAIT_OBJECT_0 )
	{
		alErrCode = ALERR_LOCK;
		return SS_ERR;
	}
	
	if ( !cdHandles[idx].used )
	{
		alErrCode = ALERR_INVHANDLE;
		ReleaseMutex( cdMutexes[idx] );
		return SS_ERR;
	}

	{
		SRB_BusDeviceReset s;

		ZeroMemory(&s, sizeof(s));
		s.SRB_Cmd = SC_RESET_DEV;
		s.SRB_HaId = cdHandles[idx].ha;
		s.SRB_Target = cdHandles[idx].tgt;
		s.SRB_Lun = cdHandles[idx].lun;

		dwStatus = pfnSendASPI32Command((LPSRB) &s);
	}
	
	ReleaseMutex( cdMutexes[idx] );
	return dwStatus;
}

extern int loadAspi( BOOL fSPTIFirst );
extern void unloadAspi( void );
extern DWORD GetInterfaceID( void );
extern BOOL fCanDynamicChangeAPI;

BOOL CanDynamicChangeAPI(void)
{
	return fCanDynamicChangeAPI;
}

BOOL ChangeAPI(DWORD dwNewAPI)
{
	DWORD dwOldAPI;
	dwOldAPI = GetInterfaceID();
#ifdef _DEBUG_BUILD
      dbprintf( "Change API");
#endif
	if (dwOldAPI != dwNewAPI)
	{
		int ret;
#ifdef _DEBUG_BUILD
		dbprintf( "Try Unload Old Interface : %s", (dwOldAPI == APIC_SCSIPT) ? "SPTI" : "ASPI");
#endif
		unloadAspi();
#ifdef _DEBUG_BUILD
      dbprintf( "Old Interface Unloaded : %s", (dwOldAPI == APIC_SCSIPT) ? "SPTI" : "ASPI");
#endif
#ifdef _DEBUG_BUILD
      dbprintf( "Try Load New Interface : %s", (dwNewAPI == APIC_SCSIPT) ? "SPTI" : "ASPI");
#endif
		ret = loadAspi((dwNewAPI == APIC_SCSIPT) ? TRUE : FALSE);
		if (ret)
		{
#ifdef _DEBUG_BUILD
      dbprintf( "Load Interface Success");
#endif
			if (dwOldAPI != GetInterfaceID())
			{
#ifdef _DEBUG_BUILD
      dbprintf( "Change API Seccess");
#endif
				return TRUE;
			}
			else
			{
#ifdef _DEBUG_BUILD
      dbprintf( "Change API Failed because no alternative API");
#endif
				return FALSE;
			}
		}
		else
		{
#ifdef _DEBUG_BUILD
      dbprintf( "Load Interface Failed Try Restore Interface");
#endif
			unloadAspi();
			ret = loadAspi((dwNewAPI == APIC_SCSIPT) ? FALSE : TRUE);
			if (ret)
			{
#ifdef _DEBUG_BUILD
      dbprintf( "Interface Restore Success");
#endif
				return FALSE;
			}
			else
			{
#ifdef _DEBUG_BUILD
      dbprintf( "Interface Restore Failed\nCritical Error!!!");
#endif
				//  vIG[
				return FALSE;
			}
		}
	}

	return TRUE;
}
