//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  AudioFile Wrapper W[ wb_[t@C  for  NVAudioFileLibrary                      //
//  NVAFWrap.h                                                                                  //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



#pragma once




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "NVAudioFile.h"


#ifdef __cplusplus
extern "C" {
#endif


#pragma pack(push, 1)





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  }N̐錾
//



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  \̂̐錾
//

struct NVAFWRAP_INFO
{
	DWORD dwFourCC;
	DWORD dwObjSize;
	QLONG qlStartOffset;
	QLONG qlSampleCount;
};

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  NX̒`  :  INVAFWRAP
//


//  NXʎq
#define NVAFWRAP_FOURCC MAKEFOURCC('V', 'A', 'F', 'W')


/*  INVAFWRAP NXWXg (VCOM.ini ւ̋Lq)
[VAFW]

Class_ID = "VAFW"
Module_Name = "NVAFLib.dll"
Entry_Point = "CreateInstance_NVAFWrap"
*/


class Class_NVAFWrap;
typedef Class_NVAFWrap * INVAFWRAP;
typedef const Class_NVAFWrap * CINVAFWRAP;
typedef INVAFWRAP * LPINVAFWRAP;
typedef const INVAFWRAP * LPCINVAFWRAP;


//  INVAFWRAP ̏f[^
struct NVAFWRAPCREATE		//  nvafwc
{
	DWORD dwFourCC;				//  NXʎq
	DWORD dwObjSize;			//  \̂̃TCY
	DWORD dwFlag;				//  tO
	union
	{
		INVAUDIOFILE invaf;		//  I[vXg[
	};
	QLONG qlStartOffset;
	QLONG qlSampleCount;
	LPNVAUDIOFILECOMMENT lpnvafcm;
	REPLAYGAININFO *lpReplayGain;
};
typedef NVAFWRAPCREATE * LPNVAFWRAPCREATE;
typedef const NVAFWRAPCREATE * LPCNVAFWRAPCREATE;


//  INVAUDIOFILE ̕ێf[^
struct NVAFWRAPDATA		//  nvafd
{
	INVAUDIOFILE invaf;
	QLONG qlStartOffset;
	QLONG qlDataSize;
	QLONG qlCurrent;
	LONG lSampleAlign;
	DWORD dwSamplerate;
	REPLAYGAININFO ReplayGain;
};
typedef NVAFWRAPDATA * LPNVAFWRAPDATA;
typedef const NVAFWRAPDATA * LPCNVAFWRAPDATA;



class NVAFLIB_CLASS_EXPORT Class_NVAFWrap : virtual public Class_NVAudioFile
{
	public:
		Class_NVAFWrap(void);
		//  ftHgRXgN^
		//
		//  SetCoreData() ĂяoāA{NXɃf[^ݒ肷B

	VCOM_CLASSMETHOD
		~Class_NVAFWrap(void);
		//  fXgN^
		//

	VCOM_CLASSMETHOD
		NVRESULT Create(LPCVOID lpvParam);
		//  CX^X̏
		//
		//  CX^XɃp[^^āACX^X̃f[^(쐬)B
		//  vcd.bIsCreated tO𗧂āAς݂`FbNs悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT ResetData(void);
		//  CX^X̃f[^Zbg
		//
		//  CX^XŗpȂǂACreate() ĂяoȌԂɖ߂B
		//  vcd.bIsCreated tOZbgAĂ Create() s悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface);
		//  C^[tF[X̎擾
		//
		//  DWORD dwFourCC			擾C^[tF[X
		//  LPVOID *lpvInterface	C^[tF[Xi[|C^
		//
		//  ̃CX^X́AdwFourCC Ŏw肵^̃C^[tF[X擾B
		//  擾łC^[tF[X́ACX^XɂĈقȂ邪A
		//  CX^XNX̃X[p[NXɂNX̃C^[tF[X
		//  K擾ł悤ɎȂ΂ȂȂB
		//  ̊֐ŕʂ̃C^[tF[X擾ƁA AddRef() ŝŁA
		//  ÂC^[tF[Xɑ΂Ă Release() KvB

	VCOM_CLASSMETHOD
		NVRESULT GetInfo(DWORD dwFourCC, LPVOID lpvInfo, LPDWORD lpdwSize);
		//  tH[}bgƎ̊g擾
		//
		//  DWORD dwFourCC			̌`NXʎq
		//  LPVOID@lpvInfo			󂯎obt@
		//  LPDWORD@lpdwSize		obt@̃TCY
		//
		//  tH[}bgƂɒ߂ꂽgԂB
		//  lpvInfo  NULL nƁAKvȃobt@TCYԂB
		//  񂪎擾ƁAlpdwSize ɎۂɊi[ꂽTCYԂB
		//  obt@TCYȂꍇAG[ԂÂƂ lpdwSize ɕKvȃTCYԂB
		//  NVAudioFileC^[tF[XW̏ƂāA
		//  NVAudioFileInfo`̂ŁAɂ͕KΉ悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT GetComment(DWORD dwFourCC, LPVOID lpvInfo, LPDWORD lpdwSize);
		//  ȖȂǂ̃Rg擾
		//
		//  DWORD dwFourCC		󂯎\̂̎ʎq
		//  LPVOID lpvInfo		󂯎obt@(\)̃|C^
		//  LPDWORD lpdwSize	obt@̃TCY
		//
		//  lpvInfo  NULL nƁAKvȃobt@TCYԂB
		//  񂪎擾ƁAlpdwSize ɎۂɊi[ꂽTCYԂB
		//  obt@TCYȂꍇAG[ԂÂƂ lpdwSize ɕKvȃTCYԂB
		//  W̌`ƂāANVAudioFileComment`̂ŁA
		//  ɂ͕KΉ悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT GetPCMWaveFormat(LPPCMWAVEFORMAT lppcmwf);
		//  fR[hf[^̃tH[}bg擾
		//
		//  LPPCMWAVEFORMAT lppcmwf		󂯎obt@
		//
		//  PCMWAVEFORMAT `ŁAfR[hĂf[^̌`擾B
		//  PCMWAVEFORMAT::wf.wFormatTaǵAWAVE_FORMAT_PCM܂WAVE_FORMAT_IEEE_FLOAT݂̂T|[g

	VCOM_CLASSMETHOD
		NVRESULT DecodeToPCMData(LPVOID lpBuffer, LONG lBufferSize, LPLONG lplResultSize);
		//  f[^fR[hA󂯎
		//
		//  LPVOID lpBuffer			fR[hꂽf[^󂯎obt@
		//  LONG lBufferSize		擾f[^̗
		//  LPLONG lplResultSize	ۂɎ擾ꂽf[^̗
		//
		//  f[^fR[hāAPCM `Ŏ󂯎B̃tH[}bǵAGetPCMWaveFormat Ŏ擾łtH[}bgɊÂĂB
		//  NV_OK Ԃꍇ́AKvTCỸf[^擾ĂB
		//  VAFERR_VALUE_ENDOFDATA ̏ꍇAۂɎ擾ꂽf[^̗ʂ́AlplResultSize ɕԂB
		//  ̌ĂяóAKVAFERR_VALUE_ENDOFDATA ɂȂB
		//  f[^ɃG[̂́A񕜂łꍇɂ́AVAFERR_VALUE_ERRORRECOVEREDԂB
		//	̏ꍇ́AfR[h͂̂܂ܑsłB
		//  ȊÕG[Ԃꍇ́AfR[h𑱂邱Ƃ͂łȂB
		//  f[^̈ꕔłɏꂽꍇ́AlplResultSize ɎۂɎ擾ꂽf[^̗ʂԂĂB

	VCOM_CLASSMETHOD
		NVRESULT Rewind(void);
		//  f[^擪܂Ŋ߂
		//
		//  ʓIɂSetCurrentPosition(0, NVAUDIOFILE_SEEKBEGIN)ƓA
		//  tH[}bgɂĂ͐擪ւ̃V[N͍ɍs邽ߕʓrp
		//  p~ĂǂȁccH

	VCOM_CLASSMETHOD
		NVRESULT FileInfoDialog(HWND hwnd);
		//  t@C̃_CAO\
		//
		//  HWND hwnd		eEBhẼnh
		//
		//  t@C̏Rg[hX_CAO\B
		//  ɍ쐬ς݂̏ꍇɂ́AQdɕ\Ȃ悤ɒ
		//  ܂AAddRef() Release()gāA
		//  \ɃfR[_N[YĂvȂ悤ɂĂKvB
		//  _CAÓANVRegisterDialog()NVUnRegisterDialog()ŁA
		//  bZ[W[vłƏ悤ɂKvB

	VCOM_CLASSMETHOD
		NVRESULT GetCurrentPosition(LPQWUNION lpquPosition, DWORD dwFlag);
		//  t@Č݈ʒuoCgPʂŎ擾
		//
		//  LPQWUNION lpquPosition	擾錻݈ʒũItZbg
		//  DWORD dwFlag			ItZbg̊ʒu

	VCOM_CLASSMETHOD
		NVRESULT SetCurrentPosition(QWUNION quPosition, DWORD dwFlag);
		//  t@Č݈ʒuoCgPʂŐݒ
		//
		//  QWUNION quPosition	ݒ肷錻݈ʒũItZbg
		//  DWORD dwFlag		ItZbg̊ʒu
		//
		//  \ȌoCgPʂł̃V[Ns悤ɂׂA
		//  ݂Lilithł́Ǎ덷ĂvȂɂȂĂB
		//  bp[vOCȂǁÃfR[_TvPʂmsPʂł
		//  V[NsȂɂ́A̒PʂɊۂ߂Ă\ȂB
		//  ÂƂthLgɖL̂S邱ƁB

	VCOM_CLASSMETHOD
		NVRESULT ReferenceTimeToSamples(QWUNION quReferenceTime, LPQWUNION lpquSamples);
		//  QƎ(}CNbP)Tv֕ϊ
		//
		//  QWUNION quReferenceTime		QƎ(}CNbP)
		//  LPQWUNION lpquSamples		Tv
	VCOM_CLASSMETHOD
		NVRESULT SamplesToReferenceTime(QWUNION quSamples, LPQWUNION lpquReferenceTime);
		//  TvQƎ(}CNbP)֕ϊ
		//
		//  QWUNION quSamples			Tv
		//  LPQWUNION lpquReferenceTime	QƎ(}CNbP)
	VCOM_CLASSMETHOD
		NVRESULT GetReferenceTime(LPQWUNION lpquReferenceTime);
		//  ݂̎QƎ(}CNbP)擾
		//
		//  LPQWUNION lpquReferenceTime		QƎ(}CNbP)

	VCOM_CLASSMETHOD
		NVRESULT GetTotalTime(LPQWUNION lpquTotalTime);
		//  }CNbPʂőSĐԂ擾
		//
		//  LPQWUNION lpquTotalTime		SĐ(}CNbP)

	VCOM_CLASSMETHOD
		NVRESULT ReInitialize(QLONG qlStartOffset, QLONG qlSampleCount, LPNVAUDIOFILECOMMENT lpnvafcm, REPLAYGAININFO *lpReplayGain);
protected:
	VCOM_CLASSMETHOD
		NVRESULT AddInterface(DWORD dwFlag);
		//  C^[tF[XQƃe[uɓo^
		//
		//  DWORD dwFlag	NXCX^X̏ꍇPAȊO͂O
		//
		//  RXgN^̒ŌĂ΂AC^[tF[X|C^e[uɓo^A
		//  VIsValidInterface() ŃC^[tF[X̗L؂ł悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT DeleteInterface(void);
		//  C^[tF[XQƃe[u폜
		//
		//  DeleteInstance() ̒ŌĂ΂AC^[tF[X|C^e[u폜B
protected:
	NVAFWRAPDATA nvafwd;

};



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̐錾
//

NVRESULT NVAFLIB_EXPORT NVAFLIB_API CreateInstance_NVAFWrap(LPIVCOM lpivcom);
//  CX^X̍쐬
//
//  INVAFWRAP CX^X쐬ÃC^[tF[XԂ


inline void SetNVAFWrapCreate(LPNVAFWRAPCREATE lpnvafwc, DWORD dwFlag, INVAUDIOFILE invaf, QLONG qlStart, QLONG qlEnd, LPNVAUDIOFILECOMMENT lpnvafcm, REPLAYGAININFO *lpReplayGain);
//  NVAFWRAPCREATE \̏֐
//
//  LPNVWRAPCREATE lpnvafwc			\
//  DWORD dwFlag					ZbgtO



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  CC֐̒`
//


inline void SetNVAFWrapCreate(LPNVAFWRAPCREATE lpnvafwc, DWORD dwFlag, INVAUDIOFILE invaf, QLONG qlStartOffset, QLONG qlSampleCount, LPNVAUDIOFILECOMMENT lpnvafcm, REPLAYGAININFO *lpReplayGain)
{
	lpnvafwc->dwFourCC = NVAFWRAP_FOURCC;
	lpnvafwc->dwObjSize = sizeof(NVAFWRAPCREATE);
	lpnvafwc->dwFlag = dwFlag;
	lpnvafwc->invaf = invaf;
	lpnvafwc->qlStartOffset = qlStartOffset;
	lpnvafwc->qlSampleCount = qlSampleCount;
	lpnvafwc->lpnvafcm = lpnvafcm;
	lpnvafwc->lpReplayGain = lpReplayGain;

	return;
}


#pragma pack(pop)

#ifdef __cplusplus
}
#endif
