//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  t@CNX  \[Xt@C  for  NVFileLibrary                                      //
//  NVFile.cpp                                                                                  //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  INVFILE ́AINVSTREAM C^[tF[X݊̃t@CNXłB                      //
//  INVSTREAM Œ`Ă@\قA                                                  //
//  t@C̍쐬ɊւĂ̓tOT|[gĂB                                  //
//  CX^X̏Af[^̓ǂݍ݁A݂܂ŁA                                  //
//  INVSTREAM C^[tF[XƂđSNXʂ̑ňB                                //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "NVFile.h"
#include <mbstring.h>


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  X^eBbN֐̒`
//


//  t@CI[v֐
static inline NVRESULT NVFILECreate(LPNVFILEDATA lpnvfd, LPNVSTREAMDATA lpnvstd, LPCNVSTREAMCREATE lpcnvstc, DWORD dwExtraFlag);
static inline NVRESULT CheckFileNameSyntax(LPCTSTR lpcszFileName);

#define NVAddUINT64(lowDest, highDest, lowSrc1, highSrc1, lowSrc2, highSrc2) \
{ \
	(lowDest) = (lowSrc1) + (lowSrc2); \
	(highDest) = (highSrc1) + (highSrc2) + (((lowDest) < (lowSrc1)) ? 1 : 0); \
}




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̒`
//


NVRESULT NVFILELIB_EXPORT NVFILELIB_API CreateInstance_NVFile(LPIVCOM lpivcom)
{
	//  CX^X̍쐬
	//  vtable Kv̂ŁAnew ZqoRŃAP[VB

	if (! lpivcom)
	{
		return NVERR_UNDEFINED;
	}

	*lpivcom = (IVCOM) new Class_NVFile;
	if (*lpivcom)
	{
		return NV_OK;
	}
	else
	{
		return NVERR_UNDEFINED;
	}
}




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  o֐̐錾  Class_NVFile
//


Class_NVFile::Class_NVFile(void)
{
//  ftHgRXgN^

	//  {NX̕ێf[^ݒ肷BRXgN^͊{NX珇ԂɌĂяôŁA
	//  ŌɌĂяo邱ƂɂȂACX^X̃IWǐ^݂̏̂cB
	//  ]ȏ̂ŃI[o[wbh邪AdldƁB
	Class_VCOM::SetCoreData((LPVOID) this, (DWORD) sizeof(Class_NVFile), NVFILE_FOURCC);

	//  ێf[^͖̏B

	return;
}


Class_NVFile::~Class_NVFile(void)
{
//  fXgN^

	//  Release oRȊOĂяoƁAvcd.bIsCreated  TRUE ł邱ƂB
	//  ̏ꍇAȉsĂȂ͂Ȃ̂ŁAASSERT B
	assert(! vcd.bIsCreated);

	return;
}


NVRESULT Class_NVFile::Create(LPCVOID lpvParam)
{
//  CX^X̏
	//  eNXŕKvȏLqB
	NVRESULT nvres;

	//  ʂ̌^ɃLXg
	LPCNVSTREAMCREATE lpcnvstc = (LPCNVSTREAMCREATE) lpvParam;

	//  ς݃IuWFNgłȂǂ`FbN
	if (vcd.bIsCreated)
	{
		//  ς݂̏ꍇAG[ɂB
		return VSTMERR_ALREADYUSED;
	}

	//  ̐`FbN
	{
		//  NX̎ʎqƈ̎ʎqr
		if (lpcnvstc->dwFourCC == NVSTREAM_FOURCC)
		{
			//  ̃TCY`FbN
			if (lpcnvstc->dwObjSize != sizeof(NVSTREAMCREATE))
			{
				//  ɓnꂽ\̂̃TCYĂ
				return VSTMERR_INVALIDPARAMSIZE;
			}

			//  ExtraFlag ftHgƂāAp
			nvres =  NVFILECreate(&nvfd, &nvstd, lpcnvstc, 0);
		}
		else if (lpcnvstc->dwFourCC == NVFILE_FOURCC)
		{
			//  ̃TCY`FbN
			if (lpcnvstc->dwObjSize != sizeof(NVFILECREATE))
			{
				//  ɓnꂽ\̂̃TCYĂ
				return VSTMERR_INVALIDPARAMSIZE;
			}
			nvres = NVFILECreate(&nvfd, &nvstd, lpcnvstc, ((LPCNVFILECREATE) lpcnvstc)->dwExtraFlag);
		}
		else
		{
			//  ԈႦĂ
			return VSTMERR_INVALIDPARAMTYPE;
		}
	}

	if (nvres)
	{
		return nvres;
	}

	vcd.bIsCreated = TRUE;
	return NV_OK;
}


static inline NVRESULT NVFILECreate(LPNVFILEDATA lpnvfd, LPNVSTREAMDATA lpnvstd, LPCNVSTREAMCREATE lpcnvstc, DWORD dwExtraFlag)
{
	//  t@CI[v֐
	if ((! lpcnvstc->lpcszDataName) || (! *lpcnvstc->lpcszDataName))
	{
		//  I[vf[^Ȃ΃G[
		return VSTMERR_INVALIDPARAM;
	}

	if (lpcnvstc->dwFlag & NVFILE_SIZEOVERRIDE && lpcnvstc->dwFlag & NVFILE_OPENWRITE)
	{
		//  ݃[h́ATCYI[o[ChłȂ
		return VSTMERR_INVALIDPARAM;
	}

	//  ̃`FbNIAۂɈ̓eɉďsB
	try
	{
		DWORD dwExist = TRUE;
		DWORD dwDesiredAccess;
		DWORD dwShareMode;
		DWORD dwCreationDisposition;
		DWORD dwFlagsAndAttributes = 0;

		//  ̒lQƂāAsB

		//  ܂t@CtpXɕϊ

		{
			LPTSTR lpszFilePart;
			GetFullPathName(lpcnvstc->lpcszDataName, NV_PATHMAX, lpnvstd->lpszDataName, &lpszFilePart);
		}

		//  t@C݂̑mF
		{
			WIN32_FIND_DATA ffd;
			HANDLE hffd;

			//  t@C
			hffd = NVFindFirstFile(lpnvstd->lpszDataName, &ffd);
			if (hffd == NULL || hffd == INVALID_HANDLE_VALUE)
			{
				dwExist = FALSE;
				if (CheckFileNameSyntax(lpnvstd->lpszDataName))
				{
					return NVERR_UNDEFINED;
				}
			}
			else
			{
				dwExist = TRUE;
				NVFindClose(hffd);

				//  t@Cf[^擾
				lpnvfd->nvfi.dwFourCC = NVFILE_FOURCC;
				lpnvfd->nvfi.dwObjSize = sizeof(NVFILEINFO);
				lpnvfd->nvfi.dwAttributes = ffd.dwFileAttributes & NVFILE_FILEATTRIBUTEMASK;
				lpnvfd->nvfi.ftCreationTime = ffd.ftCreationTime;
				lpnvfd->nvfi.ftLastAccessTime = ffd.ftLastAccessTime;
				lpnvfd->nvfi.ftLastWriteTime = ffd.ftLastWriteTime;
			}
		}

		//  ǂݏ[h
		switch (lpcnvstc->dwFlag & NVFILE_OPENMASK)
		{
		case NVFILE_OPENREADWRITE:
			{
				if (lpnvfd->nvfi.dwAttributes & FILE_ATTRIBUTE_READONLY)
				{
					//  ݕی삳Ăꍇ
					if (dwExtraFlag & NVFILE_FORCEWRITE)
					{
						BOOL bRet;
						//  ReadOnly łޏꍇAꎞIɃt@CύX
						bRet = SetFileAttributes(lpnvstd->lpszDataName, lpnvfd->nvfi.dwAttributes & (~FILE_ATTRIBUTE_READONLY));
						if (bRet)
						{
							//  ꍇAƂɖ߂Ă悤ɁAtO𗧂Ă
							lpnvfd->dwStatus |= NVFILE_STATUSINFOCHANGED;
						}
						else
						{
							//  sAG[
							throw VSTMERR_READONLY;
						}
					}
					else
					{
						//  ȊȌꍇAG[
						throw VSTMERR_READONLY;
					}
				}

				NVCreateDirectoryFromFileName(lpnvstd->lpszDataName);
				//  ǂݏp[h͖T|[g
				throw VSTMERR_UNSUPPORTED;
			}
			break;
		case NVFILE_OPENWRITE:
			{
				if (lpnvfd->nvfi.dwAttributes & FILE_ATTRIBUTE_READONLY)
				{
					//  ݕی삳Ăꍇ
					if (dwExtraFlag & NVFILE_FORCEWRITE)
					{
						BOOL bRet;
						//  ReadOnly łޏꍇAꎞIɃt@CύX
						bRet = SetFileAttributes(lpnvstd->lpszDataName, lpnvfd->nvfi.dwAttributes & (~FILE_ATTRIBUTE_READONLY));
						if (bRet)
						{
							//  ꍇAƂɖ߂Ă悤ɁAtO𗧂Ă
							lpnvfd->dwStatus |= NVFILE_STATUSINFOCHANGED;
						}
						else
						{
							//  sAG[
							throw VSTMERR_READONLY;
						}
					}
					else
					{
						//  ȊȌꍇAG[
						throw VSTMERR_READONLY;
					}
				}

				dwDesiredAccess = GENERIC_WRITE;

				//  ftHg̓VFAOnee
				if (dwExtraFlag & NVFILE_SHARING)
				{
					dwShareMode = FILE_SHARE_WRITE;
					lpnvfd->dwExtraFlag |= NVFILE_SHARING;
				}
				else
				{
					dwShareMode = 0;
					lpnvfd->dwExtraFlag |= NVFILE_NOSHARING;
				}
				dwCreationDisposition = OPEN_ALWAYS;
				lpnvstd->dwFlag |= NVFILE_OPENWRITE;
				NVCreateDirectoryFromFileName(lpnvstd->lpszDataName);
			}
			break;
		default:
			{
				//  ftHg͓ǂ݂݃ANZX
				dwDesiredAccess = GENERIC_READ;

				//  ftHg̓VFAOnm
				if (dwExtraFlag & NVFILE_NOSHARING)
				{
					dwShareMode = 0;
					lpnvfd->dwExtraFlag |= NVFILE_NOSHARING;
				}
				else
				{
					dwShareMode = FILE_SHARE_READ;
					lpnvfd->dwExtraFlag |= NVFILE_SHARING;
				}
				dwCreationDisposition = OPEN_EXISTING;
				lpnvstd->dwFlag |= NVFILE_OPENREAD;
			}
		}

		//  t@C̍쐬@
		switch (dwExtraFlag & NVFILE_CREATEMASK)
		{
		case NVFILE_CREATENEW:
			{
				dwCreationDisposition = CREATE_NEW;
				lpnvfd->dwExtraFlag |= NVFILE_CREATENEW;
			}
			break;
		case NVFILE_CREATEALWAYS:
			{
				dwCreationDisposition = CREATE_ALWAYS;
				lpnvfd->dwExtraFlag |= NVFILE_CREATEALWAYS;
			}
			break;
		case NVFILE_OPENALWAYS:
			{
				dwCreationDisposition = OPEN_ALWAYS;
				lpnvfd->dwExtraFlag |= NVFILE_OPENALWAYS;
			}
			break;
		case NVFILE_OPENEXISTING:
			{
				dwCreationDisposition = OPEN_EXISTING;
				lpnvfd->dwExtraFlag |= NVFILE_OPENEXISTING;
			}
			break;
		default:
			{
				//  łɃftHglĂ̂ŁA͂Ȃ
			}
		}

		//  CgX[ŏ݂邩ǂ
		if (dwExtraFlag & NVFILE_WRITETHROUGH)
		{
			dwFlagsAndAttributes |= FILE_FLAG_WRITE_THROUGH;
			lpnvfd->dwExtraFlag |= NVFILE_WRITETHROUGH;
		}

		//  t@C̃ANZX@
		//  ftHg̓V[PVANZX
		if (dwExtraFlag & NVFILE_RANDOMACCESS)
		{
			dwFlagsAndAttributes |= FILE_FLAG_RANDOM_ACCESS;
			lpnvfd->dwExtraFlag |= NVFILE_RANDOMACCESS;
		}
		else
		{
			dwFlagsAndAttributes |= FILE_FLAG_SEQUENTIAL_SCAN;
			lpnvfd->dwExtraFlag |= NVFILE_SEQUENTIALSCAN;
		}

		//  t@CnhI[v
		lpnvfd->hfile = NVCreateFile(lpnvstd->lpszDataName, dwDesiredAccess, dwShareMode,
			NULL, dwCreationDisposition, dwFlagsAndAttributes, NULL);
		if (lpnvfd->hfile == INVALID_HANDLE_VALUE || lpnvfd->hfile == NULL)
		{
			if (0x20 == GetLastError() && dwDesiredAccess == GENERIC_READ && (! (dwExtraFlag & NVFILE_NOSHARING)))
			{
				dwShareMode |= FILE_SHARE_WRITE;
				lpnvfd->hfile = NVCreateFile(lpnvstd->lpszDataName, dwDesiredAccess, dwShareMode,
					NULL, dwCreationDisposition, dwFlagsAndAttributes, NULL);
				if (lpnvfd->hfile == INVALID_HANDLE_VALUE || lpnvfd->hfile == NULL)
				{
					//  nhI[vłȂ΃G[
					throw VSTMERR_CANTOPENDATA;
				}
			}
			else
			{
				//  nhI[vłȂ΃G[
				throw VSTMERR_CANTOPENDATA;
			}
		}

		if (! dwExist)
		{
			//  t@CVKɍ쐬ꍇA擾
			lpnvfd->nvfi.dwFourCC = NVFILE_FOURCC;
			lpnvfd->nvfi.dwObjSize = sizeof(NVFILEINFO);
			lpnvfd->nvfi.dwAttributes = FILE_ATTRIBUTE_NORMAL;	//  Ƃ肠Aʏt@CƂƂɂĂ
			GetFileTime(lpnvfd->hfile, &lpnvfd->nvfi.ftCreationTime, &lpnvfd->nvfi.ftLastAccessTime, &lpnvfd->nvfi.ftLastWriteTime);
		}

		if (lpcnvstc->dwFlag & NVFILE_SIZEOVERRIDE)
		{
			//  TCYI[o[Chꍇ̏

			QWUNION quSize;

			//  t@CTCY擾
			quSize.dwLow = GetFileSize(lpnvfd->hfile, &quSize.dwHigh);
			if (quSize.dwLow == DWORD_MAX && GetLastError() != NO_ERROR)
			{
				throw VSTMERR_CANTGETDATASIZE;
			}

			//  Jnʒut@CɂȂ΃G[
			if (lpcnvstc->quStartOverride.qw >= quSize.qw)
			{
				throw VSTMERR_INVALIDPARAM;
			}

			//  Jnʒu̕ۑ
			lpnvstd->quStartOverride.qw = lpcnvstc->quStartOverride.qw;

			//  IʒǔvZ
			lpnvstd->quEndOverride.qw = lpcnvstc->quStartOverride.qw + lpcnvstc->quSizeOverride.qw;

			//  Iʒut@C̏I[ȂG[
			if (lpnvstd->quEndOverride.qw > quSize.qw)
			{
				throw VSTMERR_INVALIDPARAM;
			}

			//  t@C|C^Jnʒu܂ňړ
			SetFilePointer(lpnvfd->hfile, lpnvstd->quStartOverride.dwLow, (LPLONG) &lpnvstd->quStartOverride.dwHigh, FILE_BEGIN);

			//  tOۑ
			lpnvstd->dwFlag |= NVFILE_SIZEOVERRIDE;
		}

		if (lpcnvstc->dwFlag & NVFILE_DATANAMEOVERRIDE)
		{
			//  f[^I[o[Chꍇ̏

			_tcscpy_s(lpnvstd->lpszDataNameOverride, NV_PATHMAX, lpcnvstc->lpcszDataNameOverride);
			lpnvstd->dwFlag |= NVFILE_DATANAMEOVERRIDE;
		}
	}
	catch (NVRESULT nvres)
	{
		//  G[Nꍇ̏

		if (lpnvfd->hfile != INVALID_HANDLE_VALUE && lpnvfd->hfile)
		{
			//  t@CnhJĂ΁A
			CloseHandle(lpnvfd->hfile);
			lpnvfd->hfile = NULL;
		}
		return nvres;
	}

	return NV_OK;
}



NVRESULT Class_NVFile::ResetData(void)
{
//  CX^X̃f[^Zbg

	//  nh̉Aobt@̉Ȃǂs

	if (nvfd.hfile && nvfd.hfile != INVALID_HANDLE_VALUE)
	{
		if (nvfd.dwStatus & NVFILE_STATUSINFOCHANGED)
		{
			//  t@C񂪕ύXĂꍇ
			SetFileTime(nvfd.hfile, &nvfd.nvfi.ftCreationTime, &nvfd.nvfi.ftLastAccessTime, &nvfd.nvfi.ftLastWriteTime);
			CloseHandle(nvfd.hfile);
			SetFileAttributes(nvstd.lpszDataName, nvfd.nvfi.dwAttributes);
		}
		else
		{
			CloseHandle(nvfd.hfile);
		}
	}
	else
	{
		//  t@CnhJĂȂĂAύXĂ\̂ŁAɖ߂
		if (nvfd.dwStatus & NVFILE_STATUSINFOCHANGED)
		{
			SetFileAttributes(nvstd.lpszDataName, nvfd.nvfi.dwAttributes);
		}
	}

	//  ێf[^OZbg
	ZeroMemory(&nvfd, sizeof(NVFILEDATA));

	//  eNX ResetData Ɉp
	return Class_NVStream::ResetData();
}


NVRESULT Class_NVFile::QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface)
{
//  C^[tF[X̎擾

	//  dwFourCC ɂāAKȌ^̃C^[tF[XԂB
	//  ǧ^̃C^[tF[X̍쐬ȊÓAeNX̃\bhĂԂƂŉƗǂƎvB

	if (dwFourCC == NVFILE_FOURCC)
	{
		//  ̃NX̃C^[tF[X擾Ȃ̂ŁAԂli[AAddRef() ƂɐIB
		*lpvInterface = (INVFILE) this;
		AddRef();
		return NV_OK;
	}
	else
	{
		//  ǧ^ȊÓAeNXɔC
		return Class_NVStream::QueryInterface(dwFourCC, lpvInterface);
	}
}


NVRESULT Class_NVFile::AddInterface(DWORD dwFlag)
{
//  C^[tF[XQƃe[uɓo^

	//  CX^Xɑ΂ŏ̂P̌Ăяoł́A
	//  dwFlag ɂ VCOM_CLASSINTERFACE ĂB
	//  ȍ~̌Ăяoł́AOĂB
	VAddInterface(this, (IVCOM) this, NVFILE_FOURCC, dwFlag);

	//  eNX̃\bhɈp
	//  ̂ƂAdwFlag ɂ Ow肷B
	return Class_NVStream::AddInterface(0);
}


NVRESULT Class_NVFile::DeleteInterface(void)
{
//  C^[tF[XQƃe[u폜

	VDeleteInterface(this);

	//  eNX̃\bhɈp
	return Class_NVStream::DeleteInterface();
}


NVRESULT Class_NVFile::Read(LPVOID lpvDestBuffer, DWORD dwReadSize, LPDWORD lpdwResult)
{
//  Xg[f[^ǂݏo

	DWORD dwResult;

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		*lpdwResult = 0;
		return VSTMERR_NOCREATE;
	}

	//  ANZX[h𒲂ׂ
	if (! (nvstd.dwFlag & NVFILE_OPENREAD))
	{
		*lpdwResult = 0;
		//  ǂݏo[hłȂ΃G[
		return VSTMERR_INVALIDACCESSMODE;
	}

	if (! lpvDestBuffer)
	{
		return VSTMERR_INVALIDPARAM;
	}

	//  Xg[f[^ǂݏo
	if (nvstd.dwFlag & NVFILE_SIZEOVERRIDE)
	{
		//  TCYI[o[ChĂꍇ̏

		QWUNION quSize;

		//  ǂݍݗʂAǂݍ݉\ʂɃNbsO
		quSize.qw = min(dwReadSize, nvstd.quEndOverride.qw - nvstd.quCurrent.qw);
		quSize.qw = (quSize.dwHigh) ? DWORD_MAX : quSize.dwLow;

		if (quSize.dwLow)
		{
			//  ǂݍރf[^Γǂݍ
			ReadFile(nvfd.hfile, lpvDestBuffer, quSize.dwLow, &dwResult, NULL);
		}
		else
		{
			//  Ȃ΁Aǂݍ񂾗ʂO
			dwResult = 0;
		}
	}
	else
	{
		//  I[o[ChĂȂ΁Aʏɓǂݍ
		ReadFile(nvfd.hfile, lpvDestBuffer, dwReadSize, &dwResult, NULL);
	}

	//  ۂɓǂݍ܂ꂽʂQƂāA݈ʒuړ
	nvstd.quCurrent.ql += dwResult;

	*lpdwResult = dwResult;
	if (dwReadSize != dwResult)
	{
		//  vʓǂ߂ĂȂ΁At@CI[
		return VSTMERR_ENDOFDATA;
	}

	return NV_OK;
}


NVRESULT Class_NVFile::Write(LPCVOID lpvSrcBuffer, DWORD dwWriteSize, LPDWORD lpdwResult)
{
//  Xg[փf[^

	DWORD dwResult;

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	//  ANZX[h𒲂ׂ
	if (! (nvstd.dwFlag & NVFILE_OPENWRITE))
	{
		//  ݃[hłȂ΃G[
		return VSTMERR_INVALIDACCESSMODE;
	}

	if (! lpvSrcBuffer)
	{
		return VSTMERR_INVALIDPARAM;
	}

	//  Xg[Ƀf[^o

/*  Create ł͂Ă̂ŁA肦Ȃ͂
	if (nvstd.dwFlag & NVFILE_SIZEOVERRIDE)
	{
		//  TCYI[o[ChĂꍇ̏
		//  ݂͖T|[g
		return VSTMERR_UNSUPPORTED;
	}
	else
*/	{
		//  I[o[ChĂȂ΁Aʏɏ
		WriteFile(nvfd.hfile, lpvSrcBuffer, dwWriteSize, &dwResult, NULL);
	}

	//  ۂɏ܂ꂽʂQƂāA݈ʒuړ
	nvstd.quCurrent.ql += dwResult;

	*lpdwResult = dwResult;
	if (dwWriteSize != dwResult)
	{
		//  vʏ߂ĂȂ΁AG[
		return VSTMERR_CANTWRITEDATA;
	}

	return NV_OK;
}


NVRESULT Class_NVFile::GetCurrentPosition(LPQLONG lpqlOffset, DWORD dwFlag)
{
//  Xg[ł݈̌ʒu擾

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	if (! lpqlOffset)
	{
		return VSTMERR_INVALIDPARAM;
	}
	//  Xg[ł݈̌ʒu擾

	if (nvstd.dwFlag & NVFILE_SIZEOVERRIDE)
	{
		//  TCYI[o[ChĂꍇ
		switch (dwFlag)
		{
		case NVFILE_SEEKCURRENT:
			{
				//  ݈ʒȗΈʒu͕KO
				*lpqlOffset = 0;
			}
			break;
		case NVFILE_SEEKEND:
			{
				//  I[o[ChꂽI[̑ΈʒuvZ
				*lpqlOffset = nvstd.quCurrent.ql - nvstd.quEndOverride.ql;
			}
			break;
		default:
			{
				//  ftHǵANVFILE_SEEKBEGIN
				//  I[o[Chꂽ擪̑ΈʒuvZ
				*lpqlOffset = nvstd.quCurrent.ql - nvstd.quStartOverride.ql;
			}
			break;
		}
	}
	else
	{
		//  TCYI[o[ChĂȂꍇ
		switch (dwFlag)
		{
		case NVFILE_SEEKCURRENT:
			{
				//  ݈ʒȗΈʒu͕KO
				*lpqlOffset = 0;
			}
			break;
		case NVFILE_SEEKEND:
			{
				QWUNION quOffset;

				//  t@C̃TCY擾āȂΈʒuvZ
				quOffset.dwLow = GetFileSize(nvfd.hfile, &quOffset.dwHigh);
				if (quOffset.dwLow == DWORD_MAX && GetLastError() != NO_ERROR)
				{
					return VSTMERR_CANTGETPOSITION;
				}

				quOffset.ql = nvstd.quCurrent.ql - quOffset.ql;

				*lpqlOffset = quOffset.ql;
			}
			break;
		default:
			{
				//  ftHǵANVFILE_SEEKBEGIN
				//  ݈ʒuԂ

				*lpqlOffset = nvstd.quCurrent.ql;
			}
			break;
		}
	}

	return NV_OK;
}


NVRESULT Class_NVFile::SetCurrentPosition(QLONG qlOffset, DWORD dwFlag)
{
//  Xg[ł݈̌ʒuݒ

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	QWUNION quOffset;

	if (nvstd.dwFlag & NVFILE_SIZEOVERRIDE)
	{
		//  TCYI[o[ChĂꍇ

		//  ZbgΈʒuvZ
		switch (dwFlag)
		{
		case NVFILE_SEEKCURRENT:
			{
				//  ݈ʒuƂvZ
				quOffset = nvstd.quCurrent;
			}
			break;
		case NVFILE_SEEKEND:
			{
				//  I[o[ChꂽI[ƂvZ
				quOffset = nvstd.quEndOverride;
			}
			break;
		default:
			{
				//  ftHǵANVFILE_SEEKBEGIN
				//  I[o[Chꂽ擪ƂvZ
				quOffset = nvstd.quStartOverride;
			}
		}

		dwFlag = FILE_BEGIN;

		quOffset.ql += qlOffset;

		//  t@C̗L͈͂𒴂ĂȂ`FbN
		if (quOffset.ql < nvstd.quStartOverride.ql)
		{
			return VSTMERR_INVALIDOFFSET;
		}

		if (quOffset.ql > nvstd.quEndOverride.ql)
		{
			return VSTMERR_INVALIDOFFSET;
		}
	}
	else
	{
		//  ItZbgtO
		switch (dwFlag)
		{
		case NVFILE_SEEKCURRENT:
			{
				dwFlag = FILE_CURRENT;
			}
			break;
		case NVFILE_SEEKEND:
			{
				dwFlag = FILE_END;
			}
			break;
		default:
			{
				dwFlag = FILE_BEGIN;
			}
		}
		//  Xg[ł݈̌ʒuݒ肷

		quOffset.ql = qlOffset;
	}

	//  Xg[ł݈̌ʒuݒ肷
	//  DWORD_MAX Ԃ΁As

	quOffset.lLow = SetFilePointer(nvfd.hfile, quOffset.lLow, (LPLONG) &quOffset.lHigh, dwFlag);
	if (quOffset.lLow == DWORD_MAX && GetLastError() != NO_ERROR)
	{
		return VSTMERR_CANTSETPOSITION;
	}

	nvstd.quCurrent = quOffset;


	return NV_OK;
}


NVRESULT Class_NVFile::GetDataSize(LPQWORD lpqwDataSize)
{
//  Xg[̃f[^TCY擾

	QWUNION quSize;

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	if (! lpqwDataSize)
	{
		return VSTMERR_INVALIDPARAM;
	}
	//  Xg[̃f[^TCY擾

	if (nvstd.dwFlag & NVFILE_SIZEOVERRIDE)
	{
		quSize.qw = nvstd.quEndOverride.qw - nvstd.quStartOverride.qw;
	}
	else
	{
		quSize.dwLow = GetFileSize(nvfd.hfile, &quSize.dwHigh);
		if (quSize.dwLow == DWORD_MAX && GetLastError() != NO_ERROR)
		{
			return VSTMERR_CANTGETDATASIZE;
		}
	}

	*lpqwDataSize = quSize.qw;

	return NV_OK;
}

NVRESULT Class_NVFile::SetDataSize(QWORD qwDataSize)
{
//  Xg[̃f[^TCY擾

	QWUNION quSize;
	QWUNION quSetSize;

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	quSetSize.qw = qwDataSize;
	//  Xg[̃f[^TCY擾

	if (nvstd.dwFlag & NVFILE_SIZEOVERRIDE)
	{
		quSize.qw = nvstd.quEndOverride.qw - nvstd.quStartOverride.qw;
		if (quSize.qw < quSetSize.qw)
		{
			QWUNION quCurSize;
			quCurSize.dwLow = GetFileSize(nvfd.hfile, &quCurSize.dwHigh);
			if (quCurSize.dwLow == DWORD_MAX && GetLastError() != NO_ERROR)
			{
				return VSTMERR_CANTSETDATASIZE;
			}
			if (nvstd.quStartOverride.qw + quSetSize.qw > quCurSize.qw)
			{
				return VSTMERR_CANTSETDATASIZE;
			}

			nvstd.quEndOverride.qw = nvstd.quStartOverride.qw + quSetSize.qw;
		}
		else if (quSize.qw > quSetSize.qw)
		{
			nvstd.quEndOverride.qw = nvstd.quStartOverride.qw + quSetSize.qw;
		}
	}
	else
	{
		quSize.dwLow = GetFileSize(nvfd.hfile, &quSize.dwHigh);
		if (quSize.dwLow == DWORD_MAX && GetLastError() != NO_ERROR)
		{
			return VSTMERR_CANTSETDATASIZE;
		}

		if (quSize.qw < quSetSize.qw)
		{
			QWUNION quCurrent;
			NVRESULT nvres;
			nvres = GetCurrentPosition(&quCurrent.ql, NVSTREAM_SEEKBEGIN);
			if (nvres)
			{
				return VSTMERR_CANTSETDATASIZE;
			}

			nvres = SetCurrentPosition(0, NVSTREAM_SEEKEND);
			if (nvres)
			{
				SetCurrentPosition(quCurrent.ql, NVSTREAM_SEEKBEGIN);
				return VSTMERR_CANTSETDATASIZE;
			}

			quSize.qw = quSetSize.qw - quSize.qw;

			while (quSize.qw)
			{
				DWORD dwSize = (DWORD) min(65536, quSize.qw);
				DWORD dwWrite;
				BYTE lpBuf[65536];

				Write(lpBuf, dwSize, &dwWrite);
				quSize.qw -= dwWrite;
			}

			nvres = SetCurrentPosition(quCurrent.ql, NVSTREAM_SEEKBEGIN);
			if (nvres)
			{
				return VSTMERR_CANTSETDATASIZE;
			}

			quSize.dwLow = GetFileSize(nvfd.hfile, &quSize.dwHigh);
			if (quSize.dwLow == DWORD_MAX && GetLastError() != NO_ERROR)
			{
				return VSTMERR_CANTSETDATASIZE;
			}
			if (quSize.qw != quSetSize.qw)
			{
				return VSTMERR_CANTSETDATASIZE;
			}
		}
		else if (quSize.qw > quSetSize.qw)
		{
			QWUNION quCurrent;
			BOOL bRet;
			NVRESULT nvres;
			nvres = GetCurrentPosition(&quCurrent.ql, NVSTREAM_SEEKBEGIN);
			if (nvres)
			{
				return VSTMERR_CANTSETDATASIZE;
			}

			nvres = SetCurrentPosition(quSetSize.ql, NVSTREAM_SEEKBEGIN);
			if (nvres)
			{
				nvres = SetCurrentPosition(quCurrent.ql, NVSTREAM_SEEKBEGIN);
				return VSTMERR_CANTSETDATASIZE;
			}

			bRet = SetEndOfFile(nvfd.hfile);
			nvres = SetCurrentPosition(quCurrent.ql, NVSTREAM_SEEKBEGIN);
			if (nvres || (! bRet))
			{
				return VSTMERR_CANTSETDATASIZE;
			}
		}
	}
	return NV_OK;
}

NVRESULT Class_NVFile::GetDataName(LPTSTR lpszDataName, DWORD dwLength)
{
//  Xg[̃f[^擾

	//  ̊֐́Aʂ̏ŗǂ͂


	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	//  t@CRs[

	if (nvstd.dwFlag & NVSTREAM_DATANAMEOVERRIDE)
	{
		//  f[^I[o[ChĂꍇ

		_tcsncpy_s(lpszDataName, dwLength, nvstd.lpszDataNameOverride, dwLength - 1);
	}
	else
	{
		//  I[o[ChĂȂꍇ
		_tcsncpy_s(lpszDataName, dwLength, nvstd.lpszDataName, dwLength - 1);
	}


	return NV_OK;
}


NVRESULT Class_NVFile::GetOpenMode(LPDWORD lpdwFlag)
{
//  Xg[̃I[v[h擾

	//  ̊֐́Aʂ̏ŗǂ͂

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	*lpdwFlag = nvstd.dwFlag;
	return NV_OK;
}


NVRESULT Class_NVFile::ChangeOpenMode(DWORD dwFlag)
{
//  Xg[̃I[v[hύX

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	DWORD dwDesiredAccess;
	DWORD dwShareMode;
	DWORD dwCreationDisposition;
	DWORD dwFlagsAndAttributes = 0;
	QWUNION quCurrent;

	//  ǂݏ[h
	switch (dwFlag & NVFILE_OPENMASK)
	{
	case NVFILE_OPENREADWRITE:
		{
			return VSTMERR_UNSUPPORTED;
		}
	case NVFILE_OPENWRITE:
		{
			dwDesiredAccess = GENERIC_WRITE;

			//  ftHg̓VFAOnee
			if (nvfd.dwExtraFlag & NVFILE_SHARING)
			{
				dwShareMode = FILE_SHARE_WRITE;
			}
			else
			{
				dwShareMode = 0;
			}
			nvstd.dwFlag &= (~NVFILE_OPENREAD);
			nvstd.dwFlag |= NVFILE_OPENWRITE;
		}
		break;
	default:
		{
			//  ftHg͓ǂ݂݃ANZX
			dwDesiredAccess = GENERIC_READ;

			//  ftHg̓VFAOnm
			if (nvfd.dwExtraFlag & NVFILE_NOSHARING)
			{
				dwShareMode = 0;
			}
			else
			{
				dwShareMode = FILE_SHARE_READ;
			}
			nvstd.dwFlag &= (~NVFILE_OPENWRITE);
			nvstd.dwFlag |= NVFILE_OPENREAD;
		}
	}

	//  łɊJĂt@CȂ̂ŁAK͂
	dwCreationDisposition = OPEN_ALWAYS;

	GetCurrentPosition(&quCurrent.ql, NVSTREAM_SEEKBEGIN);
	//  Õnh
	CloseHandle(nvfd.hfile);

	//  VnhJ
	nvfd.hfile = NVCreateFile(nvstd.lpszDataName, dwDesiredAccess, dwShareMode, NULL, dwCreationDisposition, dwFlagsAndAttributes, NULL);
	if (nvfd.hfile == INVALID_HANDLE_VALUE || nvfd.hfile == NULL)
	{
		//  sB𑱍słȂvIG[H
		return VSTMERR_CANTCHANGEOPENMODE;
	}
	SetCurrentPosition(quCurrent.ql, NVSTREAM_SEEKBEGIN);

	return NV_OK;
}



NVRESULT Class_NVFile::OverrideDataName(LPCTSTR lpcszDataName)
{
//  Xg[̃I[o[Chݒ肷

	//  ̊֐́Aʂ̏ŗǂ͂

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	_tcscpy_s(nvstd.lpszDataNameOverride, NV_PATHMAX, lpcszDataName);

	nvstd.dwFlag |= NVSTREAM_DATANAMEOVERRIDE;

	return NV_OK;
}


NVRESULT Class_NVFile::OverrideSize(QWORD qwStartOverride, QWORD qwSizeOverride)
{
//  Xg[̃I[o[ChTCYݒ肷

	QWUNION quSize;
	QWUNION quEndOverride;
	QWUNION quStartOverride;
	QWUNION quCurrent;

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	if (nvstd.dwFlag & NVSTREAM_OPENWRITE)
	{
		return VSTMERR_UNSUPPORTED;
	}

	//  ۂ̃t@CTCY擾
	quSize.dwLow = GetFileSize(nvfd.hfile, &quSize.dwHigh);

	//  I[o[Chn_`FbN
	quStartOverride.qw = qwStartOverride;
	if (quStartOverride.qw > quSize.qw)
	{
		return VSTMERR_INVALIDPARAM;
	}

	//  \zI_vZ
	quEndOverride.qw = qwSizeOverride;
	quEndOverride.qw += quStartOverride.qw;

	//  I[o[ChI_`FbN
	if (quEndOverride.qw > quSize.qw)
	{
		return VSTMERR_INVALIDPARAM;
	}

	//  ύX݈̌ʒu`FbN
	//  KvȂANbv
	quCurrent = nvstd.quCurrent;

	if (quCurrent.qw < quStartOverride.qw)
	{
		quCurrent.qw = quStartOverride.qw;
	}

	if (quCurrent.qw > quEndOverride.qw)
	{
		quCurrent.qw = quEndOverride.qw;
	}

	//  ۂ̃t@C|C^ړ
	quCurrent.dwLow = SetFilePointer(nvfd.hfile, quCurrent.dwLow, (LPLONG) &quCurrent.dwHigh, FILE_BEGIN);
	if (quCurrent.dwLow == DWORD_MAX && GetLastError() != NO_ERROR)
	{
		return VSTMERR_CANTOVERRIDESIZE;
	}

	//  elۑďI
	nvstd.quStartOverride = quStartOverride;
	nvstd.quEndOverride = quEndOverride;
	nvstd.quCurrent = quCurrent;
	nvstd.dwFlag |= NVSTREAM_SIZEOVERRIDE;

	return NV_OK;
}


NVRESULT Class_NVFile::GetInfo(LPVOID lpvParam, LPDWORD lpdwSize)
{
//  Xg[̏擾

	if (! lpvParam)
	{
		//  TCY₢킹̏ꍇ
		*lpdwSize = sizeof(NVFILEINFO);
		return NV_OK;
	}

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	//  obt@̃TCY`FbN
	if (*lpdwSize < sizeof(NVFILEINFO))
	{
		//  Ȃ΁AKvȃTCYƃG[Ԃ
		*lpdwSize = sizeof(NVFILEINFO);
		return VSTMERR_BUFFERTOOSMALL;
	}

	//  t@CRs[

	CopyMemory(lpvParam, &nvfd.nvfi, sizeof(NVFILEINFO));

	*lpdwSize = sizeof(NVFILEINFO);

	return NV_OK;
}


NVRESULT Class_NVFile::SetInfo(LPVOID lpvParam, DWORD dwSize)
{
//  Xg[̏ݒ肷

	LPNVFILEINFO lpnvfi = (LPNVFILEINFO) lpvParam;

	//  obt@̃TCY`FbN
	if (dwSize < sizeof(NVFILEINFO))
	{
		return VSTMERR_BUFFERTOOSMALL;
	}

	//  obt@̃f[^`FbN
	if (lpnvfi->dwFourCC != NVFILE_FOURCC)
	{
		return VSTMERR_INVALIDPARAMTYPE;
	}

	if (lpnvfi->dwObjSize != sizeof(NVFILEINFO))
	{
		return VSTMERR_INVALIDPARAMSIZE;
	}

	//  ۑ
	CopyMemory(&nvfd.nvfi, lpnvfi, sizeof(NVFILEINFO));
	nvfd.nvfi.dwAttributes &= NVFILE_FILEATTRIBUTEMASK;	//  Lȑc

	nvfd.dwStatus |= NVFILE_STATUSINFOCHANGED;		//  񂪕ύXꂽtO𗧂Ă

	return NV_OK;
}


NVRESULT Class_NVFile::CreateAlias(LPINVSTREAM lpinvst)
{
//  CX^X̃GCAX쐬
	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	{
		NVFILECREATE nvfc;
		QWUNION quSizeOverride;
		INVFILE invf;
		NVRESULT nvres;

		quSizeOverride.qw = nvstd.quEndOverride.qw - nvstd.quStartOverride.qw;

		SetNVFileCreate(&nvfc, nvstd.dwFlag, nvstd.lpszDataName, nvstd.lpszDataNameOverride,
			nvstd.quStartOverride.qw, quSizeOverride.qw, nvfd.dwExtraFlag);

		nvres = VCreateInstance(NVFILE_FOURCC, NVFILE_FOURCC, (LPVOID *) &invf);
		if (nvres)
		{
			return nvres;
		}

		nvres = invf->Create(&nvfc);
		if (nvres)
		{
			invf->Release();
			return nvres;
		}

		*lpinvst = (INVSTREAM) invf;
	}

	return NV_OK;
}


NVRESULT Class_NVFile::QueryClassInfo(LPVOID lpvInfo, LPDWORD lpdwSize)
{
//  NX̎@\擾

	//  ݂͖T|[gH
	*lpdwSize = 0;

	return VSTMERR_UNSUPPORTED;
}

static inline NVRESULT CheckFileNameSyntax(LPCTSTR lpcszFileName)
{
	LPCTSTR lpcszCur = lpcszFileName;
	LPCTSTR lpcszLast = lpcszFileName;

	while (*lpcszCur)
	{
		lpcszLast = lpcszCur;
#ifdef _UNICODE
		lpcszCur++;
#else
		lpcszCur = (LPCTSTR) _mbsinc((unsigned char *) lpcszCur);
#endif
	}

	if ((*lpcszLast == TEXT(' ')) || (*lpcszLast == TEXT('.')))
	{
		return NVERR_UNDEFINED;
	}

	return NV_OK;
}