//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  t@CNX  wb_[t@C  for  NVFileLibrary                                    //
//  NVFile.h                                                                                    //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  INVFILE ́AINVSTREAM C^[tF[X݊̃t@CNXłB                      //
//  INVSTREAM Œ`Ă@\قA                                                  //
//  t@C̍쐬ɊւĂ̓tOT|[gĂB                                  //
//  CX^X̏Af[^̓ǂݍ݁A݂܂ŁA                                  //
//  INVSTREAM C^[tF[XƂđSNXʂ̑ňB                                //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////




#pragma once





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//

#include "NVStream.h"



#ifdef __cplusplus
extern "C" {
#endif

#pragma pack(push, 1)




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  }N̐錾
//

//  t@CI[v[htO
#define NVFILE_OPENMASK      NVSTREAM_OPENMASK		//  I[v[htOo߂̃}XN
#define NVFILE_OPENREAD      NVSTREAM_OPENREAD		//  ǂݍ݃[hŃI[viftHgj
#define NVFILE_OPENWRITE     NVSTREAM_OPENWRITE		//  ݃[hŃI[v
#define NVFILE_OPENREADWRITE NVSTREAM_OPENREADWRITE	//  ǂݏp[hŃI[v@i݂͖T|[gj

//  t@CI[vtO
#define NVFILE_SIZEOVERRIDE     NVSTREAM_SIZEOVERRIDE		//  TCYI[o[ChāAIȃXg[JB
#define NVFILE_DATANAMEOVERRIDE NVSTREAM_DATANAMEOVERRIDE	//  Xg[̃f[^I[o[ChĕύX


//  t@CI[vtO
//#define NVFILE_NOBUFFERING 0x10000000		//  obt@OpŃI[v
//#define NVFILE_BUFFERING 0x20000000		//  obt@OgpȂŃI[v

#define NVFILE_SHARING     0x40000000		//  L[hŃI[viǂݍݎftHgj
#define NVFILE_NOSHARING   0x80000000		//  r[hŃI[viݎftHgj

#define NVFILE_CREATEMASK   0x0F000000		//  t@C̍쐬tOo߂̃}XN
#define NVFILE_CREATENEW    0x01000000		//  VK쐬Błɑ݂΁As
#define NVFILE_CREATEALWAYS 0x02000000		//  KVK쐬
#define NVFILE_OPENEXISTING 0x04000000		//  ݂t@Ĉ݃I[viǂݍݎftHgj
#define NVFILE_OPENALWAYS   0x08000000		//  KJBȂ΍쐬BiݎftHgj

#define NVFILE_WRITETHROUGH   0x00100000	//  CgX[ŃI[v

#define NVFILE_RANDOMACCESS   0x00200000	//  _ANZXpɍœKăI[v
#define NVFILE_SEQUENTIALSCAN 0x00400000	//  V[PVANZXpɍœKăI[viftHgj

#define NVFILE_FORCEWRITE 0x00080000		//  ReadOnly t@Cłށi݌AReadOnly ɖ߂j

//  V[NtO
#define NVFILE_SEEKBEGIN   NVSTREAM_SEEKBEGIN		//  f[^̐擪̑ΈʒuŎwiftHgj
#define NVFILE_SEEKCURRENT NVSTREAM_SEEKCURRENT		//  f[^݈̌ʒȗΈʒuŎw
#define NVFILE_SEEKEND     NVSTREAM_SEEKEND			//  f[^̍Ō̑ΈʒuŎw


struct NVFILEINFO
{
	DWORD dwFourCC;
	DWORD dwObjSize;
	DWORD dwAttributes;
	union
	{
		FILETIME ftCreationTime;
		QWORD qwCreationTime;
	};
	union
	{
		FILETIME ftLastAccessTime;
		QWORD qwLastAccessTime;
	};
	union
	{
		FILETIME ftLastWriteTime;
		QWORD qwLastWriteTime;
	};
};
typedef NVFILEINFO * LPNVFILEINFO;
typedef const NVFILEINFO * LPCNVFILEINFO;

#define NVFILE_FILEATTRIBUTEMASK (FILE_ATTRIBUTE_ARCHIVE | FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_NORMAL | FILE_ATTRIBUTE_OFFLINE | FILE_ATTRIBUTE_READONLY | FILE_ATTRIBUTE_SYSTEM | FILE_ATTRIBUTE_TEMPORARY)





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  NX̒`      INVFILE
//


//  NXʎq
#define NVFILE_FOURCC MAKEFOURCC('V', 'S', 'N', 'F')


/*  INVFILE NXWXg (VCOM.ini ւ̋Lq)
[VSNF]

Class_ID = "VSNF"
Module_Name = "NVFileLib.dll"
Entry_Point = "CreateInstance_NVFile"
*/


class Class_NVFile;
typedef Class_NVFile * INVFILE;
typedef const Class_NVFile * CINVFILE;
typedef INVFILE * LPINVFILE;
typedef const INVFILE * LPCINVFILE;



//  INVFILE ̏f[^
struct NVFILECREATE		//  nvfc
{
	DWORD dwFourCC;					//  NXʎq
	DWORD dwObjSize;				//  \̂̃TCY
	DWORD dwFlag;					//  tO
	LPCTSTR lpcszDataName;			//  I[vf[^
	LPCTSTR lpcszDataNameOverride;	//  I[o[Chf[^   NVSTREAM_DATANAMEOVERRIDE gp̂ݗL
	QWUNION quStartOverride;		//  I[o[ChJnʒu   NVSTREAM_SIZEOVERRIDE gp̂ݗL
	QWUNION quSizeOverride;			//  I[o[ChTCY     NVSTREAM_SIZEOVERRIDE gp̂ݗL

	DWORD dwExtraFlag;				//  tO
};
typedef NVFILECREATE * LPNVFILECREATE;
typedef const NVFILECREATE * LPCNVFILECREATE;



//  INVFILE ̕ێf[^
struct NVFILEDATA
{
	HANDLE hfile;			//  t@Cnh
	DWORD dwExtraFlag;		//  tO
	NVFILEINFO nvfi;		//  t@C
	DWORD dwStatus;			//  eXe[^XtO
};
typedef NVFILEDATA * LPNVFILEDATA;
typedef const NVFILEDATA * LPCNVFILEDATA;

#define NVFILE_STATUSINFOCHANGED  0x01		//  t@C񂪍XVꂽǂ






//  INVFILE NX̒`
class NVFILELIB_CLASS_EXPORT Class_NVFile : virtual public Class_NVStream
{
	public:
		Class_NVFile(void);
		//  ftHgRXgN^
		//
		//  SetCoreData() ĂяoāA{NXɃf[^ݒ肷B

	VCOM_CLASSMETHOD
		~Class_NVFile(void);
		//  fXgN^
		//

	VCOM_CLASSMETHOD
		NVRESULT Create(LPCVOID lpvParam);
		//  CX^X̏
		//
		//  CX^XɃp[^^āACX^X̃f[^(쐬)B
		//  nvcd.bIsCreated tO𗧂āAς݂`FbNs悤ɂB
		//  NVSTREAMCREATE сANVFILECREATE ǂ̃p[^łłB
		//  NVSTREAMCREATE gꍇ́AExtraFlag ׂ͂ăftHgƂĉ߂

	VCOM_CLASSMETHOD
		NVRESULT ResetData(void);
		//  CX^X̃f[^Zbg
		//
		//  CX^XŗpȂǂACreate() ĂяoȌԂɖ߂B
		//  vcd.bIsCreated tOZbgAĂ Create() s悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface);
		//  C^[tF[X̎擾
		//
		//  DWORD dwFourCC			擾C^[tF[X
		//  LPVOID *lpvInterface	C^[tF[Xi[|C^
		//
		//  ̃CX^X́AdwFourCC Ŏw肵^̃C^[tF[X擾B
		//  擾łC^[tF[X́ACX^XɂĈقȂ邪A
		//  CX^XNX̃X[p[NXɂNX̃C^[tF[X
		//  K擾ł悤ɎȂ΂ȂȂB
		//  ̊֐ŕʂ̃C^[tF[X擾ƁA AddRef() ŝŁA
		//  ÂC^[tF[Xɑ΂Ă Release() KvB

	VCOM_CLASSMETHOD
		NVRESULT Read(LPVOID lpvDestBuffer, DWORD dwReadSize, LPDWORD lpdwResult);
		//  Xg[f[^ǂݏo
		//
		//  LPVOID lpvDestBuffer		ǂݏõobt@
		//  DWORD dwReadSize			ǂݏoTCY
		//  LPDWORD lpdwResult			ۂɓǂݏoꂽTCY
		//
		//  Xg[f[^ǂݏoB
		//  ǂݍ݂Ɏsꍇ́AVSTMERR_CANTREADSTREAM ԂB
		//  vꂽTCỸf[^ȂꍇAVSTMERR_STREAMEMPTY Ԃ

	VCOM_CLASSMETHOD
		NVRESULT Write(LPCVOID lpvSrcBuffer, DWORD dwWriteSize, LPDWORD lpdwResult);
		//  Xg[փf[^
		//
		//  LPVOID lpvSrcBuffer		ރf[^̃obt@
		//  DWORD dwWriteSize		ރf[^̃TCY
		//  LPDWORD lpdwResult		ۂɏ܂ꂽTCY
		//
		//  Xg[փf[^o
		//  vꂽTCYoȂꍇAVSTMERR_STREAMFULL Ԃ
		//  ݂Ɏsꍇ́AVSTMERR_CANTWRITESTREAM Ԃ

	VCOM_CLASSMETHOD
		NVRESULT GetCurrentPosition(LPQLONG lpqlOffset, DWORD dwFlag);
		//  Xg[ł݈̌ʒu擾
		//
		//  LPQLONG lpqlOffset		擾̃|C^
		//  DWORD dwFlag			擾tO
		//
		//  tOŎwvZ@ŁA݈ʒu擾
		//  ftHǵANVSTREAM_SEEKBEGIN

	VCOM_CLASSMETHOD
		NVRESULT SetCurrentPosition(QLONG lOffset, DWORD dwFlag);
		//  Xg[ł݈̌ʒuݒ
		//
		//  QLONG qlOffset			ݒ肷ʒu
		//  DWORD dwFlag			ݒtO
		//
		//  tOŎwvZ@ŁA݈ʒuݒ肷
		//  ftHǵANVSTREAM_SEEKBEGIN

	VCOM_CLASSMETHOD
		NVRESULT GetDataSize(LPQWORD lpqwDataSize);
		//  Xg[̃f[^TCY擾
		//
		//  LPQWORD lpqwDataSize		󂯎|C^
		//
		//  Xg[̃f[^TCY擾
		//  NVSTREAM_SIZEOVERRIDE tOgč쐬ĂꍇA
		//  I[o[ChꂽTCYԂ

	VCOM_CLASSMETHOD
		NVRESULT SetDataSize(QWORD qwDataSize);

	VCOM_CLASSMETHOD
		NVRESULT GetDataName(LPTSTR lpszDataName, DWORD dwLength);
		//  Xg[̃f[^擾
		//
		//  LPTSTR lpszDataName		f[^󂯎obt@
		//  DWORD dwLength			obt@̃TCY
		//
		//  Xg[̃f[^擾
		//  NVSTREAM_DATANAMEOVERRIDE tOgč쐬ĂꍇA
		//  I[o[ChꂽOԂB

	VCOM_CLASSMETHOD
		NVRESULT GetOpenMode(LPDWORD lpdwFlag);
		//  Xg[̃I[v[h擾
		//
		//  LPDWORD lpdwFlag		tO󂯎|C^
		//
		//  Xg[̃I[v[h擾

	VCOM_CLASSMETHOD
		NVRESULT ChangeOpenMode(DWORD dwFlag);
		//  Xg[̃I[v[hύX
		//
		//  DWORD dwFlag		I[vtO
		//
		//  ݈ʒuȂǂ̂܂܂ɁAI[v[hύX
		//  ΉłȂC^[tF[XȂƎv̂ŁA
		//  ߂lKmF邱

	VCOM_CLASSMETHOD
		NVRESULT OverrideDataName(LPCTSTR lpcszDataName);
		//  Xg[̃I[o[Chݒ肷
		//
		//  LPCTSTR lpszDataName
		//
		//  I[o[ChĂȂ΁AVɃI[o[Ch
		//  łɂĂ΁AXV

	VCOM_CLASSMETHOD
		NVRESULT OverrideSize(QWORD qwStartOverride, QWORD qwSizeOverride);
		//  Xg[̃I[o[CTCYݒ肷
		//
		//  QWORD qwStartOffset			I[o[ChJnʒu
		//  QWORD qwSize				I[o[ChTCY
		//
		//  I[o[ChĂȂ΁AVɃI[o[Ch
		//  łɂĂ΁Aɑ΂鑊ΈʒuƂĂɃI[o[Ch
		//  I[o[CȟʁA݈ʒuȈʒuɂȂꍇA
		//  LȔ͈͂ɃNbvB
		//  KAI[o[ChA]̈ʒuɃV[N邱

	VCOM_CLASSMETHOD
		NVRESULT GetInfo(LPVOID lpvParam, LPDWORD lpdwSize);
		//  Xg[̏擾
		//
		//  LPVOID lpvParam		Xg[̃f[^󂯎obt@
		//  LPDWORD lpdwSize	obt@̃TCYAуobt@ɏ܂ꂽTCY
		//
		//  Xg[̏擾B
		//  eCX^Xɂēe͈قȂ
		//  GetFourCC \bhŃCX^XmFAɂ\̂Ńf[^QƂB
		//  lpvParam  NULL nAobt@̃TCYsĂ
		//  lpdwSize ɕKvȃTCYԂB
		//  ֐ƁAlpdwSize ɂ́Aۂɏ܂ꂽTCYi[Ă

	VCOM_CLASSMETHOD
		NVRESULT SetInfo(LPVOID lpvParam, DWORD dwSize);
		//  Xg[̏ݒ肷
		//
		//  LPVOID lpvParam		Xg[̃f[^nobt@
		//  LPDWORD lpdwSize	obt@̃TCY
		//
		//  Xg[̏ݒ肷B
		//  eCX^Xɂēe͈قȂ

	VCOM_CLASSMETHOD
		NVRESULT CreateAlias(LPINVSTREAM lpinvst);
		//  CX^X̃GCAX쐬
		//
		//  LPINVSTREAM lpinvst		GCAX̃C^[tF[X󂯎|C^
		//
		//  f[^ɑ΂āAʂ̈ʒuȂǂێăANZXłGCAX쐬B
		//  ̏ꍇAp[^ŃCX^X쐬ȂāA
		//  ̃C^[tF[XԂB
		//  ʏAǂݍ݃[ĥƂ̂ݎ󂯕t邱ƂɂȂB

	VCOM_CLASSMETHOD
		NVRESULT QueryClassInfo(LPVOID lpvInfo, LPDWORD lpdwSize);
		//  NX̎@\擾
		//
		//  LPVOID@lpvInfo		NX̃f[^󂯎obt@
		//  LPDWORD lpdwSize	obt@̃TCYAуobt@ɏ܂ꂽTCY
		//
		//  NX INVSTREAM C^[tF[XŒ`Ă@\̂A
		//  T|[gĂ̂𒲂ׂB
		//  lpvParam  NULL nAobt@̃TCYsĂ
		//  lpdwSize ɕKvȃTCYԂB
		//  ֐ƁAlpdwSize ɂ́Aۂɏ܂ꂽTCYi[Ă

protected:
	VCOM_CLASSMETHOD
		NVRESULT AddInterface(DWORD dwFlag);
		//  C^[tF[XQƃe[uɓo^
		//
		//  DWORD dwFlag	NXCX^X̏ꍇPAȊO͂O
		//
		//  RXgN^̒ŌĂ΂AC^[tF[X|C^e[uɓo^A
		//  VIsValidInterface() ŃC^[tF[X̗L؂ł悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT DeleteInterface(void);
		//  C^[tF[XQƃe[u폜
		//
		//  DeleteInstance() ̒ŌĂ΂AC^[tF[X|C^e[u폜B

	protected:
		NVFILEDATA nvfd;
};



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̐錾
//

NVRESULT NVFILELIB_EXPORT NVFILELIB_API CreateInstance_NVFile(LPIVCOM lpivcom);
//  CX^X̍쐬
//
//  INVFILE CX^X쐬ÃC^[tF[XԂB



inline void SetNVFileCreate(LPNVFILECREATE lpnvfc, DWORD dwFlag, LPCTSTR lpcszDataName, LPCTSTR lpcszDataNameOverride = NULL,
							QWORD qwStartOverride = 0, QWORD qwSizeOverride = 0,
							DWORD dwExtraFlag = 0);
//  NVFILECREATE \̏֐
//
//  LPNVFILECREATE lpnvfc				\
//  DWORD dwFlag						ZbgtO
//  LPCTSTR lpcszDataName				I[vf[^
//  LPCTSTR lpcszDataNameOverride		I[o[Chf[^  NVSTREAM_DATANAMEOVERRIDE gp̂ݗL
//  QWORD qwStartOverride				I[o[ChJnʒu  NVSTREAM_SIZEOVERRIDE gp̂ݗL
//  QWORD qwSizeOverride				I[o[ChIʒu  NVSTREAM_SIZEOVERRIDE gp̂ݗL
//  DWORD dwExtraFlag					ݒ肷tO



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  CC֐̒`
//

inline void SetNVFileCreate(LPNVFILECREATE lpnvfc, DWORD dwFlag, LPCTSTR lpcszDataName, LPCTSTR lpcszDataNameOverride,
							QWORD qwStartOverride, QWORD qwSizeOverride,
							DWORD dwExtraFlag)
{
//  NVFILECREATE \̏֐

	lpnvfc->dwFourCC = NVFILE_FOURCC;
	lpnvfc->dwObjSize = sizeof(NVFILECREATE);
	lpnvfc->dwFlag = dwFlag;
	lpnvfc->lpcszDataName = lpcszDataName;
	lpnvfc->lpcszDataNameOverride = lpcszDataNameOverride;
	lpnvfc->quStartOverride.qw = qwStartOverride;
	lpnvfc->quSizeOverride.qw = qwSizeOverride;

	lpnvfc->dwExtraFlag = dwExtraFlag;

	return;
}




#pragma pack(pop)

#ifdef __cplusplus
}
#endif
