//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  z t@CNX  \[Xt@C  for  NVFileLibrary                                 //
//  NVMemFile.cpp                                                                               //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  INVMEMFILE ́AINVSTREAM C^[tF[X݊̃t@CNXłB                   //
//  INVSTREAM Œ`Ă@\قA                                                  //
//  t@C̍쐬ɊւĂ̓tOT|[gĂB                                  //
//  CX^X̏Af[^̓ǂݍ݁A݂܂ŁA                                  //
//  INVSTREAM C^[tF[XƂđSNXʂ̑ňB                                //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "NVMemFile.h"




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  X^eBbN֐̒`
//


//  t@CI[v֐
static inline NVRESULT NVMEMFILECreate(LPNVMEMFILEDATA lpnvfd, LPNVSTREAMDATA lpnvstd, LPCNVSTREAMCREATE lpcnvstc, QWORD qwReservedSize);


#define NVAddUINT64(lowDest, highDest, lowSrc1, highSrc1, lowSrc2, highSrc2) \
{ \
	(lowDest) = (lowSrc1) + (lowSrc2); \
	(highDest) = (highSrc1) + (highSrc2) + (((lowDest) < (lowSrc1)) ? 1 : 0); \
}




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̒`
//


NVRESULT NVFILELIB_EXPORT NVFILELIB_API CreateInstance_NVMemFile(LPIVCOM lpivcom)
{
	//  CX^X̍쐬
	//  vtable Kv̂ŁAnew ZqoRŃAP[VB

	if (! lpivcom)
	{
		return NVERR_UNDEFINED;
	}

	*lpivcom = (IVCOM) new Class_NVMemFile;
	if (*lpivcom)
	{
		return NV_OK;
	}
	else
	{
		return NVERR_UNDEFINED;
	}
}




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  o֐̐錾  Class_NVMemFile
//


Class_NVMemFile::Class_NVMemFile(void)
{
//  ftHgRXgN^

	//  {NX̕ێf[^ݒ肷BRXgN^͊{NX珇ԂɌĂяôŁA
	//  ŌɌĂяo邱ƂɂȂACX^X̃IWǐ^݂̏̂cB
	//  ]ȏ̂ŃI[o[wbh邪AdldƁB
	Class_VCOM::SetCoreData((LPVOID) this, (DWORD) sizeof(Class_NVMemFile), NVMEMFILE_FOURCC);

	//  ێf[^͖̏B

	return;
}


Class_NVMemFile::~Class_NVMemFile(void)
{
//  fXgN^

	//  Release oRȊOĂяoƁAvcd.bIsCreated  TRUE ł邱ƂB
	//  ̏ꍇAȉsĂȂ͂Ȃ̂ŁAASSERT B
	assert(! vcd.bIsCreated);

	return;
}


NVRESULT Class_NVMemFile::Create(LPCVOID lpvParam)
{
//  CX^X̏
	//  eNXŕKvȏLqB
	NVRESULT nvres;

	//  ʂ̌^ɃLXg
	LPCNVSTREAMCREATE lpcnvstc = (LPCNVSTREAMCREATE) lpvParam;

	//  ς݃IuWFNgłȂǂ`FbN
	if (vcd.bIsCreated)
	{
		//  ς݂̏ꍇAG[ɂB
		return VSTMERR_ALREADYUSED;
	}

	//  ̐`FbN
	{
		//  NX̎ʎqƈ̎ʎqr
		if (lpcnvstc->dwFourCC == NVSTREAM_FOURCC)
		{
			//  ̃TCY`FbN
			if (lpcnvstc->dwObjSize != sizeof(NVSTREAMCREATE))
			{
				//  ɓnꂽ\̂̃TCYĂ
				return VSTMERR_INVALIDPARAMSIZE;
			}

			//  ExtraFlag ftHgƂāAp
			nvres =  NVMEMFILECreate(&nvmfd, &nvstd, lpcnvstc, 0);
		}
		else if (lpcnvstc->dwFourCC == NVMEMFILE_FOURCC)
		{
			//  ̃TCY`FbN
			if (lpcnvstc->dwObjSize != sizeof(NVMEMFILECREATE))
			{
				//  ɓnꂽ\̂̃TCYĂ
				return VSTMERR_INVALIDPARAMSIZE;
			}
			nvres = NVMEMFILECreate(&nvmfd, &nvstd, lpcnvstc, ((LPCNVMEMFILECREATE) lpcnvstc)->qwReservedSize);
		}
		else
		{
			//  ԈႦĂ
			return VSTMERR_INVALIDPARAMTYPE;
		}
	}

	if (nvres)
	{
		return nvres;
	}

	vcd.bIsCreated = TRUE;
	return NV_OK;
}


static inline NVRESULT NVMEMFILECreate(LPNVMEMFILEDATA lpnvmfd, LPNVSTREAMDATA lpnvstd, LPCNVSTREAMCREATE lpcnvstc, QWORD qwReservedSize)
{
	//  t@CI[v֐
	if ((! lpcnvstc->lpcszDataName) || (! *lpcnvstc->lpcszDataName))
	{
		//  I[vf[^Ȃ΃G[
		return VSTMERR_INVALIDPARAM;
	}

	if (lpcnvstc->dwFlag & NVMEMFILE_SIZEOVERRIDE && lpcnvstc->dwFlag & NVMEMFILE_OPENWRITE)
	{
		//  ݃[h́ATCYI[o[ChłȂ
		return VSTMERR_INVALIDPARAM;
	}

	//  ̃`FbNIAۂɈ̓eɉďsB
	try
	{
		//  ̒lQƂāAsB

		qwReservedSize = max(NVMEMFILE_RESERVEDSIZE_DEFAULT, qwReservedSize);
		lpnvmfd->lpData = (LPBYTE) NVMemAlloc(NVMEM_FIXED, (SIZE_T) qwReservedSize);
		lpnvmfd->quRealSize.qw = 0;
		lpnvmfd->quMaxSize.qw = qwReservedSize;
		lpnvstd->dwFlag = lpcnvstc->dwFlag;
		if (lpcnvstc->dwFlag & NVMEMFILE_SIZEOVERRIDE)
		{
			//  TCYI[o[Chꍇ̏

			QWUNION quSize;

			//  t@CTCY擾
			quSize.qw = qwReservedSize;

			//  Jnʒut@CɂȂ΃G[
			if (lpcnvstc->quStartOverride.qw >= quSize.qw)
			{
				throw VSTMERR_INVALIDPARAM;
			}

			//  Jnʒu̕ۑ
			lpnvstd->quStartOverride.qw = lpcnvstc->quStartOverride.qw;

			//  IʒǔvZ
			lpnvstd->quEndOverride.qw = lpcnvstc->quStartOverride.qw + lpcnvstc->quSizeOverride.qw;

			//  Iʒut@C̏I[ȂG[
			if (lpnvstd->quEndOverride.qw > quSize.qw)
			{
				throw VSTMERR_INVALIDPARAM;
			}

			//  t@C|C^Jnʒu܂ňړ
			lpnvmfd->quCurrentOffset = lpnvstd->quStartOverride;

			//  tOۑ
			lpnvstd->dwFlag |= NVMEMFILE_SIZEOVERRIDE;
		}

		_tcscpy_s(lpnvstd->lpszDataName, NV_PATHMAX, lpcnvstc->lpcszDataName);
		if (lpcnvstc->dwFlag & NVMEMFILE_DATANAMEOVERRIDE)
		{
			//  f[^I[o[Chꍇ̏

			_tcscpy_s(lpnvstd->lpszDataNameOverride, NV_PATHMAX, lpcnvstc->lpcszDataNameOverride);
			lpnvstd->dwFlag |= NVMEMFILE_DATANAMEOVERRIDE;
		}
	}
	catch (NVRESULT nvres)
	{
		//  G[Nꍇ̏

		if (lpnvmfd->lpData)
		{
			NVMemFree(lpnvmfd->lpData);
		}
		return nvres;
	}

	return NV_OK;
}



NVRESULT Class_NVMemFile::ResetData(void)
{
//  CX^X̃f[^Zbg

	//  nh̉Aobt@̉Ȃǂs

	if (nvmfd.lpData)
	{
		NVMemFree(nvmfd.lpData);
	}

	//  ێf[^OZbg
	ZeroMemory(&nvmfd, sizeof(NVMEMFILEDATA));

	//  eNX ResetData Ɉp
	return Class_NVStream::ResetData();
}


NVRESULT Class_NVMemFile::QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface)
{
//  C^[tF[X̎擾

	//  dwFourCC ɂāAKȌ^̃C^[tF[XԂB
	//  ǧ^̃C^[tF[X̍쐬ȊÓAeNX̃\bhĂԂƂŉƗǂƎvB

	if (dwFourCC == NVMEMFILE_FOURCC)
	{
		//  ̃NX̃C^[tF[X擾Ȃ̂ŁAԂli[AAddRef() ƂɐIB
		*lpvInterface = (INVMEMFILE) this;
		AddRef();
		return NV_OK;
	}
	else
	{
		//  ǧ^ȊÓAeNXɔC
		return Class_NVStream::QueryInterface(dwFourCC, lpvInterface);
	}
}


NVRESULT Class_NVMemFile::AddInterface(DWORD dwFlag)
{
//  C^[tF[XQƃe[uɓo^

	//  CX^Xɑ΂ŏ̂P̌Ăяoł́A
	//  dwFlag ɂ VCOM_CLASSINTERFACE ĂB
	//  ȍ~̌Ăяoł́AOĂB
	VAddInterface(this, (IVCOM) this, NVMEMFILE_FOURCC, dwFlag);

	//  eNX̃\bhɈp
	//  ̂ƂAdwFlag ɂ Ow肷B
	return Class_NVStream::AddInterface(0);
}


NVRESULT Class_NVMemFile::DeleteInterface(void)
{
//  C^[tF[XQƃe[u폜

	VDeleteInterface(this);

	//  eNX̃\bhɈp
	return Class_NVStream::DeleteInterface();
}


NVRESULT Class_NVMemFile::Read(LPVOID lpvDestBuffer, DWORD dwReadSize, LPDWORD lpdwResult)
{
//  Xg[f[^ǂݏo

	DWORD dwResult;

	//  ƏĂ邩ǂׂ
	if (! (vcd.bIsCreated && nvmfd.lpData))
	{
		*lpdwResult = 0;
		return VSTMERR_NOCREATE;
	}

	//  ANZX[h𒲂ׂ
/*	if (! (nvstd.dwFlag & NVFILE_OPENREAD))
	{
		*lpdwResult = 0;
		//  ǂݏo[hłȂ΃G[
		return VSTMERR_INVALIDACCESSMODE;
	}
*/
	if (! lpvDestBuffer)
	{
		return VSTMERR_INVALIDPARAM;
	}

	//  Xg[f[^ǂݏo
	if (nvstd.dwFlag & NVMEMFILE_SIZEOVERRIDE)
	{
		//  TCYI[o[ChĂꍇ̏

		QWUNION quSize;

		//  ǂݍݗʂAǂݍ݉\ʂɃNbsO
		quSize.qw = min(dwReadSize, nvstd.quEndOverride.qw - nvstd.quCurrent.qw);
		quSize.qw = min(quSize.qw, nvmfd.quRealSize.qw - nvmfd.quCurrentOffset.qw);
		quSize.qw = (quSize.dwHigh) ? DWORD_MAX : quSize.dwLow;

		if (quSize.dwLow)
		{
			//  ǂݍރf[^Γǂݍ
			CopyMemory(lpvDestBuffer, nvmfd.lpData + nvmfd.quCurrentOffset.qw, quSize.dwLow);
			nvmfd.quCurrentOffset.qw += quSize.dwLow;
			dwResult = quSize.dwLow;
		}
		else
		{
			//  Ȃ΁Aǂݍ񂾗ʂO
			dwResult = 0;
		}
	}
	else
	{
		//  I[o[ChĂȂ΁Aʏɓǂݍ
		QWUNION quSize;

		//  ǂݍݗʂAǂݍ݉\ʂɃNbsO
		quSize.qw = min(dwReadSize, nvmfd.quRealSize.qw - nvmfd.quCurrentOffset.qw);
		quSize.qw = (quSize.dwHigh) ? DWORD_MAX : quSize.dwLow;

		if (quSize.dwLow)
		{
			//  ǂݍރf[^Γǂݍ
			CopyMemory(lpvDestBuffer, nvmfd.lpData + nvmfd.quCurrentOffset.qw, quSize.dwLow);
			nvmfd.quCurrentOffset.qw += quSize.dwLow;
			dwResult = quSize.dwLow;
		}
		else
		{
			//  Ȃ΁Aǂݍ񂾗ʂO
			dwResult = 0;
		}
	}

	//  ۂɓǂݍ܂ꂽʂQƂāA݈ʒuړ
	nvstd.quCurrent.ql += dwResult;

	*lpdwResult = dwResult;
	if (dwReadSize != dwResult)
	{
		//  vʓǂ߂ĂȂ΁At@CI[
		return VSTMERR_ENDOFDATA;
	}

	return NV_OK;
}


NVRESULT Class_NVMemFile::Write(LPCVOID lpvSrcBuffer, DWORD dwWriteSize, LPDWORD lpdwResult)
{
//  Xg[փf[^

	DWORD dwResult;

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	//  ANZX[h𒲂ׂ
/*	if (! (nvstd.dwFlag & NVFILE_OPENWRITE))
	{
		//  ݃[hłȂ΃G[
		return VSTMERR_INVALIDACCESSMODE;
	}
*/
	if (! lpvSrcBuffer)
	{
		return VSTMERR_INVALIDPARAM;
	}

	//  Xg[Ƀf[^o

/*  Create ł͂Ă̂ŁA肦Ȃ͂
	if (nvstd.dwFlag & NVFILE_SIZEOVERRIDE)
	{
		//  TCYI[o[ChĂꍇ̏
		//  ݂͖T|[g
		return VSTMERR_UNSUPPORTED;
	}
	else
*/	{
		//  I[o[ChĂȂ΁Aʏɏ
		QWUNION quNewOffset;

		quNewOffset.qw = nvmfd.quCurrentOffset.qw + dwWriteSize;
		if (quNewOffset.qw > nvmfd.quMaxSize.qw)
		{
			nvmfd.lpData = (LPBYTE) NVMemReAlloc(nvmfd.lpData, (DWORD) quNewOffset.qw, NVMEM_FIXED);
			nvmfd.quMaxSize = quNewOffset;
		}

		CopyMemory(nvmfd.lpData + nvmfd.quCurrentOffset.qw, lpvSrcBuffer, dwWriteSize);
		nvmfd.quCurrentOffset = quNewOffset;
		nvmfd.quRealSize = quNewOffset;
		dwResult = dwWriteSize;
	}

	//  ۂɏ܂ꂽʂQƂāA݈ʒuړ
	nvstd.quCurrent.ql += dwResult;

	*lpdwResult = dwResult;
	if (dwWriteSize != dwResult)
	{
		//  vʏ߂ĂȂ΁AG[
		return VSTMERR_CANTWRITEDATA;
	}

	return NV_OK;
}


NVRESULT Class_NVMemFile::GetCurrentPosition(LPQLONG lpqlOffset, DWORD dwFlag)
{
//  Xg[ł݈̌ʒu擾

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	if (! lpqlOffset)
	{
		return VSTMERR_INVALIDPARAM;
	}
	//  Xg[ł݈̌ʒu擾

	if (nvstd.dwFlag & NVMEMFILE_SIZEOVERRIDE)
	{
		//  TCYI[o[ChĂꍇ
		switch (dwFlag)
		{
		case NVMEMFILE_SEEKCURRENT:
			{
				//  ݈ʒȗΈʒu͕KO
				*lpqlOffset = 0;
			}
			break;
		case NVMEMFILE_SEEKEND:
			{
				//  I[o[ChꂽI[̑ΈʒuvZ
				*lpqlOffset = nvstd.quCurrent.ql - nvstd.quEndOverride.ql;
			}
			break;
		default:
			{
				//  ftHǵANVFILE_SEEKBEGIN
				//  I[o[Chꂽ擪̑ΈʒuvZ
				*lpqlOffset = nvstd.quCurrent.ql - nvstd.quStartOverride.ql;
			}
			break;
		}
	}
	else
	{
		//  TCYI[o[ChĂȂꍇ
		switch (dwFlag)
		{
		case NVMEMFILE_SEEKCURRENT:
			{
				//  ݈ʒȗΈʒu͕KO
				*lpqlOffset = 0;
			}
			break;
		case NVMEMFILE_SEEKEND:
			{
				//  t@C̃TCY擾āȂΈʒuvZ
				*lpqlOffset = nvstd.quCurrent.ql - nvmfd.quRealSize.ql;
			}
			break;
		default:
			{
				//  ftHǵANVFILE_SEEKBEGIN
				//  ݈ʒuԂ

				*lpqlOffset = nvstd.quCurrent.ql;
			}
			break;
		}
	}

	return NV_OK;
}


NVRESULT Class_NVMemFile::SetCurrentPosition(QLONG qlOffset, DWORD dwFlag)
{
//  Xg[ł݈̌ʒuݒ

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	QWUNION quOffset;

	if (nvstd.dwFlag & NVMEMFILE_SIZEOVERRIDE)
	{
		//  TCYI[o[ChĂꍇ
		//  ZbgΈʒuvZ
		switch (dwFlag)
		{
		case NVMEMFILE_SEEKCURRENT:
			{
				//  ݈ʒuƂvZ
				quOffset = nvstd.quCurrent;
			}
			break;
		case NVMEMFILE_SEEKEND:
			{
				//  I[o[ChꂽI[ƂvZ
				quOffset = nvstd.quEndOverride;
			}
			break;
		default:
			{
				//  ftHǵANVFILE_SEEKBEGIN
				//  I[o[Chꂽ擪ƂvZ
				quOffset = nvstd.quStartOverride;
			}
		}

		quOffset.ql += qlOffset;

		//  t@C̗L͈͂𒴂ĂȂ`FbN
		if (quOffset.ql < nvstd.quStartOverride.ql)
		{
			return VSTMERR_INVALIDOFFSET;
		}

		if (quOffset.ql > nvstd.quEndOverride.ql)
		{
			return VSTMERR_INVALIDOFFSET;
		}

		nvstd.quCurrent = quOffset;
		nvmfd.quCurrentOffset.ql = quOffset.ql;
	}
	else
	{
		//  ItZbgtO
		switch (dwFlag)
		{
		case NVMEMFILE_SEEKCURRENT:
			{
				quOffset = nvstd.quCurrent;
			}
			break;
		case NVMEMFILE_SEEKEND:
			{
				quOffset = nvmfd.quRealSize;
			}
			break;
		default:
			{
				quOffset.qw = 0;
			}
		}
		//  Xg[ł݈̌ʒuݒ肷

		quOffset.ql += qlOffset;

		//  t@C̗L͈͂𒴂ĂȂ`FbN
		if (quOffset.ql < 0)
		{
			return VSTMERR_INVALIDOFFSET;
		}

		if (quOffset.ql > nvmfd.quRealSize.ql)
		{
			return VSTMERR_INVALIDOFFSET;
		}

		nvstd.quCurrent = quOffset;
		nvmfd.quCurrentOffset = quOffset;
	}

	return NV_OK;
}


NVRESULT Class_NVMemFile::GetDataSize(LPQWORD lpqwDataSize)
{
//  Xg[̃f[^TCY擾

	QWUNION quSize;

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	if (! lpqwDataSize)
	{
		return VSTMERR_INVALIDPARAM;
	}
	//  Xg[̃f[^TCY擾

	if (nvstd.dwFlag & NVMEMFILE_SIZEOVERRIDE)
	{
		quSize.qw = nvstd.quEndOverride.qw - nvstd.quStartOverride.qw;
	}
	else
	{
		quSize = nvmfd.quRealSize;
	}

	*lpqwDataSize = quSize.qw;

	return NV_OK;
}

NVRESULT Class_NVMemFile::SetDataSize(QWORD qwDataSize)
{
//  Xg[̃f[^TCY擾

	QWUNION quSize;
	QWUNION quSetSize;

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	quSetSize.qw = qwDataSize;
	//  Xg[̃f[^TCY擾

	if (nvstd.dwFlag & NVMEMFILE_SIZEOVERRIDE)
	{
		quSize.qw = nvstd.quEndOverride.qw - nvstd.quStartOverride.qw;
		if (quSize.qw < quSetSize.qw)
		{
			QWUNION quCurSize;
			quCurSize = nvmfd.quRealSize;

			if (nvstd.quStartOverride.qw + quSetSize.qw > quCurSize.qw)
			{
				return VSTMERR_CANTSETDATASIZE;
			}

			nvstd.quEndOverride.qw = nvstd.quStartOverride.qw + quSetSize.qw;
		}
		else if (quSize.qw > quSetSize.qw)
		{
			nvstd.quEndOverride.qw = nvstd.quStartOverride.qw + quSetSize.qw;
		}
	}
	else
	{
		quSize = nvmfd.quRealSize;

		if (quSize.qw < quSetSize.qw)
		{
			nvmfd.lpData = (LPBYTE) NVMemReAlloc(nvmfd.lpData, (DWORD) quSetSize.qw, NVMEM_FIXED);
			nvmfd.quRealSize = quSetSize;
			nvmfd.quMaxSize = quSetSize;
		}
		else if (quSize.qw > quSetSize.qw)
		{
			nvmfd.quRealSize = quSetSize;
		}
	}
	return NV_OK;
}

NVRESULT Class_NVMemFile::GetDataName(LPTSTR lpszDataName, DWORD dwLength)
{
//  Xg[̃f[^擾

	//  ̊֐́Aʂ̏ŗǂ͂


	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	//  t@CRs[

	if (nvstd.dwFlag & NVSTREAM_DATANAMEOVERRIDE)
	{
		//  f[^I[o[ChĂꍇ

		_tcsncpy_s(lpszDataName, dwLength, nvstd.lpszDataNameOverride, dwLength - 1);
	}
	else
	{
		//  I[o[ChĂȂꍇ
		_tcsncpy_s(lpszDataName, dwLength, nvstd.lpszDataName, dwLength - 1);
	}

	return NV_OK;
}


NVRESULT Class_NVMemFile::GetOpenMode(LPDWORD lpdwFlag)
{
//  Xg[̃I[v[h擾

	//  ̊֐́Aʂ̏ŗǂ͂

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	*lpdwFlag = nvstd.dwFlag;
	return NV_OK;
}


NVRESULT Class_NVMemFile::ChangeOpenMode(DWORD dwFlag)
{
//  Xg[̃I[v[hύX

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	//  ǂݏ[h
	nvstd.dwFlag &= (~NVMEMFILE_OPENMASK);
	nvstd.dwFlag |= (dwFlag & NVMEMFILE_OPENMASK);

	return NV_OK;
}



NVRESULT Class_NVMemFile::OverrideDataName(LPCTSTR lpcszDataName)
{
//  Xg[̃I[o[Chݒ肷

	//  ̊֐́Aʂ̏ŗǂ͂

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	_tcscpy_s(nvstd.lpszDataNameOverride, NV_PATHMAX, lpcszDataName);

	nvstd.dwFlag |= NVSTREAM_DATANAMEOVERRIDE;

	return NV_OK;
}


NVRESULT Class_NVMemFile::OverrideSize(QWORD qwStartOverride, QWORD qwSizeOverride)
{
//  Xg[̃I[o[ChTCYݒ肷

	QWUNION quSize;
	QWUNION quEndOverride;
	QWUNION quStartOverride;
	QWUNION quCurrent;

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	if (nvstd.dwFlag & NVSTREAM_OPENWRITE)
	{
		return VSTMERR_UNSUPPORTED;
	}

	//  ۂ̃t@CTCY擾
	quSize = nvmfd.quRealSize;

	//  I[o[Chn_`FbN
	quStartOverride.qw = qwStartOverride;
	if (quStartOverride.qw > quSize.qw)
	{
		return VSTMERR_INVALIDPARAM;
	}

	//  \zI_vZ
	quEndOverride.qw = qwSizeOverride;
	quEndOverride.qw += quStartOverride.qw;

	//  I[o[ChI_`FbN
	if (quEndOverride.qw > quSize.qw)
	{
		return VSTMERR_INVALIDPARAM;
	}

	//  ύX݈̌ʒu`FbN
	//  KvȂANbv
	quCurrent = nvstd.quCurrent;

	if (quCurrent.qw < quStartOverride.qw)
	{
		quCurrent.qw = quStartOverride.qw;
	}

	if (quCurrent.qw > quEndOverride.qw)
	{
		quCurrent.qw = quEndOverride.qw;
	}

	//  elۑďI
	nvstd.quStartOverride = quStartOverride;
	nvstd.quEndOverride = quEndOverride;
	nvstd.quCurrent = quCurrent;
	nvstd.dwFlag |= NVSTREAM_SIZEOVERRIDE;

	return NV_OK;
}


NVRESULT Class_NVMemFile::GetInfo(LPVOID lpvParam, LPDWORD lpdwSize)
{
//  Xg[̏擾

	return VSTMERR_UNSUPPORTED;

/*	if (! lpvParam)
	{
		//  TCY₢킹̏ꍇ
		*lpdwSize = sizeof(NVMEMFILEINFO);
		return NV_OK;
	}

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	//  obt@̃TCY`FbN
	if (*lpdwSize < sizeof(NVMEMFILEINFO))
	{
		//  Ȃ΁AKvȃTCYƃG[Ԃ
		*lpdwSize = sizeof(NVMEMFILEINFO);
		return VSTMERR_BUFFERTOOSMALL;
	}

	//  t@CRs[

	CopyMemory(lpvParam, &nvmfd.nvmfi, sizeof(NVMEMFILEINFO));

	*lpdwSize = sizeof(NVMEMFILEINFO);
*/
	return NV_OK;
}


NVRESULT Class_NVMemFile::SetInfo(LPVOID lpvParam, DWORD dwSize)
{
//  Xg[̏ݒ肷

	return VSTMERR_UNSUPPORTED;

/*	LPNVMEMFILEINFO lpnvfi = (LPNVMEMFILEINFO) lpvParam;

	//  obt@̃TCY`FbN
	if (dwSize < sizeof(NVMEMFILEINFO))
	{
		return VSTMERR_BUFFERTOOSMALL;
	}

	//  obt@̃f[^`FbN
	if (lpnvfi->dwFourCC != NVMEMFILE_FOURCC)
	{
		return VSTMERR_INVALIDPARAMTYPE;
	}

	if (lpnvfi->dwObjSize != sizeof(NVMEMFILEINFO))
	{
		return VSTMERR_INVALIDPARAMSIZE;
	}

	//  ۑ
	CopyMemory(&nvfd.nvfi, lpnvfi, sizeof(NVMEMFILEINFO));
*/
	return NV_OK;
}


NVRESULT Class_NVMemFile::CreateAlias(LPINVSTREAM lpinvst)
{
//  CX^X̃GCAX쐬
	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	{
		NVMEMFILECREATE nvmfc;
		QWUNION quSizeOverride;
		INVMEMFILE invmf;
		NVRESULT nvres;

		quSizeOverride.qw = nvstd.quEndOverride.qw - nvstd.quStartOverride.qw;

		SetNVMemFileCreate(&nvmfc, nvstd.dwFlag, nvstd.lpszDataName, nvstd.lpszDataNameOverride,
			nvstd.quStartOverride.qw, quSizeOverride.qw, 
			(nvmfd.quRealSize.dwHigh) ? DWORD_MAX : nvmfd.quRealSize.dwLow);

		nvres = VCreateInstance(NVMEMFILE_FOURCC, NVMEMFILE_FOURCC, (LPVOID *) &invmf);
		if (nvres)
		{
			return nvres;
		}

		nvres = invmf->Create(&nvmfc);
		if (nvres)
		{
			invmf->Release();
			return nvres;
		}

		if (invmf->nvmfd.quMaxSize.qw < nvmfd.quRealSize.qw)
		{
			invmf->nvmfd.lpData = (LPBYTE) NVMemReAlloc(invmf->nvmfd.lpData, (DWORD) nvmfd.quRealSize.qw, NVMEM_FIXED);
			invmf->nvmfd.quMaxSize.qw = nvmfd.quRealSize.qw;
		}

		CopyMemory(invmf->nvmfd.lpData, nvmfd.lpData, (DWORD) nvmfd.quRealSize.qw);
		invmf->nvmfd.quRealSize.qw = nvmfd.quRealSize.qw;

		*lpinvst = (INVSTREAM) invmf;
	}

	return NV_OK;
}


NVRESULT Class_NVMemFile::QueryClassInfo(LPVOID lpvInfo, LPDWORD lpdwSize)
{
//  NX̎@\擾

	//  ݂͖T|[gH
	*lpdwSize = 0;

	return VSTMERR_UNSUPPORTED;
}
