//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  zt@CNX  wb_[t@C  for  NVFileLibrary                                //
//  NVMemFile.h                                                                                 //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  INVFILE ́AINVSTREAM C^[tF[X݊̃t@CNXłB                      //
//  INVSTREAM Œ`Ă@\قA                                                  //
//  t@C̍쐬ɊւĂ̓tOT|[gĂB                                  //
//  CX^X̏Af[^̓ǂݍ݁A݂܂ŁA                                  //
//  INVSTREAM C^[tF[XƂđSNXʂ̑ňB                                //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////




#pragma once





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//

#include "NVStream.h"



#ifdef __cplusplus
extern "C" {
#endif

#pragma pack(push, 1)




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  }N̐錾
//

//  t@CI[v[htO
#define NVMEMFILE_OPENMASK      NVSTREAM_OPENMASK		//  I[v[htOo߂̃}XN
#define NVMEMFILE_OPENREAD      NVSTREAM_OPENREAD		//  ǂݍ݃[hŃI[viftHgj
#define NVMEMFILE_OPENWRITE     NVSTREAM_OPENWRITE		//  ݃[hŃI[v
#define NVMEMFILE_OPENREADWRITE NVSTREAM_OPENREADWRITE	//  ǂݏp[hŃI[v@i݂͖T|[gj

//  t@CI[vtO
#define NVMEMFILE_SIZEOVERRIDE     NVSTREAM_SIZEOVERRIDE		//  TCYI[o[ChāAIȃXg[JB
#define NVMEMFILE_DATANAMEOVERRIDE NVSTREAM_DATANAMEOVERRIDE	//  Xg[̃f[^I[o[ChĕύX


//  V[NtO
#define NVMEMFILE_SEEKBEGIN   NVSTREAM_SEEKBEGIN		//  f[^̐擪̑ΈʒuŎwiftHgj
#define NVMEMFILE_SEEKCURRENT NVSTREAM_SEEKCURRENT		//  f[^݈̌ʒȗΈʒuŎw
#define NVMEMFILE_SEEKEND     NVSTREAM_SEEKEND			//  f[^̍Ō̑ΈʒuŎw


#define NVMEMFILE_RESERVEDSIZE_DEFAULT 4096



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  NX̒`      INVMEMFILE
//


//  NXʎq
#define NVMEMFILE_FOURCC MAKEFOURCC('V', 'M', 'E', 'F')


/*  INVMEMFILE NXWXg (VCOM.ini ւ̋Lq)
[VMEF]

Class_ID = "VMEF"
Module_Name = "NVFileLib.dll"
Entry_Point = "CreateInstance_NVMemFile"
*/


class Class_NVMemFile;
typedef Class_NVMemFile * INVMEMFILE;
typedef const Class_NVMemFile * CINVMEMFILE;
typedef INVMEMFILE * LPINVMEMFILE;
typedef const INVMEMFILE * LPCINVMEMFILE;



//  INVFILE ̏f[^
struct NVMEMFILECREATE		//  nvfc
{
	DWORD dwFourCC;					//  NXʎq
	DWORD dwObjSize;				//  \̂̃TCY
	DWORD dwFlag;					//  tO
	LPCTSTR lpcszDataName;			//  I[vf[^
	LPCTSTR lpcszDataNameOverride;	//  I[o[Chf[^   NVSTREAM_DATANAMEOVERRIDE gp̂ݗL
	QWUNION quStartOverride;		//  I[o[ChJnʒu   NVSTREAM_SIZEOVERRIDE gp̂ݗL
	QWUNION quSizeOverride;			//  I[o[ChTCY     NVSTREAM_SIZEOVERRIDE gp̂ݗL

	QWORD qwReservedSize;
};
typedef NVMEMFILECREATE * LPNVMEMFILECREATE;
typedef const NVMEMFILECREATE * LPCNVMEMFILECREATE;



//  INVMEMFILE ̕ێf[^
struct NVMEMFILEDATA
{
	LPBYTE lpData;
	QWUNION quCurrentOffset;
	QWUNION quRealSize;
	QWUNION quMaxSize;
};
typedef NVMEMFILEDATA * LPNVMEMFILEDATA;
typedef const NVMEMFILEDATA * LPCNVMEMFILEDATA;




//  INVMEMFILE NX̒`
class NVFILELIB_CLASS_EXPORT Class_NVMemFile : virtual public Class_NVStream
{
	public:
		Class_NVMemFile(void);
		//  ftHgRXgN^
		//
		//  SetCoreData() ĂяoāA{NXɃf[^ݒ肷B

	VCOM_CLASSMETHOD
		~Class_NVMemFile(void);
		//  fXgN^
		//

	VCOM_CLASSMETHOD
		NVRESULT Create(LPCVOID lpvParam);
		//  CX^X̏
		//
		//  CX^XɃp[^^āACX^X̃f[^(쐬)B
		//  nvcd.bIsCreated tO𗧂āAς݂`FbNs悤ɂB
		//  NVSTREAMCREATE сANVFILECREATE ǂ̃p[^łłB
		//  NVSTREAMCREATE gꍇ́AExtraFlag ׂ͂ăftHgƂĉ߂

	VCOM_CLASSMETHOD
		NVRESULT ResetData(void);
		//  CX^X̃f[^Zbg
		//
		//  CX^XŗpȂǂACreate() ĂяoȌԂɖ߂B
		//  vcd.bIsCreated tOZbgAĂ Create() s悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface);
		//  C^[tF[X̎擾
		//
		//  DWORD dwFourCC			擾C^[tF[X
		//  LPVOID *lpvInterface	C^[tF[Xi[|C^
		//
		//  ̃CX^X́AdwFourCC Ŏw肵^̃C^[tF[X擾B
		//  擾łC^[tF[X́ACX^XɂĈقȂ邪A
		//  CX^XNX̃X[p[NXɂNX̃C^[tF[X
		//  K擾ł悤ɎȂ΂ȂȂB
		//  ̊֐ŕʂ̃C^[tF[X擾ƁA AddRef() ŝŁA
		//  ÂC^[tF[Xɑ΂Ă Release() KvB

	VCOM_CLASSMETHOD
		NVRESULT Read(LPVOID lpvDestBuffer, DWORD dwReadSize, LPDWORD lpdwResult);
		//  Xg[f[^ǂݏo
		//
		//  LPVOID lpvDestBuffer		ǂݏõobt@
		//  DWORD dwReadSize			ǂݏoTCY
		//  LPDWORD lpdwResult			ۂɓǂݏoꂽTCY
		//
		//  Xg[f[^ǂݏoB
		//  ǂݍ݂Ɏsꍇ́AVSTMERR_CANTREADSTREAM ԂB
		//  vꂽTCỸf[^ȂꍇAVSTMERR_STREAMEMPTY Ԃ

	VCOM_CLASSMETHOD
		NVRESULT Write(LPCVOID lpvSrcBuffer, DWORD dwWriteSize, LPDWORD lpdwResult);
		//  Xg[փf[^
		//
		//  LPVOID lpvSrcBuffer		ރf[^̃obt@
		//  DWORD dwWriteSize		ރf[^̃TCY
		//  LPDWORD lpdwResult		ۂɏ܂ꂽTCY
		//
		//  Xg[փf[^o
		//  vꂽTCYoȂꍇAVSTMERR_STREAMFULL Ԃ
		//  ݂Ɏsꍇ́AVSTMERR_CANTWRITESTREAM Ԃ

	VCOM_CLASSMETHOD
		NVRESULT GetCurrentPosition(LPQLONG lpqlOffset, DWORD dwFlag);
		//  Xg[ł݈̌ʒu擾
		//
		//  LPQLONG lpqlOffset		擾̃|C^
		//  DWORD dwFlag			擾tO
		//
		//  tOŎwvZ@ŁA݈ʒu擾
		//  ftHǵANVSTREAM_SEEKBEGIN

	VCOM_CLASSMETHOD
		NVRESULT SetCurrentPosition(QLONG qlOffset, DWORD dwFlag);
		//  Xg[ł݈̌ʒuݒ
		//
		//  QLONG qlOffset			ݒ肷ʒu
		//  DWORD dwFlag			ݒtO
		//
		//  tOŎwvZ@ŁA݈ʒuݒ肷
		//  ftHǵANVSTREAM_SEEKBEGIN

	VCOM_CLASSMETHOD
		NVRESULT GetDataSize(LPQWORD lpdwDataSize);
		//  Xg[̃f[^TCY擾
		//
		//  LPQWORD lpqwDataSize		󂯎|C^
		//
		//  Xg[̃f[^TCY擾
		//  NVSTREAM_SIZEOVERRIDE tOgč쐬ĂꍇA
		//  I[o[ChꂽTCYԂ

	VCOM_CLASSMETHOD
		NVRESULT SetDataSize(QWORD qwDataSize);

	VCOM_CLASSMETHOD
		NVRESULT GetDataName(LPTSTR lpszDataName, DWORD dwLength);
		//  Xg[̃f[^擾
		//
		//  LPTSTR lpszDataName		f[^󂯎obt@
		//  DWORD dwLength			obt@̃TCY
		//
		//  Xg[̃f[^擾
		//  NVSTREAM_DATANAMEOVERRIDE tOgč쐬ĂꍇA
		//  I[o[ChꂽOԂB

	VCOM_CLASSMETHOD
		NVRESULT GetOpenMode(LPDWORD lpdwFlag);
		//  Xg[̃I[v[h擾
		//
		//  LPDWORD lpdwFlag		tO󂯎|C^
		//
		//  Xg[̃I[v[h擾

	VCOM_CLASSMETHOD
		NVRESULT ChangeOpenMode(DWORD dwFlag);
		//  Xg[̃I[v[hύX
		//
		//  DWORD dwFlag		I[vtO
		//
		//  ݈ʒuȂǂ̂܂܂ɁAI[v[hύX
		//  ΉłȂC^[tF[XȂƎv̂ŁA
		//  ߂lKmF邱

	VCOM_CLASSMETHOD
		NVRESULT OverrideDataName(LPCTSTR lpcszDataName);
		//  Xg[̃I[o[Chݒ肷
		//
		//  LPTSTR lpszDataName
		//
		//  I[o[ChĂȂ΁AVɃI[o[Ch
		//  łɂĂ΁AXV

	VCOM_CLASSMETHOD
		NVRESULT OverrideSize(QWORD qwStartOverride, QWORD qwSizeOverride);
		//  Xg[̃I[o[CTCYݒ肷
		//
		//  QWORD qwStartOffset			I[o[ChJnʒu
		//  QWORD qwSize				I[o[ChTCY
		//
		//  I[o[ChĂȂ΁AVɃI[o[Ch
		//  łɂĂ΁Aɑ΂鑊ΈʒuƂĂɃI[o[Ch
		//  I[o[CȟʁA݈ʒuȈʒuɂȂꍇA
		//  LȔ͈͂ɃNbvB
		//  KAI[o[ChA]̈ʒuɃV[N邱

	VCOM_CLASSMETHOD
		NVRESULT GetInfo(LPVOID lpvParam, LPDWORD lpdwSize);
		//  Xg[̏擾
		//
		//  LPVOID lpvParam		Xg[̃f[^󂯎obt@
		//  LPDWORD lpdwSize	obt@̃TCYAуobt@ɏ܂ꂽTCY
		//
		//  Xg[̏擾B
		//  eCX^Xɂēe͈قȂ
		//  GetFourCC \bhŃCX^XmFAɂ\̂Ńf[^QƂB
		//  lpvParam  NULL nAobt@̃TCYsĂ
		//  lpdwSize ɕKvȃTCYԂB
		//  ֐ƁAlpdwSize ɂ́Aۂɏ܂ꂽTCYi[Ă

	VCOM_CLASSMETHOD
		NVRESULT SetInfo(LPVOID lpvParam, DWORD dwSize);
		//  Xg[̏ݒ肷
		//
		//  LPVOID lpvParam		Xg[̃f[^nobt@
		//  LPDWORD lpdwSize	obt@̃TCY
		//
		//  Xg[̏ݒ肷B
		//  eCX^Xɂēe͈قȂ

	VCOM_CLASSMETHOD
		NVRESULT CreateAlias(LPINVSTREAM lpinvst);
		//  CX^X̃GCAX쐬
		//
		//  LPINVSTREAM lpinvst		GCAX̃C^[tF[X󂯎|C^
		//
		//  f[^ɑ΂āAʂ̈ʒuȂǂێăANZXłGCAX쐬B
		//  ̏ꍇAp[^ŃCX^X쐬ȂāA
		//  ̃C^[tF[XԂB
		//  ʏAǂݍ݃[ĥƂ̂ݎ󂯕t邱ƂɂȂB

	VCOM_CLASSMETHOD
		NVRESULT QueryClassInfo(LPVOID lpvInfo, LPDWORD lpdwSize);
		//  NX̎@\擾
		//
		//  LPVOID@lpvInfo		NX̃f[^󂯎obt@
		//  LPDWORD lpdwSize	obt@̃TCYAуobt@ɏ܂ꂽTCY
		//
		//  NX INVSTREAM C^[tF[XŒ`Ă@\̂A
		//  T|[gĂ̂𒲂ׂB
		//  lpvParam  NULL nAobt@̃TCYsĂ
		//  lpdwSize ɕKvȃTCYԂB
		//  ֐ƁAlpdwSize ɂ́Aۂɏ܂ꂽTCYi[Ă

protected:
	VCOM_CLASSMETHOD
		NVRESULT AddInterface(DWORD dwFlag);
		//  C^[tF[XQƃe[uɓo^
		//
		//  DWORD dwFlag	NXCX^X̏ꍇPAȊO͂O
		//
		//  RXgN^̒ŌĂ΂AC^[tF[X|C^e[uɓo^A
		//  VIsValidInterface() ŃC^[tF[X̗L؂ł悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT DeleteInterface(void);
		//  C^[tF[XQƃe[u폜
		//
		//  DeleteInstance() ̒ŌĂ΂AC^[tF[X|C^e[u폜B

	protected:
		NVMEMFILEDATA nvmfd;
};



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̐錾
//

NVRESULT NVFILELIB_EXPORT NVFILELIB_API CreateInstance_NVMemFile(LPIVCOM lpivcom);
//  CX^X̍쐬
//
//  INVMEMFILE CX^X쐬ÃC^[tF[XԂB



inline void SetNVMemFileCreate(LPNVMEMFILECREATE lpnvmfc, DWORD dwFlag, LPCTSTR lpcszDataName, LPCTSTR lpcszDataNameOverride = NULL,
							QWORD qwStartOverride = 0, QWORD qwSizeOverride = 0,
							QWORD qwReservedSize = NVMEMFILE_RESERVEDSIZE_DEFAULT);
//  NVMEMFILECREATE \̏֐
//
//  LPNVFILECREATE lpnvfc				\
//  DWORD dwFlag						ZbgtO
//  LPCTSTR lpcszDataName				I[vf[^
//  LPCTSTR lpcszDataNameOverride		I[o[Chf[^  NVSTREAM_DATANAMEOVERRIDE gp̂ݗL
//  QWORD qwStartOverride				I[o[ChJnʒu  NVSTREAM_SIZEOVERRIDE gp̂ݗL
//  QWORD qwSizeOverride				I[o[ChIʒu  NVSTREAM_SIZEOVERRIDE gp̂ݗL
//  QWORD qwReservedSize				



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  CC֐̒`
//

inline void SetNVMemFileCreate(LPNVMEMFILECREATE lpnvmfc, DWORD dwFlag, LPCTSTR lpcszDataName, LPCTSTR lpcszDataNameOverride,
							QWORD qwStartOverride, QWORD qwSizeOverride,
							QWORD qwReservedSize)
{
//  NVMEMFILECREATE \̏֐

	lpnvmfc->dwFourCC = NVMEMFILE_FOURCC;
	lpnvmfc->dwObjSize = sizeof(NVMEMFILECREATE);
	lpnvmfc->dwFlag = dwFlag;
	lpnvmfc->lpcszDataName = lpcszDataName;
	lpnvmfc->lpcszDataNameOverride = lpcszDataNameOverride;
	lpnvmfc->quStartOverride.qw = qwStartOverride;
	lpnvmfc->quSizeOverride.qw = qwSizeOverride;

	lpnvmfc->qwReservedSize = qwReservedSize;

	return;
}




#pragma pack(pop)

#ifdef __cplusplus
}
#endif
