//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  t@CNX  \[Xt@C  for  NVFileLibrary                                      //
//  NVResource.cpp                                                                              //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  INVRESOURCE ́AINVSTREAM C^[tF[X݊̃t@CNXłB                  //
//  INVSTREAM C^[tF[XƂđSNXʂ̑ňB                                //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////






//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "NVResource.h"





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  X^eBbN֐̒`
//


//  t@CI[v֐
static inline NVRESULT NVResourceCreate(LPNVRESOURCEDATA lpnvrd, LPNVSTREAMDATA lpnvstd, LPCNVSTREAMCREATE lpcnvstc, LPCTSTR lpcszModuleName, LPCTSTR lpcszType);


#define NVAddUINT64(lowDest, highDest, lowSrc1, highSrc1, lowSrc2, highSrc2) \
{ \
	(lowDest) = (lowSrc1) + (lowSrc2); \
	(highDest) = (highSrc1) + (highSrc2) + (((lowDest) < (lowSrc1)) ? 1 : 0); \
}




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̒`
//


NVRESULT NVFILELIB_EXPORT NVFILELIB_API CreateInstance_NVResource(LPIVCOM lpivcom)
{
	//  CX^X̍쐬
	//  vtable Kv̂ŁAnew ZqoRŃAP[VB

	if (! lpivcom)
	{
		return NVERR_UNDEFINED;
	}

	*lpivcom = (IVCOM) new Class_NVResource;
	if (*lpivcom)
	{
		return NV_OK;
	}
	else
	{
		return NVERR_UNDEFINED;
	}
}




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  o֐̐錾  Class_NVResource
//


Class_NVResource::Class_NVResource(void)
{
//  ftHgRXgN^

	//  {NX̕ێf[^ݒ肷BRXgN^͊{NX珇ԂɌĂяôŁA
	//  ŌɌĂяo邱ƂɂȂACX^X̃IWǐ^݂̏̂cB
	//  ]ȏ̂ŃI[o[wbh邪AdldƁB
	Class_VCOM::SetCoreData((LPVOID) this, (DWORD) sizeof(Class_NVResource), NVRESOURCE_FOURCC);

	//  ێf[^͖̏B

	return;
}


Class_NVResource::~Class_NVResource(void)
{
//  fXgN^

	//  Release oRȊOĂяoƁAvcd.bIsCreated  TRUE ł邱ƂB
	//  ̏ꍇAȉsĂȂ͂Ȃ̂ŁAASSERT B
	assert(! vcd.bIsCreated);

	return;
}


NVRESULT Class_NVResource::Create(LPCVOID lpvParam)
{
//  CX^X̏
	//  eNXŕKvȏLqB
	NVRESULT nvres;

	//  ʂ̌^ɃLXg
	LPCNVSTREAMCREATE lpcnvstc = (LPCNVSTREAMCREATE) lpvParam;

	//  ς݃IuWFNgłȂǂ`FbN
	if (vcd.bIsCreated)
	{
		//  ς݂̏ꍇAG[ɂB
		return VSTMERR_ALREADYUSED;
	}

	//  ̐`FbN
	{
		//  NX̎ʎqƈ̎ʎqr
		if (lpcnvstc->dwFourCC == NVSTREAM_FOURCC)
		{
			//  ̃TCY`FbN
			if (lpcnvstc->dwObjSize != sizeof(NVSTREAMCREATE))
			{
				//  ɓnꂽ\̂̃TCYĂ
				return VSTMERR_INVALIDPARAMSIZE;
			}

			//  ǉ ftHgƂāAp

			nvres =  NVResourceCreate(&nvrd, &nvstd, lpcnvstc, NULL, NULL);
		}
		else if (lpcnvstc->dwFourCC == NVRESOURCE_FOURCC)
		{
			//  ̃TCY`FbN
			if (lpcnvstc->dwObjSize != sizeof(NVRESOURCECREATE))
			{
				//  ɓnꂽ\̂̃TCYĂ
				return VSTMERR_INVALIDPARAMSIZE;
			}

			LPCNVRESOURCECREATE lpcnvrc = (LPCNVRESOURCECREATE) lpcnvstc;
			//  ǉ ftHgƂāAp

			nvres =  NVResourceCreate(&nvrd, &nvstd, lpcnvstc, lpcnvrc->lpcszModuleName, lpcnvrc->lpcszType);
		}
		else
		{
			//  ԈႦĂ
			return VSTMERR_INVALIDPARAMTYPE;
		}
	}

	if (nvres)
	{
		return nvres;
	}

	vcd.bIsCreated = TRUE;
	return NV_OK;
}


static inline NVRESULT NVResourceCreate(LPNVRESOURCEDATA lpnvrd, LPNVSTREAMDATA lpnvstd, LPCNVSTREAMCREATE lpcnvstc, LPCTSTR lpcszModuleName, LPCTSTR lpcszType)
{
	HINSTANCE hModule = NULL;
	HRSRC hResource = NULL;

	//  t@CI[v֐
	if ((! lpcnvstc->lpcszDataName) || (! *lpcnvstc->lpcszDataName))
	{
		//  I[vf[^Ȃ΃G[
		return VSTMERR_INVALIDPARAM;
	}

	if (lpcnvstc->dwFlag & NVRESOURCE_OPENWRITE)
	{
		//  ݃[h̓T|[głȂ
		return VSTMERR_INVALIDPARAM;
	}

	//  ̃`FbNIAۂɈ̓eɉďsB
	try
	{
		lpnvstd->dwFlag |= NVRESOURCE_OPENREAD;

		//  ܂t@CtpXɕϊ
		TCHAR lpszModuleName[NV_PATHMAX];
		LPBYTE lpData;

		if (lpcszModuleName)
		{
			LPTSTR lpszFilePart;
			GetFullPathName(lpcszModuleName, NV_PATHMAX, lpszModuleName, &lpszFilePart);
		}
		else
		{
			NVGetProgramFileName(lpszModuleName, NV_PATHMAX);
		}

		hModule = LoadLibrary(lpszModuleName);
		if (! hModule)
		{
			throw VSTMERR_CANTOPENDATA;
		}

		if (lpcszType)
		{
			hResource = FindResource(hModule, lpcnvstc->lpcszDataName, lpcszType);
		}
		else
		{
			hResource = FindResource(hModule, lpcnvstc->lpcszDataName, TEXT("BINARY"));
		}

		if (! hResource)
		{
			throw VSTMERR_CANTOPENDATA;
		}

		lpData = (LPBYTE) LockResource(LoadResource(hModule, hResource));
		if (! lpData)
		{
			throw VSTMERR_CANTOPENDATA;
		}

		if (lpcnvstc->dwFlag & NVRESOURCE_SIZEOVERRIDE)
		{
			//  TCYI[o[Chꍇ̏

			QWUNION quSize;

			//  t@CTCY擾
			quSize.qw = SizeofResource(hModule, hResource);

			//  Jnʒut@CɂȂ΃G[
			if (lpcnvstc->quStartOverride.qw >= quSize.qw)
			{
				throw VSTMERR_INVALIDPARAM;
			}

			//  Jnʒu̕ۑ
			lpnvstd->quStartOverride.qw = lpcnvstc->quStartOverride.qw;

			//  IʒǔvZ
			lpnvstd->quEndOverride.qw = lpcnvstc->quStartOverride.qw + lpcnvstc->quSizeOverride.qw;

			//  Iʒut@C̏I[ȂG[
			if (lpnvstd->quEndOverride.qw > quSize.qw)
			{
				throw VSTMERR_INVALIDPARAM;
			}

			//  tOۑ
			lpnvstd->dwFlag |= NVRESOURCE_SIZEOVERRIDE;
		}

		if (lpcnvstc->dwFlag & NVRESOURCE_DATANAMEOVERRIDE)
		{
			//  f[^I[o[Chꍇ̏

			_tcscpy_s(lpnvstd->lpszDataNameOverride, NV_PATHMAX, lpcnvstc->lpcszDataNameOverride);
			lpnvstd->dwFlag |= NVRESOURCE_DATANAMEOVERRIDE;
		}
		_tcscpy_s(lpnvstd->lpszDataName, NV_PATHMAX, lpcnvstc->lpcszDataName);
		lpnvrd->lpOrgPtr = lpData;
		lpnvrd->hModule = hModule;
		lpnvrd->hResource = hResource;
		if (lpcszModuleName)
		{
			_tcscpy_s(lpnvrd->lpszModuleName, NV_PATHMAX, lpcszModuleName);
		}
		if (lpcszType)
		{
			_tcscpy_s(lpnvrd->lpszType, NV_PATHMAX, lpcszType);
		}
	}
	catch (NVRESULT nvres)
	{
		//  G[Nꍇ̏

/*		if (hResource)
		{
			CloseHandle(hResource);
		}
*/
		if (hModule)
		{
			FreeLibrary(hModule);
		}
		return nvres;
	}

	return NV_OK;
}



NVRESULT Class_NVResource::ResetData(void)
{
//  CX^X̃f[^Zbg

	//  nh̉Aobt@̉Ȃǂs

/*
	if (nvrd.hResource)
	{
		CloseHandle(nvrd.hResource);
	}
*/
	if (nvrd.hModule)
	{
		FreeLibrary(nvrd.hModule);
	}

	//  ێf[^OZbg
	ZeroMemory(&nvrd, sizeof(NVRESOURCEDATA));

	//  eNX ResetData Ɉp
	return Class_NVStream::ResetData();
}


NVRESULT Class_NVResource::QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface)
{
//  C^[tF[X̎擾

	//  dwFourCC ɂāAKȌ^̃C^[tF[XԂB
	//  ǧ^̃C^[tF[X̍쐬ȊÓAeNX̃\bhĂԂƂŉƗǂƎvB

	if (dwFourCC == NVRESOURCE_FOURCC)
	{
		//  ̃NX̃C^[tF[X擾Ȃ̂ŁAԂli[AAddRef() ƂɐIB
		*lpvInterface = (INVRESOURCE) this;
		AddRef();
		return NV_OK;
	}
	else
	{
		//  ǧ^ȊÓAeNXɔC
		return Class_NVStream::QueryInterface(dwFourCC, lpvInterface);
	}
}


NVRESULT Class_NVResource::AddInterface(DWORD dwFlag)
{
//  C^[tF[XQƃe[uɓo^

	//  CX^Xɑ΂ŏ̂P̌Ăяoł́A
	//  dwFlag ɂ VCOM_CLASSINTERFACE ĂB
	//  ȍ~̌Ăяoł́AOĂB
	VAddInterface(this, (IVCOM) this, NVRESOURCE_FOURCC, dwFlag);

	//  eNX̃\bhɈp
	//  ̂ƂAdwFlag ɂ Ow肷B
	return Class_NVStream::AddInterface(0);
}


NVRESULT Class_NVResource::DeleteInterface(void)
{
//  C^[tF[XQƃe[u폜

	VDeleteInterface(this);

	//  eNX̃\bhɈp
	return Class_NVStream::DeleteInterface();
}


NVRESULT Class_NVResource::Read(LPVOID lpvDestBuffer, DWORD dwReadSize, LPDWORD lpdwResult)
{
//  Xg[f[^ǂݏo

	DWORD dwResult;

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

/*	//  ANZX[h𒲂ׂ
	if (! (nvstd.dwFlag & NVRESOURCE_OPENREAD))
	{
		//  ǂݏo[hłȂ΃G[
		return VSTMERR_INVALIDACCESSMODE;
	}
*/
	//  Xg[f[^ǂݏo
	if (nvstd.dwFlag & NVRESOURCE_SIZEOVERRIDE)
	{
		//  TCYI[o[ChĂꍇ̏

		QWUNION quSize;

		//  ǂݍݗʂAǂݍ݉\ʂɃNbsO
		quSize.qw = min(dwReadSize, nvstd.quEndOverride.qw - nvstd.quCurrent.qw);

		if (quSize.dwLow)
		{
			//  ǂݍރf[^Γǂݍ
			CopyMemory(lpvDestBuffer, nvrd.lpOrgPtr + nvstd.quCurrent.dwLow, quSize.dwLow);
			dwResult = quSize.dwLow;
		}
		else
		{
			//  Ȃ΁Aǂݍ񂾗ʂO
			dwResult = 0;
		}
	}
	else
	{
		//  I[o[ChĂȂ΁Aʏɓǂݍ
		DWORD dwSize;

		dwSize = min(SizeofResource(nvrd.hModule, nvrd.hResource), dwReadSize);
		CopyMemory(lpvDestBuffer, nvrd.lpOrgPtr + nvstd.quCurrent.dwLow, dwSize);
		dwResult = dwSize;
	}

	//  ۂɓǂݍ܂ꂽʂQƂāA݈ʒuړ
	nvstd.quCurrent.qw += dwResult;

	*lpdwResult = dwResult;
	if (dwReadSize != dwResult)
	{
		//  vʓǂ߂ĂȂ΁At@CI[
		return VSTMERR_ENDOFDATA;
	}

	return NV_OK;
}


NVRESULT Class_NVResource::Write(LPCVOID lpvSrcBuffer, DWORD dwWriteSize, LPDWORD lpdwResult)
{
//  Xg[փf[^

	//  \[Xւ݂̏͂łȂ

	return VSTMERR_UNSUPPORTED;
}


NVRESULT Class_NVResource::GetCurrentPosition(LPQLONG lpqlOffset, DWORD dwFlag)
{
//  Xg[ł݈̌ʒu擾

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	//  Xg[ł݈̌ʒu擾

	if (nvstd.dwFlag & NVRESOURCE_SIZEOVERRIDE)
	{
		//  TCYI[o[ChĂꍇ
		switch (dwFlag)
		{
		case NVRESOURCE_SEEKCURRENT:
			{
				//  ݈ʒȗΈʒu͕KO
				*lpqlOffset = 0;
			}
			break;
		case NVRESOURCE_SEEKEND:
			{
				//  I[o[ChꂽI[̑ΈʒuvZ
				*lpqlOffset = nvstd.quCurrent.ql - nvstd.quEndOverride.ql;
			}
			break;
		default:
			{
				//  ftHǵANVRESOURCE_SEEKBEGIN
				//  I[o[Chꂽ擪̑ΈʒuvZ

				*lpqlOffset = nvstd.quCurrent.ql - nvstd.quStartOverride.ql;
			}
			break;
		}
	}
	else
	{
		//  TCYI[o[ChĂȂꍇ
		switch (dwFlag)
		{
		case NVRESOURCE_SEEKCURRENT:
			{
				//  ݈ʒȗΈʒu͕KO
				*lpqlOffset = 0;
			}
			break;
		case NVRESOURCE_SEEKEND:
			{
				QWUNION quOffset;

				//  t@C̃TCY擾āȂΈʒuvZ
				quOffset.qw = SizeofResource(nvrd.hModule, nvrd.hResource);
				*lpqlOffset = nvstd.quCurrent.ql - quOffset.ql;
			}
			break;
		default:
			{
				//  ftHǵANVRESOURCE_SEEKBEGIN
				//  ݈ʒuԂ

				*lpqlOffset = nvstd.quCurrent.ql;
			}
			break;
		}
	}

	return NV_OK;
}


NVRESULT Class_NVResource::SetCurrentPosition(QLONG qlOffset, DWORD dwFlag)
{
//  Xg[ł݈̌ʒuݒ

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	QWUNION quOffset;

	if (nvstd.dwFlag & NVRESOURCE_SIZEOVERRIDE)
	{
		//  TCYI[o[ChĂꍇ

		//  ZbgΈʒuvZ
		switch (dwFlag)
		{
		case NVRESOURCE_SEEKCURRENT:
			{
				//  ݈ʒuƂvZ
				quOffset = nvstd.quCurrent;
			}
			break;
		case NVRESOURCE_SEEKEND:
			{
				//  I[o[ChꂽI[ƂvZ
				quOffset = nvstd.quEndOverride;
			}
			break;
		default:
			{
				//  ftHǵANVRESOURCE_SEEKBEGIN
				//  I[o[Chꂽ擪ƂvZ
				quOffset = nvstd.quStartOverride;
			}
		}

		quOffset.ql += qlOffset;

		//  t@C̗L͈͂𒴂ĂȂ`FbN
		if (quOffset.qw < nvstd.quStartOverride.qw)
		{
			return VSTMERR_INVALIDOFFSET;
		}

		if (quOffset.qw > nvstd.quEndOverride.qw)
		{
			return VSTMERR_INVALIDOFFSET;
		}
	}
	else
	{
		//  ItZbgtO
		switch (dwFlag)
		{
		case NVRESOURCE_SEEKCURRENT:
			{
				quOffset = nvstd.quCurrent;
			}
			break;
		case NVRESOURCE_SEEKEND:
			{
				quOffset.qw = SizeofResource(nvrd.hModule, nvrd.hResource);
			}
			break;
		default:
			{
				quOffset.qw = 0;
			}
		}
		//  Xg[ł݈̌ʒuݒ肷

		quOffset.qw += qlOffset;
	}

	//  Xg[ł݈̌ʒuݒ肷
	nvstd.quCurrent = quOffset;

	return NV_OK;
}


NVRESULT Class_NVResource::GetDataSize(LPQWORD lpqwDataSize)
{
//  Xg[̃f[^TCY擾

	QWUNION quSize;

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	//  Xg[̃f[^TCY擾

	if (nvstd.dwFlag & NVRESOURCE_SIZEOVERRIDE)
	{
		quSize.qw = nvstd.quEndOverride.qw - nvstd.quStartOverride.qw;
	}
	else
	{
		quSize.qw = SizeofResource(nvrd.hModule, nvrd.hResource);
	}

	*lpqwDataSize = quSize.qw;

	return NV_OK;
}


NVRESULT Class_NVResource::GetDataName(LPTSTR lpszDataName, DWORD dwLength)
{
//  Xg[̃f[^擾

	//  ̊֐́Aʂ̏ŗǂ͂


	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	//  t@CRs[

	if (nvstd.dwFlag & NVSTREAM_DATANAMEOVERRIDE)
	{
		//  f[^I[o[ChĂꍇ

		_tcsncpy_s(lpszDataName, dwLength, nvstd.lpszDataNameOverride, dwLength - 1);
	}
	else
	{
		//  I[o[ChĂȂꍇ
		_tcsncpy_s(lpszDataName, dwLength, nvstd.lpszDataName, dwLength - 1);
	}

	return NV_OK;
}


NVRESULT Class_NVResource::GetOpenMode(LPDWORD lpdwFlag)
{
//  Xg[̃I[v[h擾

	//  ̊֐́Aʂ̏ŗǂ͂

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	*lpdwFlag = nvstd.dwFlag;
	return NV_OK;
}


NVRESULT Class_NVResource::ChangeOpenMode(DWORD dwFlag)
{
//  Xg[̃I[v[hύX

	//  \[Xɂ͓ǂݍ݃[hȂ
	return VSTMERR_UNSUPPORTED;
}



NVRESULT Class_NVResource::OverrideDataName(LPCTSTR lpcszDataName)
{
//  Xg[̃I[o[Chݒ肷

	//  ̊֐́Aʂ̏ŗǂ͂

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	_tcscpy_s(nvstd.lpszDataNameOverride, NV_PATHMAX, lpcszDataName);

	nvstd.dwFlag |= NVSTREAM_DATANAMEOVERRIDE;

	return NV_OK;
}


NVRESULT Class_NVResource::OverrideSize(QWORD qwStartOverride, QWORD qwSizeOverride)
{
//  Xg[̃I[o[ChTCYݒ肷

	QWUNION quSize;
	QWUNION quEndOverride;
	QWUNION quStartOverride;
	QWUNION quCurrent;

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	//  ۂ̃t@CTCY擾
	quSize.qw = SizeofResource(nvrd.hModule, nvrd.hResource);

	//  I[o[Chn_`FbN
	quStartOverride.qw = qwStartOverride;
	if (quStartOverride.qw > quSize.qw)
	{
		return VSTMERR_INVALIDPARAM;
	}

	//  \zI_vZ
	quEndOverride.qw = qwSizeOverride;

	//  I[o[ChI_`FbN
	if (quEndOverride.qw > quSize.qw)
	{
		return VSTMERR_INVALIDPARAM;
	}

	//  ύX݈̌ʒu`FbN
	//  KvȂANbv
	quCurrent = nvstd.quCurrent;

	if (quCurrent.qw < quStartOverride.qw)
	{
		quCurrent.qw = quStartOverride.qw;
	}

	if (quCurrent.qw > quEndOverride.qw)
	{
		quCurrent.qw = quEndOverride.qw;
	}

	//  elۑďI
	nvstd.quStartOverride = quStartOverride;
	nvstd.quEndOverride = quEndOverride;
	nvstd.quCurrent = quCurrent;
	nvstd.dwFlag |= NVSTREAM_SIZEOVERRIDE;

	return NV_OK;
}


NVRESULT Class_NVResource::GetInfo(LPVOID lpvParam, LPDWORD lpdwSize)
{
//  Xg[̏擾

	return VSTMERR_UNSUPPORTED;

/*	if (! lpvParam)
	{
		//  TCY₢킹̏ꍇ
		*lpdwSize = sizeof(NVRESOURCEINFO);
		return NV_OK;
	}

	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	//  obt@̃TCY`FbN
	if (*lpdwSize < sizeof(NVRESOURCEINFO))
	{
		//  Ȃ΁AKvȃTCYƃG[Ԃ
		*lpdwSize = sizeof(NVRESOURCEINFO);
		return VSTMERR_BUFFERTOOSMALL;
	}

	//  t@CRs[

	CopyMemory(lpvParam, &nvrd.nvfi, sizeof(NVRESOURCEINFO));

	*lpdwSize = sizeof(NVRESOURCEINFO);

	return NV_OK;
*/
}


NVRESULT Class_NVResource::SetInfo(LPVOID lpvParam, DWORD dwSize)
{
//  Xg[̏ݒ肷
	return VSTMERR_UNSUPPORTED;
/*
	LPNVRESOURCEINFO lpnvfi = (LPNVRESOURCEINFO) lpvParam;

	//  obt@̃TCY`FbN
	if (dwSize < sizeof(NVRESOURCEINFO))
	{
		return VSTMERR_BUFFERTOOSMALL;
	}

	//  obt@̃f[^`FbN
	if (lpnvfi->dwFourCC != NVRESOURCE_FOURCC)
	{
		return VSTMERR_INVALIDPARAMTYPE;
	}

	if (lpnvfi->dwObjSize != sizeof(NVRESOURCEINFO))
	{
		return VSTMERR_INVALIDPARAMSIZE;
	}

	//  ۑ
	CopyMemory(&nvrd.nvfi, lpnvfi, sizeof(NVRESOURCEINFO));
	nvrd.nvfi.dwAttributes &= NVRESOURCE_RESOURCEATTRIBUTEMASK;	//  Lȑc

	nvrd.dwStatus |= NVRESOURCE_STATUSINFOCHANGED;		//  񂪕ύXꂽtO𗧂Ă

	return NV_OK;
*/
}


NVRESULT Class_NVResource::CreateAlias(LPINVSTREAM lpinvst)
{
//  CX^X̃GCAX쐬
	//  ƏĂ邩ǂׂ
	if (! vcd.bIsCreated)
	{
		return VSTMERR_NOCREATE;
	}

	{
		NVRESOURCECREATE nvrc;
		QWUNION quSizeOverride;
		INVRESOURCE invrsc;
		NVRESULT nvres;

		quSizeOverride.qw = nvstd.quEndOverride.qw - nvstd.quStartOverride.qw;

		SetNVResourceCreate(&nvrc, nvstd.dwFlag, nvstd.lpszDataName, nvstd.lpszDataNameOverride,
			nvstd.quStartOverride.qw, quSizeOverride.qw, NULL, NULL);
		if (nvrd.lpszModuleName[0])
		{
			nvrc.lpcszModuleName = nvrd.lpszModuleName;
		}
		if (nvrd.lpszType[0])
		{
			nvrc.lpcszType = nvrd.lpszType;
		}

		nvres = VCreateInstance(NVRESOURCE_FOURCC, NVRESOURCE_FOURCC, (LPVOID *) &invrsc);
		if (nvres)
		{
			return nvres;
		}

		nvres = invrsc->Create(&nvrc);
		if (nvres)
		{
			invrsc->Release();
			return nvres;
		}

		*lpinvst = (INVSTREAM) invrsc;
	}

	return NV_OK;
}


NVRESULT Class_NVResource::QueryClassInfo(LPVOID lpvInfo, LPDWORD lpdwSize)
{
//  NX̎@\擾

	//  ݂͖T|[gH
	*lpdwSize = 0;

	return VSTMERR_UNSUPPORTED;
}


