//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  o̓Xg[ Ԋ{NX  wb_[t@C  for  NVFileLibrary                       //
//  NVStream.h                                                                                  //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  eo̓Xg[̊{C^[tF[XƂȂ_~[NXłB                            //
//  t@Co͂Albg[Nf[^]ȂǂɂāAʂ̃C^[tF[X              //
//  Ȃׂ̂CvgĂ܂B                                                  //
//  ۊ{NXł͂Ȃ̂ŁACX^X̍쐬oĂ܂܂A                        //
//  ̃NX̃CX^X쐬ĂAsȂ̂ňӖ܂B                    //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



#pragma once





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "NVFileLibDef.h"


#ifdef __cplusplus
extern "C" {
#endif

#pragma pack(push, 1)



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  }N̒`
//

//  Xg[I[v[htO
#define NVSTREAM_OPENMASK      0x0F		//  I[v[htOo߂̃}XN
#define NVSTREAM_OPENREAD      0x01		//  ǂݍ݃[hŃI[viftHgj
#define NVSTREAM_OPENWRITE     0x02		//  ݃[hŃI[v
#define NVSTREAM_OPENREADWRITE 0x03		//  ǂݏp[hŃI[v


//  Xg[I[vtO
#define NVSTREAM_SIZEOVERRIDE     0x10	//  TCYI[o[ChāAIȃXg[JB
#define NVSTREAM_DATANAMEOVERRIDE 0x20	//  Xg[̃f[^I[o[ChĕύX


//  V[NtO
#define NVSTREAM_SEEKBEGIN   0x00		//  f[^̐擪̑ΈʒuŎwiftHgj
#define NVSTREAM_SEEKCURRENT 0x01		//  f[^݈̌ʒȗΈʒuŎw
#define NVSTREAM_SEEKEND     0x02		//  f[^̍Ō̑ΈʒuŎw


#define NVFILEFORMAT_FOURCC MAKEFOURCC('V', 'C', 'F', 'F')


//  CüIWit@C`̊{wb_[
struct NVFILEHEADER			//  nvfh
{
	DWORD dwFileSign;							//  K NVFILEFORMAT_FOURCC (VCFF)
	DWORD dwDriverType;							//  hCoʃR[h hCoƂȂ INVSTREAM ݊C^[tF[X̃NXʎq
	DWORD dwFileType;							//  t@CʃR[h t@Cʎʎq
	DWORD dwFlag;								//  t@C̃tO (CRC on/off Ȃ)
	QWUNION quFileSize;							//  t@CTCY  ̃wb_[܂߂TCY
	DWORD dwCRC32;								//  t@CCRC (CRC on ̎̂ݗL)
	DWORD dwReserved1;							//  ̊ĝ߂̗\(pfBÖӖ)  OĂ
};
typedef NVFILEHEADER * LPNVFILEHEADER;
typedef const NVFILEHEADER * LPCNVFILEHEADER;



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  NX̒`      INVSTREAM
//


//  NXʎq
#define NVSTREAM_FOURCC MAKEFOURCC('V', 'S', 'T', 'M')


/*  INVSTREAM NXWXg (VCOM.ini ւ̋Lq)
[VSTM]

Class_ID = "VSTM"
Module_Name = "NVFileLib.dll"
Entry_Point = "CreateInstance_NVStream"
*/


class Class_NVStream;
typedef Class_NVStream * INVSTREAM;
typedef const Class_NVStream * CINVSTREAM;
typedef INVSTREAM * LPINVSTREAM;
typedef const INVSTREAM * LPCINVSTREAM;

class Class_NVComStream;


//  INVSTREAM ̏f[^
struct NVSTREAMCREATE		//  nvstc
{
	DWORD dwFourCC;					//  NXʎq
	DWORD dwObjSize;				//  \̂̃TCY
	DWORD dwFlag;					//  tO
	LPCTSTR lpcszDataName;			//  I[vf[^
	LPCTSTR lpcszDataNameOverride;	//  I[o[Chf[^   NVSTREAM_DATANAMEOVERRIDE gp̂ݗL
	QWUNION quStartOverride;		//  I[o[ChJnʒu   NVSTREAM_SIZEOVERRIDE gp̂ݗL
	QWUNION quSizeOverride;			//  I[o[ChTCY     NVSTREAM_SIZEOVERRIDE gp̂ݗL
};
typedef NVSTREAMCREATE * LPNVSTREAMCREATE;
typedef const NVSTREAMCREATE * LPCNVSTREAMCREATE;


//  INVSTREAM ̕ێf[^
struct NVSTREAMDATA		//  nvstd
{
	TCHAR lpszDataName[NV_PATHMAX];			//  f[^
	TCHAR lpszDataNameOverride[NV_PATHMAX];	//  I[o[Chf[^
	DWORD dwFlag;							//  tO
	QWUNION quCurrent;						//  ݈ʒu
	QWUNION quStartOverride;				//  I[o[ChJnʒu
	QWUNION quEndOverride;					//  I[o[ChIʒu
};
typedef NVSTREAMDATA * LPNVSTREAMDATA;
typedef const NVSTREAMDATA * LPCNVSTREAMDATA;





//  INVSTREAM NX̒`
class NVFILELIB_CLASS_EXPORT Class_NVStream : virtual public Class_VCOM
{
	public :
		Class_NVStream(void);
		//  ftHgRXgN^
		//
		//  SetCoreData() ĂяoāA{NXɃf[^ݒ肷B

	VCOM_CLASSMETHOD
		~Class_NVStream(void);
		//  fXgN^
		//

	VCOM_CLASSMETHOD
		NVRESULT Create(LPCVOID lpvParam);
		//  CX^X̏
		//
		//  CX^XɃp[^^āACX^X̃f[^(쐬)B
		//  nvcd.bIsCreated tO𗧂āAς݂`FbNs悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT ResetData(void);
		//  CX^X̃f[^Zbg
		//
		//  CX^XŗpȂǂACreate() ĂяoȌԂɖ߂B
		//  vcd.bIsCreated tOZbgAĂ Create() s悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface);
		//  C^[tF[X̎擾
		//
		//  DWORD dwFourCC			擾C^[tF[X
		//  LPVOID *lpvInterface	C^[tF[Xi[|C^
		//
		//  ̃CX^X́AdwFourCC Ŏw肵^̃C^[tF[X擾B
		//  擾łC^[tF[X́ACX^XɂĈقȂ邪A
		//  CX^XNX̃X[p[NXɂNX̃C^[tF[X
		//  K擾ł悤ɎȂ΂ȂȂB
		//  ̊֐ŕʂ̃C^[tF[X擾ƁA AddRef() ŝŁA
		//  ÂC^[tF[Xɑ΂Ă Release() KvB

	VCOM_CLASSMETHOD
		NVRESULT Read(LPVOID lpvDestBuffer, DWORD dwReadSize, LPDWORD lpdwResult);
		//  Xg[f[^ǂݏo
		//
		//  LPVOID lpvDestBuffer		ǂݏõobt@
		//  DWORD dwReadSize			ǂݏoTCY
		//  LPDWORD lpdwResult			ۂɓǂݏoꂽTCY
		//
		//  Xg[f[^ǂݏoB
		//  ǂݍ݂Ɏsꍇ́AVSTMERR_CANTREADSTREAM ԂB
		//  vꂽTCỸf[^ȂꍇAVSTMERR_STREAMEMPTY Ԃ

	VCOM_CLASSMETHOD
		NVRESULT Write(LPCVOID lpvSrcBuffer, DWORD dwWriteSize, LPDWORD lpdwResult);
		//  Xg[փf[^
		//
		//  LPVOID lpvSrcBuffer		ރf[^̃obt@
		//  DWORD dwWriteSize		ރf[^̃TCY
		//  LPDWORD lpdwResult		ۂɏ܂ꂽTCY
		//
		//  Xg[փf[^o
		//  vꂽTCYoȂꍇAVSTMERR_STREAMFULL Ԃ
		//  ݂Ɏsꍇ́AVSTMERR_CANTWRITESTREAM Ԃ

	VCOM_CLASSMETHOD
		NVRESULT GetCurrentPosition(LPQLONG lpqlOffset, DWORD dwFlag);
		//  Xg[ł݈̌ʒu擾
		//
		//  LPQLONG lpqlOffset		擾̃|C^
		//  DWORD dwFlag			擾tO
		//
		//  tOŎwvZ@ŁA݈ʒu擾
		//  ftHǵANVSTREAM_SEEKBEGIN

	VCOM_CLASSMETHOD
		NVRESULT SetCurrentPosition(QLONG qlOffset, DWORD dwFlag);
		//  Xg[ł݈̌ʒuݒ
		//
		//  QLONG qlOffset			ݒ肷ʒu
		//  DWORD dwFlag			ݒtO
		//
		//  tOŎwvZ@ŁA݈ʒuݒ肷
		//  ftHǵANVSTREAM_SEEKBEGIN

	VCOM_CLASSMETHOD
		NVRESULT GetDataSize(LPQWORD lpqwDataSize);
		//  Xg[̃f[^TCY擾
		//
		//  LPQWORD lpqwDataSize		󂯎|C^
		//
		//  Xg[̃f[^TCY擾
		//  NVSTREAM_SIZEOVERRIDE tOgč쐬ĂꍇA
		//  I[o[ChꂽTCYԂ

	VCOM_CLASSMETHOD
		NVRESULT SetDataSize(QWORD qwDataSize);

	VCOM_CLASSMETHOD
		NVRESULT GetDataName(LPTSTR lpszDataName, DWORD dwLength);
		//  Xg[̃f[^擾
		//
		//  LPTSTR lpszDataName		f[^󂯎obt@
		//  DWORD dwLength			obt@̃TCY
		//
		//  Xg[̃f[^擾
		//  NVSTREAM_DATANAMEOVERRIDE tOgč쐬ĂꍇA
		//  I[o[ChꂽOԂB

	VCOM_CLASSMETHOD
		NVRESULT GetOpenMode(LPDWORD lpdwFlag);
		//  Xg[̃I[v[h擾
		//
		//  LPDWORD lpdwFlag		tO󂯎|C^
		//
		//  Xg[̃I[v[h擾

	VCOM_CLASSMETHOD
		NVRESULT ChangeOpenMode(DWORD dwFlag);
		//  Xg[̃I[v[hύX
		//
		//  DWORD dwFlag		I[vtO
		//
		//  ݈ʒuȂǂ̂܂܂ɁAI[v[hύX
		//  ΉłȂC^[tF[XȂƎv̂ŁA
		//  ߂lKmF邱

	VCOM_CLASSMETHOD
		NVRESULT OverrideDataName(LPCTSTR lpcszDataName);
		//  Xg[̃I[o[Chݒ肷
		//
		//  LPCTSTR lpszDataName
		//
		//  I[o[ChĂȂ΁AVɃI[o[Ch
		//  łɂĂ΁AXV

	VCOM_CLASSMETHOD
		NVRESULT OverrideSize(QWORD qwStartOverride, QWORD qwSizeOverride);
		//  Xg[̃I[o[CTCYݒ肷
		//
		//  QWORD qwStartOffset			I[o[ChJnʒu
		//  QWORD qwSize				I[o[ChTCY
		//
		//  I[o[ChĂȂ΁AVɃI[o[Ch
		//  łɂĂ΁Aɑ΂鑊ΈʒuƂĂɃI[o[Ch
		//  I[o[CȟʁA݈ʒuȈʒuɂȂꍇA
		//  LȔ͈͂ɃNbv

	VCOM_CLASSMETHOD
		NVRESULT GetInfo(LPVOID lpvParam, LPDWORD lpdwSize);
		//  Xg[̏擾
		//
		//  LPVOID lpvParam		Xg[̃f[^󂯎obt@
		//  LPDWORD lpdwSize	obt@̃TCYAуobt@ɏ܂ꂽTCY
		//
		//  Xg[̏擾B
		//  eCX^Xɂēe͈قȂ
		//  GetFourCC \bhŃCX^XmFAɂ\̂Ńf[^QƂB
		//  lpvParam  NULL nAobt@̃TCYsĂ
		//  lpdwSize ɕKvȃTCYԂB
		//  ֐ƁAlpdwSize ɂ́Aۂɏ܂ꂽTCYi[Ă

	VCOM_CLASSMETHOD
		NVRESULT SetInfo(LPVOID lpvParam, DWORD dwSize);
		//  Xg[̏ݒ肷
		//
		//  LPVOID lpvParam		Xg[̃f[^nobt@
		//  LPDWORD lpdwSize	obt@̃TCY
		//
		//  Xg[̏ݒ肷B
		//  eCX^Xɂēe͈قȂ

	VCOM_CLASSMETHOD
		NVRESULT CreateAlias(LPINVSTREAM lpinvst);
		//  CX^X̃GCAX쐬
		//
		//  LPINVSTREAM lpinvst		GCAX̃C^[tF[X󂯎|C^
		//
		//  f[^ɑ΂āAʂ̈ʒuȂǂێăANZXłGCAX쐬B
		//  ̏ꍇAp[^ŃCX^X쐬ȂāA
		//  ̃C^[tF[XԂB
		//  ʏAǂݍ݃[ĥƂ̂ݎ󂯕t邱ƂɂȂB

	VCOM_CLASSMETHOD
		NVRESULT QueryClassInfo(LPVOID lpvInfo, LPDWORD lpdwSize);
		//  NX̎@\擾
		//
		//  LPVOID@lpvInfo		NX̃f[^󂯎obt@
		//  LPDWORD lpdwSize	obt@̃TCYAуobt@ɏ܂ꂽTCY
		//
		//  NX INVSTREAM C^[tF[XŒ`Ă@\̂A
		//  T|[gĂ̂𒲂ׂB
		//  lpvParam  NULL nAobt@̃TCYsĂ
		//  lpdwSize ɕKvȃTCYԂB
		//  ֐ƁAlpdwSize ɂ́Aۂɏ܂ꂽTCYi[Ă
	VCOM_BASICMETHOD
		NVRESULT QueryIStreamInterface(IStream **lplpStream);
protected:
	VCOM_CLASSMETHOD
		NVRESULT AddInterface(DWORD dwFlag);
		//  C^[tF[XQƃe[uɓo^
		//
		//  DWORD dwFlag	NXCX^X̏ꍇPAȊO͂O
		//
		//  RXgN^̒ŌĂ΂AC^[tF[X|C^e[uɓo^A
		//  VIsValidInterface() ŃC^[tF[X̗L؂ł悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT DeleteInterface(void);
		//  C^[tF[XQƃe[u폜
		//
		//  DeleteInstance() ̒ŌĂ΂AC^[tF[X|C^e[u폜B

	friend class Class_NVComStream;
	protected:
		NVSTREAMDATA nvstd;
};


NVRESULT NVFILELIB_EXPORT NVFILELIB_API CreateInstance_NVStream(LPIVCOM lpivcom);
//  CX^X̍쐬
//
//  INVSTREAM CX^X쐬ÃC^[tF[XԂB



inline void SetNVStreamCreate(LPNVSTREAMCREATE lpnvstc, DWORD dwFlag, LPCTSTR lpcszDataName, LPCTSTR lpcszDataNameOverride = NULL,
							  DWORD dwStartOverride = 0, DWORD dwStartOverrideHigh = 0, 
							  DWORD dwSizeOverride = 0, DWORD dwSizeOverrideHigh = 0);
//  NVSTREAMCREATE \̏֐
//
//  LPNVSTREAMCREATE lpnvstc			\
//  DWORD dwFlag						ZbgtO
//  LPCTSTR lpcszDataName				I[vf[^
//  LPCTSTR lpcszDataNameOverride		I[o[Chf[^  NVSTREAM_DATANAMEOVERRIDE gp̂ݗL
//  DWORD dwStartOverride				I[o[ChJnʒu              NVSTREAM_SIZEOVERRIDE gp̂ݗL
//  DWORD dwStartOverrideHigh			I[o[ChJnʒȕ DWORD  NVSTREAM_SIZEOVERRIDE gp̂ݗL
//  DWORD dwSizeOverride				I[o[ChIʒu              NVSTREAM_SIZEOVERRIDE gp̂ݗL
//  DWORD dwSizeOverrideHigh			I[o[ChIʒȕ DWORD  NVSTREAM_SIZEOVERRIDE gp̂ݗL



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  CC֐̒`
//

inline void SetNVStreamCreate(LPNVSTREAMCREATE lpnvstc, DWORD dwFlag, LPCTSTR lpcszDataName, LPCTSTR lpcszDataNameOverride,
							  DWORD dwStartOverride, DWORD dwStartOverrideHigh,
							  DWORD dwSizeOverride, DWORD dwSizeOverrideHigh)
{
//  NVSTREAMCREATE \̏֐

	lpnvstc->dwFourCC = NVSTREAM_FOURCC;
	lpnvstc->dwObjSize = sizeof(NVSTREAMCREATE);
	lpnvstc->dwFlag = dwFlag;
	lpnvstc->lpcszDataName = lpcszDataName;
	lpnvstc->lpcszDataNameOverride = lpcszDataNameOverride;
	lpnvstc->quStartOverride.dwLow = dwStartOverride;
	lpnvstc->quStartOverride.dwHigh = dwStartOverrideHigh;
	lpnvstc->quSizeOverride.dwLow = dwSizeOverride;
	lpnvstc->quSizeOverride.dwHigh = dwSizeOverrideHigh;

	return;
}




#pragma pack(pop)

#ifdef __cplusplus
}
#endif
