//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  ėpW[  wb_[t@C  for  NVLibraryCore                                        //
//  NVCommon.h                                                                                  //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



#pragma once



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//

#include "NVLibCoreDef.h"
#include "VCOM.h"
#include <time.h>

//  STL  map Rei𗘗p\
//#pragma warning(disable:4786)

#include <map>
#include <vector>


#ifdef __cplusplus
extern "C" {
#endif

#pragma pack(push, 1)



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  }N̒`
//


//  NVGetFileList ptO
#define NVGETFILELIST_INCLUDEDIRECTORY 0x01		//  fBNg܂߂ė񋓂
#define NVGETFILELIST_DIRECTORYONLY    0x02		//  fBNĝݗ񋓂


//  _CAOǗpe[u
typedef std::map<LPVOID, HWND> NVDLGLIST;
typedef NVDLGLIST * LPNVDLGLIST;
typedef const NVDLGLIST * LPCNVDLGLIST;


#define CPUTYPE_GETTYPE(dw)     (((dw) >> 12) & 0x03)
#define CPUTYPE_GETFAMILY(dw)   (((dw) >> 8) & 0x0F)
#define CPUTYPE_GETMODEL(dw)    (((dw) >> 4) & 0x0F)
#define CPUTYPE_GETSTEPPING(dw) ((dw) & 0x0F)

#ifdef USING_INTEL_COMPILER
#define SETROUND_FLOATMODE
#define RESTORE_FLOATMODE
#else
#define SETROUND_FLOATMODE WORD oldword; WORD newword; __asm { __asm fstcw word ptr [oldword] __asm mov ax, word ptr [oldword] __asm and ax, ~(0x3 << 10) __asm mov word ptr [newword], ax __asm fldcw word ptr [newword] }
#define RESTORE_FLOATMODE __asm	fldcw word ptr [oldword]
#endif

#ifdef USING_INTEL_COMPILER
#define SETTRUNC_FLOATMODE WORD oldword; WORD newword; __asm { __asm fstcw word ptr [oldword] __asm mov ax, word ptr [oldword] __asm or ax, (0x3 << 10) __asm mov word ptr [newword], ax __asm fldcw word ptr [newword] }
#define RESETTRUNC_FLOATMODE __asm	fldcw word ptr [oldword]
#else
#define SETTRUNC_FLOATMODE
#define RESETTRUNC_FLOATMODE
#endif

#define THREAD_PRIORITY_MAX 7

//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̒`
//

#define SWAP_DWORD(dw) (((dw) << 24) | (((dw) & 0xFF00) << 8) | (((dw) & 0xFF0000) >> 8) | ((dw) >> 24))

LONGLONG NVLIBCORE_EXPORT NVLIBCORE_API NVMulAddDiv64(LONGLONG llNumber, LONGLONG llNumerator, LONGLONG llDenominator, LONGLONG llAdd);
inline LONGLONG NVMulDiv64(LONGLONG llNumber, LONGLONG llNumerator, LONGLONG llDenominator)
{
	return NVMulAddDiv64(llNumber, llNumerator, llDenominator, 0);
}

inline BOOL NVStringToBool(LPCTSTR str)
{
	if (_tcsicmp(str, TEXT("TRUE")) == 0)
	{
		return TRUE;
	}
	else if (_tcsicmp(str, TEXT("ENABLE")) == 0)
	{
		return TRUE;
	}
	else if (_tcsicmp(str, TEXT("On")) == 0)
	{
		return TRUE;
	}
	else if (_tstoi(str) == 1)
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}
inline BOOL GetPrivateProfileBool(LPCTSTR pszField, LPCTSTR pszKey, BOOL fDefault, LPCTSTR pszFileName)
{
	TCHAR szBuf[256];

	GetPrivateProfileString(pszField, pszKey, fDefault ? TEXT("TRUE") : TEXT("FALSE"), szBuf, 256, pszFileName);
	return NVStringToBool(szBuf);
}

inline BOOL IsValidIntString(LPCTSTR pszString)
{
	if (*pszString == TEXT('\0'))
	{
		return FALSE;
	}
	while (*pszString == TEXT(' ') || *pszString == TEXT('\t'))
	{
		pszString++;
	}
	if (*pszString == TEXT('\0'))
	{
		return FALSE;
	}
	if (! _istdigit(*pszString))
	{
		return FALSE;
	}
	pszString++;
	while (_istdigit(*pszString))
	{
		pszString++;
	}
	while (*pszString == TEXT(' ') || *pszString == TEXT('\t'))
	{
		pszString++;
	}
	if (*pszString != TEXT('\0'))
	{
		return FALSE;
	}
	return TRUE;
}

inline __int64 GetPrivateProfileInt64(LPCTSTR pszField, LPCTSTR pszKey, __int64 nDefault, LPCTSTR pszFileName)
{
	TCHAR szBuf[256];

	GetPrivateProfileString(pszField, pszKey, TEXT(""), szBuf, 256, pszFileName);
	if (IsValidIntString(szBuf))
	{
		return _tstoi64(szBuf);
	}
	else
	{
		return nDefault;
	}
}

inline BOOL IsValidFloatString(LPCTSTR pszString)
{
	BOOL fIntExist = FALSE;
	if (*pszString == TEXT('\0'))
	{
		return FALSE;
	}
	while (*pszString == TEXT(' ') || *pszString == TEXT('\t'))
	{
		pszString++;
	}
	if (*pszString == TEXT('\0'))
	{
		return FALSE;
	}
	if (*pszString == TEXT('+') || *pszString == TEXT('-'))
	{
		pszString++;
	}
	if (*pszString == TEXT('\0'))
	{
		return FALSE;
	}
	if (_istdigit(*pszString))
	{
		fIntExist = TRUE;
	}
	while (_istdigit(*pszString))
	{
		pszString++;
	}
	if (*pszString == TEXT('\0'))
	{
		return TRUE;
	}
	if (*pszString == TEXT('.'))
	{
		pszString++;
		if ((! fIntExist) && (! _istdigit(*pszString)))
		{
			return FALSE;
		}
		while (_istdigit(*pszString))
		{
			pszString++;
		}
	}
	if (*pszString == TEXT('\0'))
	{
		return TRUE;
	}
	if (*pszString != TEXT('d') && *pszString != TEXT('D') && *pszString != TEXT('e') && *pszString != TEXT('E'))
	{
		return FALSE;
	}
	pszString++;
	if (*pszString == TEXT('+') || *pszString == TEXT('-'))
	{
		pszString++;
	}
	while (_istdigit(*pszString))
	{
		pszString++;
	}
	if (*pszString != TEXT('\0'))
	{
		return FALSE;
	}

	return TRUE;
}

inline DOUBLE GetPrivateProfileDouble(LPCTSTR pszField, LPCTSTR pszKey, DOUBLE dDefault, LPCTSTR pszFileName)
{
	TCHAR szBuf[256];

	GetPrivateProfileString(pszField, pszKey, TEXT(""), szBuf, 256, pszFileName);
	if (IsValidFloatString(szBuf))
	{
		return _tstof(szBuf);
	}
	else
	{
		return dDefault;
	}
}

inline BOOL WritePrivateProfileInt(LPCTSTR pszField, LPCTSTR pszKey, int nValue, LPCTSTR pszFileName)
{
	TCHAR szBuf[256];

	_stprintf_s(szBuf, 256, TEXT("%d"), nValue);
	return WritePrivateProfileString(pszField, pszKey, szBuf, pszFileName);
}

inline BOOL WritePrivateProfileInt64(LPCTSTR pszField, LPCTSTR pszKey, __int64 nValue, LPCTSTR pszFileName)
{
	TCHAR szBuf[256];

	_stprintf_s(szBuf, 256, TEXT("%I64d"), nValue);
	return WritePrivateProfileString(pszField, pszKey, szBuf, pszFileName);
}

inline BOOL WritePrivateProfileHex(LPCTSTR pszField, LPCTSTR pszKey, unsigned int uValue, LPCTSTR pszFileName)
{
	TCHAR szBuf[256];

	_stprintf_s(szBuf, 256, TEXT("0x%08X"), uValue);
	return WritePrivateProfileString(pszField, pszKey, szBuf, pszFileName);
}

inline BOOL WritePrivateProfileDouble(LPCTSTR pszField, LPCTSTR pszKey, double dValue, LPCTSTR pszFileName)
{
	TCHAR szBuf[256 + _CVTBUFSIZE];


	_stprintf_s(szBuf, 256 + _CVTBUFSIZE, TEXT("%f"), dValue);
	return WritePrivateProfileString(pszField, pszKey, szBuf, pszFileName);
}

inline BOOL WritePrivateProfileBool(LPCTSTR pszField, LPCTSTR pszKey, BOOL fValue, LPCTSTR pszFileName)
{
	return WritePrivateProfileString(pszField, pszKey, fValue ? TEXT("TRUE") : TEXT("FALSE"), pszFileName);
}


inline LRESULT NVSendMessage(HWND hwnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
	if (GetCurrentThreadId() != GetWindowThreadProcessId(hwnd, NULL))
	{
		PostMessage(hwnd, uMessage, wParam, lParam);
		return -1;
	}
	else
	{
		return SendMessage(hwnd, uMessage, wParam, lParam);
	}
}

int NVLIBCORE_EXPORT NVLIBCORE_API NVCreateEscapeCode(LPTSTR pszString, int nLength);
int NVLIBCORE_EXPORT NVLIBCORE_API NVProcessEscapeCode(LPTSTR pszString, int nLength);
int NVLIBCORE_EXPORT NVLIBCORE_API NVLoadString(HINSTANCE hInstance, UINT uID, LPTSTR lpBuffer, int nBufferMax);
HMODULE NVLIBCORE_EXPORT NVLIBCORE_API NVGetResourceDLL(void);
int NVLIBCORE_EXPORT NVLIBCORE_API NVGetConfigFileDirectory(LPTSTR pszConfigFileDirectory, int len);
NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVGetPluginDirectory(LPTSTR pszPluginDirectory, int len);
NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVPathCanonicalize(LPTSTR pszDest, LPCTSTR pszSrc, int len);
NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVPathCanonicalizeToString(_tstring& stDest, LPCTSTR pszSrc);

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVGetFileVersion(LPTSTR lpszPath, LPQLONG lpqlFileVersion);

DWORD NVLIBCORE_EXPORT NVLIBCORE_API NVGetFileAttributes(LPCTSTR lpFileName);
HANDLE NVLIBCORE_EXPORT NVLIBCORE_API NVFindFirstFile(LPCTSTR lpFileName, LPWIN32_FIND_DATA lpFindFileData);
//BOOL NVLIBCORE_EXPORT NVLIBCORE_API NVFindNextFile(HANDLE hFindFile, LPWIN32_FIND_DATA lpFindFileData);
//BOOL NVLIBCORE_EXPORT NVLIBCORE_API NVFindClose(HANDLE hFindFile);
#define NVFindNextFile(handle, ffd) FindNextFile(handle, ffd)
#define NVFindClose(handle) FindClose(handle)
HANDLE NVLIBCORE_EXPORT NVLIBCORE_API NVCreateFile(LPCTSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode,
												   LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition,
												   DWORD dwFlagsAndAttributes, HANDLE hTemplateFile);


LONG NVLIBCORE_EXPORT NVLIBCORE_API NVGetFontType(LPCTSTR lpcszFontFaceName);
//

BOOL NVLIBCORE_EXPORT NVLIBCORE_API NVIsUTF8(LPCSTR utf8, LONG lLength);
LONG NVLIBCORE_EXPORT NVLIBCORE_API NVUTF8ToWideChar(LPWSTR wide, LONG lDestLen, LPCSTR utf8, LONG lSrcLen);
LONG NVLIBCORE_EXPORT NVLIBCORE_API NVWideCharToUTF8(LPSTR utf8, LONG lDestLen, LPCWSTR wide, LONG lSrcLen);

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVClipWindowPos(HWND hwnd);



NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVRegisterDialog(HWND hwnd);
//  _CAO̓o^
//
//  HWND hwnd		o^_CAÕnh
//  ߂l : NVRESULT
//
//  _CAOǗe[uɓo^AbZ[Wnhł悤ɂB


NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVUnRegisterDialog(HWND hwnd);
//  _CAO̓o^
//
//  HWND hwnd		o^_CAÕnh
//  ߂l : NVRESULT
//
//  _CAOǗe[u폜B


BOOL NVLIBCORE_EXPORT NVLIBCORE_API NVIsDialogMessage(LPMSG lpmsg);
//  _CAÕbZ[W̃nh
//
//  LPMSG lpmsg		nh郁bZ[W
//  ߂l : BOOL	::IsDialogMessage() ɏ
//
//  Ǘe[uɂ_CAOɂāA::IsDialogMessage() ŃbZ[WnhB


LPCTSTR NVLIBCORE_EXPORT NVLIBCORE_API NVGetCommandOption(LPCTSTR lpcszCommandLine, LPTSTR lpszOption, DWORD dwSize);

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVGetProgramFileName(LPTSTR lpszBuf, DWORD dwLength);
//  vOt@C̎擾
//
//  R}hCANꂽAvP[VvZX̃t@C擾B
//  Ȃ킿Ag̃t@C擾B

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVGetLongFileName(LPTSTR lpszFileName, int nLength);
//  t@COt@Cl[ɕϊ
//
//  LPTSTR lpszFileName		ϊt@Cяo͐
//  ߂l : NVRESULT
//
//  nꂽt@COt@Cl[ɕϊAi[ȂB
//  pX܂܂ꍇApXϊB
//  ͂Əo͂̃obt@Ȃ̂ŁAOt@Cl[i[̂
//  \ȗʂ̃obt@nƁBʏANV_PATHMAX (1024) Ώ\łB


NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVGetFileList(LPCTSTR lpcszFileName, LPTSTR *lplpszFileName, LPDWORD lpdwCount, DWORD dwFlag = 0);
//  w̃fBNgȉ̑St@CXg擾
//
//  LPCTSTR lpcszFileName		fBNg
//  LPTSTR lplpszFileName		ʂ󂯎|C^
//  LPDWORD lpdwCount			擾t@C󂯎
//  DWORD dwFlag				tO
//
//  lpcszFileName œn̂t@CłꍇÃt@CԂB
//  fBNgnꍇATufBNg܂ށÃfBNg̑St@Co͂B
//  t@ĆANV_PATHMAX oCg~t@ĈQzŕԂB
//  (lplpszFileName + NV_PATHMAX * Index) ŁAIndex Ԗڂ̃t@CQƂłB
//  t@Ci[obt@́A֐̓ŎIɊ蓖ĂB
//  ŏ̌Ăяoł́AlplpszFileName ɂ NULL ̊i[ꂽ|C^A
//  lpdwCount ɂ O ̊i[ꂽ|C^nƁB
//  obt@́ANVMemAlloc ŃAP[VAt@C(*lpdwCount)~NV_PATHMAX oCg̃TCYɊgĂB
//  obt@ NVMemAlloc ŃAP[Vꂽ̂ł΁ANULL ȊOnĂ܂ȂB
//  ̏ꍇAlpdwCount ̎wt@C̎̈ʒut@Ci[ĂA
//  TCYɍ킹Ē̂ŁAӂ邱ƁB
//  obt@́AKvȂȂANVMemFree ŉ邱ƁB
//  nfBNg݂Ȃꍇ́AlplpszFileName lpdwCount ƂO(NULL)ԂB
//  fBNgɂ́AŌ'\'ĕԂB


NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVGetFirstPath(LPCTSTR lpcszFileName, LPLONG lplFirstPath);
//  pX̂ŏ̃fBNg擾
//
//  LPCTSTR lpcszFileName	pX
//  LPLONG lplFirstPath		ŏ̃pX̃ItZbg
//
//  pX擪猟āAŏ'\'ʒuԂB
//  NVGetFirstPath(lpcszFileName + *lplFirstPath + 1);
//  ƂČJԂĂяo΁ApXԂɂǂ邱ƂłB


NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVCreateDirectory(LPCTSTR lpcszDirectoryName);
//  fBNg쐬
//
//  LPCTSTR lpcszDirectoryName	쐬fBNg
//
//  Win32 API  CreateDirectory ƈāApXԂɏĂ̂ŁA
//  TufBNgPx̌Ăяoō쐬łB
//  w̃fBNg̊Kw̃fBNgȂꍇ́A
//  ܂߂č쐬B

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVCreateDirectoryFromFileName(LPCTSTR lpcszFileName);
//  fBNg쐬
//
//  LPCTSTR lpcszDirectoryName	쐬fBNg
//
//  Win32 API  CreateDirectory ƈāApXԂɏĂ̂ŁA
//  TufBNgPx̌Ăяoō쐬łB
//  w̃fBNg̊Kw̃fBNgȂꍇ́A
//  ܂߂č쐬B


DWORD NVLIBCORE_EXPORT NVLIBCORE_API NVGetCPUType(LPTSTR lpszName = NULL, DWORD dwLength = 0, LPDWORD lpdwModel = NULL, LPTSTR pszCpuName = NULL);
//  bot̎ނ擾
//
//  AZu cpuid ߂sāAllwтrrd̗p\ǂ𔻕ʂB
//  rrdp\̏ꍇACPUTYPE_SSE tOB
//  llwp\̏ꍇACPUTYPE_MMX tOB
//  ȊȌꍇ́ACPUTYPE_DEFAULT ԂB
//  rrdɊւẮAnr̃T|[g̗L킹ă`FbNĂB
//  3DNow! ɊւẮAFeature flag ̃`FbN݂̂ŁAseXgĂȂ̂Œ

QWORD NVLIBCORE_EXPORT NVLIBCORE_API NVGetCPUFreq(BOOL bChangePriority);
//  bot̎g擾
//
//  AZu rdtsc ߂𗘗pāAbot̓g擾B
//  rdtsc ߂ss̏ꍇAOԂB

LONG NVLIBCORE_EXPORT NVLIBCORE_API NVGetThreadPriorityIndex(LONG lThreadPriority);
//  Xbh̃vCIeBCfbNXɕϊ
//
//  LONG lThreadPriority	Xbh̃vCIeB
//
//  Win32 API  SetThreadPriority ȂǂŎg}NlA
//  THREAD_PRIORITY_IDLE OƂCfbNXlɕϊB
//  }N̒l͕sAȂ̂ŁAvCIeB݂̂̂
//  PNグƂȂǂɕsւłB
//
//  THREAD_PRIORITY_IDLE          : 0
//  THREAD_PRIORITY_LOWEST        : 1
//  THREAD_PRIORITY_BELOW_NORMAL  : 2
//  THREAD_PRIORITY_NORMAL        : 3
//  THREAD_PRIORITY_ABOVE_NORMAL  : 4
//  THREAD_PRIORITY_HIGHEST       : 5
//  THREAD_PRIORITY_TIME_CRITICAL : 6

LONG NVLIBCORE_EXPORT NVLIBCORE_API NVGetThreadPriorityValue(LONG lThreadPriorityIndex);
//  Xbh̃vCIeB̃CfbNXlɕϊ
//
//  LONG lThreadPriorityIndex	Xbh̃vCIeB̃CfbNX
//
//  NVGetThreadPriorityIndex ̋tϊłB
//  Xbh̃vCIeBPNグꍇ́A
//  GetThreadPriority Ō݂̃vCIeB擾A
//  NVGetThreadPriorityIndex ŃCfbNXɕϊA
//  {P NVGetThreadPriorityValue Œlɖ߂A
//  SetThreadPriority ƂɂȂB



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  \̂̒`
//

//  64rbg int ōWێ RECT \
struct RECT64 {		//  rc64
	LONGLONG left;		//  `̍
	LONGLONG top;		//  `̏
	LONGLONG right;		//  `̉E
	LONGLONG bottom;	//  `̉
};
typedef RECT64 * LPRECT64;
typedef const RECT64 * LPCRECT64;



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̒`
//


BOOL NVLIBCORE_EXPORT NVLIBCORE_API SetRect64(LPRECT64 lprc, LONGLONG left, LONGLONG top, LONGLONG right, LONGLONG bottom);
//  RECT64 p̏֐
//
//  LPRECT64 lprc		lݒ肷 RECT64 \̂ւ̃|C^
//  LONGLONG left		left ɐݒ肷l
//  LONGLONG top		top ɐݒ肷l
//  LONGLONG right		right ɐݒ肷l
//  LONGLONG bottom		bottom ɐݒ肷l
//  ߂l				TRUE :   FALSE : s
//
//   32bitRECT 𑀍삷AWin32 API ̂̂ƓłB

BOOL NVLIBCORE_EXPORT NVLIBCORE_API IntersectRect64(LPRECT64 lprcResult, LPRECT64 lprc1, LPRECT64 lprc2);
//  RECT64 p IntersectRect
//
//  LPRECT64 lprc		lݒ肷 RECT64 \̂ւ̃|C^
//  LPRECT64 lprc1			`P
//  LPRECT64 lprc2			`Q
//  ߂l				TRUE : dȂĂ̈悪  FALSE :@dȂĂȂ
//
//   32bitRECT 𑀍삷AWin32 API ̂̂ƓłB


BOOL NVLIBCORE_EXPORT NVLIBCORE_API IntersectRect64_32(LPRECT64 lprcResult, LPRECT64 lprc1, LPRECT lprc2);
//  RECT64 p IntersectRect
//
//  LPRECT64 lprc		lݒ肷 RECT64 \̂ւ̃|C^
//  LPRECT64 lprc1		`P
//  LPRECT lprc2		`Q
//  ߂l				TRUE : dȂĂ̈悪  FALSE :@dȂĂȂ
//
//   32bitRECT 𑀍삷AWin32 API ̂̂ƓłB


BOOL NVLIBCORE_EXPORT NVLIBCORE_API IntersectRect32_64(LPRECT64 lprcResult, LPRECT lprc1, LPRECT64 lprc2);
//  RECT64 p IntersectRect
//
//  LPRECT64 lprc		lݒ肷 RECT64 \̂ւ̃|C^
//  LPRECT lprc1		`P
//  LPRECT64 lprc2		`Q
//  ߂l				TRUE : dȂĂ̈悪  FALSE :@dȂĂȂ
//
//   32bitRECT 𑀍삷AWin32 API ̂̂ƓłB


BOOL NVLIBCORE_EXPORT NVLIBCORE_API IntersectRect32_32(LPRECT64 lprcResult, LPRECT lprc1, LPRECT lprc2);
//  RECT64 p IntersectRect
//
//  LPRECT64 lprc		lݒ肷 RECT64 \̂ւ̃|C^
//  LPRECT lprc1		`P
//  LPRECT lprc2		`Q
//  ߂l				TRUE : dȂĂ̈悪  FALSE :@dȂĂȂ
//
//   32bitRECT 𑀍삷AWin32 API ̂̂ƓłB



NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVGetFileNameFromShortcut(HWND hwnd, LPCTSTR lpszShortcut, LPTSTR lpszFileName, DWORD dwLength);
//  V[gJbgt@CANt@C擾
//
//  HWND hwnd				eEBhẼnh
//  LPCTSTR lpcszShortCut	V[gJbg̃t@C
//  LPTSTR lpszFileName		t@C󂯎obt@
//
//  CoInitialize() ɌĂяoĂƁBCoInitializeEx() ŁACOINIT_APARTMENTTHREADED ȊOw肵ĂƎŝŒ

#ifdef NVSAFELOCK_DEADLOCK_ASSERT
NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVInternalSafeLock(IVCOM ivcom, LPCTSTR pszFileName, long lLine, LPCTSTR pszDate, LPCTSTR pszTime);
#else
NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVInternalSafeLock(IVCOM ivcom);
#endif
//  C^[tF[X̗Lm߂ƂƂɁASɃbN
//
//  IVCOM ivcom		bNC^[tF[X
//  ߂l : BOOL	TRUE :   FALSE : s
//
//  AvP[VŒP̃NeBJZNV
//  C^[tF[X̗L؂AăbNB
//  łɑ̃XbhɂăbNĂꍇ́A
//  bNł܂ŏubNB

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVInternalTrySafeLock(IVCOM ivcom);

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVInternalSafeUnLock(IVCOM ivcom);
//  NVSafeLock ɑ΂AbN
//
//  IVCOM ivcom		AbNC^[tF[X
//  ߂l : BOOL	TRUE :    FALSE : s
//
//  NVSafeLock() ŃbNC^[tF[XAbNB


#pragma pack(pop)


#ifdef __cplusplus
}
#endif

#ifdef NVSAFELOCK_DEADLOCK_ASSERT
#define NVSafeLock(it) _NVSafeLock((it), TEXT(__FILE__), __LINE__, TEXT(__DATE__), TEXT(__TIME__))

template<class T> NVRESULT _NVSafeLock(T *iT, LPCTSTR pszFileName, long lLine, LPCTSTR pszDate, LPCTSTR pszTime)
{
	IVCOM ivcom;
	__try
	{
		ivcom = (IVCOM) iT;
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
	{
		ivcom = NULL;
	}

	return NVInternalSafeLock(ivcom, pszFileName, lLine, pszDate, pszTime);
}

#else
template<class T> NVRESULT NVSafeLock(T *iT)
{
	IVCOM ivcom;
	__try
	{
		ivcom = (IVCOM) iT;
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
	{
		ivcom = NULL;
	}

	return NVInternalSafeLock(ivcom);
}

#endif

template<class T> NVRESULT NVTrySafeLock(T *iT)
{
	IVCOM ivcom;
	__try
	{
		ivcom = (IVCOM) iT;
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
	{
		ivcom = NULL;
	}

	return NVInternalTrySafeLock(ivcom);
}

template<class T> NVRESULT NVSafeUnLock(T *iT)
{
	IVCOM ivcom;
	__try
	{
		ivcom = (IVCOM) iT;
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
	{
		ivcom = NULL;
	}

	return NVInternalSafeUnLock(ivcom);
}

inline FILE *NVOpenDebugLogFile(const TCHAR *filename, const TCHAR *mode)
{
	FILE *fp = NULL;
	if (PathIsRelative(filename))
	{
		TCHAR szName[NV_PATHMAX];

		NVGetConfigFileDirectory(szName, NV_PATHMAX);
		PathAppend(szName, filename);
		NVCreateDirectoryFromFileName(szName);
#ifdef _UNICODE
		TCHAR szMode[NV_PATHMAX];
		_stprintf_s(szMode, NV_PATHMAX, TEXT("%s, ccs=UTF-16LE"), mode);
		if (! _tfopen_s(&fp, szName, szMode) && fp)
#else
		if (! _tfopen_s(&fp, szName, mode) && fp)
#endif
		{
			return fp;
		}
	}
	else
	{
		NVCreateDirectoryFromFileName(filename);
#ifdef _UNICODE
		TCHAR szMode[NV_PATHMAX];
		_stprintf_s(szMode, NV_PATHMAX, TEXT("%s, ccs=UTF-16LE"), mode);
		if (! _tfopen_s(&fp, filename, szMode) && fp)
#else
		if (! _tfopen_s(&fp, filename, mode) && fp)
#endif
		{
			return fp;
		}
	}
	return NULL;
}

inline void NVGetLocalTimeString(LPTSTR pszTime, DWORD dwLength)
{
	__time64_t time;
	tm nowtime;

	_time64(&time);
	_localtime64_s(&nowtime, &time);
	_tasctime_s(pszTime, dwLength, &nowtime);

	DWORD i;
	DWORD iMax = min(dwLength, (DWORD) _tcslen(pszTime));

	for (i = 0; i < iMax; i++)
	{
#ifndef _UNICODE
		if (IsDBCSLeadByteEx(CP_ACP, pszTime[i]))
		{
			i++;
		}
		else
#endif
		{
			if (pszTime[i] == TEXT('\n') || pszTime[i] == TEXT('\r'))
			{
				pszTime[i] = TEXT('\0');
				break;
			}
		}
	}

	return;
}

template<class T> BOOL NVSafeAddRef(T *iT)
{
	LONG ret = 0;
	__try
	{
		IVCOM t = (IVCOM) iT;
		if (t)
		{
			ret = t->SafeAddRef();
		}
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
	{
		ret = 0;
	}

	if (ret >= 2)
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}


class DesktopWorkArea
{
	struct WorkArea
	{
		RECT rcWorkArea;
		RECT rcScreen;
	};
	typedef std::vector<WorkArea> WorkAreaList;
public:
	DesktopWorkArea(void)
	{
		list.clear();
	}
	~DesktopWorkArea(void)
	{
		list.clear();
	}
	void Update(void)
	{
		list.clear();
		EnumDisplayMonitors(NULL, NULL, MonitorEnumProc, (LPARAM) this);
		if (list.empty())
		{
			WorkArea area;
			HDC hic;

			hic = CreateIC(TEXT("DISPLAY"), NULL, NULL, NULL);
			area.rcScreen.left = 0;
			area.rcScreen.top = 0;
			area.rcScreen.right = GetDeviceCaps(hic, HORZRES);
			area.rcScreen.bottom = GetDeviceCaps(hic, VERTRES);
			DeleteDC(hic);

			SystemParametersInfo(SPI_GETWORKAREA, 0, &area.rcWorkArea, 0);
			list.push_back(area);
		}
	}
	BOOL RectInWorkArea(RECT& rc, RECT& rcWorkArea)
	{
		WorkAreaList::iterator it;

		for (it = list.begin(); it != list.end(); it++)
		{
			POINT pt;
			pt.x = rc.left;
			pt.y = rc.top;
			if (PtInRect(&it->rcWorkArea, pt))
			{
				pt.x = rc.right;
				pt.y = rc.bottom;
				if (PtInRect(&it->rcWorkArea, pt))
				{
					rcWorkArea = it->rcWorkArea;
					return TRUE;
				}
			}
		}

		WorkAreaList::iterator itBig = list.begin();
		int nBigArea = 0;
		for (it = list.begin(); it != list.end(); it++)
		{
			RECT rcTemp;

			if (IntersectRect(&rcTemp, &it->rcScreen, &rc))
			{
				int nArea = (rcTemp.right - rcTemp.left) * (rcTemp.bottom - rcTemp.top);
				if (nArea > nBigArea)
				{
					itBig = it;
					nBigArea = nArea;
				}
			}
		}

		rcWorkArea = itBig->rcWorkArea;
		return FALSE;
	}
	void ClipWindow(HWND hwnd)
	{
		RECT rcWindow;
		RECT rcWorkArea;

		GetWindowRect(hwnd, &rcWindow);
		if (! RectInWorkArea(rcWindow, rcWorkArea))
		{
			if (rcWindow.right > rcWorkArea.right)
			{
				rcWindow.left -= rcWindow.right - rcWorkArea.right;
			}
			if (rcWindow.left < rcWorkArea.left)
			{
				rcWindow.left += rcWorkArea.left - rcWindow.left;
			}
			if (rcWindow.bottom > rcWorkArea.bottom)
			{
				rcWindow.top -= rcWindow.bottom - rcWorkArea.bottom;
			}
			if (rcWindow.top < rcWorkArea.top)
			{
				rcWindow.top += rcWorkArea.top - rcWindow.top;
			}
			SetWindowPos(hwnd, NULL, rcWindow.left, rcWindow.top, 0, 0, SWP_NOOWNERZORDER | SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
		}
	}
protected:
	static BOOL CALLBACK MonitorEnumProc(HMONITOR hMonitor, HDC hdcMonitor, LPRECT lprcMonitor, LPARAM dwData)
	{
		DesktopWorkArea * pthis = (DesktopWorkArea *) dwData;
		if (pthis)
		{
			return pthis->MonitorEnumProcSub(hMonitor, hdcMonitor, lprcMonitor);
		}
		return TRUE;
	}
	BOOL MonitorEnumProcSub(HMONITOR hMonitor, HDC hdcMonitor, LPRECT lprcMonitor)
	{
		MONITORINFO info;
		WorkArea area;

		ZeroMemory(&info, sizeof(MONITORINFO));
		info.cbSize = sizeof(MONITORINFO);
		if (GetMonitorInfo(hMonitor, &info))
		{
			area.rcWorkArea = info.rcWork;
		}
		else
		{
			area.rcWorkArea = *lprcMonitor;
		}

		area.rcScreen = *lprcMonitor;
		list.push_back(area);
		return TRUE;
	}

	WorkAreaList list;
};
