//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  Xg[obt@W[ wb_[t@C  for  NVLibraryBase                           //
//  NVStreamBuffer.h                                                                            //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



#pragma once




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//

#include "VCOM.h"


#ifdef __cplusplus
extern "C" {
#endif

#pragma pack(push, 1)





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  NX̒`
//


//  NXʎq
#define NVSTREAMBUFFER_FOURCC MAKEFOURCC('V', 'S', 'T', 'B')


/*  INVSTREAMBUFFER NXWXg (VCOM.ini ւ̋Lq)
[VSTB]

Class_ID = "VSTB"
Module_Name = "NVLibCore.dll"
Entry_Point = "CreateInstance_NVStreamBuffer"
*/


class Class_NVStreamBuffer;
typedef Class_NVStreamBuffer * INVSTREAMBUFFER;
typedef const Class_NVStreamBuffer * CINVSTREAMBUFFER;
typedef INVSTREAMBUFFER * LPINVSTREAMBUFFER;
typedef const INVSTREAMBUFFER * LPCINVSTREAMBUFFER;


//  INVSTREAMBUFFER ̏f[^
struct NVSTREAMBUFFERCREATE		//  nvsbc
{
	DWORD dwFourCC;				//  NXʎq
	DWORD dwObjSize;			//  \̂̃TCY
	DWORD dwFlag;				//  tO@݂̂ƂAtO͉`ĂȂBKB
	DWORD dwBufferSize;			//  vobt@̃TCY
};
typedef NVSTREAMBUFFERCREATE * LPNVSTREAMBUFFERCREATE;
typedef const NVSTREAMBUFFERCREATE * LPCNVSTREAMBUFFERCREATE;


//  INVSTREAMBUFFER ̕ێf[^
struct NVSTREAMBUFFERDATA		//  nvsbd
{
	LPBYTE lpBuf;				//  obt@̃|C^
	LONG lStartOffset;			//  Lf[^̊Jnʒuiǂݍ݈ʒuj
	LONG lEndOffset;			//  Lf[^̏Iʒui݈ʒuj
	LONG lBufferSize;			//  obt@̃TCY
	LONG lRestSize;				//  obt@̎cTCY
	CRITICAL_SECTION crsec;		//  }`Xbh̃G[pNeBJZNV
};
typedef NVSTREAMBUFFERDATA * LPNVSTREAMBUFFERDATA;
typedef const NVSTREAMBUFFERDATA * LPCNVSTREAMBUFFERDATA;




//  INVSTREAMBUFFER NX̒`
class NVLIBCORE_CLASS_EXPORT Class_NVStreamBuffer : virtual public Class_VCOM
{
	public:

		Class_NVStreamBuffer(void);
		//  ftHgRXgN^
		//
		//  SetCoreData() ĂяoāA{NXɃf[^ݒ肷B

	VCOM_CLASSMETHOD
		~Class_NVStreamBuffer(void);
		//  fXgN^
		//

	VCOM_CLASSMETHOD
		NVRESULT Create(LPCVOID lpvParam);
		//  CX^X̏
		//
		//  CX^XɃp[^^āACX^X̃f[^(쐬)B
		//  nvcd.bIsCreated tO𗧂āAς݂`FbNs悤ɂB
		//  vꂽobt@̕mɏ߂悤ɂɂ́A
		//  Pxɓǂݏʂ̔{ȏw肷Ɨǂ
		//  ݂̂ƂAp[^̓obt@TCŶݎ󂯕tB
		//  tO̎QƂ͍sȂ

	VCOM_CLASSMETHOD
		NVRESULT ResetData(void);
		//  CX^X̃f[^Zbg
		//
		//  CX^XŗpȂǂACreate() ĂяoȌԂɖ߂B
		//  vcd.bIsCreated tOZbgAĂ Create() s悤ɂB
		//  obt@ĴŁAobt@̓e͎

	VCOM_CLASSMETHOD
		NVRESULT QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface);
		//  C^[tF[X̎擾
		//
		//  DWORD dwFourCC			擾C^[tF[X
		//  LPVOID *lpvInterface	C^[tF[Xi[|C^
		//
		//  ̃CX^X́AdwFourCC Ŏw肵^̃C^[tF[X擾B
		//  擾łC^[tF[X́ACX^XɂĈقȂ邪A
		//  CX^XNX̃X[p[NXɂNX̃C^[tF[X
		//  K擾ł悤ɎȂ΂ȂȂB
		//  ̊֐ŕʂ̃C^[tF[X擾ƁA AddRef() ŝŁA
		//  ÂC^[tF[Xɑ΂Ă Release() KvB

	VCOM_CLASSMETHOD
		NVRESULT Write(LPBYTE lpSrc, LONG lSize);
		//  obt@ւ̏
		//
		//  LPBYTE  lpSrc		ރf[^
		//  LONG lSize			ރTCY
		//
		//  obt@փf[^ށB
		//  QueryWriteSize() Ŏ擾ł鏑݉\ʂ葽ƁA֐͎s

	VCOM_CLASSMETHOD
		NVRESULT Read(LPBYTE lpDest, LONG lSize, LPLONG lplResult);
		//  obt@̓ǂݍ
		//
		//  LPBYTE lpDest		Ǎ
		//  LONG lSize			ǂݍރTCY
		//  LPLONG lplResult	ۂɓǂݍ܂ꂽTCY
		//
		//  obt@f[^ǂݍށB
		//  obt@̃f[^vʂ菭ȂĂA֐͐
		//  lplResult ɂ́Aۂɓǂݍ܂ꂽTCYԂB
		//  ǂݍ߂f[^܂Ȃꍇ́As

	VCOM_CLASSMETHOD
		NVRESULT Read1Byte(LPBYTE lpDest);
		//  obt@̂PoCgǂݍ
		//
		//  LPBYTE lpDest		Ǎ
		//
		//  obt@APoCgǂݍށB
		//  obt@󂾂ƎsB

	VCOM_CLASSMETHOD
		LONG QueryRestSize(void);
		//  obt@̃f[^̗ʂ擾
		//
		//  obt@ɃXgAꂽf[^̗ʂԂB
		//  c̗ʂ́A߂lŕԂB

	VCOM_CLASSMETHOD
		LONG QueryWriteSize(void);
		//  obt@ɏ݉\ȃTCY𓾂
		//
		//  obt@ɂƂǂꂾ߂邩擾B
		//  ̃TCYȏ Write ŏƂƁAsB

	VCOM_CLASSMETHOD
		NVRESULT ClearBuffer(void);
		//  obt@ɂ
		//

	VCOM_CLASSMETHOD
		NVRESULT WasteBytes(LPLONG lplSize);

	VCOM_CLASSMETHOD
		LONG GetBufferSize(void);

protected:
	VCOM_CLASSMETHOD
		NVRESULT AddInterface(DWORD dwFlag);
		//  C^[tF[XQƃe[uɓo^
		//
		//  DWORD dwFlag	NXCX^X̏ꍇPAȊO͂O
		//
		//  RXgN^̒ŌĂ΂AC^[tF[X|C^e[uɓo^A
		//  VIsValidInterface() ŃC^[tF[X̗L؂ł悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT DeleteInterface(void);
		//  C^[tF[XQƃe[u폜
		//
		//  DeleteInstance() ̒ŌĂ΂AC^[tF[X|C^e[u폜B

	protected:
		NVSTREAMBUFFERDATA nvsbd;	//  CX^X̕ێf[^
};

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API CreateInstance_NVStreamBuffer(LPIVCOM lpivcom);
//  CX^X̍쐬
//
//  INVSTREAMBUFFER CX^X쐬ÃC^[tF[XԂB
//  INVSTREAMBUFFER C^[tF[X́AOobt@ȈՓo͋@\łB
//  obt@ɏ܂ꂽf[^́A܂ꂽɓǂݏoB
//  NeBJZNVŕی삵Ă̂ŁAقȂXbhԂœo͂sĂA
//  f[^͕̐ۏ؂B


inline void SetNVStreamBufferCreate(LPNVSTREAMBUFFERCREATE lpnvsbc, DWORD dwFlag, DWORD dwBufferSize);
//  NVSTREAMBUFFERCREATE \̏֐
//
//  LPNVSTREAMBUFFERCREATE lpnvsbc		\
//  DWORD dwFlag						ZbgtO
//  DWORD dwBufferSize					vobt@̃TCY


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  CC֐̒`
//

inline void SetNVStreamBufferCreate(LPNVSTREAMBUFFERCREATE lpnvsbc, DWORD dwFlag, DWORD dwBufferSize)
{
//  NVSTREAMBUFFERCREATE \̏֐
	lpnvsbc->dwFourCC = NVSTREAMBUFFER_FOURCC;
	lpnvsbc->dwObjSize = sizeof(NVSTREAMBUFFERCREATE);
	lpnvsbc->dwFlag = dwFlag;
	lpnvsbc->dwBufferSize = dwBufferSize;

	return;
}



#pragma pack(pop)

#ifdef __cplusplus
}
#endif
