//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  {NX  \[Xt@C  for  NVLibraryCore                                              //
//  VCOM.cpp                                                                                    //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////




//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  NVLibrary Œ񋟂邷ׂẴIuWFNg̊{NXB                                    //
//  {ۊ{NXɂׂAepNX̃Cvg̎QlɂȂ悤A              //
//  ev[gIȓẽoĂB                                                //
//  ׂĂ̌pNX́AŎꂽC^[tF[XdlɊÂāA                        //
//  Ȃ΂ȂȂB                                                                  //
//  RXgN^A Create() CreateInstance() ֐A                                     //
//  virtual Ő錾Ă鉼z֐́AepNXŃI[o[ChȂ΂ȂȂB        //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "VCOM.h"
#include "NVMemory.h"
#include "NVCommon.h"



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  X^eBbNϐ̒`
//

#define OPTION_DELIMITA TEXT(" \n\r\t,")

static VCOMCOREDATA vccd;		//  VCOM I[g[VT[rX̕ێf[^

extern HINSTANCE hinstNVLibCore;				//  DLL W[̃CX^Xnh

DWORD dwVCOMCPUType = (DWORD) -1;




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  o֐̐錾  Class_VCOM
//

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API CreateInstance_VCOM(LPIVCOM lpivcom)
{
	//  CX^X̍쐬
	//  vtable Kv̂ŁAnew ZqoRŃAP[VB

	if (! lpivcom)
	{
		return NVERR_UNDEFINED;
	}

	*lpivcom = (IVCOM) new Class_VCOM;
	if (*lpivcom)
	{
		return NV_OK;
	}
	else
	{
		return NVERR_UNDEFINED;
	}
}



Class_VCOM::Class_VCOM(void)
{
	//  {NX̕ێf[^ݒ肷BRXgN^͊{NX珇ԂɌĂяôŁA
	//  ŌɌĂяo邱ƂɂȂACX^X̃IWǐ^݂̏̂cB
	//  ]ȏ̂ŃI[o[wbh邪AdldƁB
	Class_VCOM::SetCoreData((LPVOID) this, (DWORD) sizeof(Class_VCOM), VCOM_FOURCC);

	//  eNXŁAێf[^OȊOɏKvꍇ́AōsB

	//  IuWFNgbNp̃~[ebNX쐬
	vcd.hMutexLock = CreateMutex(NULL, FALSE, NULL);
	vcd.hEventLost = CreateEvent(NULL, TRUE, FALSE, NULL);
	//InitializeCriticalSection(&vcd.cr);

	vcd.ivcom = this;
	//  QƃJEgCNg
	Class_VCOM::AddRef();

	return;
}


Class_VCOM::~Class_VCOM(void)
{
	//  Release oRȊOĂяoƁAvcd.bIsCreated  TRUE ł邱ƂB
	//  ̏ꍇAȉsĂȂ͂Ȃ̂ŁAASSERT B
	assert(! vcd.bIsCreated);

	return;
}


NVRESULT Class_VCOM::Create(LPCVOID lpvParam)
{
	//  eNXŕKvȏLqB
	//  AP[VAt@Cǂ݂Ńf[^ƂĕێȂǁB
	//  ȉ́AʓIȎ菇

	//  IWǐ^ɃLXg
	LPCVCOMCREATE lpcvcc = (LPCVCOMCREATE) lpvParam;

	//  ς݃IuWFNgłȂǂ`FbN
	if (vcd.bIsCreated)
	{
		//  ς݂̏ꍇAG[ɂB
		return VCOMERR_ALREADYUSED;
	}

	//  ̐`FbN
	{
		//  NX̎ʎqƈ̎ʎqr
		if (lpcvcc->dwFourCC != VCOM_FOURCC)
		{
			//  ԈႦĂ
			return VCOMERR_INVALIDPARAMTYPE;
		}

		//  ̃TCY`FbN
		if (lpcvcc->dwObjSize != sizeof(VCOMCREATE))
		{
			//  ɓnꂽ\̂̃TCYĂ
			return VCOMERR_INVALIDPARAMSIZE;
		}
	}

	//  ̃`FbNIAۂɈ̓eɉďsB
	{
		//  ̒lQƂāAsB
	}

	//  ɐꍇAς݃tO𗧂Ă
	vcd.bIsCreated = TRUE;

	return NV_OK;
}


NVRESULT Class_VCOM::ResetData(void)
{
	//  ŊeCX^XŊmۂ̉nh̉ȂǂsA
	//  Create() ȌԂɖ߂B
	//  ̊֐́ApNX̃\bhɌĂяoĂKvB

	//  ς݃tONA
	vcd.bIsCreated = FALSE;

	return NV_OK;
}


NVRESULT Class_VCOM::QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface)
{
//  C^[tF[X̎擾

	//  dwFourCC ɂāAKȌ^̃C^[tF[XԂB
	//  ǧ^̃C^[tF[X̍쐬ȊÓAeNX̃\bhĂԂƂŉƗǂƎvB

	if (dwFourCC == VCOM_FOURCC)
	{
		//  ̃NX̃C^[tF[X擾Ȃ̂ŁAԂli[AAddRef() ƂɐIB
		*lpvInterface = (IVCOM) this;
		AddRef();
		return NV_OK;
	}
	else
	{
		//  eNXȂ̂ŁAG[ƂB
		*lpvInterface = NULL;
		return VCOMERR_UNKNOWNFOURCC;
	}
}


NVRESULT Class_VCOM::AddInterface(DWORD dwFlag)
{
//  C^[tF[XQƃe[uɓo^

	//  CX^Xɑ΂ŏ̂P̌Ăяoł́A
	//  dwFlag ɂ VCOM_CLASSINTERFACE ĂB
	//  ȍ~̌Ăяoł́AOĂB
	VAddInterface(this, (IVCOM) this, VCOM_FOURCC, dwFlag);

	//  eNX̃\bhɈp
	//  ̂ƂAdwFlag ɂ Ow肷B
	return NV_OK;
}


NVRESULT Class_VCOM::DeleteInterface(void)
{
//  C^[tF[XQƃe[u폜

	VDeleteInterface(this);

	//  eNX̃\bhɈp
	return NV_OK;
}



LONG Class_VCOM::AddRef(void)
{
	//  QƃJEgCNgAʂ̒lԂB
	return InterlockedIncrement(&vcd.lRefCount);
}

LONG Class_VCOM::SafeAddRef(void)
{
	LONG ret = InterlockedIncrement(&vcd.lRefCount);
	if (ret >= 2)
	{
		return ret;
	}
	else
	{
		InterlockedDecrement(&vcd.lRefCount);
		return 0;
	}
}

LONG Class_VCOM::Release(void)
{
	//  QƃJEgfNgAOɂȂCX^X̔jsB
	//  IWĩCX^Xւ̃|C^ێĂ̂ŁAjB
	//  ResetData() ͉z֐Œ񋟂ADeleteInstance ̓IWǐ^ɈˑȂ߁A
	//  {NXŒP̊֐ƂĒ񋟂邱ƂoB

	if (InterlockedDecrement(&vcd.lRefCount) == 0)
	{
		NVRESULT nvres;

		nvres = NVSafeLock(this);
		while (nvres == VCOMERR_VALUE_CANTLOCKOBJECT)
		{
			Sleep(1);
			nvres = NVSafeLock(this);
		}

		if (nvres)
		{
			return vcd.lRefCount;
		}

		ResetData();
//		NVSafeUnLock(this);
		Class_VCOM::DeleteInstance();
		delete this;
		return 0;
	}
	else
	{
		return vcd.lRefCount;
	}
}


LONG Class_VCOM::GetRefCount(void)
{
	//  QƃJEgԂB
	return vcd.lRefCount;
}



void Class_VCOM::DeleteInstance(void)
{
	//  ResetData() ͂łɌĂ΂Ă̂ƂāACX^X̂ݔjB
	HANDLE hMutexLock;
	HANDLE hEventLost;
	LPVOID lpvOrgPtr;
	extern CRITICAL_SECTION crSafeLock;
	BOOL ret;

	//  C^[tF[Xe[u폜
	DeleteInterface();

	EnterCriticalSection(&crSafeLock);

	hEventLost = vcd.hEventLost;
	hMutexLock = vcd.hMutexLock;
	lpvOrgPtr = vcd.lpvOrgPtr;
//	if (vcd.lRecursionCount > 1)
	{
		//  Release()  P Lock Ă͂
//		NVOutputDebugString("\nDeleteInstance_VCOM has detected that this object is still locked !!\n\n");
	}
	//  ȎQƂh߂Ƀ̈NAĂ
	ZeroMemory(&vcd, sizeof(VCOMDATA));

	//  XgCxg𑗂āÃXbh Lock ҂Ȃ悤ɂ
	//  ꂪȂƁA ReleaseMutex  CloseHandle ̊Ԃ ̃Xbh  Lock ҂NĂ܂B
	SetEvent(hEventLost);
	//  Release() ŃbNAbN
	do
	{
		ret = ReleaseMutex(hMutexLock);
	} while (ret);

	//  Ń~[ebNXj
	CloseHandle(hMutexLock);
	CloseHandle(hEventLost);
/*	//  ŃNeBJZNVj
	if (vcd.cr.LockSemaphore)
	{
		DeleteCriticalSection(&vcd.cr);
	}
	ZeroMemory(&vcd.cr, sizeof(CRITICAL_SECTION));
*/
	LeaveCriticalSection(&crSafeLock);

	return;
}


LPVOID Class_VCOM::operator new(size_t stAllocateBlock)
{
	//  NVMem֐ŃAP[VÃ|C^ԂB
	return (LPVOID) NVMemAlloc(NVMEM_FIXED | NVMEM_ZEROINIT, (DWORD) stAllocateBlock);
}


void Class_VCOM::operator delete(LPVOID lpv)
{
	//  j
	if (NVMemFree(lpv))
	{
		//  ̔jɎsB
		NVOutputDebugString(TEXT("\nDeleteInstance_VCOM is failed in NVMemFree!!\nAllocated memory for VCOM_Instance is still alive!!\nIt may happen Memory Leak!!\n\n"));
	}

	return;
}


DWORD Class_VCOM::GetFourCC(void)
{
	//  NX̎ʃR[hԂB
	//  IWĩCX^X̂̂ԂB

	return vcd.dwFourCC;
}

BOOL Class_VCOM::IsCreated(void)
{
	//  tOԂ
	return vcd.bIsCreated;
}

NVRESULT Class_VCOM::LockObject(void)
{
//  IuWFNg̃bN

	DWORD dwRet;
	dwRet = WaitForSingleObject(vcd.hMutexLock, INFINITE);

	if (dwRet != WAIT_OBJECT_0)
	{
		return NVERR_UNDEFINED;
	}

	//vcd.lRecursionCount++;
	return NV_OK;
}

NVRESULT Class_VCOM::TryLockObject(void)
{
//  IuWFNg̃bN
	DWORD dwRet;

	dwRet = WaitForSingleObject(vcd.hMutexLock, 0);

	switch (dwRet)
	{
	case WAIT_OBJECT_0:
#ifdef NVSAFELOCK_DEADLOCK_ASSERT
		vcd.dwLockingThread = GetCurrentThreadId();
		vcd.lRecursionCount++;
#endif
		return NV_OK;
	case WAIT_TIMEOUT:
		return VCOMERR_VALUE_CANTLOCKOBJECT;
	default:
		return NVERR_UNDEFINED;
	}
}

NVRESULT Class_VCOM::UnLockObject(void)
{
//  IuWFNg̃AbN
//	DWORD dwRet;
//	dwRet = WaitForSingleObject(vcd.hMutexLock, INFINITE);
//	if (dwRet == WAIT_OBJECT_0)
	{
//		vcd.lRecursionCount--;
		//if (vcd.lRecursionCount <= 0)
		{
//			ReleaseMutex(vcd.hMutexLock);
#ifdef NVSAFELOCK_DEADLOCK_ASSERT
		if (ReleaseMutex(vcd.hMutexLock))
		{
			vcd.lRecursionCount--;
			if (vcd.lRecursionCount <= 0)
			{
				vcd.dwLockingThread = 0;
			}
		}
#else
		ReleaseMutex(vcd.hMutexLock);
#endif
		}
		return NV_OK;
	}
//	else
	{
//		return NVERR_UNDEFINED;
	}
}


void Class_VCOM::SetCoreData(LPVOID lpvOrgPtr, DWORD dwObjSize, DWORD dwFourCC)
{
	//  NX̎ʏȂǂ{NX̕ێf[^Ɋi[B
	vcd.lpvOrgPtr = lpvOrgPtr;		//  IWĩCX^Xւ̃|C^
	vcd.dwObjSize = dwObjSize;		//  CX^X̃TCY
	vcd.dwFourCC = dwFourCC;		//  CX^X̎ʃR[h
	return;
}


LONG Class_VCOM::DecRef(void)
{
	//  QƃJEgfNgāAʂԂB
	InterlockedDecrement(&vcd.lRefCount);
	return vcd.lRefCount;
}




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  VCOM I[g[VT[rX֐
//


NVRESULT VCOM_Prepare(void)
{
//  VCOM I[g[VT[rX̏
	if (vccd.lpvml)
	{
		//  łɏς݂ȂG[
		return NVERR_UNDEFINED;
	}

	BOOL bOK = FALSE;
	WIN32_FIND_DATA ffd;
	HANDLE hffd;

	InitializeCriticalSection(&vccd.cr);

	EnterCriticalSection(&vccd.cr);

	{
		TCHAR lpszModuleFileName[NV_PATHMAX] = TEXT("");
		LPTSTR lpszFileName;

		if (GetModuleFileName(hinstNVLibCore, lpszModuleFileName, NV_PATHMAX))
		{
			//  ŏ́ANVLibCore.dll Ɠɂ VCOM fBNg VCOM ̊fBNg
			GetFullPathName(lpszModuleFileName, NV_PATHMAX, vccd.lpszVCOMDirectory, &lpszFileName);
			*lpszFileName = TEXT('\0');
			PathAppend(vccd.lpszVCOMDirectory, TEXT("VCOM\\"));
			//PathAddBackslash(vccd.lpszVCOMDirectory);
			_tcscpy_s(vccd.lpszVCOMIniFileName, NV_PATHMAX, vccd.lpszVCOMDirectory);
			PathAppend(vccd.lpszVCOMIniFileName, TEXT("VCOM.cfg"));

			//  VCOM.ini 
			hffd = NVFindFirstFile(vccd.lpszVCOMIniFileName, &ffd);
			if (hffd != NULL && hffd != INVALID_HANDLE_VALUE)
			{
				bOK = TRUE;
				NVFindClose(hffd);
				NVOutputDebugString(TEXT("Module Path Getting : \""));
				NVOutputDebugString(vccd.lpszVCOMDirectory);
				NVOutputDebugString(TEXT("\"\n"));
			}
		}
	}

	if (! bOK)
	{
		TCHAR lpszModuleFileName[NV_PATHMAX] = TEXT("");
		LPTSTR lpszFileName;

		if (GetModuleFileName(hinstNVLibCore, lpszModuleFileName, NV_PATHMAX))
		{
			//  QԖڂɁANVLibCore ̃fBNg VCOM ̊fBNg
			GetFullPathName(lpszModuleFileName, NV_PATHMAX, vccd.lpszVCOMDirectory, &lpszFileName);
			*lpszFileName = TEXT('\0');
			//PathAddBackslash(vccd.lpszVCOMDirectory);
			_tcscpy_s(vccd.lpszVCOMIniFileName, NV_PATHMAX, vccd.lpszVCOMDirectory);
			PathAppend(vccd.lpszVCOMIniFileName, TEXT("VCOM.cfg"));

			//  VCOM.ini 
			hffd = NVFindFirstFile(vccd.lpszVCOMIniFileName, &ffd);
			if (hffd != NULL && hffd != INVALID_HANDLE_VALUE)
			{
				bOK = TRUE;
				NVFindClose(hffd);
				NVOutputDebugString(TEXT("Module Path Getting : \""));
				NVOutputDebugString(vccd.lpszVCOMDirectory);
				NVOutputDebugString(TEXT("\"\n"));
			}
		}
	}

	if (! bOK)
	{
		TCHAR lpszProgramFileName[NV_PATHMAX];
		LPTSTR lpszFileName;

		//  AvP[VvO擾AtpX擾A
		//  vÕfBNg擾
		GetModuleFileName(NULL, lpszProgramFileName, NV_PATHMAX);
		GetFullPathName(lpszProgramFileName, NV_PATHMAX, vccd.lpszVCOMDirectory, &lpszFileName);
		*(lpszFileName) = TEXT('\0');
		//  Ƃ肠AvÕfBNg VCOM ̊fBNg
		//PathAddBackslash(vccd.lpszVCOMDirectory);
		_tcscpy_s(vccd.lpszVCOMIniFileName, NV_PATHMAX, vccd.lpszVCOMDirectory);
		PathAppend(vccd.lpszVCOMIniFileName, TEXT("VCOM.cfg"));
		//  VCOM.ini 
		hffd = NVFindFirstFile(vccd.lpszVCOMIniFileName, &ffd);
		if (hffd != NULL && hffd != INVALID_HANDLE_VALUE)
		{
			bOK = TRUE;
			NVFindClose(hffd);
			NVOutputDebugString(TEXT("Execution Path Getting : \""));
			NVOutputDebugString(vccd.lpszVCOMDirectory);
			NVOutputDebugString(TEXT("\"\n"));
		}
	}

	if (! bOK)
	{
		//  Ȃ΁AfBNg Windows ̃VXefBNg (95/98 : windows\system  NT/2k : windows\system32) ɂ
		GetSystemDirectory(vccd.lpszVCOMDirectory, NV_PATHMAX);
		PathAddBackslash(vccd.lpszVCOMDirectory);
		_tcscpy_s(vccd.lpszVCOMIniFileName, NV_PATHMAX, vccd.lpszVCOMDirectory);
		PathAppend(vccd.lpszVCOMIniFileName, TEXT("VCOM.cfg"));

		//  VCOM.ini 
		hffd = NVFindFirstFile(vccd.lpszVCOMIniFileName, &ffd);
		if (hffd != NULL && hffd != INVALID_HANDLE_VALUE)
		{
			bOK = TRUE;
			NVFindClose(hffd);
			NVOutputDebugString(TEXT("System Path Getting : \""));
			NVOutputDebugString(vccd.lpszVCOMDirectory);
			NVOutputDebugString(TEXT("\"\n"));
		}
	}

	if (! bOK)
	{
		LeaveCriticalSection(&vccd.cr);
		return NVERR_UNDEFINED;
	}

	//  NXe[uAW[e[u𐶐
	vccd.lpvml = new VCOMMODULELIST;
	vccd.lpvcl = new VCOMCLASSLIST;
	vccd.lpvit = new VCOMINTERFACETABLE;

	{
		LPTSTR pContext = NULL;
		TCHAR szBuf[1024];
		const DWORD dwCPUFlagMax = 6;
		const TCHAR *lpszFlag[dwCPUFlagMax] = { TEXT("MMX"), TEXT("SSE"), TEXT("SSE2"), TEXT("SSE3"), TEXT("3DNOW"), TEXT("E3DNOW"), };
		const DWORD lpdwFlag[dwCPUFlagMax] = { CPUTYPE_MMX, CPUTYPE_SSE, CPUTYPE_SSE2, CPUTYPE_SSE3, CPUTYPE_3DNOW, CPUTYPE_E3DNOW, };
		DWORD i;
		DWORD dwCurCPUType = NVGetCPUType(NULL, 0, NULL);
		LPTSTR lpszCur = szBuf;
		DWORD dwCPUFlag = 0;
		szBuf[0] = TEXT('\0');
		GetPrivateProfileString(TEXT("Preference"), TEXT("ForceCPUType"), TEXT("NONE"), szBuf, 1024, vccd.lpszVCOMIniFileName);

		lpszCur = _tcstok_s(szBuf, OPTION_DELIMITA, &pContext);

		while (lpszCur != NULL)
		{
			if (_tcsicmp(lpszCur, TEXT("x86")) == 0)
			{
				dwCPUFlag = 0;
				break;
			}
			for (i = 0; i < dwCPUFlagMax; i++)
			{
				if (_tcsicmp(lpszCur, lpszFlag[i]) == 0)
				{
					dwCPUFlag |= lpdwFlag[i];
					break;
				}
			}
			if (i >= dwCPUFlagMax)
			{
				dwCPUFlag = dwCurCPUType;
				break;
			}
			lpszCur = _tcstok_s(NULL, OPTION_DELIMITA, &pContext);
		}

		if (dwCPUFlag != dwCurCPUType)
		{
			_stprintf_s(szBuf, 1024, TEXT("CPUType Override : %08X\n"), dwCPUFlag);
			OutputDebugString(szBuf);
			dwVCOMCPUType = dwCPUFlag;
		}
	}

	{
		//  SGgǂ
		TCHAR lpszClassID[16];
		TCHAR lpszModuleName[NV_PATHMAX];
		VCOMCLASSDATA vclass;

		LPTSTR lpszEntryTable;
		LPTSTR lpszCur;

		DWORD ret;

		lpszEntryTable = (LPTSTR) NVMemAlloc(NVMEM_FIXED | NVMEM_ZEROINIT, 65536);
		GetPrivateProfileString(NULL, NULL, TEXT("Preference"), lpszEntryTable, 65535, vccd.lpszVCOMIniFileName);

		lpszCur = lpszEntryTable;
		while (*((LPWORD) lpszCur))
		{
			do
			{
				if (_tcslen(lpszCur) != 4)
				{
					break;;
				}
				ret = GetPrivateProfileString(lpszCur, TEXT("CLASS_ID"), TEXT("NOTFOUND"), lpszClassID, 16, vccd.lpszVCOMIniFileName);
				if (ret != 4)
				{
					//  GgȂ΃G[
					break;
				}
				if (_tcscmp(lpszCur, lpszClassID) != 0)
				{
					//  Class_ID vȂ΃G[
					break;
				}

				ret = GetPrivateProfileString(lpszCur, TEXT("MODULE_NAME"), TEXT("NOTFOUND"), lpszModuleName, NV_PATHMAX, vccd.lpszVCOMIniFileName);
				if (! _tcsicmp(lpszModuleName, TEXT("NOTFOUND")))
				{
					//  W[Ȃ΃G[
					break;
				}

				//  tpXł邩ǂׂ
				if (lpszModuleName[0] == TEXT('\\'))
				{
					if (lpszModuleName[1] == TEXT('\\'))
					{
						//  lbg[NpX
						_tcscpy_s(vclass.lpszModuleName, NV_PATHMAX, lpszModuleName);
					}
					else
					{
						//  PڂȂAhCuȗtpX
						//  hCu₤
						vclass.lpszModuleName[0] = vccd.lpszVCOMDirectory[0];
						vclass.lpszModuleName[1] = vccd.lpszVCOMDirectory[1];
						_tcscpy_s(vclass.lpszModuleName + 2, NV_PATHMAX - 2, lpszModuleName);
					}
				}
				else if (lpszModuleName[1] == ':')
				{
					//  QڂFȂAtpXB̂܂܃Rs[
					_tcscpy_s(vclass.lpszModuleName, NV_PATHMAX, lpszModuleName);
				}
				else
				{
					//  tpXłȂ΁AfBNg𓪂ɂ
					_stprintf_s(vclass.lpszModuleName, NV_PATHMAX, TEXT("%s%s"), vccd.lpszVCOMDirectory, lpszModuleName);
				}

				ret = GetPrivateProfileString(lpszCur, TEXT("ENTRY_POINT"), TEXT("NOTFOUND"), vclass.lpszEntryPoint, NV_PATHMAX, vccd.lpszVCOMIniFileName);
				if (! _tcsicmp(vclass.lpszEntryPoint, TEXT("NOTFOUND")))
				{
					break;
				}

				vclass.dwFourCC = NVStringToFourCC(lpszCur);
				vclass.hModule = NULL;
				vclass.CreateInstance = NULL;

				vccd.lpvcl->insert(std::make_pair(vclass.dwFourCC, vclass));
			} while (0);
			lpszCur += _tcslen(lpszCur) + 1;
		}

		NVMemFree(lpszEntryTable);

	}

	LeaveCriticalSection(&vccd.cr);
	return NV_OK;
}



NVRESULT VCOM_UnPrepare(void)
{
//  VCOM I[g[VT[rX̉
	EnterCriticalSection(&vccd.cr);
	if (! vccd.lpvml)
	{
		LeaveCriticalSection(&vccd.cr);
		//  ĂȂ̂ŁAG[
		return NVERR_UNDEFINED;
	}

	{
		VCOMMODULELIST::iterator it;

		//  W[e[uS擾AׂẴW[A[h
		for (it = vccd.lpvml->begin(); it != vccd.lpvml->end(); it++)
		{
			FreeLibrary((*it).second);
		}
	}

	//  e[u
	delete vccd.lpvml;
	delete vccd.lpvcl;
	if (vccd.lpvit->size())
	{
		//  ŉĂȂIuWFNgxo͂

		TCHAR lpstr[256];
		TCHAR szFourCC[5];
		_stprintf_s(lpstr, 256, TEXT("VCOM UnPrepare : Error !!  Some Objects was still Used !!\n"));
		NVOutputDebugString(lpstr);

		VCOMINTERFACETABLE::iterator it;
		for (it = vccd.lpvit->begin(); it != vccd.lpvit->end(); it++)
		{
			if ((*it).second.dwFlag & VCOM_CLASSINTERFACE)
			{
				//  ĂȂIuWFNg̃NXCX^Xo
				NVFourCCToString((*it).second.dwFourCC, szFourCC, 5);
				_stprintf_s(lpstr, 256, TEXT("VCOM UnPrepare : Object %s 0x%X was still Used !!\n"), szFourCC, (*it).second.lpvInterface);
				NVOutputDebugString(lpstr);
			}
		}
	}
	delete vccd.lpvit;

	LeaveCriticalSection(&vccd.cr);
	if (vccd.cr.LockSemaphore)
	{
		DeleteCriticalSection(&vccd.cr);
	}
	//  f[^OZbg
	ZeroMemory(&vccd, sizeof(VCOMCOREDATA));

	return NV_OK;
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VReportObjectLeak(LPCTSTR lpcszFileName)
{
	EnterCriticalSection(&vccd.cr);
	if (vccd.lpvit && vccd.lpvit->size())
	{
		//  ŉĂȂIuWFNgo͂

		TCHAR szFourCC[5];
		FILE *fp = NVOpenDebugLogFile(lpcszFileName, TEXT("w"));
		if (! fp)
		{
			LeaveCriticalSection(&vccd.cr);
			return NVERR_UNDEFINED;
		}
		LONG lCount = 0;

		_ftprintf(fp, TEXT("VCOM UnPrepare : Error !!  Some Objects was still Used !!\n"));

		VCOMINTERFACETABLE::iterator it;
		for (it = vccd.lpvit->begin(); it != vccd.lpvit->end(); it++)
		{
			if ((*it).second.dwFlag & VCOM_CLASSINTERFACE)
			{
				//  ĂȂIuWFNg̃NXCX^Xo
				NVFourCCToString((*it).second.dwFourCC, szFourCC, 5);
				_ftprintf(fp, TEXT("VCOM ReportObjectLeak : Object %s 0x%08IX was still Used !!\n"), szFourCC, (*it).second.lpvInterface);
				lCount++;
			}
		}

		_ftprintf(fp, TEXT("\nTotal Counts : %d\n"), lCount);
		fclose(fp);
	}

	LeaveCriticalSection(&vccd.cr);
	return NV_OK;
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VEntryClass(DWORD dwFourCC, LPTSTR lpszModuleFileName, LPTSTR lpszEntryPoint)
{
	if (dwFourCC == 0)
	{
		return NVERR_UNDEFINED;
	}
	EnterCriticalSection(&vccd.cr);

	if (vccd.lpvcl->find(dwFourCC) != vccd.lpvcl->end())
	{
		LeaveCriticalSection(&vccd.cr);
		return NVERR_UNDEFINED;
	}

	{
		VCOMCLASSDATA vclass;

		vclass.dwFourCC = dwFourCC;
		vclass.hModule = NULL;
		_tcscpy_s(vclass.lpszModuleName, NV_PATHMAX, lpszModuleFileName);
		_tcscpy_s(vclass.lpszEntryPoint, NV_PATHMAX, lpszEntryPoint);
		vclass.CreateInstance = NULL;

		vccd.lpvcl->insert(std::make_pair(vclass.dwFourCC, vclass));
	}

	LeaveCriticalSection(&vccd.cr);
	return NV_OK;
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VDeleteClass(DWORD dwFourCC)
{
	EnterCriticalSection(&vccd.cr);

	VCOMCLASSLIST::iterator it;

	it = vccd.lpvcl->find(dwFourCC);
	if (it == vccd.lpvcl->end())
	{
		LeaveCriticalSection(&vccd.cr);
		return NVERR_UNDEFINED;
	}
	else
	{
		vccd.lpvcl->erase(it);
	}

	LeaveCriticalSection(&vccd.cr);
	return NV_OK;
}



NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VCreateInstance(DWORD dwInstanceFourCC, DWORD dwInterfaceFourCC, LPVOID *lplpvInterface)
{
	//  CX^X̍쐬
	
	NVRESULT nvres;
	VCOMCLASSLIST::iterator it;
	IVCOM ivcom = NULL;
	
	EnterCriticalSection(&vccd.cr);
	//  NXe[uAߋɃCX^X쐬ĂȂׂ
	it = vccd.lpvcl->find(dwInstanceFourCC);
	
	try
	{
		if (it == vccd.lpvcl->end())
		{
			throw NVERR_UNDEFINED;
		}
		else
		{
			//  ߂ẴCX^X쐬̏ꍇ̏
			//  NX擾AKvȃW[̃[hƃGg|Cg̎擾s
			
			WIN32_FIND_DATA ffd;
			HANDLE hffd;
			HINSTANCE hModule;
			VCOMMODULELIST::iterator itvml;

			if ((*it).second.CreateInstance == NULL)
			{
				//  W[ŃW[e[u
				itvml = vccd.lpvml->find((*it).second.lpszModuleName);
				
				if (itvml == vccd.lpvml->end())
				{
					//  Ȃ΁A܂[hĂȂ̂ŁA[h
					
					//  W[t@C݂邩ǂmF
					hffd = NVFindFirstFile((*it).second.lpszModuleName, &ffd);
					if (hffd == NULL || hffd == INVALID_HANDLE_VALUE)
					{
						//  Ȃ΃G[
						throw NVERR_UNDEFINED;
					}
					else
					{
						NVFindClose(hffd);
					}

					{
						LPCTSTR lpszCur;
						TCHAR szFourCC[5];
						TCHAR szDependence[4096];
						TCHAR szModule[NV_PATHMAX];
						szDependence[0] = TEXT('\0');
						NVFourCCToString((*it).second.dwFourCC, szFourCC, 5);
						GetPrivateProfileString(szFourCC, TEXT("DEPENDENCE"), TEXT(""), szDependence, NV_PATHMAX, vccd.lpszVCOMIniFileName);
						lpszCur = szDependence;
						szModule[0] = TEXT('\0');
						lpszCur = NVGetCommandOption(lpszCur, szModule, NV_PATHMAX);
						while (lpszCur && szModule[0])
						{
							HMODULE hModule;
							VLoadLibraryByFileName(szModule, &hModule);
							lpszCur = NVGetCommandOption(lpszCur, szModule, NV_PATHMAX);
						}
					}
					//  W[[h
					hModule = LoadLibrary((*it).second.lpszModuleName);
					
					if (! hModule)
					{
						//  [hɎsAG[
						throw NVERR_UNDEFINED;
					}
					
					//  [hɐAW[e[uɒǉ
					vccd.lpvml->insert(std::make_pair((*it).second.lpszModuleName, hModule));
				}
				else
				{
					//  e[u猩΁AłɃ[hς
					//  e[u烂W[nh擾
					hModule = (*itvml).second;
				}

				(*it).second.hModule = hModule;

				//  W[AGg|Cg̃AhX擾
#ifdef _UNICODE
				{
					int len = ((int) _tcslen(it->second.lpszEntryPoint) + 1) * sizeof(TCHAR);
					LPSTR pszTemp = new CHAR[len];
					pszTemp[0] = '\0';
					WideCharToMultiByte(CP_ACP, 0, it->second.lpszEntryPoint, -1, pszTemp, len, NULL, NULL);
					(*it).second.CreateInstance = (VCOM_CREATEINSTANCEPROC) GetProcAddress(hModule, pszTemp);
					delete [] pszTemp;
				}
#else
				(*it).second.CreateInstance = (VCOM_CREATEINSTANCEPROC) GetProcAddress(hModule, (*it).second.lpszEntryPoint);
#endif
				if (! (*it).second.CreateInstance)
				{
					//  擾łȂ΁AG[
					throw NVERR_UNDEFINED;
				}
			}
			
			//  Gg|CgĂяo
			nvres = (*it).second.CreateInstance(&ivcom);
			if (nvres)
			{
				throw nvres;
			}

			//  C^[tF[Xe[uɓo^
			ivcom->AddInterface(VCOM_CLASSINTERFACE);
			
			//  ]̃C^[tF[X擾
			nvres = ivcom->QueryInterface(dwInterfaceFourCC, lplpvInterface);
			if (nvres)
			{
				throw nvres;
			}
			
			//  AÂC^[tF[X
			ivcom->Release();
		}
	}
	catch (NVRESULT nvres)
	{
		//  G[Nꍇ̏
		//  fobOrĥƂAt@CƃNXo
#ifdef _DEBUG
		TCHAR szFourCC[5];
		TCHAR lpszErrorMessage[512];
		
		//  NXʎq𕶎ɕϊ
		NVFourCCToString(dwInstanceFourCC, szFourCC, 5);
		_stprintf_s(lpszErrorMessage, 512, TEXT("\nVCOM : CreateInstance Fatal Error!! \nCan'n find \"%s\" ClassData from \"%s\".\n\n"),
			szFourCC, vccd.lpszVCOMIniFileName);
		NVOutputDebugString(lpszErrorMessage);
#endif
		if (ivcom)
		{
			ivcom->Release();
		}
		
		//  ̃[XłANULL|C^Ԃ
		*lplpvInterface = NULL;
		LeaveCriticalSection(&vccd.cr);
		return nvres;
	}

	LeaveCriticalSection(&vccd.cr);
	return NV_OK;
}



NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VAddInterface(LPVOID lpvInterface, IVCOM ivcom, DWORD dwFourCC, DWORD dwFlag)
{
//  C^[tF[Xe[uɓo^
	VCOMINTERFACETABLE::iterator it;

	//  łɓo^Ă邩`FbN
	EnterCriticalSection(&vccd.cr);
	it = vccd.lpvit->find((LPBYTE) lpvInterface);
	if (it != vccd.lpvit->end())
	{
		LeaveCriticalSection(&vccd.cr);
		//  o^Ă΃G[
		return NVERR_UNDEFINED;
	}

	{
		//  C^[tF[X̃f[^o^
		VCOMINTERFACEDATA vid;

		vid.lpvInterface = lpvInterface;
		vid.ivcom = ivcom;
		vid.dwFourCC = dwFourCC;
		vid.dwFlag = dwFlag;

		vccd.lpvit->insert(std::make_pair(lpvInterface, vid));
	}

	LeaveCriticalSection(&vccd.cr);

	return NV_OK;
}


NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VDeleteInterface(LPVOID lpvInterface)
{
//  C^[tF[Xe[u폜
	VCOMINTERFACETABLE::iterator it;

	//  łɓo^Ă邩`FbN
	EnterCriticalSection(&vccd.cr);
	it = vccd.lpvit->find(lpvInterface);
	if (it == vccd.lpvit->end())
	{
		LeaveCriticalSection(&vccd.cr);
		//  o^ĂȂ΃G[
		return NVERR_UNDEFINED;
	}

	vccd.lpvit->erase(it);

	LeaveCriticalSection(&vccd.cr);
	return NV_OK;
}

BOOL NVLIBCORE_EXPORT NVLIBCORE_API VIsValidInterface(LPVOID lpvInterface)
{
//  C^[tF[X̗LmF
	VCOMINTERFACETABLE::iterator it;

	//  łɓo^Ă邩`FbN
	EnterCriticalSection(&vccd.cr);
	it = vccd.lpvit->find(lpvInterface);
	if (it == vccd.lpvit->end())
	{
		//  o^ĂȂ΃G[
		LeaveCriticalSection(&vccd.cr);
		return FALSE;
	}

	LeaveCriticalSection(&vccd.cr);
	return TRUE;
}


DWORD NVLIBCORE_EXPORT NVLIBCORE_API VGetInterfaceFourCC(LPVOID lpvInterface)
{
//  C^[tF[X̗LmFÃNXʎqԂ
	VCOMINTERFACETABLE::iterator it;

	//  łɓo^Ă邩`FbN
	EnterCriticalSection(&vccd.cr);
	it = vccd.lpvit->find(lpvInterface);
	if (it == vccd.lpvit->end())
	{
		//  o^ĂȂ΃G[
		LeaveCriticalSection(&vccd.cr);
		return 0;
	}

	DWORD dwFourCC = (*it).second.dwFourCC;
	LeaveCriticalSection(&vccd.cr);
	return dwFourCC;
}


IVCOM NVLIBCORE_EXPORT NVLIBCORE_API VGetInterface(LPVOID lpvInterface)
{
//  C^[tF[X̗LmFASȊ{C^[tF[X (IVCOM) Ԃ
	VCOMINTERFACETABLE::iterator it;

	//  łɓo^Ă邩`FbN
	EnterCriticalSection(&vccd.cr);
	it = vccd.lpvit->find(lpvInterface);
	if (it == vccd.lpvit->end())
	{
		LeaveCriticalSection(&vccd.cr);
		//  o^ĂȂ΃G[
		return NULL;
	}

	(*it).second.ivcom->AddRef();
	IVCOM iv = (*it).second.ivcom;
	LeaveCriticalSection(&vccd.cr);
	return iv;
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VLoadLibrary(DWORD dwInstanceFourCC, HINSTANCE *lphModule)
{
	//  CX^X̍쐬
	
	VCOMCLASSLIST::iterator it;
	HINSTANCE hModule = NULL;
	
	//  NXe[uAߋɃCX^X쐬ĂȂׂ
	EnterCriticalSection(&vccd.cr);
	it = vccd.lpvcl->find(dwInstanceFourCC);
	
	try
	{
		if (it == vccd.lpvcl->end())
		{
			//  ߂ẴCX^X̏ꍇ̏
			//  NX擾AKvȃW[̃[hs
			
			DWORD ret;
			TCHAR szFourCC[5];
			TCHAR lpszClassID[16];
			TCHAR lpszModuleName[NV_PATHMAX];
			TCHAR lpszLoadName[NV_PATHMAX];
			WIN32_FIND_DATA ffd;
			HANDLE hffd;
			VCOMMODULELIST::iterator itvml;
			
			//  NXʎq𕶎ɕϊ
			NVFourCCToString(dwInstanceFourCC, szFourCC, 5);

			//  VCOM.ini ANX̃ZNV
			//  Ƃ肠ACLASS_ID L[擾
			ret = GetPrivateProfileString(szFourCC, TEXT("CLASS_ID"), TEXT("NOTFOUND"), lpszClassID, 16, vccd.lpszVCOMIniFileName);
			if (ret != 4)
			{
				//  Ȃ΃G[
				throw NVERR_UNDEFINED;
			}

			if (NVStringToFourCC(lpszClassID) != dwInstanceFourCC)
			{
				//  Class_ID  vȂ΃G[
				throw NVERR_UNDEFINED;
			}
			
			//  W[擾
			ret = GetPrivateProfileString(szFourCC, TEXT("MODULE_NAME"), TEXT("NOTFOUND"), lpszModuleName, NV_PATHMAX, vccd.lpszVCOMIniFileName);
			if (! _tcsicmp(lpszModuleName, TEXT("NOTFOUND")))
			{
				//  Ȃ΃G[
				throw NVERR_UNDEFINED;
			}
			
			//  tpXł邩ǂׂ
			if (lpszModuleName[0] == TEXT('\\'))
			{
				if (lpszModuleName[1] == TEXT('\\'))
				{
					//  lbg[NpX
					_tcscpy_s(lpszLoadName, NV_PATHMAX, lpszModuleName);
				}
				else
				{
					//  PڂȂAhCuȗtpX
					//  hCu₤
					lpszLoadName[0] = vccd.lpszVCOMDirectory[0];
					lpszLoadName[1] = vccd.lpszVCOMDirectory[1];
					_tcscpy_s(lpszLoadName + 2, NV_PATHMAX - 2, lpszModuleName);
				}
			}
			else if (lpszModuleName[1] == ':')
			{
				//  QڂFȂAtpXB̂܂܃Rs[
				_tcscpy_s(lpszLoadName, NV_PATHMAX, lpszModuleName);
			}
			else
			{
				//  tpXłȂ΁AfBNg (VCOM.cfg t@CfBNg) 𓪂ɂ
				_stprintf_s(lpszLoadName, NV_PATHMAX, TEXT("%s%s"), vccd.lpszVCOMDirectory, lpszModuleName);
			}
			
			//  W[ŃW[e[u
			itvml = vccd.lpvml->find(lpszLoadName);
			
			if (itvml == vccd.lpvml->end())
			{
				//  Ȃ΁A܂[hĂȂ̂ŁA[h
				
				//  W[t@C݂邩ǂmF
				hffd = NVFindFirstFile(lpszLoadName, &ffd);
				if (hffd == NULL || hffd == INVALID_HANDLE_VALUE)
				{
					//  Ȃ΃G[
					throw NVERR_UNDEFINED;
				}
				else
				{
					NVFindClose(hffd);
				}
				
				//  W[[h
				hModule = LoadLibrary(lpszLoadName);
				
				if (! hModule)
				{
					//  [hɎsAG[
					throw NVERR_UNDEFINED;
				}
				
				//  [hɐAW[e[uɒǉ
				vccd.lpvml->insert(std::make_pair(lpszLoadName, hModule));
			}
			else
			{
				//  e[u猩΁AłɃ[hς
				//  e[u烂W[nh擾
				hModule = (*itvml).second;
			}
		}
		else if ((*it).second.hModule == NULL)
		{
			WIN32_FIND_DATA ffd;
			HANDLE hffd;
			VCOMMODULELIST::iterator itvml;
			//  W[ŃW[e[u
			
			itvml = vccd.lpvml->find((*it).second.lpszModuleName);
			
			if (itvml == vccd.lpvml->end())
			{
				//  Ȃ΁A܂[hĂȂ̂ŁA[h
				
				//  W[t@C݂邩ǂmF
				hffd = NVFindFirstFile((*it).second.lpszModuleName, &ffd);
				if (hffd == NULL || hffd == INVALID_HANDLE_VALUE)
				{
					//  Ȃ΃G[
					throw NVERR_UNDEFINED;
				}
				else
				{
					NVFindClose(hffd);
				}
				
				{
					LPCTSTR lpszCur;
					TCHAR szFourCC[5];
					TCHAR szDependence[4096];
					TCHAR szModule[NV_PATHMAX];

					NVFourCCToString((*it).second.dwFourCC, szFourCC, 5);
					szDependence[0] = TEXT('\0');
					GetPrivateProfileString(szFourCC, TEXT("DEPENDENCE"), TEXT(""), szDependence, NV_PATHMAX, vccd.lpszVCOMIniFileName);
					lpszCur = szDependence;
					szModule[0] = TEXT('\0');
					lpszCur = NVGetCommandOption(lpszCur, szModule, NV_PATHMAX);
					while (lpszCur && szModule[0])
					{
						HMODULE hModule;
						VLoadLibraryByFileName(szModule, &hModule);
						lpszCur = NVGetCommandOption(lpszCur, szModule, NV_PATHMAX);
					}
				}
				//  W[[h
				hModule = LoadLibrary((*it).second.lpszModuleName);
				
				if (! hModule)
				{
					//  [hɎsAG[
					throw NVERR_UNDEFINED;
				}
				
				//  [hɐAW[e[uɒǉ
				vccd.lpvml->insert(std::make_pair((*it).second.lpszModuleName, hModule));
			}
			else
			{
				//  e[u猩΁AłɃ[hς
				//  e[u烂W[nh擾
				hModule = (*itvml).second;
			}
			
			(*it).second.hModule = hModule;
		}
		else
		{
			hModule = (*it).second.hModule;
		}
	}
	catch (NVRESULT nvres)
	{
		//  G[Nꍇ̏
		//  fobOrĥƂAt@CƃNXo
#ifdef _DEBUG
		TCHAR szFourCC[5];
		TCHAR lpszErrorMessage[512];

		NVFourCCToString(dwInstanceFourCC, szFourCC, 5);
		_stprintf_s(lpszErrorMessage, 512, TEXT("\nVCOM : CreateInstance Fatal Error!! \nCan'n find \"%s\" ClassData from \"%s\".\n\n"),
			512, szFourCC, vccd.lpszVCOMIniFileName);
		NVOutputDebugString(lpszErrorMessage);
#endif
		*lphModule = NULL;
		LeaveCriticalSection(&vccd.cr);

		return nvres;
	}

	*lphModule = hModule;

	LeaveCriticalSection(&vccd.cr);
	return NV_OK;
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VLoadLibraryByFileName(LPCTSTR lpcszLibraryName, HINSTANCE *lphModule)
{
	//  CX^X̍쐬
	
	HINSTANCE hModule = NULL;
	
	EnterCriticalSection(&vccd.cr);

	try
	{
		//  ߂ẴCX^X̏ꍇ̏
		//  NX擾AKvȃW[̃[hs
		
		TCHAR lpszLoadName[NV_PATHMAX];
		WIN32_FIND_DATA ffd;
		HANDLE hffd;
		VCOMMODULELIST::iterator itvml;
		
		//  tpXł邩ǂׂ
		if (lpcszLibraryName[0] == TEXT('\\'))
		{
			if (lpcszLibraryName[1] == TEXT('\\'))
			{
				//  lbg[NpX
				_tcscpy_s(lpszLoadName, NV_PATHMAX, lpcszLibraryName);
			}
			else
			{
				//  PڂȂAhCuȗtpX
				//  hCu₤
				lpszLoadName[0] = vccd.lpszVCOMDirectory[0];
				lpszLoadName[1] = vccd.lpszVCOMDirectory[1];
				_tcscpy_s(lpszLoadName + 2, NV_PATHMAX - 2, lpcszLibraryName);
			}
		}
		else if (lpcszLibraryName[1] == TEXT(':'))
		{
			//  QڂFȂAtpXB̂܂܃Rs[
			_tcscpy_s(lpszLoadName, NV_PATHMAX, lpcszLibraryName);
		}
		else
		{
			//  tpXłȂ΁AfBNg𓪂ɂ
			_stprintf_s(lpszLoadName, NV_PATHMAX, TEXT("%s%s"), vccd.lpszVCOMDirectory, lpcszLibraryName);
		}
		
		//  W[ŃW[e[u
		itvml = vccd.lpvml->find(lpszLoadName);
		
		if (itvml == vccd.lpvml->end())
		{
			BOOL fFoundOnOtherPath = FALSE;
			//  Ȃ΁A܂[hĂȂ̂ŁA[h
			//  W[t@C݂邩ǂmF
			hffd = NVFindFirstFile(lpszLoadName, &ffd);
			if (hffd == NULL || hffd == INVALID_HANDLE_VALUE)
			{
				//  Ȃ Plugin fBNg Common fBNgT
				TCHAR szTemp[NV_PATHMAX];

				_tcscpy_s(szTemp, NV_PATHMAX, PathFindFileName(lpszLoadName));
				GetModuleFileName(NULL, lpszLoadName, NV_PATHMAX);
				PathRemoveFileSpec(lpszLoadName);
				PathAppend(lpszLoadName, TEXT("Common"));
				PathAppend(lpszLoadName, szTemp);

				{
					//  ɂ炩烍[hĂȂ`FbN
					itvml = vccd.lpvml->find(lpszLoadName);
					if (itvml != vccd.lpvml->end())
					{
						fFoundOnOtherPath = TRUE;
					}
				}

				if (! fFoundOnOtherPath)
				{
					hffd = NVFindFirstFile(lpszLoadName, &ffd);
					if (hffd == NULL || hffd == INVALID_HANDLE_VALUE)
					{
						{
							//  ɂ炩烍[hĂȂ`FbN
							itvml = vccd.lpvml->find(lpszLoadName);
							if (itvml != vccd.lpvml->end())
							{
								fFoundOnOtherPath = TRUE;
							}
						}

						if (! fFoundOnOtherPath)
						{
							GetModuleFileName(NULL, lpszLoadName, NV_PATHMAX);
							PathRemoveFileSpec(lpszLoadName);
							PathAppend(lpszLoadName, TEXT("Plugin"));
							PathAppend(lpszLoadName, szTemp);

							hffd = NVFindFirstFile(lpszLoadName, &ffd);
							if (hffd == NULL || hffd == INVALID_HANDLE_VALUE)
							{
								//  ǂɂ΃VXeCɂĂ݂
								_tcscpy_s(lpszLoadName, NV_PATHMAX, lpcszLibraryName);
								//throw NVERR_UNDEFINED;
							}
							else
							{
								NVFindClose(hffd);
							}
						}
					}
					else
					{
						NVFindClose(hffd);
					}
				}
			}
			else
			{
				NVFindClose(hffd);
			}
			
			if (fFoundOnOtherPath)
			{
				hModule = (*itvml).second;
			}
			else
			{
				//  W[[h
				hModule = LoadLibrary(lpszLoadName);
				if (! hModule)
				{
					//  [hɎsAG[
					throw NVERR_UNDEFINED;
				}

				//  [hɐAW[e[uɒǉ
				vccd.lpvml->insert(std::make_pair(lpszLoadName, hModule));
			}
		}
		else
		{
			//  e[u猩΁AłɃ[hς
			//  e[u烂W[nh擾
			hModule = (*itvml).second;
		}
	}
	catch (NVRESULT nvres)
	{
		//  G[Nꍇ̏
		*lphModule = NULL;
		LeaveCriticalSection(&vccd.cr);
		return nvres;
	}

	*lphModule = hModule;

	LeaveCriticalSection(&vccd.cr);
	return NV_OK;
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VInternalAddInterface(IVCOM ivcom)
{
	return ivcom->AddInterface(VCOM_CLASSINTERFACE);
}

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VGetVCOMDirectory(LPTSTR lpszDirectory, DWORD dwLength)
{
	_tcsncpy_s(lpszDirectory, dwLength, vccd.lpszVCOMDirectory, dwLength - 1);
	return ((DWORD)_tcslen(vccd.lpszVCOMDirectory) + 1 <= dwLength) ? NV_OK : NVERR_UNDEFINED;
}

