//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  VCOM {NX  wb_[t@C  for  NVLibraryCore                                       //
//  VCOM.h                                                                                      //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  NVLibrary Œ񋟂邷ׂẴIuWFNg̊{NXB                                    //
//  {ۊ{NXɂׂAepNX̃Cvg̎QlɂȂ悤A              //
//  ev[gIȓẽoĂB                                                //
//  ׂĂ̌pNX́AŎꂽC^[tF[XdlɊÂāA                        //
//  Ȃ΂ȂȂB                                                                  //
//  eC^[tF[XNXƂɓƎɃCvgȂĂ͂ȂȂ                        //
//  \bh́AVCOM_CLASSMETHOD ƂĐ錾ĂB                                         //
//  ƂĊ{NX̂̂pAɎȂCvgKv̂Ȃ̂́A    //
//  VCOM_BASICMETHOD ƂĐ錾ĂB                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////


#pragma once





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//

#include "NVLibCoreDef.h"

#include <map>


#ifdef __cplusplus
extern "C" {
#endif

#pragma pack(push, 1)


	
	//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  }N̒`
//


#define VCOM_CLASSMETHOD virtual
#define VCOM_BASICMETHOD virtual
#define VCOM_CLASSINTERFACE 0x01


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  NX̒`      IVCOM
//


//  NX̎ʃR[h
//  _ł́A啶̃At@xbgSƂ
//  Iɂ́A̎gpAoCil̎gp\ɂ\
#define VCOM_FOURCC MAKEFOURCC('V', 'C', 'O', 'M')

/*  IVCOM NXWXg (VCOM.ini ւ̋Lq)
[VCOM]

Class_ID = "VCOM"
Module_Name = "NVLibCore.dll"
Entry_Point = "CreateInstance_VCOM"
*/

//  {C^[tF[XNX
class Class_VCOM;

// {C^[tF[X
typedef Class_VCOM * IVCOM;

//  const {C^[tF[X
typedef const Class_VCOM * CIVCOM;

//  {C^[tF[Xւ̃|C^
typedef IVCOM * LPIVCOM;

//  {C^[tF[Xւ const |C^
typedef const IVCOM * LPCIVCOM;



//  Create() ɓn̊{` (VCOMCREATE \)
struct VCOMCREATE
{
	DWORD dwFourCC;		//  Ăяoꂽ Create() ƈ̑Ή`FbN邽߂̌^ʎq
	DWORD dwObjSize;	//  \̂̃TCY
	DWORD dwFlag;		//  tO
};

//  CREATE \ ւ̃|C^
typedef VCOMCREATE * LPVCOMCREATE;

//  CREATE \̂ւ const |C^
typedef const VCOMCREATE * LPCVCOMCREATE;

//  {C^[tF[X̕ێf[^
struct VCOMDATA		//  vcd
{
	DWORD dwFourCC;		//  IWĩCX^X̌^ێ
	DWORD dwObjSize;	//  IWĩCX^X̃TCYێ
	LPVOID lpvOrgPtr;	//  IWĩCX^Xւ̃|C^ێ
	LONG lRefCount;		//  QƃJEg
	BOOL bIsCreated;	//  Create() sꂽǂ̃tO
	HANDLE hMutexLock;	//  ~[ebNXIuWFNg
	IVCOM ivcom;		//  {C^[tF[Xۑ
	HANDLE hEventLost;	//  bNLZpCxg(폜p)
#ifdef NVSAFELOCK_DEADLOCK_ASSERT
	DWORD dwLockingThread;
	LONG lRecursionCount;	//  bN
#endif
};

//  {C^[tF[X̕ێf[^ւ̃|C^
typedef VCOMDATA * LPVCOMDATA;

//  {C^[tF[X̕ێf[^ւ const |C^
typedef const VCOMDATA * LPCVCOMDATA;


//  {C^[tF[XNX̒`
class NVLIBCORE_CLASS_EXPORT Class_VCOM
{
//  VCOM_CLASSMETHOD
	public :
		Class_VCOM(void);
		//  ftHgRXgN^
		//
		//  SetCoreData() ĂяoāA{NXɃf[^ݒ肷B
		//  RXgN^́A{NX̂̂珇ԂɎŝŁA
		//  ŌɌĂяoIWĩCX^X̌^̃f[^cB
		//  ܂Aێf[^̒lOȊOɏꍇ̂݁AsB

	VCOM_CLASSMETHOD
		~Class_VCOM(void);
		//  fXgN^
		//

	VCOM_CLASSMETHOD
		NVRESULT Create(LPCVOID lpvParam);
		//  CX^X̏
		//
		//  CX^XɃp[^^āACX^X̃f[^(쐬)B
		//  CX^XŕKvȃAP[V肷B
		//  nvcd.bIsCreated tO𗧂āAς݂`FbNs悤ɂB
		//  nvcd.bIsCreated tOłɗĂƂ́AG[Ԃ悤ɂ̂ǂƎvB
		//  f[^Zbg(ResetData() Ăяo)Aď悤ɂĂǂA
		//  Xbhł̊eC^[tF[X̃Rs[Ԃł̓ςɂȂ\B

	VCOM_CLASSMETHOD
		NVRESULT ResetData(void);
		//  CX^X̃f[^Zbg
		//
		//  CX^XŗpȂǂACreate() ĂяoȌԂɖ߂B
		//  vcd.bIsCreated tOZbgAĂ Create() s悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface);
		//  C^[tF[X̎擾
		//
		//  DWORD dwFourCC			擾C^[tF[X
		//  LPVOID *lpvInterface	C^[tF[Xi[|C^
		//
		//  ̃CX^X́AdwFourCC Ŏw肵^̃C^[tF[X擾B
		//  擾łC^[tF[X́ACX^XɂĈقȂ邪A
		//  CX^XNX̃X[p[NXɂNX̃C^[tF[X
		//  K擾ł悤ɎȂ΂ȂȂB
		//  ̊֐ŕʂ̃C^[tF[X擾ƁA AddRef() ŝŁA
		//  ÂC^[tF[Xɑ΂Ă Release() KvB

	protected:
	VCOM_CLASSMETHOD
		NVRESULT AddInterface(DWORD dwFlag);
		//  C^[tF[XQƃe[uɓo^
		//
		//  DWORD dwFlag	NXCX^X̏ꍇPAȊO͂O
		//
		//  RXgN^̒ŌĂ΂AC^[tF[X|C^e[uɓo^A
		//  VIsValidInterface() ŃC^[tF[X̗L؂ł悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT DeleteInterface(void);
		//  C^[tF[XQƃe[u폜
		//
		//  DeleteInstance() ̒ŌĂ΂AC^[tF[X|C^e[u폜B

	public:
	VCOM_BASICMETHOD
		LONG AddRef(void);
		//  QƃJEg̃CNg
		//
		//  QƃJEgCNgBɂāAx Release() ĂԂƃCX^X
		//  j邩ς̂ŁAC^[tF[XRs[āȀꏊŎgƂɁA
		//  XgCX^XփANZXĂ܂̂hB
		//  C^[tF[XRs[ꍇ́A̓x AddRef() ĂяoA
		//  eX̃C^[tF[X Release() Ăяo悤ɂB
		//  Ō̎QƂjꂽ_ŁACX^XB
	VCOM_BASICMETHOD
		LONG SafeAddRef(void);

	VCOM_BASICMETHOD
		LONG Release(void);
		//  C^[tF[X̉
		//
		//  QƃJEgfNgB
		//  QƃJEgOɂȂꍇAResetData() ŃCX^X̃f[^ZbgB
		//  ܂ADeleteInstance() sACX^XjB
		//  ȌÃCX^Xւ̎QƂ̓G[ɂȂB

//  VCOM_BASICMETHOD
	public:
	VCOM_BASICMETHOD
		LONG GetRefCount(void);
		//  QƃJEg擾B

	VCOM_BASICMETHOD
		void DeleteInstance(void);
		//  CX^X̔j
		//
		//  CX^X̃jAC^[tF[XB
		//  ̓eAׂĂ̌pNX{NX̂̂ĂяoĂ\ȂB

		void *operator new(size_t stAllocateBlock);
		//  new Zq
		//

		void operator delete(void *pvMem);
		//  delete Zq
		//

	VCOM_BASICMETHOD
		DWORD GetFourCC(void);
		//  NX̎ʎq(SR[h)擾B
		//
		//  FourCC(SR[h)邱ƂŁAC^[tF[X̌^Ɉ˂炸A
		//  ɃIWĩCX^X̌^𔻕ʂłB

	VCOM_BASICMETHOD
		BOOL IsCreated(void);
		//  Create() \bhĂяoꂽォǂʂB
		//
		//  TRUE ԂꍇAłɃCX^XpĂ̂ŁA
		//  ResetData() ɂăZbgłȂƁACreate() ͍sȂB

	protected:
	VCOM_BASICMETHOD
		void SetCoreData(LPVOID lpvOrgPtr, DWORD dwObjSize, DWORD dwFourCC);
		//  {NX̃f[^ݒ肷B
		//
		//  epNX̃RXgN^ŌĂяoB

	VCOM_BASICMETHOD
		LONG DecRef(void);
		//  QƃJEgfNgB
		//
		//  Relese() ̒ŗpB

	friend NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VCreateInstance(DWORD dwInstanceFourCC, DWORD dwInterfaceFourCC, LPVOID *lplpvInterface);
	private:
	VCOM_BASICMETHOD
		NVRESULT LockObject(void);
		//  IuWFNg̃bN
		//
		//  IuWFNgbNÃXbhQdɃANZXȂB
		//  VCOM IuWFNǵAȂׂo֐ LockObject 𗘗pāA
		//  }`XbhɂG[ׂłB
		//  bNIuWFNǵAbN̂Ɠ񐔂AbNȂ΂ȂȂB
		//  ̃\bh𒼐ڌĂяôł͂ȂANVSafeLock() ɃC^[tF[X|C^n
		//  bN邱Ƃ𐄏BȃC^[tF[XłAANZXᔽɂȂȂB

	VCOM_BASICMETHOD
		NVRESULT TryLockObject(void);

	VCOM_BASICMETHOD
		NVRESULT UnLockObject(void);
		//  IuWFNg̃AbN
		//
		//  IuWFNgAbNAbNJEgP炷B
		//  LockObject() ĂяôƓ񐔂ĂяoȂ΂ȂȂB
#ifdef NVSAFELOCK_DEADLOCK_ASSERT
	friend NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVInternalSafeLock(IVCOM ivcom, LPCTSTR pszFileName, long lLine, LPCTSTR pszDate, LPCTSTR pszTime);
#else
	friend NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVInternalSafeLock(IVCOM ivcom);
#endif
	friend NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVInternalSafeUnLock(IVCOM ivcom);
	friend NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API NVInternalTrySafeLock(IVCOM ivcom);
	friend NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VInternalAddInterface(IVCOM ivcom);

	protected:
		VCOMDATA vcd;	//  {NX̕ێf[^
};

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API CreateInstance_VCOM(LPIVCOM lpivcom);
//  CX^X̍쐬
//
//  IVCOM CX^X쐬ÃC^[tF[XԂB
//  IVCOM ͉̂̋@\ȂC^[tF[Xł̂ŁA
//  ̊֐́APȂv[XtH_łB


inline void SetVCOMCreate(LPVCOMCREATE lpvcc, DWORD dwFlag);



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  VCOM I[g[VT[rX񋟂̂߂̃wb_[
//


NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VCreateInstance(DWORD dwInstanceFourCC, DWORD dwInterfaceFourCC, LPVOID *lplpvInterface);
//  CX^X̍쐬
//
//  DWORD dwInstanceFourCC		쐬CX^X̎ʎq
//  DWORD dwInterfaceFourCC		擾C^[tF[X̎ʎq
//  LPVOID *lplpvInterface		C^[tF[X󂯎obt@ւ̃|C^
//
//  CX^XɃAP[VAC^[tF[X𗘗pł悤ɂB
//  ̊֐oRŃCX^X쐬ƁAAvP[V̖{ (*.exe) ̂tH_
//  ɂ VCOM.ini t@Cǂݍ݁AIɕKvȃW[ (*.dll) [hA
//  CX^X쐬ĂB
//  AvP[VtH_ VCOM.ini ȂꍇAEBhEỸVXetH_B
//  ɂȂ΁A֐͎sB
//
//  쐬CX^XƎ󂯎C^[tF[X̎ʎq́AʌɎwłB
//  ́AȌɂĖm̃NX̃CX^X쐬ƂȂǂɁA
//  m̃C^[tF[X擾ł悤ɂƂ̔złB
//
//  VCOM.ini ̋Lq
//
//  [VCOM]								; ZNVɂ́ANX̂S̎ʎqLq
//
//  Class_ID = "VCOM"					; Class_ID ƂL[AɂʎqLq
//  Module_Name = "NVLibCore.dll"		; Module_Name ƂL[AKvȂckkLqB
//										; ΃pX̋LqȂ΁AVCOM.ini ̓ĂtH_̑΃pXŎ擾B
//  Entry_Point = "CreateInstance_VCOM"	; Entry_Point ƂL[ɁANX̃C^[tF[X擾֐LqB
//										; C^[tF[X擾֐́AVCOM_CREATEINSTANCEPROC ^̊֐łKvB
//										; ĂяoḰA__stdcall łB


NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VAddInterface(LPVOID lpvInterface, IVCOM ivcom, DWORD dwFourCC, DWORD dwFlag);
//  C^[tF[Xe[uɓo^
//
//  LPVOID lpvInterface		o^C^[tF[X
//  IVCOM ivcom				o^CX^X̊C^[tF[X
//  DWORD dwFourCC			C^[tF[X̎ʎq
//  DWORD dwFlag			NXCX^X̏ꍇPAȊO͂O

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VDeleteInterface(LPVOID lpvInterface);
//  C^[tF[Xe[u폜
//
//  LPVOID lpvInterface		폜C^[tF[X

BOOL NVLIBCORE_EXPORT NVLIBCORE_API VIsValidInterface(LPVOID lpvInterface);
//  C^[tF[X̗LmF
//
//  LPVOID lpvInterface		mFC^[tF[X
//
//  LȂubnlC^[tF[Xł΁AOԂB

DWORD NVLIBCORE_EXPORT NVLIBCORE_API VGetInterfaceFourCC(LPVOID lpvInterface);
//  C^[tF[X̗LmFÃNXʎqԂ
//
//  LPVOID lpvInterface		mFC^[tF[X
//
//  LȂubnlC^[tF[X̏ꍇÃNXʎqԂB
//  ȏꍇ́AOԂB

IVCOM NVLIBCORE_EXPORT NVLIBCORE_API VGetInterface(LPVOID lpvInterface);
//  C^[tF[X̗LmFASȊ{C^[tF[X (IVCOM) Ԃ
//
//  LPVOID lpvInterface		mFC^[tF[X
//
//  LȂubnlC^[tF[X̏ꍇÃCX^X̊{C^[tF[XԂB
//  ȏꍇ́ANULL ԂB
//
//  C^[tF[XsȃIuWFNg̏ꍇA
//  ̊֐Ŋ{C^[tF[X擾A
//  ]̃C^[tF[XQueryInterface() Ŏ擾΁A
//  SɃIuWFNgɃANZXłB
//  ȂÅ֐ԂC^[tF[X́A̓sxRelease() Ȃ΂ȂȂB
//  C^[tF[X̗LmF̏ꍇ́AVIsValidInterface() p邱ƁB

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VLoadLibrary(DWORD dwInstanceFourCC, HINSTANCE *lphModule);
//  w̃NXCX^X̃R[h܂ރCu[hA[hς݃XgɉANVLibCore.dll ɃA[h

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VLoadLibraryByFileName(LPCTSTR lpcszLibraryName, HINSTANCE *lphModule);
//  Cӂ̃Cu[hA[hς݃XgɉANVLibCore.dll ɃA[h

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VGetVCOMDirectory(LPTSTR lpszDirectory, DWORD dwLength);
//  VCOM fBNg (VCOM.cfg fBNg) Ԃ

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VEntryClass(DWORD dwFourCC, LPTSTR lpszModuleFileName, LPTSTR lpszEntryPoint);
NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VDeleteClass(DWORD dwFourCC);


NVRESULT VCOM_Prepare(void);
//  VCOM I[g[VT[rX̏
//
//  NVLibCore.dll ɌĂяo
//  NXe[uAW[e[u쐬


NVRESULT VCOM_UnPrepare(void);
//  VCOM I[g[VT[rX̉
//
//  NVLibCore.dll vZXf^b`ƂɌĂ΂B
//  ǂݍ񂾃W[ׂĉANXe[uAW[e[uB

NVRESULT NVLIBCORE_EXPORT NVLIBCORE_API VReportObjectLeak(LPCTSTR lpcszFileName);
//  fobO⏕֐Fݓo^ς݂VCOM IuWFNg̈ꗗt@Cɏo͂
//
//  LPCTSTR lpcszFileName    o̓t@C


typedef NVRESULT (_stdcall *VCOM_CREATEINSTANCEPROC)(LPIVCOM lpivcom);
/*  VCOM CX^X쐬֐̌^`
NVRESULT __stdcall CreateInstance_ClassName(LPIVCOM lpivcom);
*/

//  VCOM NXe[ũf[^
struct VCOMCLASSDATA		// vclass
{
	DWORD dwFourCC;								//  NXʎq
	HINSTANCE hModule;							//  KvȃW[̃nh
	TCHAR lpszModuleName[NV_PATHMAX];			//  KvȃW[
	TCHAR lpszEntryPoint[NV_PATHMAX];			//  CX^X쐬֐̖O
	VCOM_CREATEINSTANCEPROC CreateInstance;		//  NCX^X쐬֐̃AhX
};
typedef VCOMCLASSDATA * LPVCOMCLASSDATA;
typedef const VCOMCLASSDATA * LPCVCOMCLASSDATA;

//  VCOM NXe[u
//  L[́ANXʎq
//  VCOMCLASSDATA ێ
typedef std::map<DWORD, VCOMCLASSDATA> VCOMCLASSLIST;
typedef VCOMCLASSLIST * LPVCOMCLASSLIST;
typedef const VCOMCLASSLIST * LPCVCOMCLASSLIST;

//  VCOM W[e[u
//  L[́AW[
//  [hW[̃CX^Xnhێ
typedef std::map<_tstring, HINSTANCE> VCOMMODULELIST;
typedef VCOMMODULELIST * LPVCOMMODULELIST;
typedef const VCOMMODULELIST * LPCVCOMMODULELIST;


//  VCOM C^[tF[Xe[ũf[^
struct VCOMINTERFACEDATA		//  vid
{
	LPVOID lpvInterface;		//  C^[tF[X(L[)
	IVCOM ivcom;				//  CX^X̊{C^[tF[X
	DWORD dwFourCC;				//  NXʎq
	DWORD dwFlag;				//  tO
};
typedef VCOMINTERFACEDATA * LPVCOMINTERFACEDATA;
typedef const VCOMINTERFACEDATA * LPCVCOMINTERFACEDATA;

//  VCOM C^[tF[Xe[u
typedef std::map<LPVOID, VCOMINTERFACEDATA> VCOMINTERFACETABLE;
typedef VCOMINTERFACETABLE * LPVCOMINTERFACETABLE;
typedef const VCOMINTERFACETABLE * LPCVCOMINTERFACETABLE;



//  VCOM I[g[VT[rX̕ێf[^
struct VCOMCOREDATA			//  vccd
{
	TCHAR lpszVCOMDirectory[NV_PATHMAX];		//  VCOM ̊fBNgBVCOM.ini ǂݍ񂾃fBNgɂȂ
	TCHAR lpszVCOMIniFileName[NV_PATHMAX];	//  VCOM.ini ̃t@C
	LPVCOMMODULELIST lpvml;					//  W[e[u
	LPVCOMCLASSLIST lpvcl;					//  NXe[u
	LPVCOMINTERFACETABLE lpvit;				//  C^[tF[Xe[u
	CRITICAL_SECTION cr;
};
typedef VCOMCOREDATA * LPVCOMCOREDATA;
typedef const VCOMCOREDATA * LPCVCOMCOREDATA;

inline void NVFourCCToString(DWORD dwFourCC, LPTSTR pszString, int nLen);
inline DWORD NVStringToFourCC(LPCTSTR pszString);


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  CC֐̒`
//


inline void SetVCOMCreate(LPVCOMCREATE lpvcc, DWORD dwFlag)
{
//  CX^X̍쐬
	lpvcc->dwFourCC = VCOM_FOURCC;
	lpvcc->dwObjSize = sizeof(VCOMCREATE);
	lpvcc->dwFlag = dwFlag;
	return;
}

inline void NVFourCCToString(DWORD dwFourCC, LPTSTR pszString, int nLen)
{
	CHAR szFourCC[5];

	*((LPDWORD)szFourCC) = dwFourCC;
	szFourCC[4] = '\0';

#ifdef _UNICODE
	TCHAR wszFourCC[5];
	MultiByteToWideChar(CP_ACP, 0, szFourCC, -1, wszFourCC, 5);
	_tcsncpy_s(pszString, nLen, wszFourCC, nLen - 1);
#else
	_tcsncpy_s(pszString, nLen, szFourCC, nLen - 1);
#endif
	return;
}

inline DWORD NVStringToFourCC(LPCTSTR pszString)
{
	assert(_tcslen(pszString) >= 4);
#ifdef _UNICODE
	CHAR sz[5];
	sz[0] = '\0';
	WideCharToMultiByte(CP_ACP, 0, pszString, -1, sz, 5, NULL, NULL);
	sz[4] = '\0';
	return *((LPDWORD) sz);
#else
	return *((LPDWORD) pszString);
#endif
}

#pragma pack(pop)

#ifdef __cplusplus
}
#endif
