//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  PCM Wave File Compression W[ \[Xt@C  for  NVWaveLibrary	    			    //
//  NVPCMEnc.h                                                                                  //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "NVPCMEnc.h"
#include "..\\Resource\\Resource.h"

//#define PARSE_IMAGE_FILE

#ifdef PARSE_IMAGE_FILE
LONG ImageToPCM(LPBYTE lpBuf, LONG lSize);
#endif

static INT_PTR CALLBACK DialogProc(HWND hwnd, UINT uMessage, WPARAM wParam, LPARAM lParam);
extern TCHAR szConfigFileName[NV_PATHMAX];


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̒`
//


NVRESULT NVWAVE_EXPORT NVWAVE_API CreateInstance_NVPCMEnc(LPIVCOM lpivcom)
{
	//  CX^X̍쐬
	//  vtable Kv̂ŁAnew ZqoRŃAP[VB

	if (! lpivcom)
	{
		return NVERR_UNDEFINED;
	}

	*lpivcom = (IVCOM) new Class_NVPCMEnc;
	if (*lpivcom)
	{
		return NV_OK;
	}
	else
	{
		return NVERR_UNDEFINED;
	}
}

HWND NVPCMEncConfigDialog(HINSTANCE hInstance, HWND hwndOwner, LPVOID *lplpvParam)
{
	extern HINSTANCE hinstNVWave;

	return CreateDialogParam(NVGetResourceDLL(), MAKEINTRESOURCE(IDD_PCM_ENCOPTION), hwndOwner, DialogProc, (LPARAM) lplpvParam);
}


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  o֐̐錾  Class_NVPCMEnc
//



Class_NVPCMEnc::Class_NVPCMEnc(void)
{
//  ftHgRXgN^

	//  {NX̕ێf[^ݒ肷BRXgN^͊{NX珇ԂɌĂяôŁA
	//  ŌɌĂяo邱ƂɂȂACX^X̃IWǐ^݂̏̂cB
	//  ]ȏ̂ŃI[o[wbh邪AdldƁB
	Class_VCOM::SetCoreData((LPVOID) this, (DWORD) sizeof(Class_NVPCMEnc), NVPCMENC_FOURCC);

	//  ێf[^͖̏B

	return;
}


Class_NVPCMEnc::~Class_NVPCMEnc(void)
{
//  fXgN^

	//  Release oRȊOĂяoƁAvcd.bIsCreated  TRUE ł邱ƂB
	//  ̏ꍇAȉsĂȂ͂Ȃ̂ŁAASSERT B
	assert(! vcd.bIsCreated);

	return;
}


NVRESULT Class_NVPCMEnc::Create(LPCVOID lpvParam)
{
//  CX^X̏

	LPCVSSENCODERCREATE lpvssec = (LPCVSSENCODERCREATE) lpvParam;

	if (lpvssec->dwFourCC != VSSENCODER_FOURCC && lpvssec->dwFourCC != NVPCMENC_FOURCC)
	{
		return VAFERR_INVALIDPARAMTYPE;
	}

	if (lpvssec->dwObjSize != sizeof(VSSENCODERCREATE))
	{
		return VAFERR_INVALIDPARAMSIZE;
	}

	if (VGetInterfaceFourCC(lpvssec->invaf) != NVAUDIOFILE_FOURCC)
	{
		return VAFERR_INVALIDPARAM;
	}

	if (VGetInterfaceFourCC(lpvssec->invst) != NVSTREAM_FOURCC)
	{
		return VAFERR_INVALIDPARAM;
	}

	if (lpvssec->lpvParam)
	{
		LPCNVPCMENCPARAM lpcParam = (LPCNVPCMENCPARAM) lpvssec->lpvParam;
		if (lpcParam->dwFourCC != NVPCMENC_FOURCC)
		{
			return VAFERR_INVALIDPARAM;
		}
		if (lpcParam->dwObjSize != sizeof(NVPCMENCPARAM))
		{
			return VAFERR_INVALIDPARAM;
		}
	}

	if (lpvssec->lpnvafc)
	{
		LPCNVAUDIOFILECOMMENT lpnvafc = (LPCNVAUDIOFILECOMMENT) lpvssec->lpnvafc;

		if (lpnvafc->dwFourCC != NVAUDIOFILE_FOURCC)
		{
			return VAFERR_INVALIDPARAM;
		}
		if (lpnvafc->dwObjSize < sizeof(NVAUDIOFILECOMMENT))
		{
			return VAFERR_INVALIDPARAM;
		}
	}

	vssed.dwFlag = lpvssec->dwFlag;
	vssed.invaf = lpvssec->invaf;
	vssed.invst = lpvssec->invst;
	vssed.lpvParam = lpvssec->lpvParam;
	vssed.lpnvafc = lpvssec->lpnvafc;
	vssed.VSSEncProgress = lpvssec->VSSEncProgress;
	vssed.lpvProgressParam = lpvssec->lpvProgressParam;

	vcd.bIsCreated = TRUE;
	return NV_OK;
}


NVRESULT Class_NVPCMEnc::ResetData(void)
{
//  CX^X̃f[^Zbg

	//  ێf[^OZbg
	//  eNX ResetData Ɉp
	return Class_VSSEncoder::ResetData();
}


NVRESULT Class_NVPCMEnc::QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface)
{
//  C^[tF[X̎擾

	//  dwFourCC ɂāAKȌ^̃C^[tF[XԂB
	//  ǧ^̃C^[tF[X̍쐬ȊÓAeNX̃\bhĂԂƂŉƗǂƎvB

	if (dwFourCC == NVPCMENC_FOURCC)
	{
		//  ̃NX̃C^[tF[X擾Ȃ̂ŁAԂli[AAddRef() ƂɐIB
		*lpvInterface = (INVPCMENC) this;
		AddRef();
		return NV_OK;
	}
	else
	{
		//  ǧ^ȊÓAeNXɔC
		return Class_VSSEncoder::QueryInterface(dwFourCC, lpvInterface);
	}
}


NVRESULT Class_NVPCMEnc::AddInterface(DWORD dwFlag)
{
//  C^[tF[XQƃe[uɓo^

	//  CX^Xɑ΂ŏ̂P̌Ăяoł́A
	//  dwFlag ɂ VCOM_CLASSINTERFACE ĂB
	//  ȍ~̌Ăяoł́AOĂB
	VAddInterface(this, (IVCOM) this, NVPCMENC_FOURCC, dwFlag);

	//  eNX̃\bhɈp
	//  ̂ƂAdwFlag ɂ Ow肷B
	return Class_VSSEncoder::AddInterface(0);
}


NVRESULT Class_NVPCMEnc::DeleteInterface(void)
{
//  C^[tF[XQƃe[u폜

	VDeleteInterface(this);

	//  eNX̃\bhɈp
	return Class_VSSEncoder::DeleteInterface();
}

#define DECODE_BUFFER_SIZE (4 * 256 * 256)

NVRESULT Class_NVPCMEnc::ProcessData(void)
{
	INVAUDIOFILE invaf = vssed.invaf;
	INVSTREAM invst = vssed.invst;
//	static const NVPCMENCPARAM DefParam = { NVPCMENC_FOURCC, sizeof(NVPCMENCPARAM), 0 };
//	LPCNVPCMENCPARAM lpParam = (vssed.lpvParam) ? (LPCNVPCMENCPARAM)vssed.lpvParam : &DefParam;
	LPCNVPCMENCPARAM lpParam = (vssed.lpvParam) ? (LPCNVPCMENCPARAM)vssed.lpvParam : NVPCMEncGetSetting();
	LPCNVAUDIOFILECOMMENT lpnvafc = (LPCNVAUDIOFILECOMMENT)vssed.lpnvafc;
	VSSENCPROGRESS VSSEncProgress = vssed.VSSEncProgress;
	LPCVOID lpvProgressParam = vssed.lpvProgressParam;

	NVRESULT nvres;
	__declspec (align(16)) BYTE lpBuf[DECODE_BUFFER_SIZE];
	WAVEFORMATPCMEX wfx;
	QWORD qwWriteTotal = 0;
	DWORD dwCommentSize = 0;
	DWORD dwHeaderSize;
	DWORD dw;
	DWORD dwWrite;
	LONG lResult;
	QWORD qw;

	if (! vcd.bIsCreated)
	{
		if (lpParam != vssed.lpvParam)
		{
			NVMemFree(lpParam);
		}
		return VAFERR_NOCREATE;
	}

	try
	{
		//  PCMWAVEFORMAT 擾
		{
			PCMWAVEFORMAT pcmwf;
			nvres = invaf->GetPCMWaveFormat(&pcmwf);
			if (nvres)
			{
				throw nvres;
			}
			if (lpParam->dwFlag & NVPCMENC_USE_WAVEFORMAT_EXTENSIBLE)
			{
				NVAudioFile_PCMWaveFormatToWaveFormatPCMEx(&pcmwf, &wfx);
			}
			else
			{
				*(LPPCMWAVEFORMAT)&wfx = pcmwf;
				wfx.Format.cbSize = 0;
			}
		}

		//  ㏑[hŊJĂ邩Ȃ̂ŁAŏɃt@CɂB
		invst->SetDataSize(0);

		//  RIFF ̃wb_Ȃǂ
		dw = MAKEFOURCC('R', 'I', 'F', 'F');
		invst->Write(&dw, 4, &dwWrite);
		invst->Write(&dw, 4, &dwWrite);
		dw = MAKEFOURCC('W', 'A', 'V', 'E');
		invst->Write(&dw, 4, &dwWrite);
		dw = MAKEFOURCC('f', 'm', 't', ' ');
		invst->Write(&dw, 4, &dwWrite);
		if (wfx.Format.cbSize > 0)
		{
			dwHeaderSize = sizeof(WAVEFORMATEX) + wfx.Format.cbSize;
		}
		else
		{
			dwHeaderSize = sizeof(PCMWAVEFORMAT);
		}
		invst->Write(&dwHeaderSize, 4, &dwWrite);
		invst->Write(&wfx, dwHeaderSize, &dwWrite);
		dw = MAKEFOURCC('d', 'a', 't', 'a');
		invst->Write(&dw, 4, &dwWrite);
		invst->Write(&dw, 4, &dwWrite);

		{
			const DWORD dwReadSize = DECODE_BUFFER_SIZE - (DECODE_BUFFER_SIZE % wfx.Format.nBlockAlign);
			while ((VSSEncProgress ? VSSEncProgress(lpvProgressParam, qwWriteTotal) : NV_OK) == NV_OK)
			{
				//  f[^PʕfR[h
				nvres = invaf->DecodeToPCMData(lpBuf, dwReadSize, &lResult);
				if (nvres == VAFERR_VALUE_ERRORRECOVERED)
				{
				}
				else if (nvres)
				{
					if (lResult != 0)
					{
						//  G[ĂAfR[hł͏o
						//  fR[hf[^o
						invst->Write(lpBuf, lResult, &dwWrite);
						qwWriteTotal += lResult;
					}
					break;
				}
				//  fR[hf[^o
				invst->Write(lpBuf, lResult, &dwWrite);
				qwWriteTotal += lResult;
				Sleep(0);
			}
		}
		if (VSSEncProgress)
		{
			//  100% \邽߂ɏIɂĂяo
			VSSEncProgress(lpvProgressParam, qwWriteTotal);
		}

		//  oꂽTCYARIFF ̊e`ÑTCYݒ
		invst->GetDataSize(&qw);
		if (qwWriteTotal & 0x01)
		{
			BYTE b = 0;
			invst->Write(&b, 1, &dwWrite);
		}
		invst->SetCurrentPosition(4 * 6 + dwHeaderSize, NVSTREAM_SEEKBEGIN);
		qw -= 4 * 2 + 4 * 5 + dwHeaderSize;
		dw = (DWORD) min(DWORD_MAX, qw);
		invst->Write(&dw, 4, &dwWrite);

		if (lpnvafc)
		{
			NVAudioFile_WriteSIF(invst, lpnvafc);
		}

		invst->GetDataSize(&qw);
		qw -= 4 * 2;
		invst->SetCurrentPosition(4, NVSTREAM_SEEKBEGIN);
		dw = (DWORD) min(DWORD_MAX, qw);
		invst->Write(&dw, 4, &dwWrite);

		if (nvres != VAFERR_VALUE_ENDOFDATA)
		{
			//  G[I
			//  ɃG[\͂ȂH
		}
		else
		{
			//  I
		}
	}
	catch (NVRESULT nvres)
	{
		if (lpParam != vssed.lpvParam)
		{
			NVMemFree(lpParam);
		}
		return nvres;
	}
	
	if (lpParam != vssed.lpvParam)
	{
		NVMemFree(lpParam);
	}
	return NV_OK;
}

NVRESULT Class_NVPCMEnc::FreeParam(LPVOID lpvEncParam)
{
	NVMemFree(lpvEncParam);
	return NV_OK;
}


LPNVPCMENCPARAM NVPCMEncGetSetting(void)
{
	LPNVPCMENCPARAM lpParam = (LPNVPCMENCPARAM) NVMemAlloc(NVMEM_FIXED, sizeof(NVPCMENCPARAM));
	TCHAR szBuf[16];

	lpParam->dwFourCC = NVPCMENC_FOURCC;
	lpParam->dwObjSize = sizeof(NVPCMENCPARAM);
	GetPrivateProfileString(TEXT("NVPCMWriter"), TEXT("UseExtensible"), TEXT("FALSE"), szBuf, 16, szConfigFileName);
	if (_tcsicmp(szBuf, TEXT("TRUE")))
	{
		lpParam->dwFlag = 0;
	}
	else
	{
		lpParam->dwFlag = NVPCMENC_USE_WAVEFORMAT_EXTENSIBLE;
	}

	return lpParam;
}

LPVOID NVPCMEncCopySetting(LPVOID lpSrc)
{
	LPVOID lpDest = NVMemAlloc(NVMEM_FIXED, sizeof(NVPCMENCPARAM));

	CopyMemory(lpDest, lpSrc, sizeof(NVPCMENCPARAM));

	return lpDest;
}

static INT_PTR CALLBACK DialogProc(HWND hwnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
	switch (uMessage)
	{
	case WM_INITDIALOG:
		{
			BOOL bUseExtensible = FALSE;
			if (lParam)
			{
				LPNVPCMENCPARAM lpParam = NVPCMEncGetSetting();
				bUseExtensible = (lpParam->dwFlag & NVPCMENC_USE_WAVEFORMAT_EXTENSIBLE) ? TRUE : FALSE;
				*((LPVOID *)lParam) = lpParam;
			}
			SendDlgItemMessage(hwnd, IDC_PCM_USEEXTENSIBLE, BM_SETCHECK, bUseExtensible ? BST_CHECKED : BST_UNCHECKED, 0);
			SetProp(hwnd, TEXT("PCMENCPARAM"), (HANDLE)lParam);
			SetFocus(GetDlgItem(hwnd, IDC_PCM_USEEXTENSIBLE));
			NVClipWindowPos(hwnd);
			ShowWindow(hwnd, SW_SHOW);
		}
		return TRUE;
	case WM_DESTROY:
		{
			RemoveProp(hwnd, TEXT("PCMENCPARAM"));
		}
		return TRUE;
	case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
			case IDOK:
				{
					LPNVPCMENCPARAM *lplpParam = (LPNVPCMENCPARAM *)GetProp(hwnd, TEXT("PCMENCPARAM"));
					if (lplpParam && *lplpParam)
					{
						(*lplpParam)->dwFlag = (SendDlgItemMessage(hwnd, IDC_PCM_USEEXTENSIBLE, BM_GETCHECK, 0, 0) == BST_CHECKED) ? NVPCMENC_USE_WAVEFORMAT_EXTENSIBLE : 0;
						WritePrivateProfileString(TEXT("NVPCMWriter"), TEXT("UseExtensible"), ((*lplpParam)->dwFlag & NVPCMENC_USE_WAVEFORMAT_EXTENSIBLE) ? TEXT("TRUE") : TEXT("FALSE"), szConfigFileName);
					}
				}
			case IDCANCEL:
				DestroyWindow(hwnd);
				return TRUE;
			}
		}
		break;
	}

	return FALSE;
}
