//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  PCM Wave File Compression W[ wb_[t@C  for  NVWaveLibrary	    			//
//  NVPCMEnc.h                                                                                  //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////



#pragma once




//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "NVWaveDef.h"


#ifdef __cplusplus
extern "C" {
#endif


#pragma pack(push, 1)





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  }N̐錾
//

#define NVPCMENC_USE_WAVEFORMAT_EXTENSIBLE 0x01


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  \̂̐錾
//

struct NVPCMENCPARAM
{
	DWORD dwFourCC;
	DWORD dwObjSize;
	DWORD dwFlag;
};
typedef NVPCMENCPARAM * LPNVPCMENCPARAM;
typedef const NVPCMENCPARAM * LPCNVPCMENCPARAM;


//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  NX̒`  :  INVPCMENC
//


//  NXʎq
#define NVPCMENC_FOURCC MAKEFOURCC('P', 'C', 'M', 'E')


/*  NVPCMENC NXWXg (VCOM.ini ւ̋Lq)
[PCME]

Class_ID = "PCME"
Module_Name = "NVWave.vss"
Entry_Point = "CreateInstance_NVPCMEnc"
Dependence = ""NVAFLib.dll""
*/


class Class_NVPCMEnc;
typedef Class_NVPCMEnc * INVPCMENC;
typedef const Class_NVPCMEnc * CINVPCMENC;
typedef INVPCMENC * LPINVPCMENC;
typedef const INVPCMENC * LPCINVPCMENC;


class NVWAVE_CLASS_EXPORT Class_NVPCMEnc : virtual public Class_VSSEncoder
{
	public:
		Class_NVPCMEnc(void);
		//  ftHgRXgN^
		//
		//  SetCoreData() ĂяoāA{NXɃf[^ݒ肷B

	VCOM_CLASSMETHOD
		~Class_NVPCMEnc(void);
		//  fXgN^
		//

	VCOM_CLASSMETHOD
		NVRESULT Create(LPCVOID lpvParam);
		//  CX^X̏
		//
		//  CX^XɃp[^^āACX^X̃f[^(쐬)B
		//  vcd.bIsCreated tO𗧂āAς݂`FbNs悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT ResetData(void);
		//  CX^X̃f[^Zbg
		//
		//  CX^XŗpȂǂACreate() ĂяoȌԂɖ߂B
		//  vcd.bIsCreated tOZbgAĂ Create() s悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT QueryInterface(DWORD dwFourCC, LPVOID *lpvInterface);
		//  C^[tF[X̎擾
		//
		//  DWORD dwFourCC			擾C^[tF[X
		//  LPVOID *lpvInterface	C^[tF[Xi[|C^
		//
		//  ̃CX^X́AdwFourCC Ŏw肵^̃C^[tF[X擾B
		//  擾łC^[tF[X́ACX^XɂĈقȂ邪A
		//  CX^XNX̃X[p[NXɂNX̃C^[tF[X
		//  K擾ł悤ɎȂ΂ȂȂB
		//  ̊֐ŕʂ̃C^[tF[X擾ƁA AddRef() ŝŁA
		//  ÂC^[tF[Xɑ΂Ă Release() KvB

	VCOM_CLASSMETHOD
		NVRESULT ProcessData(void);
	VCOM_CLASSMETHOD
		NVRESULT FreeParam(LPVOID lpvEncParam);

protected:
	VCOM_CLASSMETHOD
		NVRESULT AddInterface(DWORD dwFlag);
		//  C^[tF[XQƃe[uɓo^
		//
		//  DWORD dwFlag	NXCX^X̏ꍇPAȊO͂O
		//
		//  RXgN^̒ŌĂ΂AC^[tF[X|C^e[uɓo^A
		//  VIsValidInterface() ŃC^[tF[X̗L؂ł悤ɂB

	VCOM_CLASSMETHOD
		NVRESULT DeleteInterface(void);
		//  C^[tF[XQƃe[u폜
		//
		//  DeleteInstance() ̒ŌĂ΂AC^[tF[X|C^e[u폜B
protected:
};



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Cu֐̐錾
//

NVRESULT NVWAVE_EXPORT NVWAVE_API CreateInstance_NVPCMEnc(LPIVCOM lpivcom);
//  CX^X̍쐬
//
//  INVPCMENC CX^X쐬ÃC^[tF[XԂ

HWND NVPCMEncConfigDialog(HINSTANCE hInstance, HWND hwndOwner, LPVOID *lplpvParam);
LPNVPCMENCPARAM NVPCMEncGetSetting(void);
LPVOID NVPCMEncCopySetting(LPVOID lpSrc);



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  CC֐̒`
//


#pragma pack(pop)

#ifdef __cplusplus
}
#endif
