//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
//  NVWaveFileLibrary `t@C  for  NVWaveFileLibrary                                      //
//  NVWaveDef.h                                                                                 //
//                                                                                              //
//  Programed by Northern Verse (Project9k)                                                     //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////




#pragma once



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  wb_[t@C̃CN[h
//


#include "..\\NVLibCore\\NVLibCore.h"
#include "..\\NVAFLib\\NVAFLib.h"


#ifdef __cplusplus
extern "C" {
#endif



#pragma pack(push, 1)





//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  }N̒`
//


//  DLLGNX|[gp
#define NVWAVE_API _stdcall

#ifdef NVWAVE_EXPORTS

#define NVWAVE_CLASS_EXPORT __declspec(dllexport)
#define NVWAVE_EXPORT
//#define NVWAVE_EXPORT __declspec(dllexport)

#else

#define NVWAVE_CLASS_EXPORT __declspec(dllimport)
#define NVWAVE_EXPORT __declspec(dllimport)

#endif	//  #ifdef NVWAVE_EXPORTS



//////////////////////////////////////////////////////////////////////////////////////////////////
//
//  ߂l̒`
//

//  INVPCMp}N

#define VPCMERR_                        0x3300
#define MAKE_VPCMERR(name, value, flag) MAKE_NVERR((name), (VPCMERR_ | (value)), (flag))
#define MAKE_VPCMERR_VALUE(value) MAKE_NVERR_VALUE(VPCMERR_ | (value))


//  0x3301   //  vꂽIy[V́A܂T|[gĂȂ
#define VPCMERR_UNSUPPORTED                   MAKE_VPCMERR(TEXT("VPCMERR_UNSUPPORTED"), 0x01, NVERR_FATAL)
#define VPCMERR_VALUE_UNSUPPORTED             MAKE_VPCMERR_VALUE(0x01)

//  0x3302
#define VPCMERR_ALREADYUSED                   MAKE_VPCMERR(TEXT("VPCMERR_ALREADYUSED"), 0x02, NVERR_FATAL)
#define VPCMERR_VALUE_ALREADYUSED             MAKE_VPCMERR_VALUE(0x02)

//  0x3303
#define VPCMERR_INVALIDPARAMTYPE              MAKE_VPCMERR(TEXT("VPCMERR_INVALIDPARAMTYPE"), 0x03, NVERR_FATAL)
#define VPCMERR_VALUE_INVALIDPARAMTYPE        MAKE_VPCMERR_VALUE(0x03)

//  0x3304
#define VPCMERR_INVALIDPARAMSIZE              MAKE_VPCMERR(TEXT("VPCMERR_INVALIDPARAMSIZE"), 0x04, NVERR_FATAL)
#define VPCMERR_VALUE_INVALIDPARAMSIZE        MAKE_VPCMERR_VALUE(0x04)

//  0x3305
#define VPCMERR_INVALIDPARAM                  MAKE_VPCMERR(TEXT("VPCMERR_INVALIDPARAM"), 0x05, NVERR_FATAL)
#define VPCMERR_VALUE_INVALIDPARAM            MAKE_VPCMERR_VALUE(0x05)

//  0x3306
#define VPCMERR_NOCREATE                      MAKE_VPCMERR(TEXT("VPCMERR_NOCREATE"), 0x06, NVERR_FATAL)
#define VPCMERR_VALUE_NOCREATE                MAKE_VPCMERR_VALUE(0x06)

//  0x3307
#define VPCMERR_ENDOFDATA                     VAFERR_ENDOFDATA//MAKE_VPCMERR(TEXT("VPCMERR_ENDOFDATA"), 0x07, NVERR_SAFE)
#define VPCMERR_VALUE_ENDOFDATA               VAFERR_VALUE_ENDOFDATA//MAKE_VPCMERR_VALUE(0x07)

//  0x3308
#define VPCMERR_BUFFERTOOSMALL                MAKE_VPCMERR(TEXT("VPCMERR_BUFFERTOOSMALL"), 0x08, NVERR_FATAL)
#define VPCMERR_VALUE_BUFFERTOOSMALL          MAKE_VPCMERR_VALUE(0x08)

//  0x3309
#define VPCMERR_FILEISBROKEN                  MAKE_VPCMERR(TEXT("VPCMERR_FILEISBROKEN"), 0x09, NVERR_NORMAL)
#define VPCMERR_VALUE_FILEISBROKEN            MAKE_VPCMERR_VALUE(0x09)

//  0x330A
#define VPCMERR_UNSUPPORTEDFILE               MAKE_VPCMERR(TEXT("VPCMERR_UNSUPPORTEDFILE"), 0x0A, NVERR_NORMAL)
#define VPCMERR_VALUE_UNSUPPORTEDFILE         MAKE_VPCMERR_VALUE(0x0A)

//  0x330B
#define VPCMERR_UNKNOWNFOURCC                 MAKE_VPCMERR(TEXT("VPCMERR_UNKNOWNFOURCC"), 0x0B, NVERR_FATAL)
#define VPCMERR_VALUE_UNKNOWNFOURCC           MAKE_VPCMERR_VALUE(0x0B)

//  0x330C
#define VPCMERR_CANTCREATEINFODIALOG          MAKE_VPCMERR(TEXT("VPCMERR_CANTCREATEINFODIALOG"), 0x0C, NVERR_FATAL)
#define VPCMERR_VALUE_CANTCREATEINFODIALOG    MAKE_VPCMERR_VALUE(0x0C)




//  INVACMp}N

#define VACMERR_                        0x3400
#define MAKE_VACMERR(name, value, flag) MAKE_NVERR((name), (VACMERR_ | (value)), (flag))
#define MAKE_VACMERR_VALUE(value) MAKE_NVERR_VALUE(VACMERR_ | (value))

//  0x3401   //  vꂽIy[V́A܂T|[gĂȂ
#define VACMERR_UNSUPPORTED                   MAKE_VACMERR(TEXT("VACMERR_UNSUPPORTED"), 0x01, NVERR_FATAL)
#define VACMERR_VALUE_UNSUPPORTED             MAKE_VACMERR_VALUE(0x01)

//  0x3402
#define VACMERR_ALREADYUSED                   MAKE_VACMERR(TEXT("VACMERR_ALREADYUSED"), 0x02, NVERR_FATAL)
#define VACMERR_VALUE_ALREADYUSED             MAKE_VACMERR_VALUE(0x02)

//  0x3403
#define VACMERR_INVALIDPARAMTYPE              MAKE_VACMERR(TEXT("VACMERR_INVALIDPARAMTYPE"), 0x03, NVERR_FATAL)
#define VACMERR_VALUE_INVALIDPARAMTYPE        MAKE_VACMERR_VALUE(0x03)

//  0x3404
#define VACMERR_INVALIDPARAMSIZE              MAKE_VACMERR(TEXT("VACMERR_INVALIDPARAMSIZE"), 0x04, NVERR_FATAL)
#define VACMERR_VALUE_INVALIDPARAMSIZE        MAKE_VACMERR_VALUE(0x04)

//  0x3405
#define VACMERR_INVALIDPARAM                  MAKE_VACMERR(TEXT("VACMERR_INVALIDPARAM"), 0x05, NVERR_FATAL)
#define VACMERR_VALUE_INVALIDPARAM            MAKE_VACMERR_VALUE(0x05)

//  0x3406
#define VACMERR_NOCREATE                      MAKE_VACMERR(TEXT("VACMERR_NOCREATE"), 0x06, NVERR_FATAL)
#define VACMERR_VALUE_NOCREATE                MAKE_VACMERR_VALUE(0x06)

//  0x3407
#define VACMERR_ENDOFDATA                     VAFERR_ENDOFDATA//MAKE_VACMERR(TEXT("VACMERR_ENDOFDATA"), 0x07, NVERR_SAFE)
#define VACMERR_VALUE_ENDOFDATA               VAFERR_VALUE_ENDOFDATA//MAKE_VACMERR_VALUE(0x07)

//  0x3408
#define VACMERR_BUFFERTOOSMALL                MAKE_VACMERR(TEXT("VACMERR_BUFFERTOOSMALL"), 0x08, NVERR_FATAL)
#define VACMERR_VALUE_BUFFERTOOSMALL          MAKE_VACMERR_VALUE(0x08)

//  0x3409
#define VACMERR_FILEISBROKEN                  MAKE_VACMERR(TEXT("VACMERR_FILEISBROKEN"), 0x09, NVERR_FATAL)
#define VACMERR_VALUE_FILEISBROKEN            MAKE_VACMERR_VALUE(0x09)

//  0x340A
#define VACMERR_UNSUPPORTEDFILE               MAKE_VACMERR(TEXT("VACMERR_UNSUPPORTEDFILE"), 0x0A, NVERR_FATAL)
#define VACMERR_VALUE_UNSUPPORTEDFILE         MAKE_VACMERR_VALUE(0x0A)

//  0x340B
#define VACMERR_UNKNOWNFOURCC                 MAKE_VACMERR(TEXT("VACMERR_UNKNOWNFOURCC"), 0x0B, NVERR_FATAL)
#define VACMERR_VALUE_UNKNOWNFOURCC           MAKE_VACMERR_VALUE(0x0B)

//  0x340C
#define VACMERR_CANTCREATEINFODIALOG          MAKE_VACMERR(TEXT("VACMERR_CANTCREATEINFODIALOG"), 0x0C, NVERR_FATAL)
#define VACMERR_VALUE_CANTCREATEINFODIALOG    MAKE_VACMERR_VALUE(0x0C)

//  0x340D
#define VACMERR_CANTOPENACMSTREAM             MAKE_VACMERR(TEXT("VACMERR_CANTOPENACMSTREAM"), 0x0D, NVERR_NORMAL)
#define VACMERR_VALUE_CANTOPENACMSTREAM       MAKE_VACMERR_VALUE(0x0D)

//  0x340E
#define VACMERR_CANTSETCURRENTPOSITION        MAKE_VACMERR(TEXT("VACMERR_CANTSETCURRENTPOSITION"), 0x0E, NVERR_FATAL)
#define VACMERR_VALUE_CANTSETCURRENTPOSITION  MAKE_VACMERR_VALUE(0x0E)


#pragma pack(pop)



#ifdef __cplusplus
}
#endif
